#ifndef _GET_DB_BASE_H_
#define _GET_DB_BASE_H_

#include "dbcard.h"
#include "goldenconn.h"

/** Base class for all the classes of database import. It holds the raw buffer,
  * splitted words and connection object pointer
  */
class GetDBBase
{
public:
   /** Constructor for creating this object
     * \param gold_con Connection object for accessing the data
     * \param imp_obj Object to store the data from database
     */
   GetDBBase(GoldenConn *gold_con, ImportObject *imp_obj)
   {
      goldenConn = gold_con;
      impObj = imp_obj;
      numFields = 0;
      wordArray = NULL;
      cardObj = NULL;
   }

   /** Destructor to release memory for this object */
   virtual ~GetDBBase()
   {
      goldenConn = NULL;
      impObj = NULL;
      numFields = 0;
      wordArray = NULL;
      cardObj = NULL;
   }

public:
   /** Count of fields in a card */
   unsigned int   numFields;
   /** Array of words after split the line of data */
   char           **wordArray;
   /** Object to store the data in the form of cards and fields */
   ImportObject   *impObj;
   /** Object store the card data */
   Card           *cardObj;
   /** Database Connection to connect to */
   GoldenConn     *goldenConn;
};

#endif

