#include <iostream>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <unistd.h>
#include "dbgetnodes.h"
#include "gentime.h"
#include "myconnection.h"
#include "filegeneric.h"
#include "getincludesfilewise.h"
#include "libgen.h"
#include "card.h"
#include "definemanager.h"
#include "defineexport.h"
#include "definetype.h"
#include "transform.h"

using namespace std;

map<string,string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

void getJSStr
     (
        vector<string> & file_list,
        vector<string> & table_list,
        vector<TransformPtr> & trans_list,
        string & js_str,
        string & mainFile,
        string & mainTabName
     )
{
    if(file_list.empty())
        return;

   char js_buf[256];
   js_str = "var options = parent.frames['HeadFrame'].document.mainForm.includeFiles.options;\n";
   string file_str = "[\"" + mainFile + "\",";
   string value_str = "[\"" + mainTabName + "\",";

   unsigned int i = 0;
   for(i = 0; i < file_list.size()-1; i++)
   {
      if( !strstr(file_list[i].data(), "MAIN") )
         sprintf(js_buf, "\"%s_%d\",", file_list[i].data(), trans_list[i]->fileIndex);
      else
         sprintf(js_buf, "\"%s\",", file_list[i].data());
      file_str += js_buf;

      if( !strstr(file_list[i].data(), "MAIN") )
         sprintf(js_buf, "\"%s_%d\",", table_list[i].data(), trans_list[i]->fileIndex);
      else
         sprintf(js_buf, "\"%s\",", table_list[i].data());
      value_str += js_buf;
   }

   if( !strstr(file_list[i].data(), "MAIN") )
      sprintf(js_buf, "\"%s_%d\",", file_list[i].data(), trans_list[i]->fileIndex);
   else
      sprintf(js_buf, "\"%s\",", file_list[i].data());
   file_str += js_buf;
   file_str += "];";

   if( !strstr(file_list[i].data(), "MAIN") )
      sprintf(js_buf, "\"%s_%d\",", table_list[i].data(), trans_list[i]->fileIndex);
   else
      sprintf(js_buf, "\"%s\",", table_list[i].data());
   value_str += js_buf;
   value_str += "];";
   
   js_str += "var names_array = ";
   js_str += file_str;
   js_str += "\n";
   js_str += "var values_array = ";
   js_str += value_str;
   js_str += "\n";
   js_str += "modifyKWList(options, names_array, values_array);";
}

void writeJSFile(char *dir, string & js_str, vector<TransformPtr> & tlist)
{
   if(js_str.empty())
      return;

   char js_buf[256];
   sprintf(js_buf, "%s/include.js", dir);
   FILE *js_fp = fopen(js_buf, "wb");
   fwrite(js_str.data(), js_str.size() * sizeof(char), 1, js_fp);
   fclose(js_fp);

   sprintf(js_buf, "%s/transform", dir);
   js_fp = fopen(js_buf, "wb");
   for(size_t i = 0; i <tlist.size(); i++)
   {
      fwrite(tlist[i], sizeof(TransformStr), 1, js_fp);
   }
   fclose(js_fp);
}

/*
int cmpFunc(const void *p1, const void *p2)
{
   return ( (*(const int *)p1 > *(const int *)p2) ? 1 : ((*(const int *)p1 == *(const int *)p2) ? 0 : -1) );
}

int getFilePointer(char *file_name, void **ret_ptr, size_t *size)
{
   struct stat statbuf;
   int fileDes = open(file_name, O_RDONLY);

   if( fileDes < 0 )
      return -1;

   if( fstat(fileDes, &statbuf) < 0 )
   {
      cout << "Unable to stat file nids_bin\n";
      close(fileDes);
      return -1;
   }
 
   *size = statbuf.st_size;

cout << "BLOCK SIZE=" << statbuf.st_blksize << endl;
cout << "NUM BLOCK =" << statbuf.st_blocks << endl;

   *ret_ptr = mmap(0, statbuf.st_size, PROT_READ, 
			  MAP_SHARED, fileDes, 0);
   if( *ret_ptr == NULL )
   {
      cout << "MMAP error for file " << file_name << endl;
      close(fileDes);
      return -1;
   }

   return fileDes;
}
*/

int getNodesByFile(const char *fileDir, const char *fileName, TransformPtr tranPtr, GoldenConn *sql_conn, float *exts)
{
   DBGetNodes *get_nodes = new DBGetNodes(fileDir, fileName, sql_conn);
   if( get_nodes->byCountSort(exts, tranPtr) )
   {
      delete get_nodes;
      return 1;
   }

   if( get_nodes->writeTwoFilesByBuf() )
   {
      delete get_nodes;
      return 2;
   }

   delete get_nodes;

   return 0;
}

int main(int argc, char *argv[])
{
   if( argc < 3 )
   {
      cout << "dbgetnodes dir_name model_name" << endl;
      return 1;
   }

   GoldenConn *sql_conn = MyConnection::get();

   if( !sql_conn )
      return 1;

   char buf[1024], dir_buf[1024];
   float exts[6];
 
   vector<string> file_list;
   IncludeFileDetailsVector incVector;
   GetIncludesDBFileWise get_inc(argv[2], sql_conn);
   int num_files = get_inc.fetch(incVector);

//cout << "NUM FILES=" << num_files << endl;
   
   if( !num_files )
   {
      cout << "No data for model " << argv[2] << endl;
      return 2;
   }

   char        *main_ptr = strstr(argv[2], "MAIN");
   int         i;
   float       xmin = 1.0e6, ymin = 1.0e6, zmin = 1.0e6;
   float       xmax = -1.0e6, ymax = -1.0e6, zmax = -1.0e6;
   string      js_str;

   buf[0] = '\0';

cout << "NUM FILES=" << incVector.size() << endl;

   num_files = 0;
   Card::setFlag(SAVE_CARDS_FIELDS);
   for(i = incVector.size()-1; i >= 0 ; i--)
   {
      getJSStr(incVector[i].second->m_FilesList, incVector[i].second->m_TablesList,
               incVector[i].second->m_TransList, js_str, incVector[i].first, 
               incVector[i].second->m_TableName);
cout << "FNAME=" << incVector[i].first << endl;
      if( !strstr(incVector[i].second->m_TableName.data(), "MAIN") )
            sprintf(dir_buf, "%s/%s_%d", argv[1], incVector[i].second->m_TableName.data(), 
            incVector[i].second->m_FileIndex);
      else
            sprintf(dir_buf, "%s/%s", argv[1], incVector[i].second->m_TableName.data());
      if( access(dir_buf, W_OK) < 0 )
            mkdir(dir_buf, 0755);
cout << "DIR" << dir_buf << endl;

      writeJSFile(dir_buf, js_str, incVector[i].second->m_TransList);

      if(i == 0)
      {
         xmin = ymin = zmin = 1.0e6;
         xmax = ymax = zmax = -1.0e6;
         TransformStr transStr;
         memset(&transStr, 0, sizeof(TransformStr));
         transStr.fileIndex = incVector[i].second->m_FileIndex;
         transStr.sX = transStr.sY = transStr.sZ = 1.0;
         if(!getNodesByFile(dir_buf, incVector[i].second->m_TableName.data(), &transStr, sql_conn, exts))
         {
            sprintf(buf, "%s/part_start", dir_buf);
            writeFile(buf, exts, sizeof(float) * 6);

            if( exts[0] < xmin ) xmin = exts[0];
            if( exts[1] > xmax ) xmax = exts[1];
            if( exts[2] < ymin ) ymin = exts[2];
            if( exts[3] > ymax ) ymax = exts[3];
            if( exts[4] < zmin ) zmin = exts[4];
            if( exts[5] > zmax ) zmax = exts[5];
         }
         num_files++;
      }

      for(size_t j = 0; j < incVector[i].second->m_TablesList.size(); j++)
      {
         if( !strstr(incVector[i].second->m_TablesList[j].data(), "MAIN") )
            sprintf(dir_buf, "%s/%s_%d", argv[1], incVector[i].second->m_TablesList[j].data(),
                     incVector[i].second->m_TransList[j]->fileIndex);
         else
            sprintf(dir_buf, "%s/%s", argv[1], incVector[i].second->m_TablesList[j].data());
         if( access(dir_buf, W_OK) < 0 )
            mkdir(dir_buf, 0755);
cout << "DIR" << dir_buf << endl;

         if(!getNodesByFile(dir_buf, incVector[i].second->m_TablesList[j].data(), 
                              incVector[i].second->m_TransList[j], sql_conn, exts))
         {
            sprintf(buf, "%s/part_start", dir_buf);
            writeFile(buf, exts, sizeof(float) * 6);

            if( exts[0] < xmin ) xmin = exts[0];
            if( exts[1] > xmax ) xmax = exts[1];
            if( exts[2] < ymin ) ymin = exts[2];
            if( exts[3] > ymax ) ymax = exts[3];
            if( exts[4] < zmin ) zmin = exts[4];
            if( exts[5] > zmax ) zmax = exts[5];
         }
         num_files++;
      }
   }

   if( buf[0] != '\0' && main_ptr )
   {
      exts[0] = xmin; exts[1] = xmax;
      exts[2] = ymin; exts[3] = ymax;
      exts[4] = zmin; exts[5] = zmax;

cout << "FINAL EXTS=" << exts[0] << "," << exts[1] << "," << exts[2]
     << "," << exts[3] << "," << exts[4] << "," << exts[5] << endl;
      sprintf(dir_buf, "%s/%s", argv[1], argv[2]);
      sprintf(buf, "%s/part_start", dir_buf);
      FILE *fp = fopen(buf, "wb");
      if(fp)
      {
	 fwrite(exts, sizeof(float) * 6, 1, fp);

   cout << "NUM FILES IN WRITE=" << num_files << endl;
	 fwrite(&num_files, sizeof(int), 1, fp);
	 int len = 0;
	 for(size_t i = 0; i < incVector.size(); i++)
	 {
	    if( !strstr(incVector[i].first.data(), "MAIN") )
	       sprintf(buf, "%s_%d", incVector[i].second->m_TableName.data(), 
						   incVector[i].second->m_FileIndex);
	    else
	       sprintf(buf, "%s", incVector[i].second->m_TableName.data());
	    len = strlen(buf);
	    fwrite(&len, sizeof(int), 1, fp);
	    fwrite(buf, len * sizeof(char), 1, fp);
	    for(size_t j = 0; j < incVector[i].second->m_TablesList.size(); j++)
	    {
	       sprintf(buf, "%s_%d", incVector[i].second->m_TablesList[j].data(), 
					  incVector[i].second->m_TransList[j]->fileIndex);
	       len = strlen(buf);
	       fwrite(&len, sizeof(int), 1, fp);
	       fwrite(buf, len * sizeof(char), 1, fp);
	    }
	 }

	 fclose(fp);
      }
   }

   delete sql_conn;

/*
   if( argc > 3 )
   {
unsigned long stime = GenTime::getCurrentMillis();
      char file[128];
      size_t size = 0;
      int id = atoi(argv[3]);
      void *base = NULL;
      sprintf(file, "%s/%s_node_ids", argv[1], argv[2]);
      int fd = getFilePointer(file, &base, &size); 

      if( fd < 0 )
	 return 1;

      int *id_ptr = (int *)bsearch(&id,base,size/sizeof(int),sizeof(int), cmpFunc);
      int *ptr = (int *)base;
      if( id_ptr )
         cout << "Node idx=" << (id_ptr-ptr) << endl;

      munmap(base, size);
      close(fd);
unsigned long etime = GenTime::getCurrentMillis();
cout << "time to find id=" << etime-stime << endl;
   }
*/

   return 0;
}

