#include <iostream>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/mman.h>
#include "bufio.h"
#include "transform.h"

void print(TransformPtr tptr)
{
   cout << "FILE INDEX=" << tptr->fileIndex << "\n"
        << "ROT=" << tptr->rotAngle << "," << tptr->rX << "," << tptr->rY 
        << "," << tptr->rZ << "\n"
        << "TRANS=" << tptr->tX << "," << tptr->tY << "," << tptr->tZ << "\n";
}

int main(int argc, char *argv[])
{
   if( argc < 2 )
   {
      cout << "Usage:test tranform_file\n";
      return 1;
   }

   char buf[256];
   struct stat statbuf;
   int fd = open(argv[1], O_RDONLY);

   if( fd < 0 )
   {
      cout << "No node data for =" << buf << endl;
      return 0;
   }

   if( fstat(fd, &statbuf) < 0 )
   {
      cout << "Unable to stat file " << buf << endl;
      return 0;
   }
//cout << "BLOCK SIZE=" << statbuf.st_blksize << endl;
//cout << "NUM BLOCK =" << statbuf.st_blocks << endl;

   unsigned int *base = (unsigned int *)mmap(0, statbuf.st_size, PROT_READ, 
			  MAP_SHARED, fd, 0);
   if( !base )
   {
      cout << "MMAP error for file " << buf << endl;
      return 0;
   }

   unsigned int num_ids = statbuf.st_size/sizeof(TransformStr);

   TransformPtr tlist = new TransformStr[num_ids];
   memcpy(tlist, base, sizeof(TransformStr) * num_ids);

   for(unsigned int i = 0; i < num_ids; i++)
      print(&tlist[i]);

   return 0;
}

