#include "dbputsets.h"
#include "dbputgen.h"
#include "setmanager.h"

int  DBPutSets::insert(const char *model_name, GoldenConn *golden_conn)
{
   SetManager *set_man = SetManager::create();

   if( !set_man->length() )
      return 0;

   string modelName = model_name;
   string table_name = "`" + modelName + "___SETS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( golden_conn->executeQuery( create_query.data(), false ) )
   {
      cout << golden_conn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(80), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( golden_conn->executeQuery( create_query.data(), false ) )
   {
      cout << golden_conn->error() << endl;
      return 5;
   }

cout << "FROM SET INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, set_man, golden_conn);
}

