#include <iostream>
#include <math.h>
#include <stdlib.h>
#include "getdb.h"
#include "includetype.h"
#include "myconnection.h"
#include "oglcmds.h"
#include "getincludesfilewise.h"
#include "dbgetnodes.h"
#include "card.h"

//map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;
/*
string MyConnection::db = "test";
string MyConnection::vendor = "mysql";
string MyConnection::user = "krishna";
string MyConnection::password = "";
string MyConnection::host = "localhost";
unsigned int MyConnection::port = 3306;
unsigned int MyConnection::width = 800;
unsigned int MyConnection::height = 600;
*/

static inline void randomColor(float rgb[3]);

int getNodesElementsAndParts(const char *dir_name, const char *file_name, TransformPtr trans_ptr, GoldenConn *sql_conn,
         string *partDetailsJSON, set<float> & xValues, set<float> & yValues, set<float> & zValues,
                             float exts[])
{
    time_t t2, t3, t4;

    time(&t2);
    GetDB           *getdb = NULL;
    unsigned int    nodeOffset;

cout << "FILE=" << file_name << endl;
    if(!GetDB::m_GetDB)
    {
         getdb = new GetDB(file_name, sql_conn);
         GetDB::m_GetDB = getdb;
    }
    else
    {
         getdb = GetDB::m_GetDB;
         getdb->setModelName(file_name);
    }

    int retShell = getdb->partsByElementType();
    int retSolid = getdb->partsByElementType(ELEMENT_SOLID);

    if(retShell && retSolid)
    {
        //delete getdb;
        return 1;
    }

/*cout
    << "EX[0]=" << exts[0]
    << " EX[1]=" << exts[1]
    << " EX[2]=" << exts[2]
    << " EX[3]=" << exts[3]
    << " EX[4]=" << exts[4]
    << " EX[5]=" << exts[5] << endl;*/

    //getdb->nodes(exts);
    //getdb->nodeExtents(exts);

/*cout
    << "EX[0]=" << exts[0]
    << " EX[1]=" << exts[1]
    << " EX[2]=" << exts[2]
    << " EX[3]=" << exts[3]
    << " EX[4]=" << exts[4]
    << " EX[5]=" << exts[5] << endl;*/

    nodeOffset = trans_ptr->idnoff;
    if(!retShell)
        getdb->shellElements(nodeOffset);
    if(!retSolid)
        getdb->solidElements(nodeOffset);

    /*xValues.insert(exts[0]);
    xValues.insert(exts[1]);

    yValues.insert(exts[2]);
    yValues.insert(exts[3]);

    zValues.insert(exts[4]);
    zValues.insert(exts[5]);*/

    //delete getdb;
    time(&t4);
cout << "TIME FOR DELETE=" << difftime(t4, t3) << endl;
cout << "FILE=" << file_name << " TIME=" << difftime(t4, t2) << endl;
    return 0;
}

int main(int argc, char *argv[])
{
   if( argc < 3 )
   {
      cout << "dbtojs dir_name model_name" << endl;
      return 1;
   }

   time_t t1, t2, t3, t4, t5;

   time(&t1);

   GoldenConn *sql_conn = MyConnection::get();

   if( !sql_conn )
      return 1;
   
/**
   MySqlConn sql_conn("twocars", "localhost", "krishna", "");
   if( sql_conn.connect() )
   {
      cout << "UNABLE to connect to database" << endl;
      return 1;
   }
**/

   //to test with remote machine
   //int opt_ret = sql_conn.setOption(MYSQL_OPT_COMPRESS);
//cout << "OPT RESULT=" << opt_ret << endl;
   
   char            *main_file = argv[2], *dir_name = argv[1], buff[128];
   unsigned int    total_parts = 0, wh[2];
   float           exts[6];
   set<float>      xValues;
   set<float>      yValues;
   set<float>      zValues;



   time(&t2);
   GetIncludesDBFileWise    includeDB(main_file, sql_conn);
   IncludeFileDetailsVector incVector;
   includeDB.fetch(incVector);
   time(&t3);

cout << "TIME FOR INC FILES=" << difftime(t3, t2) << " NUM=" 
     << incVector.size() << endl;

   string   partDetailsJSON = "{\"PDArray\":[";
   TransformStr transStr;
   map<unsigned int, Node *> *nodeMap = NULL;
   for(size_t i = 0; i < incVector.size(); i++)
   {
       if(i != 0)
       {
           if(!GetDB::m_GetDB)
                GetDB::m_GetDB = new GetDB(incVector[i].second->m_TableName.data(), sql_conn);
           nodeMap = GetDB::m_GetDB->GetNodeMap();
       }
       else
       {
           memset(&transStr, 0, sizeof(TransformStr));
           transStr.fileIndex = incVector[i].second->m_FileIndex;
           transStr.sX = transStr.sY = transStr.sZ = 1.0;

           if(!GetDB::m_GetDB)
                GetDB::m_GetDB = new GetDB(incVector[i].second->m_TableName.data(), sql_conn);

           DBGetNodes *getNodesObj = new DBGetNodes(dir_name, incVector[i].second->m_TableName.data(), sql_conn);
           nodeMap = GetDB::m_GetDB->GetNodeMap();
           getNodesObj->byCountSort(exts, &transStr, nodeMap);
           if(nodeMap->size())
           {
               xValues.insert(exts[0]);
               xValues.insert(exts[1]);

               yValues.insert(exts[2]);
               yValues.insert(exts[3]);

               zValues.insert(exts[4]);
               zValues.insert(exts[5]);
           }
           
           delete getNodesObj;
       }

       for(size_t j = 0; j < incVector[i].second->m_TablesList.size(); j++)
       {
           DBGetNodes *getNodesObj = new DBGetNodes(dir_name, incVector[i].second->m_TablesList[j].data(), sql_conn);
           getNodesObj->byCountSort(exts, incVector[i].second->m_TransList[j], nodeMap);
           if(nodeMap->size())
           {
                xValues.insert(exts[0]);
                xValues.insert(exts[1]);

                yValues.insert(exts[2]);
                yValues.insert(exts[3]);

                zValues.insert(exts[4]);
                zValues.insert(exts[5]);
           }
           delete getNodesObj;
       }

       if(i == 0)
            getNodesElementsAndParts(dir_name, incVector[i].second->m_TableName.data(), &transStr, sql_conn, &partDetailsJSON, xValues, yValues, zValues, exts);
       for(size_t j = 0; j < incVector[i].second->m_TablesList.size(); j++)
       {
           cout << "SUB FILE=" << incVector[i].second->m_FilesList[j].data() << endl;
           getNodesElementsAndParts(dir_name, incVector[i].second->m_TablesList[j].data(), incVector[i].second->m_TransList[j],
                                    sql_conn, &partDetailsJSON, xValues, yValues, zValues, exts);
       }
       time(&t3);
       string   dname = dir_name;
       GetDB::m_GetDB->writeDataToFiles(dname, total_parts, GL_TRIANGLES, GZIP_COMPRESSION, &partDetailsJSON);
       time(&t4);
       total_parts += GetDB::m_GetDB->numParts();

       cout << "TIME FOR SORTING=" << difftime(t4, t3) << endl;
       GetDB::deleteGetDB();
   }
   time(&t5);

   partDetailsJSON += "]}";

   sprintf(buff, "%s/partdetails.js", dir_name);
   string details_file_name = buff;
   GetDB::writeGZIPFile(details_file_name, partDetailsJSON);

cout << "TIME FOR WRITING=" << difftime(t5, t3) << endl;

   set<float>::iterator b = xValues.begin(), e = xValues.end();
   if( b == e )
   {
      cout << "No details in DB for model=" << main_file << endl;
      return 1;
   } 

   exts[0] = *b; e--; exts[1] = *e;
   b = yValues.begin(); e = yValues.end();
   exts[2] = *b; e--; exts[3] = *e;
   b = zValues.begin(); e = zValues.end();
   exts[4] = *b; e--; exts[5] = *e;

   for(int iIndex = 0; iIndex < 6; iIndex++)
   {
       float curVal = fabs(exts[iIndex]); 
       if((curVal - 1.0e-2) < 1.0e-2)
           exts[iIndex] = 0.0;
   }

cout << "FINAL EXTS=" << exts[0] << "," << exts[1] << ","
  << exts[2] << "," << exts[3] << "," << exts[4] << "," << exts[5] << endl;

   float    rcolor = 0.7f, gcolor = 0.5f, bcolor = 0.3f, alpha = 1.0f;

   string pcolor_str = PART_COLOR_ARRAY_NAME, part_cmds;
   pcolor_str += "=[";

   float 	rgb[3];
   for(unsigned int j = 0; j < total_parts-1; j++)
   {
      GetDB::randomColor(rgb);
      sprintf(buff, "[%.2f,%.2f,%.2f,%.2f],", rgb[0], rgb[1], rgb[2], alpha);
      pcolor_str += buff;
      /*rcolor = ( rcolor > 1.0 ) ? 0.3 : (rcolor + 0.05);
      gcolor = ( gcolor > 1.0 ) ? 0.5 : (gcolor + 0.05);
      bcolor = ( bcolor > 1.0 ) ? 0.7 : (bcolor + 0.05);*/
      //OglCmds::getPartCmd(j, part_cmds, GL_TRIANGLE_STRIP);
   }

   wh[0] = atoi(MyConnection::getParam("width"));
   wh[1] = atoi(MyConnection::getParam("height"));
   sprintf(buff, "[%g,%g,%g,%g]];", rcolor, gcolor, bcolor, alpha);
   pcolor_str += buff;

   string file_name = dir_name, init_str, end_str;
   file_name += "/part_start.js";

   float light0x = (exts[0] + exts[1])/2.0f;
   float light0y = -exts[1];
   float light0z = -exts[5];
   float light1x = 2 * exts[1];
   float light1y = 2 * exts[3];
   float light1z = 2 * exts[5];
   
   sprintf(buff, "\nNUM_PARTS=%d;\n", total_parts);
   pcolor_str += buff;
   sprintf(buff, "\nglobalLight0x=%g;globalLight0y=%g;globalLight0z=%g;", 
       light0x, light0y, light0z);
   pcolor_str += buff;
   sprintf(buff, "\nglobalLight1x=%g;globalLight1y=%g;globalLight1z=%g;\n", 
       light1x, light1y, light1z);
   pcolor_str += buff;
   sprintf(buff, "\nmodelExts=[%g,%g,%g,%g,%g,%g];\n", 
       exts[0], exts[1],exts[2], exts[3], exts[4],exts[5]);
   pcolor_str += buff;

   pcolor_str += "function drawModel()\n{\n";
   OglCmds::getInitCmds(wh, exts, init_str);
   pcolor_str += init_str;
   pcolor_str += part_cmds;
   OglCmds::getEndCmds(end_str);
   pcolor_str += end_str;
   pcolor_str += "}\n";
   //pcolor_str += init_str;
   GetDB::writeGZIPFile(file_name, pcolor_str);

   file_name = dir_name;
   file_name += "/part_end.js";
   GetDB::writeGZIPFile(file_name, end_str);

cout << "TOTAL TIME=" << difftime(t5, t1) << " PARTS=" << total_parts << endl;

   return 0;
}


