#ifndef _NODE_H_
#define _NODE_H_

#include <iostream>
#include <vector>
#include <map>
#include <unordered_set>
#include <set>
#include <math.h>
#include "normal.h"

using namespace std;

class Node
{
public:
   Node(float _x, float _y, float _z)
   {
      x = _x;
      y = _y;
      z = _z;
      m_Normal = NULL;
   }

   Node(char *_x, char *_y, char *_z)
   {
      x = atof(_x);	y = atof(_y);	z = atof(_z);
      m_Normal = NULL;
   }

   friend std::ostream & operator<<(std::ostream & os, Node *ptr)
   {
      os << "X = " << ptr->x << endl
	      << "Y = " << ptr->y << endl
	      << "Z = " << ptr->z << endl;
      return os;
   }

   virtual ~Node(){}

   void AddNormal(Normal *norm)
   {
       m_NodeNormals.push_back(norm);
   }

   Normal* getNormal()
   {
        vector<Normal*>::iterator b = m_NodeNormals.begin(), e = m_NodeNormals.end();
        float _x = 0, _y = 0, _z = 0;
        for(; b != e; ++b)
        {
            _x += (*b)->x;
            _y += (*b)->y;
            _z += (*b)->z;
        }

        _x /= m_NodeNormals.size();
        _y /= m_NodeNormals.size();
        _z /= m_NodeNormals.size();

        if(!m_Normal)
            m_Normal = new Normal(_x, _y, _z);
        else
        {
            m_Normal->x = _x;
            m_Normal->y = _y;
            m_Normal->z = _z;
        }
        m_Normal->normalize();
        return m_Normal;
   }

public:
   float	x, y, z;
   unsigned int idx;
   vector<Normal*>   m_NodeNormals;
   Normal   *m_Normal;
};

typedef std::pair<unsigned int, Node *> IDNodePtrPair;
typedef std::map<unsigned int, Node *>::iterator IDNodePtrIterator;
typedef std::vector<Node *>::iterator NodePtrIterator;

#endif

