#include "oglcmds.h"
#include <stdio.h>
#include <math.h>
#include <iostream>

void OglCmds::getInitCmds
(
   unsigned int wh[2],
   float exts[6],
   string & cmds_string
)
{
   char buff[512];
   float left = exts[0];
   float right = exts[1];

   float bottom = exts[3];
   float top = exts[2];

   if(top >= 0 && bottom >= 0)
   {
       bottom = exts[5];
       top = exts[4];
   }

   sprintf(buff, "globalCamera.orthoLeft=%g;\nglobalCamera.orthoRight=%g;\nglobalCamera.orthoBottom=%g;\nglobalCamera.orthoTop=%g;\n",
	            left, right, top, bottom);
   cmds_string += buff;
}

void OglCmds::getPartCmdModify
     (
        unsigned int & part_index,
    string & cmds_string,
        unsigned int draw_type
     )
{
     char buff[1024];
    sprintf(buff, "var partMesh=globalScene.getMeshByName(\"PART_%d\");\n", part_index);
    cmds_string += buff;
    sprintf(buff, "if(pNormalA%d.length == 0)\nBABYLON.VertexData.ComputeNormals(pNodeA%d,pShellA%d,pNormalA%d);\n", part_index, part_index, part_index, part_index);
    cmds_string += buff;


    sprintf(buff, "partMesh.updateVerticesData(BABYLON.VertexBuffer.PositionKind, pNodeA%d);\n", part_index);
    cmds_string += buff;
    sprintf(buff, "partMesh.updateIndices(pShellA%d);\n", part_index);
    cmds_string += buff;
    sprintf(buff, "partMesh.updateVerticesData(BABYLON.VertexBuffer.NormalKind, pNormalA%d);\n", part_index);
    cmds_string += buff;
}

void OglCmds::getPartCmd
     (
        unsigned int & part_index,
	string & cmds_string,
        unsigned int draw_type
     )
{
   char buff[512];

//cout << "DRAW TYPE=" << draw_type << "\n"; 

   switch( draw_type )
   {
      case GL_QUADS:
	   sprintf(buff, "vBA[%d]=glCanvas.createBuffer();\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "fBA[%d]=new Float32Array(%s%d);\n", part_index, PART_NODES_ARRAY_NAME, part_index);
	   cmds_string += buff;
	   sprintf(buff, "iAR[%d]=new Uint16Array(%s%d);\n", part_index, PART_SHELLS_ARRAY_NAME, part_index);
	   cmds_string += buff;
	   sprintf(buff, "glCanvas.bindBuffer(glCanvas.ARRAY_BUFFER, vBA[%d]);\n", 
					part_index);
	   cmds_string += buff;
         sprintf(buff, "glCanvas.bufferData(glCanvas.ARRAY_BUFFER,fBA[%d],glCanvas.STATIC_DRAW);\n", part_index);
         cmds_string += buff;
	   sprintf(buff, "iBA[%d]=glCanvas.createBuffer();\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "iBALength[%d]=%s%d.length;\n", part_index, PART_SHELLS_ARRAY_NAME,part_index);
	   cmds_string += buff;
	   sprintf(buff, "glCanvas.bindBuffer(glCanvas.ELEMENT_ARRAY_BUFFER, iBA[%d]);\n", part_index);
	   cmds_string += buff;
         sprintf(buff, "glCanvas.bufferData(glCanvas.ELEMENT_ARRAY_BUFFER, iAR[%d],glCanvas.STATIC_DRAW);\n", part_index);
         cmds_string += buff;
//cout << "DRAW TYPE=QUADS" << draw_type << "\n"; 
      break;
      case GL_TRIANGLE_STRIP:
	   sprintf(buff, "vBA[%d]=glCanvas.createBuffer();\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "fBA[%d]=new Float32Array(%s%d);\n", part_index, PART_NODES_ARRAY_NAME, part_index);
	   cmds_string += buff;
	   sprintf(buff, "iAR[%d]=new Uint16Array(%s%d);\n", part_index, PART_SHELLS_ARRAY_NAME, part_index);
	   cmds_string += buff;
	   sprintf(buff, "glCanvas.bindBuffer(glCanvas.ARRAY_BUFFER, vBA[%d]);\n", part_index);
	   cmds_string += buff;
         sprintf(buff, "glCanvas.bufferData(glCanvas.ARRAY_BUFFER, fBA[%d],glCanvas.STATIC_DRAW);\n", part_index);
         cmds_string += buff;
	   sprintf(buff, "iBA[%d]=glCanvas.createBuffer();\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "iBALength[%d]=%s%d.length;\n", part_index, PART_SHELLS_ARRAY_NAME, part_index);
	   cmds_string += buff;
	   sprintf(buff, "glCanvas.bindBuffer(glCanvas.ELEMENT_ARRAY_BUFFER, iBA[%d]);\n", 
					part_index);
	   cmds_string += buff;
         sprintf(buff, "glCanvas.bufferData(glCanvas.ELEMENT_ARRAY_BUFFER, iAR[%d],glCanvas.STATIC_DRAW);\n", part_index);
         cmds_string += buff;
//cout << "DRAW TYPE=STRIP" << draw_type << "\n"; 
      break;
      case GL_TRIANGLES:
	   sprintf(buff, "var partMesh=new BABYLON.Mesh(\"PART_%d\", globalScene);\n", part_index);
	   cmds_string += buff;
       sprintf(buff, "if(pNormalA%d.length == 0)\nBABYLON.VertexData.ComputeNormals(pNodeA%d,pShellA%d,pNormalA%d);\n", part_index, part_index, part_index, part_index);
       cmds_string += buff;
	   sprintf(buff, "var vertexData=new BABYLON.VertexData();\n");
	   cmds_string += buff;
	   sprintf(buff, "vertexData.positions=pNodeA%d;\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "vertexData.indices=pShellA%d;\n", part_index);
	   cmds_string += buff;
       sprintf(buff, "vertexData.normals=pNormalA%d;\n", part_index);
       cmds_string += buff;
	   sprintf(buff, "var partMat=new BABYLON.StandardMaterial(\"MAT_%d\",globalScene);\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "partMat.backFaceCulling=false;\n");
	   cmds_string += buff;
	   //sprintf(buff, "partMat.wireframe=true;\n");
	   //cmds_string += buff;
	   //sprintf(buff, "partMat.emissiveColor=new BABYLON.Color3(pCA[%d][0],pCA[%d][1],pCA[%d][2]);\n", part_index, part_index, part_index);
	   //cmds_string += buff;
	   sprintf(buff, "partMat.diffuseColor=new BABYLON.Color3(pCA[%d][0],pCA[%d][1],pCA[%d][2]);\n", part_index, part_index, part_index);
	   cmds_string += buff;
	   //sprintf(buff, "partMat.specularColor=new BABYLON.Color3(pCA[%d][0],pCA[%d][1],pCA[%d][2]);\n", part_index, part_index, part_index);
	   //cmds_string += buff;
	   sprintf(buff, "partMesh.material=partMat;\n");
	   cmds_string += buff;
	   /*sprintf(buff, "partMesh.enableEdgesRendering(0.999);\n");
	   cmds_string += buff;
	   sprintf(buff, "partMesh.edgesWidth=3.0;\n");
	   cmds_string += buff;
	   sprintf(buff, "partMesh.edgesColor=new BABYLON.Color4(0,0,0,0);\n");
	   cmds_string += buff;*/
           sprintf(buff, "vertexData.applyToMesh(partMesh, true);\n", part_index);
           cmds_string += buff;
           //sprintf(buff, "partMesh.forceSharedVertices();\n");
           //cmds_string += buff;
//cout << "DRAW TYPE=STRIP" << draw_type << "\n"; 
      break;
   }
}

void OglCmds::getEndCmds
(
   string & cmds_string
)
{
}

