#ifndef _SHELL_H_
#define _SHELL_H_

#include <iostream>
#include <vector>
#include <stdlib.h>
#include "element.h"
#include "elementtype.h"

class Shell : public Element
{
public:

   friend std::ostream & operator<<(std::ostream & os, Shell *ptr)
   {
      os << "PID = " << ptr->pID << endl
	      << "N1 = " << ptr->NIDList[0] << endl
	      << "N2 = " << ptr->NIDList[1] << endl
	      << "N3 = " << ptr->NIDList[2] << endl
	      << "N4 = " << ptr->NIDList[3] << endl;
      return os;
   }

   ~Shell()
   {
   }

   const unsigned int *getNodeIDList()
   {
      return NIDList;
   }

   Node **getNodePtrList()
   {
      return nodePtrList;
   }

   Shell(char *_id, char *_pid, char *n1, char *n2, char *n3, char *n4)
   {
      ID = atoi(_id);
      pID = atoi(_pid);
      NIDList[0] = atoi(n1);
      NIDList[1] = atoi(n2);
      NIDList[2] = atoi(n3);
      NIDList[3] = atoi(n4);
   }

   Shell(unsigned int _id, unsigned int _pid, unsigned int n1, unsigned int n2, unsigned int n3, unsigned int n4)
   {
      ID = (_id);
      pID = (_pid);
      NIDList[0] = (n1);
      NIDList[1] = (n2);
      NIDList[2] = (n3);
      NIDList[3] = (n4);
   }

public:
   unsigned int	  NIDList[4];
   Node	          *nodePtrList[4];
};

typedef std::pair<unsigned int, Shell *> IDShellPtrPair;
typedef std::vector<Shell *>::iterator ShellPtrIterator;
typedef std::map<unsigned int, Shell *>::iterator IDShellPtrIterator;

#endif

