#ifndef _GET_DB_H_
#define _GET_DB_H_

#include  <string>
#include  <stdlib.h>
#include  <map>
#include  <GL/gl.h>
#include "goldenconn.h"
#include "node.h"
#include "shell.h"
#include "part.h"

using namespace std;

typedef enum _CompressionType
{
   NO_COMPRESSION,
   GZIP_COMPRESSION,
   BZIP_COMPRESSION
}
 CompressionType;

class GetDB
{
public:
   GetDB
   (
      const char *model_name,
      GoldenConn *gold_conn
   );

   ~GetDB();

   int partsByElementType(unsigned int kw_type=ELEMENT_SHELL);

   int  shellElements();

   int  nodes(float exts[6]);

   int writeDataToFiles
       (
           string    dir_name,
           unsigned int part_count,
           unsigned int draw_type = GL_QUADS,
           unsigned int compress_flag = GZIP_COMPRESSION
       );

   int numPartsAndNodeExtents
       (
	  int      *num_parts,
	  float   exts[6]
       );

   static int writeGZIPFile
       (
	  string & file_name,
	  string & buf
       );

   static int writeFile
       (
	  string & file_name,
	  string & buf
       );

   void nodeExtents(float min_max[]);

   void partExtents(Part *part_ptr, float min_max[]);

   unsigned int numParts(){ return partMap.size(); }

private:
   string                    modelName;
   GoldenConn                *goldenConn;
   map<unsigned int, Node *> nodeMap;
   map<unsigned int, Part *> partMap;
};

class insertInto
{
public:
   insertInto(vector<Node *> & vect) : target(vect) {}
   void operator () (IDNodePtrPair iter)
   {
      target.push_back(iter.second);
   }

   void operator () (Node *iter)
   {
      target.push_back(iter);
   }

   vector<Node *> &target;
};

int getIncludeFilesFromDB
    (
       const char *main_file,
       GoldenConn *golden_conn,   
       vector<string> & files_list
    );

#endif

