#include <iostream>
#include "getdb.h"
#include "includetype.h"
#include "myconnection.h"
#include "oglcmds.h"

map<string, string> MyConnection::nvMap;
/*
string MyConnection::db = "test";
string MyConnection::vendor = "mysql";
string MyConnection::user = "krishna";
string MyConnection::password = "";
string MyConnection::host = "localhost";
unsigned int MyConnection::port = 3306;
unsigned int MyConnection::width = 800;
unsigned int MyConnection::height = 600;
*/

int main(int argc, char *argv[])
{
   if( argc < 3 )
   {
      cout << "getfedb dir_name model_name" << endl;
      return 1;
   }

   time_t t1, t2, t3, t4, t5;

   time(&t1);

   GoldenConn *sql_conn = MyConnection::get();

   if( !sql_conn )
      return 1;
   
/**
   MySqlConn sql_conn("twocars", "localhost", "krishna", "");
   if( sql_conn.connect() )
   {
      cout << "UNABLE to connect to database" << endl;
      return 1;
   }
**/

   //to test with remote machine
   //int opt_ret = sql_conn.setOption(MYSQL_OPT_COMPRESS);
//cout << "OPT RESULT=" << opt_ret << endl;
   
   char            *main_file = argv[2], *dir_name = argv[1], buff[128];
   unsigned int    total_parts = 0, num_parts = 0, wh[2];
   float          exts[6];
   set<float>     xValues;
   set<float>     yValues;
   set<float>     zValues;
   GetDB           *getdb;
   vector<string>  files_list;

   time(&t2);
   getIncludeFilesFromDB(main_file, sql_conn, files_list);
   time(&t3);
cout << "TIME FOR INC FILES=" << difftime(t3, t2) << " NUM=" 
     << files_list.size() << endl;

   for(unsigned int i = 0; i < files_list.size(); i++)
   {
      time(&t2);
cout << "FILE=" << files_list[i] << endl;
      getdb = new GetDB(files_list[i].data(), sql_conn);

      if( getdb->partsByElementType() )
         continue;

      getdb->nodes(exts);
      getdb->nodeExtents(exts);

      getdb->shellElements();

      time(&t3);
      getdb->writeDataToFiles(dir_name, total_parts, GL_TRIANGLES);
      time(&t4);
cout << "TIME FOR WRITING=" << difftime(t4, t3) << endl;

      num_parts = getdb->numParts();

      xValues.insert(exts[0]);
      xValues.insert(exts[1]);

      yValues.insert(exts[2]);
      yValues.insert(exts[3]);

      zValues.insert(exts[4]);
      zValues.insert(exts[5]);

      total_parts += num_parts;
      time(&t3);
cout << "TIME FOR SORTING=" << difftime(t3, t4) << endl;

      delete getdb;
      time(&t4);
cout << "TIME FOR DELETE=" << difftime(t4, t3) << endl;
cout << "FILE=" << files_list[i] << " TIME=" << difftime(t4, t2) << endl;
   }
   time(&t5);

   set<float>::iterator b = xValues.begin(), e = xValues.end();
   if( b == e )
   {
      cout << "No details in DB for model=" << main_file << endl;
      return 1;
   } 

   exts[0] = *b; e--; exts[1] = *e;
   b = yValues.begin(); e = yValues.end();
   exts[2] = *b; e--; exts[3] = *e;
   b = zValues.begin(); e = zValues.end();
   exts[4] = *b; e--; exts[5] = *e;

cout << "FINAL EXTS=" << exts[0] << "," << exts[1] << ","
  << exts[2] << "," << exts[3] << "," << exts[4] << "," << exts[5] << endl;

   float    rcolor = 0.7f, gcolor = 0.5f, bcolor = 0.3f, alpha = 1.0f;

   string pcolor_str = PART_COLOR_ARRAY_NAME, part_cmds;
   pcolor_str += "=[";

   for(unsigned int j = 0; j < total_parts-1; j++)
   {
      sprintf(buff, "[%g,%g,%g,%g],", rcolor, gcolor, bcolor, alpha);
      pcolor_str += buff;
      rcolor = ( rcolor > 1.0 ) ? 0.3 : (rcolor + 0.05);
      gcolor = ( gcolor > 1.0 ) ? 0.5 : (gcolor + 0.05);
      bcolor = ( bcolor > 1.0 ) ? 0.7 : (bcolor + 0.05);
      //OglCmds::getPartCmd(j, part_cmds, GL_TRIANGLE_STRIP);
   }

   wh[0] = atoi(MyConnection::getParam("width"));
   wh[1] = atoi(MyConnection::getParam("height"));
   sprintf(buff, "[%g,%g,%g,%g]];", rcolor, gcolor, bcolor, alpha);
   pcolor_str += buff;

   string file_name = dir_name, init_str, end_str;
   file_name += "/part_start.js";

   sprintf(buff, "\nNUM_PARTS=%d;\n", total_parts);
   pcolor_str += buff;

   pcolor_str += "function drawModel()\n{\n";
   OglCmds::getInitCmds(wh, exts, init_str);
   pcolor_str += init_str;
   pcolor_str += part_cmds;
   OglCmds::getEndCmds(end_str);
   pcolor_str += end_str;
   pcolor_str += "}\n";
   //pcolor_str += init_str;
   GetDB::writeGZIPFile(file_name, pcolor_str);

   file_name = dir_name;
   file_name += "/part_end.js";
   GetDB::writeGZIPFile(file_name, end_str);

cout << "TOTAL TIME=" << difftime(t5, t1) << " PARTS=" << total_parts << endl;

   return 0;
}

