#include <iostreams/filter/gzip.hpp>
#include <iostreams/device/file.hpp>
#include <string>

using namespace std;
using namespace boost;

int writeGZIPFile
    (
       string & file_name,
       string & buf
    );

typedef union
{
    int intVal;
    float floatVal;
} FloatToInt;

int main()
{
    string 	intStr, floatStr;
    char 	valBuf[256];
    float       initVal = 1.0, floatVal;
    string floatFile = "float";
    string intFile = "int";
    int    fileCount = 1;
    for(int i = 0; i < 100000000; i++)
    {
       floatVal = initVal/i;
       sprintf(valBuf, "%g", floatVal);
       floatStr += valBuf;
       FloatToInt ftoi;
       ftoi.floatVal = floatVal;
       sprintf(valBuf, "%d", ftoi.intVal);
       intStr += valBuf;

       if(i && i%1000000 == 0)
       {
           sprintf(valBuf, "float_%d", fileCount);
           floatFile = valBuf;
           sprintf(valBuf, "int_%d", fileCount);
           intFile = valBuf;
           writeGZIPFile(floatFile, floatStr);
           writeGZIPFile(intFile, intStr);
           floatStr = "";
           intStr = "";
           fileCount++;
       }
    }

   return 0;
}

int writeGZIPFile
    (
       string & file_name,
       string & buf
    )
{
   iostreams::gzip_params gzp;
   //gzp.file_name = file_name.data();

   file_name += ".gz";
   iostreams::file_sink snk(file_name, BOOST_IOS::trunc);

   if( !snk.is_open() )
   {
      cout << "Unable to open file in temp directory" << endl;
      return 1;
   }
   
   iostreams::gzip_compressor gzc(gzp);
   gzc.write(snk, buf.data(), buf.length());
   gzc.close(snk, BOOST_IOS::out);

   return 0;
}
