#include "oglcmds.h"
#include "stdio.h"
#include <iostream>

void OglCmds::getInitCmds
(
   unsigned int wh[2],
   float exts[6],
   string & cmds_string
)
{
   char buff[512];

   sprintf(buff, "glCanvas.viewport(0,0,%u,%u);\n", wh[0], wh[1]);
   cmds_string += buff;
   cmds_string += "getMatrixUniforms();\n";
   cmds_string += "glCanvas.clearColor(0.0,0.0,0.0,1.0);\n";

   cmds_string += "glCanvas.clear(glCanvas.COLOR_BUFFER_BIT|glCanvas.DEPTH_BUFFER_BIT);\n";
   cmds_string += "glCanvas.enable(glCanvas.DEPTH_TEST);\n";
   cmds_string += "glCanvas.enable(glCanvas.CULL_FACE);\n";
   cmds_string += "glCanvas.useProgram(glProgram);\n";

   sprintf(buff, "mat4.ortho(pMatrix, %g,%g,%g,%g,-99999,99999);\n",
	            exts[0], exts[1], exts[2], exts[3]);
   cmds_string += buff;
   cmds_string += "mat4.identity(mvMatrix);\n";
   cmds_string += "mat4.rotateX(mvMatrix, mvMatrix, degToRadian(rotX));";
   cmds_string += "mat4.rotateY(mvMatrix, mvMatrix, degToRadian(rotY));";
   cmds_string += "mat4.rotateZ(mvMatrix, mvMatrix, degToRadian(rotZ));";
   //sprintf(buff, "mat4.fromRotationTranslation(mvMatrix,[-90,0,-180,0],[%g,0,%g]);\n", -(exts[1]+exts[0]), (exts[4]-exts[5])/2.0);
   //cmds_string += buff;
   cmds_string += "drawScene();\n";
}

void OglCmds::getPartCmd
     (
        unsigned int & part_index,
	string & cmds_string,
        unsigned int draw_type
     )
{
   char buff[512];

//cout << "DRAW TYPE=" << draw_type << "\n"; 

   switch( draw_type )
   {
      case GL_QUADS:
	   sprintf(buff, "vBA[%d]=glCanvas.createBuffer();\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "fBA[%d]=new Float32Array(%s%d);\n", part_index, PART_NODES_ARRAY_NAME, part_index);
	   cmds_string += buff;
	   sprintf(buff, "iAR[%d]=new Uint16Array(%s%d);\n", part_index, PART_SHELLS_ARRAY_NAME, part_index);
	   cmds_string += buff;
	   sprintf(buff, "glCanvas.bindBuffer(glCanvas.ARRAY_BUFFER, vBA[%d]);\n", 
					part_index);
	   cmds_string += buff;
         sprintf(buff, "glCanvas.bufferData(glCanvas.ARRAY_BUFFER,fBA[%d],glCanvas.STATIC_DRAW);\n", part_index);
         cmds_string += buff;
	   sprintf(buff, "iBA[%d]=glCanvas.createBuffer();\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "iBALength[%d]=%s%d.length;\n", part_index, PART_SHELLS_ARRAY_NAME,part_index);
	   cmds_string += buff;
	   sprintf(buff, "glCanvas.bindBuffer(glCanvas.ELEMENT_ARRAY_BUFFER, iBA[%d]);\n", part_index);
	   cmds_string += buff;
         sprintf(buff, "glCanvas.bufferData(glCanvas.ELEMENT_ARRAY_BUFFER, iAR[%d],glCanvas.STATIC_DRAW);\n", part_index);
         cmds_string += buff;
//cout << "DRAW TYPE=QUADS" << draw_type << "\n"; 
      break;
      case GL_TRIANGLE_STRIP:
	   sprintf(buff, "vBA[%d]=glCanvas.createBuffer();\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "fBA[%d]=new Float32Array(%s%d);\n", part_index, PART_NODES_ARRAY_NAME, part_index);
	   cmds_string += buff;
	   sprintf(buff, "iAR[%d]=new Uint16Array(%s%d);\n", part_index, PART_SHELLS_ARRAY_NAME, part_index);
	   cmds_string += buff;
	   sprintf(buff, "glCanvas.bindBuffer(glCanvas.ARRAY_BUFFER, vBA[%d]);\n", part_index);
	   cmds_string += buff;
         sprintf(buff, "glCanvas.bufferData(glCanvas.ARRAY_BUFFER, fBA[%d],glCanvas.STATIC_DRAW);\n", part_index);
         cmds_string += buff;
	   sprintf(buff, "iBA[%d]=glCanvas.createBuffer();\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "iBALength[%d]=%s%d.length;\n", part_index, PART_SHELLS_ARRAY_NAME, part_index);
	   cmds_string += buff;
	   sprintf(buff, "glCanvas.bindBuffer(glCanvas.ELEMENT_ARRAY_BUFFER, iBA[%d]);\n", 
					part_index);
	   cmds_string += buff;
         sprintf(buff, "glCanvas.bufferData(glCanvas.ELEMENT_ARRAY_BUFFER, iAR[%d],glCanvas.STATIC_DRAW);\n", part_index);
         cmds_string += buff;
//cout << "DRAW TYPE=STRIP" << draw_type << "\n"; 
      break;
      case GL_TRIANGLES:
	   sprintf(buff, "var pNormalA%d=[];\ncalculateVertexNormals(pNodeA%d,pShellA%d,pNormalA%d);\n", part_index, part_index, part_index, part_index);
	   cmds_string += buff;
	   sprintf(buff, "vNA[%d]=glCanvas.createBuffer();\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "glCanvas.bindBuffer(glCanvas.ARRAY_BUFFER,vNA[%d]);\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "fNA[%d]=new Float32Array(%s%d);\n", part_index, PART_NODE_NORMAL_ARRAY_NAME, part_index);
	   cmds_string += buff;
           sprintf(buff, "glCanvas.bufferData(glCanvas.ARRAY_BUFFER, fNA[%d],glCanvas.STATIC_DRAW);\n", part_index);
           cmds_string += buff;
	   sprintf(buff, "glCanvas.bindBuffer(glCanvas.ARRAY_BUFFER,null);\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "vBA[%d]=glCanvas.createBuffer();\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "glCanvas.bindBuffer(glCanvas.ARRAY_BUFFER, vBA[%d]);\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "fBA[%d]=new Float32Array(%s%d);\n", part_index, PART_NODES_ARRAY_NAME, part_index);
	   cmds_string += buff;
           sprintf(buff, "glCanvas.bufferData(glCanvas.ARRAY_BUFFER, fBA[%d],glCanvas.STATIC_DRAW);\n", part_index);
           cmds_string += buff;
	   sprintf(buff, "glCanvas.bindBuffer(glCanvas.ARRAY_BUFFER,null);\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "iBA[%d]=glCanvas.createBuffer();\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "glCanvas.bindBuffer(glCanvas.ELEMENT_ARRAY_BUFFER, iBA[%d]);\n", part_index);
	   cmds_string += buff;
	   sprintf(buff, "iAR[%d]=new Uint16Array(%s%d);\n", part_index, PART_SHELLS_ARRAY_NAME, part_index);
	   cmds_string += buff;
           sprintf(buff, "glCanvas.bufferData(glCanvas.ELEMENT_ARRAY_BUFFER, iAR[%d],glCanvas.STATIC_DRAW);\n", part_index);
           cmds_string += buff;
	   sprintf(buff, "iBALength[%d]=%s%d.length;\n", part_index, PART_SHELLS_ARRAY_NAME, part_index);
	   cmds_string += buff;
	   sprintf(buff, "glCanvas.bindBuffer(glCanvas.ARRAY_BUFFER,null);\n", part_index);
	   cmds_string += buff;
//cout << "DRAW TYPE=STRIP" << draw_type << "\n"; 
      break;
   }
}

void OglCmds::getEndCmds
(
   string & cmds_string
)
{
}

