#ifndef _PART_H_
#define _PART_H_

#include "element.h"
#include "generic.h"
#include <vector>
#include <set>

using namespace std;

class Part
{
public:
   Part(char *name)
   {
      partName = name;
   }

   vector<Element *> & getPartElementList()
   {
      return elementList;
   }

   void addElement(Element *elm)
   {
      elementList.push_back( elm );
   }

   virtual ~Part()
   {
      vector<Element *>::iterator be = elementList.begin(), 
				  ee = elementList.end();
      for(; be != ee; be++)
         delete *be;
      elementList.clear();

/*** the nodes should not be delete because this is only a reference here
      for(; bn != en; bn++)
         delete *bn; ***/

      uniqueNodeList.clear();
   }

public:
   string	        partName;
   vector<Element *>    elementList;
   set<Node *>          uniqueNodeList;
};

typedef std::pair<unsigned int, Part *> IDPartPtrPair;
typedef std::vector<Part *>::iterator PartPtrIterator;
typedef std::map<unsigned int, Part *>::iterator IDPartPtrIterator;

#endif

