#include  "feputdb.h"
#include  "card.h"
#include  "manager_inc.h"
#include  "gentime.h"
#include  "contactimpobj.h"
#include  "dbputgen.h"
#include  <iterator>
#include  <iostream>
#include  <map>

using namespace std;

FePutDB::~FePutDB()
{
   goldenConn = NULL;
}

int  FePutDB::insertAirbagsIntoDB()
{
   AirbagManager *ab_man = AirbagManager::create();

   if( !ab_man->length() )
      return 0;

   string    table_name = "`" + modelName + "_AIRBAGS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null,VALUE1 varchar(16), VALUE2 varchar(80), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }
cout << "FROM AIRBAGS INSERT CALLBACK" << endl;
   
   return insertIntoDBWithLastRowNull(8, table_name, ab_man, goldenConn);
}

int  FePutDB::insertAlesIntoDB()
{
   ALEManager *ale_man = ALEManager::create();

   if( !ale_man->length() )
      return 0;

   string table_name = "`" + modelName + "_ALES`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(80), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }
cout << "FROM ALE INSERT CALLBACK" << endl;

   return insertIntoDBWithLastRowNull(8, table_name, ale_man, goldenConn);
}

int  FePutDB::insertBoundarysIntoDB()
{
   BdryManager *bdry_man = BdryManager::create();

   if( !bdry_man->length() )
      return 0;

   string table_name = "`" + modelName + "_BOUNDARYS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(80), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM BDRY INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, bdry_man, goldenConn);
}

int  FePutDB::insertComponentsIntoDB()
{
   CompManager *comp_man = CompManager::create();

   if( !comp_man->length() )
      return 0;

   string table_name = "`" + modelName + "_COMPONENTS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM COMPONENT INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, comp_man, goldenConn);
}

int  FePutDB::insertConstraintsIntoDB()
{
   ConstManager *const_man = ConstManager::create();

   if( !const_man->length() )
      return 0;

   string table_name = "`" + modelName + "_CONSTRAINEDS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(80), VALUE2 varchar(80), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM CONSTRAINT INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, const_man, goldenConn);
}

int  FePutDB::insertContactsIntoDB()
{
   ContactManager *contact_man = ContactManager::create();
 
   if( !contact_man->length() )
      return 0;

   string table_name = "`" + modelName + "_CONTACTS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(80), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16), CON_TYPE int unsigned);";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM CONTACT INSERT CALLBACK" << endl;
   return insertContactsIntoDBWithLastRowNull(8, table_name, contact_man);
}

int  FePutDB::insertControlsIntoDB()
{
   ControlManager *ctrl_man = ControlManager::create();

   if( !ctrl_man->length() )
      return 0;

   string table_name = "`" + modelName + "_CONTROLS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(80), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16), VALUE9 varchar(16), VALUE10 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM CONTROL INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(10, table_name, ctrl_man, goldenConn);
}

int  FePutDB::insertDampingsIntoDB()
{
   DampingManager *damp_man = DampingManager::create();

   if( !damp_man->length() )
      return 0;

   string table_name = "`" + modelName + "_DAMPINGS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM DAMPING INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, damp_man, goldenConn);
}

int  FePutDB::insertDatabasesIntoDB()
{
   DatabaseManager *db_man = DatabaseManager::create();

   if( !db_man->length() )
      return 0;

   string table_name = "`" + modelName + "_DATABASES`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(80), VALUE2 varchar(80), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM DATABASE INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, db_man, goldenConn);
}

int  FePutDB::insertDefinesIntoDB()
{
   DefineManager *def_man = DefineManager::create();

   if( !def_man->length() )
      return 0;

   string table_name = "`" + modelName + "_DEFINES`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(80), VALUE2 varchar(24), VALUE3 varchar(24), VALUE4 varchar(24), VALUE5 varchar(24), VALUE6 varchar(24), VALUE7 varchar(24), VALUE8 varchar(24));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM DEFINES INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, def_man, goldenConn);
}

int  FePutDB::insertDeformsIntoDB()
{
   DeformManager *def_man = DeformManager::create();

   if( !def_man->length() )
      return 0;

   string table_name = "`" + modelName + "_DEFORMABLES`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM DEFORM INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, def_man, goldenConn);
}

int  FePutDB::insertEfsIntoDB()
{
   EFManager *ef_man = EFManager::create();

   if( !ef_man->length() )
      return 0;

   string table_name = "`" + modelName + "_EFS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(80), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM EFS INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, ef_man, goldenConn);
}

int  FePutDB::insertEossIntoDB()
{
   EosManager *eos_man = EosManager::create();

   if( !eos_man->length() )
      return 0;

   string table_name = "`" + modelName + "_EOSS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(80), VALUE2 varchar(24), VALUE3 varchar(24), VALUE4 varchar(24), VALUE5 varchar(24), VALUE6 varchar(24), VALUE7 varchar(24), VALUE8 varchar(24));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM EOS INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, eos_man, goldenConn);
}

int  FePutDB::insertHgsIntoDB()
{
   HgManager *hg_man = HgManager::create();

   if( !hg_man->length() )
      return 0;

   string table_name = "`" + modelName + "_HOURGLASSS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(80), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM HG INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, hg_man, goldenConn);
}

int  FePutDB::insertIncludesIntoDB()
{
   IncludeManager *inc_man = IncludeManager::create();

   if( !inc_man->length() )
      return 0;

   string table_name = "`" + modelName + "_INCLUDES`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(80), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM INCLUDE INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, inc_man, goldenConn);
}

int  FePutDB::insertIntegrationsIntoDB()
{
   IntegrationManager *int_man = IntegrationManager::create();

   if( !int_man->length() )
      return 0;

   string table_name = "`" + modelName + "_INTEGRATIONS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM INTEGRATION INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, int_man, goldenConn);
}

int  FePutDB::insertInitialsIntoDB()
{
   InitialManager *init_man = InitialManager::create();

   if( !init_man->length() )
      return 0;

   string table_name = "`" + modelName + "_INITIALS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM INITIAL INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, init_man, goldenConn);
}

int  FePutDB::insertInterfacesIntoDB()
{
   InterfaceManager *int_man = InterfaceManager::create();

   if( !int_man->length() )
      return 0;

   string table_name = "`" + modelName + "_INTERFACES`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM INTERFACE INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, int_man, goldenConn);
}

int  FePutDB::insertLoadsIntoDB()
{
   LoadManager *load_man = LoadManager::create();
   
   if( !load_man->length() )
      return 0;

   string table_name = "`" + modelName + "_LOADS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(80), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM LOAD INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, load_man, goldenConn);
}

int  FePutDB::insertMatsIntoDB()
{
   MatManager *mat_man = MatManager::create();

   if( !mat_man->length() )
      return 0;

   string table_name = "`" + modelName + "_MATS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM MAT INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, mat_man, goldenConn);
}

int  FePutDB::insertParametersIntoDB()
{
   ParameterManager *param_man = ParameterManager::create();

   if( !param_man->length() )
      return 0;

   string table_name = "`" + modelName + "_PARAMETERS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(80), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM PARAM INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, param_man, goldenConn);
}

int  FePutDB::insertPartCsIntoDB()
{
   PartCManager *part_man = PartCManager::create();

   if( !part_man->length() )
      return 0;

   string table_name = "`" + modelName + "_PARTS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(80), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM PART INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, part_man, goldenConn);
}

int  FePutDB::insertPerturbsIntoDB()
{
   PerturbManager *pert_man = PerturbManager::create();

   if( !pert_man->length() )
      return 0;

   string table_name = "`" + modelName + "_PERTURBATIONS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(80), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM PERT INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, pert_man, goldenConn);
}

int  FePutDB::insertRailsIntoDB()
{
   RailManager *rail_man = RailManager::create();

   if( !rail_man->length() )
      return 0;

   string table_name = "`" + modelName + "_RAILS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM RAIL INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, rail_man, goldenConn);
}

int  FePutDB::insertRigidwallsIntoDB()
{
   RigidwallManager *rigid_man = RigidwallManager::create();

   if( !rigid_man->length() )
      return 0;

   string table_name = "`" + modelName + "_RIGIDWALLS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM RIGIDWALL INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, rigid_man, goldenConn);
}

int  FePutDB::insertSectionsIntoDB()
{
   SectionManager *sec_man = SectionManager::create();

   if( !sec_man->length() )
      return 0;

   string table_name = "`" + modelName + "_SECTIONS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(80), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM SECTION INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, sec_man, goldenConn);
}

int  FePutDB::insertSensorsIntoDB()
{
   SensorManager *sen_man = SensorManager::create();

   if( !sen_man->length() )
      return 0;

   string table_name = "`" + modelName + "_SENSORS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM SENSOR INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, sen_man, goldenConn);
}

int  FePutDB::insertTermsIntoDB()
{
   TermManager *term_man = TermManager::create();

   if( !term_man->length() )
      return 0;

   string table_name = "`" + modelName + "_TERMINATIONS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM TERM INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, term_man, goldenConn);
}

int  FePutDB::insertUsersIntoDB()
{
   UserManager *user_man = UserManager::create();

   if( !user_man->length() )
      return 0;

   string table_name = "`" + modelName + "_USERS`";

   string create_query = "DROP TABLE IF EXISTS ";
   create_query += table_name;
   create_query += ";";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   create_query = ("CREATE TABLE ");
   create_query += table_name;
   create_query += " (CARD_INDEX int not null primary key auto_increment, KW_TYPE int not null, VALUE1 varchar(16), VALUE2 varchar(16), VALUE3 varchar(16), VALUE4 varchar(16), VALUE5 varchar(16), VALUE6 varchar(16), VALUE7 varchar(16), VALUE8 varchar(16));";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

cout << "FROM USER INSERT CALLBACK" << endl;
   return insertIntoDBWithLastRowNull(8, table_name, user_man, goldenConn);
}

int FePutDB::insertContactsIntoDBWithLastRowNull
    (
       int      max_num_fields,
       string & table_name,
       Manager  *man_ptr
    )
{
   vector<ImportObject *> & imp_arr = man_ptr->getImportObjectList();

   if( !imp_arr.size() )
      return 0;

cout << "SIZE OF IMP OBJECTs = " << imp_arr.size() << endl;
   vector<ImportObject *>::iterator b = imp_arr.begin(), e = imp_arr.end();

   ContactImportObject *imp_obj;
   vector<Card *>::iterator bc, ec;
   Card *card;
   vector<Data *>::iterator bv, ev;
   Data *data;

   char   buff[4096], buff1[256], *char_val, buff2[256];
   int    int_val, num_values = 0;
   unsigned int num_cards = 0, kw_type;
   double dbl_val;

   sprintf(buff1, "INSERT INTO %s VALUES (NULL,", table_name.data());

   while( b != e )
   {
      imp_obj = (ContactImportObject *) *b;

      vector<Card *> & card_arr = imp_obj->getCardList();
      bc = card_arr.begin();
      ec = card_arr.end();
      kw_type = imp_obj->getKeywordType();

      num_cards = 0;
      while( bc != ec )
      {
         card = *bc;
         vector<Data *> & var_values = card->getVarValues();
         bv = var_values.begin();
         ev = var_values.end();

         if( !num_cards )
            sprintf(buff, "%s%u,", buff1, kw_type);
 
         if( !num_cards && !var_values.size() )
            sprintf(buff, "%s%u", buff1, kw_type);
 
         while(bv != ev)
         {
            data = *bv;
            switch(data->dataType)
            {
               case DATA_INT:
                  data->value(&int_val);
                  sprintf(buff2, "\"%d\"", int_val);
                  break;
               case DATA_DOUBLE:
                  data->value(&dbl_val);
                  sprintf(buff2, "\"%.9g\"", dbl_val);
                  break;
               case DATA_CHAR_ARRAY:
                  data->value(&char_val);
                  sprintf(buff2, "\"%s\"", char_val);
                  break;
               case DATA_BLANK:
                  sprintf(buff2, "\"\"");
                  break;
            }

            bv++;
            if( bv != ev )
            {
               strcat(buff, buff2);
               strcat(buff, ",");
            }
            else
               strcat(buff, buff2);
         }

         num_values = max_num_fields - var_values.size();
         
         if( var_values.size() )
         {
	    for(int i = 0; i < num_values; i++)
	       strcat(buff, ", NULL");
         }
         else
         {
            strcat(buff, "NULL");
	    for(int i = 1; i < num_values; i++)
	       strcat(buff, ", NULL");
         }

         sprintf(buff2, ", %u)", imp_obj->contactBinType);
         strcat(buff, buff2);

         num_cards++;
         bc++;

         if( num_cards < 10 && bc != ec )
         {
            sprintf(buff2, ", (NULL, %u,", kw_type);
            strcat(buff, buff2);
         }
         else
         {
            strcat(buff, ";");
            num_cards = 0;
	    //create_query = buff;
//cout << "QUERY=" << buff << endl;
	    if( goldenConn->executeQuery( buff ) )
	    {
	       cout << goldenConn->error() << endl;
	       return 6;
	    }
         }
      }

      buff2[0] = '\0';
      getNullFields(max_num_fields, buff2);
      sprintf(buff, "%s%u, \"$\"%s);", buff1, kw_type, buff2);
      //create_query = buff;
//cout << "NULL QUERY = " << create_query << endl;

      if( goldenConn->executeQuery( buff ) )
      {
	 cout << goldenConn->error() << endl;
	 return 6;
      }
      b++;
   }

   return 0;
}

void FePutDB::getNullFields(int & num_val, char *buff)
{
   for(int i = 0; i < num_val; i++)
   {
      strcat(buff, ", NULL");
   }
}

int FePutDB::insertModelDetailsIntoDB
    (
       const char *kw, 
       const char *title, 
       const char *descr
    )
{
   string    table_name = "FE_MODELS";
   string    create_query = ("CREATE TABLE IF NOT EXISTS ");
   create_query += table_name;
   create_query += " (MODEL_INDEX int not null primary key auto_increment, MODEL_NAME varchar(256), KEYWORD varchar(80), TITLE varchar(256), DESCRIPTION varchar(256), AIRBAGS int, ALES int, BOUNDARYS int, COMPONENTS int, CONSTRAINEDS int, CONTACTS int, CONTROLS int, DAMPINGS int, DATABASES int, DEFINES int, DEFORMABLES int, EFS int, ELEMENTS int, EOSS int, HOURGLASSS int, INCLUDES int, INITIALS int, INTEGRATIONS int, INTERFACES int, LOADS int, MATS int, NODES int, PARAMETERS int, PARTS int, PERTURBATIONS int, RAILS int, RIGIDWALLS int, SECTIONS int, SENSORS int, SETS int, TERMINATIONS int, USERS int);";

   if( goldenConn->executeQuery( create_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 4;
   }

   int num_ctrls, num_dbs, num_mats, num_secs, num_eoss, num_hgs, num_parts,
       num_nodes, num_elms, num_defs, num_consts, num_cnts, num_abs, num_ales,
       num_bdrys, num_comps, num_damps, num_deforms, num_efs, num_incs,
       num_inits, num_integs, num_inters, num_loads, num_params, num_perts,
       num_rails, num_rws, num_sensors, num_sets, num_users, num_terms;

   Manager *man_ptr = ControlManager::create();
   num_ctrls = man_ptr->length();

   man_ptr = DatabaseManager::create();
   num_dbs = man_ptr->length();

   man_ptr = MatManager::create();
   num_mats = man_ptr->length();

   man_ptr = SectionManager::create();
   num_secs = man_ptr->length();

   man_ptr = EosManager::create();
   num_eoss = man_ptr->length();

   man_ptr = HgManager::create();
   num_hgs = man_ptr->length();

   man_ptr = PartCManager::create();
   num_parts = man_ptr->length();

   man_ptr = NodManager::create();
   num_nodes = man_ptr->length();

   man_ptr = ElementManager::create();
   num_elms = man_ptr->length();

   man_ptr = DefineManager::create();
   num_defs = man_ptr->length();

   man_ptr = ConstManager::create();
   num_consts = man_ptr->length();

   man_ptr = ContactManager::create();
   num_cnts = man_ptr->length();

   man_ptr = AirbagManager::create();
   num_abs = man_ptr->length();

   man_ptr = ALEManager::create();
   num_ales = man_ptr->length();

   man_ptr = BdryManager::create();
   num_bdrys = man_ptr->length();

   man_ptr = CompManager::create();
   num_comps = man_ptr->length();

   man_ptr = DampingManager::create();
   num_damps = man_ptr->length();

   man_ptr = DeformManager::create();
   num_deforms = man_ptr->length();

   man_ptr = EFManager::create();
   num_efs = man_ptr->length();

   man_ptr = IncludeManager::create();
   num_incs = man_ptr->length();

   man_ptr = InitialManager::create();
   num_inits = man_ptr->length();

   man_ptr = IntegrationManager::create();
   num_integs = man_ptr->length();

   man_ptr = InterfaceManager::create();
   num_inters = man_ptr->length();

   man_ptr = LoadManager::create();
   num_loads = man_ptr->length();

   man_ptr = ParameterManager::create();
   num_params = man_ptr->length();

   man_ptr = PerturbManager::create();
   num_perts = man_ptr->length();

   man_ptr = RailManager::create();
   num_rails = man_ptr->length();

   man_ptr = RigidwallManager::create();
   num_rws = man_ptr->length();

   man_ptr = SensorManager::create();
   num_sensors = man_ptr->length();

   man_ptr = SetManager::create();
   num_sets = man_ptr->length();

   man_ptr = UserManager::create();
   num_users = man_ptr->length();

   man_ptr = TermManager::create();
   num_terms = man_ptr->length();

   string insert_query = "INSERT INTO ";
   insert_query += table_name;
   insert_query += " VALUES (NULL,\"";
   insert_query += modelName;
   insert_query += "\",\"";
   insert_query += kw;
   insert_query += "\",\"";
   insert_query += title;
   insert_query += "\",\"";
   insert_query += descr;
   insert_query += "\",";

   char buff[1024];

   //create_query += " (MODEL_INDEX int not null primary key auto_increment, MODEL_NAME varchar(256), TITLE varchar(256), DESCRIPTION varchar(256), AIRBAGS int, ALES int, BOUNDARYS int, COMPONENTS int, CONSTRAINEDS int, CONTACTS int, CONTROLS int, DAMPINGS int, DATABASES int, DEFINES int, DEFORMABLES int, EFS int, ELEMENTS int, EOSS int, HOURGLASSS int, INCLUDES int, INITIALS int, INTEGRATIONS int, INTERFACES int, LOADS int, MATS int, NODES int, PARAMETERS int, PARTS int, PERTURBATIONS int, RAILS int, RIGIDWALLS int, SECTIONS int, SENSORS int, SETS int, TERMINATIONS int, USERS int);";

   sprintf(buff, "%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,"
       "%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d);", 
       num_abs, num_ales, num_bdrys, num_comps, num_consts, num_cnts, num_ctrls,
       num_damps, num_dbs, num_defs, num_deforms, num_efs, num_elms, num_eoss, 
       num_hgs, num_incs, num_inits, num_integs, num_inters, num_loads, 
       num_mats, num_nodes, num_params, num_parts, num_perts, num_rails, 
       num_rws, num_secs, num_sensors, num_sets, num_terms, num_users);

   insert_query += buff;

cout << "INSERT QUERY = " << insert_query << endl;

   if( goldenConn->executeQuery( insert_query.data(), false ) )
   {
      cout << goldenConn->error() << endl;
      return 5;
   }

   return 0;
}

