#include "oglcmds.h"
#include "stdio.h"

void OglCmds::getInitCmds
(
   unsigned int wh[2],
   float exts[6],
   string & cmds_string
)
{
   char buff[512];

   sprintf(buff, "glCanvas.viewport(0,0,%u,%u);\n", wh[0], wh[1]);
   cmds_string += buff;
   cmds_string += "glCanvas.viewport(0,0,0.0,1.0);\n";
   cmds_string += "glCanvas.clearColor(0.0,0.0,0.0,1.0);\n";

   cmds_string += "glCanvas.clear(glCanvas.COLOR_BUFFER_BIT|glCanvas.DEPTH_BUFFER_BIT);\n";
   cmds_string += "glCanvas.enable(glCanvas.DEPTH_TEST);\n";
   cmds_string += "glCanvas.useProgram(shaderProgram);\n";

   sprintf(buff, "mat4.ortho(%g,%g,%g,%g,-99999,99999, pMatrix);\n",
	            exts[0], exts[1], exts[2], exts[3]);
   cmds_string += buff;
   cmds_string += "mat4.identity(mvMatrix);\n";
   sprintf(buff, "mat4.fromRotationTranslation(mvMatrix,[-90,0,-180,0],[%g,0,%g]);\n", -(exts[1]+exts[0]), (exts[4]-exts[5])/2.0);
   cmds_string += buff;
}

void OglCmds::getPartCmd
     (
        unsigned int & part_index,
	string & cmds_string,
        unsigned int draw_type
     )
{
   char buff[512];

   sprintf(buff, "pCB%d=createColorBuffer(%s[%d][0],%s[%d][1],%s[%d][2],%s[%d][3],%s%d.length);\n", part_index, PART_COLOR_ARRAY_NAME, part_index, 
      PART_COLOR_ARRAY_NAME, part_index, PART_COLOR_ARRAY_NAME, part_index, 
      PART_COLOR_ARRAY_NAME, part_index, PART_NODES_ARRAY_NAME, part_index);
   cmds_string += buff;

   sprintf(buff,
	"glCanvas.vertexAttribPointer(shader.vPos,3,glCanvas.FLOAT,%s%d);\n", 
				PART_NODES_ARRAY_NAME, part_index);
   cmds_string += buff;
   switch( draw_type )
   {
      case GL_QUADS:
         sprintf(buff, "glCanvas.drawElements(glCanvas.QUADS,"
	   "%s%d.length,%s%d);\n", PART_SHELLS_ARRAY_NAME, 
                part_index, PART_SHELLS_ARRAY_NAME, part_index);
      break;
      case GL_TRIANGLE_STRIP:
         sprintf(buff, "glCanvas.drawElements(glCanvas.TRIANGLE_STRIP,"
	   "%s%d.length,%s%d);\n", PART_SHELLS_ARRAY_NAME,
		part_index, PART_SHELLS_ARRAY_NAME, part_index);
      break;
      case GL_TRIANGLES:
         sprintf(buff, "glCanvas.drawElements(glCanvas.TRIANGLES,"
	   "%s%d.length,%s%d);\n", PART_SHELLS_ARRAY_NAME,
		part_index, PART_SHELLS_ARRAY_NAME, part_index);
      break;
   }

   cmds_string += buff;
}

void OglCmds::getEndCmds
(
   string & cmds_string
)
{
   cmds_string += "glCanvas.popMatrix();\n";
   cmds_string += "glCanvas.disableClientState(glCanvas.VERTEX_ARRAY);\n";
   cmds_string += "glCanvas.swapBuffers();\n";
}

