#ifndef _SOLID_H_
#define _SOLID_H_

#include "element.h"

class Solid : public Element
{
   public:

   friend std::ostream & operator<<(std::ostream & os, Solid *ptr)
   {
      os << "PID = " << ptr->pID << endl
	      << "N1 = " << ptr->NIDList[0] << endl
	      << "N2 = " << ptr->NIDList[1] << endl
	      << "N3 = " << ptr->NIDList[2] << endl
	      << "N4 = " << ptr->NIDList[3] << endl
         << "N5 = " << ptr->NIDList[4] << endl
	      << "N6 = " << ptr->NIDList[5] << endl
	      << "N7 = " << ptr->NIDList[6] << endl
	      << "N8 = " << ptr->NIDList[7] << endl;
      return os;
   }

   unsigned int getNumNodes()
   {
      return 8;
   }


   ~Solid()
   {
   }

   const unsigned int *getNodeIDList()
   {
      return NIDList;
   }

   Node **getNodePtrList()
   {
      return nodePtrList;
   }

   Solid(char *_id, char *_pid, char *n1, char *n2, char *n3, char *n4, char *n5, char *n6, char *n7, char *n8, unsigned int nodeOff)
   {
      ID = atoi(_id);
      pID = atoi(_pid);
      NIDList[0] = atoi(n1) + nodeOff;
      NIDList[1] = atoi(n2) + nodeOff;
      NIDList[2] = atoi(n3) + nodeOff;
      NIDList[3] = atoi(n4) + nodeOff;
      NIDList[4] = atoi(n5) + nodeOff;
      NIDList[5] = atoi(n6) + nodeOff;
      if(n7)
         NIDList[6] = atoi(n7) + nodeOff;
      else
         NIDList[6] = 0;
      if(n8)
         NIDList[7] = atoi(n8) + nodeOff;
      else
         NIDList[7] = 0;
   }

   Solid(unsigned int _id, unsigned int _pid, unsigned int n1, unsigned int n2, unsigned int n3, unsigned int n4, unsigned int n5, unsigned int n6, unsigned int n7, unsigned int n8, unsigned int nodeOff)
   {
      ID = (_id);
      pID = (_pid);
      NIDList[0] = (n1) + nodeOff;
      NIDList[1] = (n2) + nodeOff;
      NIDList[2] = (n3) + nodeOff;
      NIDList[3] = (n4) + nodeOff;
      NIDList[4] = (n5) + nodeOff;
      NIDList[5] = (n6) + nodeOff;
      NIDList[6] = (n7) + nodeOff;
      NIDList[7] = (n8) + nodeOff;
   }

public:
   int      numNodes;
   Node		*nodePtrList[8];
   unsigned int	NIDList[8];
};

#endif
