#include "oglcmds.h"
#include <math.h>
#include <fstream>
#include <iostream>

int OglCmds::writeOglCmds
    (
       int      num_parts,
       double   exts[6],
       string   & cmds_string
    )
{
   int     j = 0;
   char    buff[256];

   cmds_string += "function drawModel()\n";  

   cmds_string += "{\n";
   cmds_string += "   if( xmlHttp.readyState != 4 )\n";
   cmds_string += "      return;\n";
   cmds_string += 
       "   gl = document.getElementById('canvas').getContext('moz-gles11');\n";
   cmds_string += "   gl.clearColor(0.0, 0.0, 0.0, 1.0);\n";

   cmds_string += "   gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_TEST);\n";

   sprintf(buff, "   gl.viewport(0, 0, %d, %d);\n", (int)1000, (int)600);
   cmds_string += buff;

   cmds_string += "   gl.matrixMode(gl.PROJECTION);\n";
   cmds_string += "   gl.loadIdentity();\n";
   sprintf(buff, "   gl.ortho(%lf, %lf, %lf, %lf, 999999.0, -999999.0);\n",
	            exts[1], exts[0], exts[2], exts[3]);
   cmds_string += buff;
   cmds_string += "   gl.matrixMode(gl.MODELVIEW);\n";
   cmds_string += "   gl.loadIdentity();\n";

   cmds_string += "   gl.rotate(rotX, 1.0, 0.0, 0.0);\n";
   cmds_string += "   gl.rotate(rotY, 0.0, 1.0, 0.0);\n";
   cmds_string += "   gl.rotate(rotZ, 0.0, 0.0, 1.0);\n";

   cmds_string += "   gl.shadeModel(gl.FLAT);\n";
   cmds_string += "   gl.enableClientState(gl.VERTEX_ARRAY);\n\n";

   double rcolor = 0.4, gcolor = 0.6, bcolor = 0.7;

   for(int i = 0; i < num_parts; i++)
   {
      j = i + 1;
      sprintf(buff, 
	   "   gl.color(%lf, %lf, %lf, 1.0);\n", rcolor, gcolor, bcolor);
      cmds_string += buff;
      sprintf(buff,
	   "   gl.vertexPointer(3, gl.FLOAT, part%d_nodes_array);\n", j);
      cmds_string += buff;
      sprintf(buff, "   gl.drawElements(gl.TRIANGLE_STRIP, "
		"4 * part%d_num_elms, part%d_elms_array);\n\n", j, j);
      cmds_string += buff;

      rcolor += 0.1;gcolor += 0.2;bcolor += 0.1;
      if(rcolor >= 1.0) rcolor = 0.4;
      if(gcolor >= 1.0) gcolor = 0.3;
      if(bcolor >= 1.0) bcolor = 0.5;
   }

   cmds_string += "   gl.disableClientState(gl.VERTEX_ARRAY);\n";
   cmds_string += "   gl.swapBuffers();\n";
   cmds_string += "}\n";

   return 0;
}

