#include <iostream>
#include <time.h>
#include <set>
#include "alemanager.h"
#include "aleexport.h"
#include "aleimport.h"
#include "myconnection.h"
#include "filepath.h"
#include "filegeneric.h"
#include "dynatobin.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: ale dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   FilePath::set(argv[1], argv[2]);
   unsigned int ale_type = ALE_NEW_TYPE, ale_id;
   string select_query, model_name, kw_name = "*ALE";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      ale_type = ALEImport::getALETypeFromKeyword(kw_name.data(), &ale_id);
   }

   int file_idx = getFileName(argv[2], model_name);Card::setFlag(SAVE_IDS|SAVE_REFERENCES);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_ALES\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      delete goldenConn;
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No ale table for model=" << argv[2] << endl;
      delete goldenConn;
      return 3;
   }

   TransformStr trans_str;
   if( file_idx )
   {
      getTransformPtr(FilePath::fPath, file_idx, &trans_str);
      FilePath::setTransPtr(&trans_str);
   }

   ALEManager *ale_man = ALEManager::create();
   ALEExport ale_exp((char *)model_name.data(), goldenConn, ale_man);

   int num_ale = ale_exp.dbReadALEs();

   if( !num_ale )
   {
cout << "WARNING: No ale available for model<" << argv[2] << ">\n";
      ALEManager::reset();FilePath::closeIDFile();
      delete goldenConn;
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], ale_man);
   dtob.write("ale");

   FilePath::closeIDFile();
   FilePath::closeFile();
   ALEManager::reset();
   delete goldenConn;

   time(&t2);
   cout << "TIME FOR ALE FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

