#include <iostream>
#include <time.h>
#include <set>
#include "compmanager.h"
#include "compexport.h"
#include "compimport.h"
#include "myconnection.h"
#include "filepath.h"
#include "filegeneric.h"
#include "dynatobin.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: component dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   FilePath::set(argv[1], argv[2]);
   unsigned int comp_type = COMP_NEW_TYPE, comp_id;
   string select_query, model_name, kw_name = "*COMPONENT";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      comp_type = CompImport::getCompTypeFromKeyword(kw_name.data(), &comp_id);
   }

   int file_idx = getFileName(argv[2], model_name);Card::setFlag(SAVE_IDS|SAVE_REFERENCES);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_COMPONENTS\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      delete goldenConn;
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No component table for model=" << argv[2] << endl;
      delete goldenConn;
      return 3;
   }

   TransformStr trans_str;
   if( file_idx )
   {
      getTransformPtr(FilePath::fPath, file_idx, &trans_str);
      FilePath::setTransPtr(&trans_str);
   }

   CompManager *comp_man = CompManager::create();
   CompExport comp_exp((char *)model_name.data(), goldenConn, comp_man);

   int num_comp = comp_exp.dbReadComps();

   if( !num_comp )
   {
cout << "WARNING: No component available for model<" << argv[2] << ">\n";
      delete goldenConn;
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], comp_man);
   dtob.write("component");

   FilePath::closeIDFile();
   FilePath::closeFile();
   CompManager::reset();
   delete goldenConn;

   time(&t2);
   cout << "TIME FOR COMPONENTS FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

