#include <iostream>
#include <time.h>
#include <set>
#include "constmanager.h"
#include "constexport.h"
#include "constimport.h"
#include "myconnection.h"
#include "filepath.h"
#include "filegeneric.h"
#include "dynatobin.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: constrained dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   FilePath::set(argv[1], argv[2]);
   unsigned int const_type = CONST_NEW_TYPE, const_id;
   string select_query, model_name, kw_name = "*CONSTRAINED";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      const_type = ConstImport::getConstTypeFromKeyword(
                                           kw_name.data(), &const_id);
   }

   int file_idx = getFileName(argv[2], model_name);Card::setFlag(SAVE_IDS|SAVE_REFERENCES);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_CONSTRAINEDS\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      delete goldenConn;
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No constrained table for model=" << argv[2] << endl;
      delete goldenConn;
      return 3;
   }

   TransformStr trans_str;
   if( file_idx )
   {
      getTransformPtr(FilePath::fPath, file_idx, &trans_str);
      FilePath::setTransPtr(&trans_str);
   }

   ConstManager *const_man = ConstManager::create();
   ConstExport const_exp((char *)model_name.data(), goldenConn, const_man);

   int num_const = const_exp.dbReadConsts();

   if( !num_const )
   {
cout << "WARNING: No constrained available for model<" << argv[2] << ">\n";
      delete goldenConn;
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], const_man);
   dtob.write("constrained");

   FilePath::closeIDFile();
   FilePath::closeFile();

   ConstManager::reset();
   delete goldenConn;

   time(&t2);
   cout << "TIME FOR CONSTRAINED FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

