#include <iostream>
#include <time.h>
#include <set>
#include "contactmanager.h"
#include "contactexport.h"
#include "contactimport.h"
#include "myconnection.h"
#include "filepath.h"
#include "filegeneric.h"
#include "dynatobin.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: contact dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   FilePath::set(argv[1], argv[2]);
   unsigned int contact_type = CONTACT_NEW_TYPE, contact_id;
   string select_query, model_name, kw_name = "*CONTACT";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      contact_type = ContactImport::getContactTypeFromKeyword(
                                           kw_name.data(), &contact_id);
   }

   int file_idx = getFileName(argv[2], model_name);Card::setFlag(SAVE_IDS|SAVE_REFERENCES);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_CONTACTS\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      delete goldenConn;
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No contact table for model=" << argv[2] << endl;
      delete goldenConn;
      return 3;
   }

   TransformStr trans_str;
   if( file_idx )
   {
      getTransformPtr(FilePath::fPath, file_idx, &trans_str);
      FilePath::setTransPtr(&trans_str);
   }

   ContactManager *contact_man = ContactManager::create();
   ContactExport contact_exp((char *)model_name.data(),goldenConn,contact_man);

   int num_contact = contact_exp.dbReadContacts();

   if( !num_contact )
   {
cout << "WARNING: No contact available for model<" << argv[2] << ">\n";
      delete goldenConn;
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], contact_man);
   dtob.write("contact");

   FilePath::closeIDFile();
   FilePath::closeFile();
   ContactManager::reset();
   delete goldenConn;

   time(&t2);
   cout << "TIME FOR CONTACTS FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

