#include <iostream>
#include <time.h>
#include <set>
#include "databasemanager.h"
#include "databaseexport.h"
#include "databaseimport.h"
#include "myconnection.h"
#include "filepath.h"
#include "filegeneric.h"
#include "dynatobin.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: database dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   FilePath::set(argv[1], argv[2]);
   unsigned int database_type = DATABASE_NEW_TYPE, database_id;
   string select_query, model_name, kw_name = "*DATABASE";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      database_type = DatabaseImport::getDatabaseTypeFromKeyword(
                                        kw_name.data(), &database_id);
   }

   int file_idx = getFileName(argv[2], model_name);Card::setFlag(SAVE_IDS|SAVE_REFERENCES);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_DATABASES\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      delete goldenConn;
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No database table for model=" << argv[2] << endl;
      delete goldenConn;
      return 3;
   }

   TransformStr trans_str;
   if( file_idx )
   {
      getTransformPtr(FilePath::fPath, file_idx, &trans_str);
      FilePath::setTransPtr(&trans_str);
   }

   DatabaseManager *database_man = DatabaseManager::create();
   DatabaseExport database_exp((char *)model_name.data(), goldenConn, database_man);

   int num_database = database_exp.dbReadDatabases();

   if( !num_database )
   {
cout << "WARNING: No database available for model<" << argv[2] << ">\n";
      delete goldenConn;
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], database_man);
   dtob.write("database");

   FilePath::closeIDFile();
   FilePath::closeFile();
   DatabaseManager::reset();
   delete goldenConn;

   time(&t2);
   cout << "TIME FOR DATABASE FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

