#include <iostream>
#include <time.h>
#include <set>
#include "elementmanager.h"
#include "elementexport.h"
#include "elementimport.h"
#include "myconnection.h"
#include "myconnection.h"
#include "filepath.h"
#include "filegeneric.h"
#include "dynatobin.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: element dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;
   
   FilePath::set(argv[1], argv[2]);
   unsigned int element_type = ELEMENT_NEW_TYPE, element_id, count=1000, offset=0;
   string select_query, model_name, kw_name = "*ELEMENT";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      element_type = ElementImport::getElementTypeFromKeyword(
                                            kw_name.data(), &element_id);
   }

   if( argc > 4 )
      count = atoi(argv[4]);

   if( argc > 5 )
      offset = atoi(argv[5]);

   int file_idx = getFileName(argv[2], model_name);Card::setFlag(SAVE_IDS|SAVE_REFERENCES);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_ELEMENTS\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      delete goldenConn;
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No element table for model=" << argv[2] << endl;
      delete goldenConn;
      return 3;
   }

   TransformStr trans_str;
   if( file_idx )
   {
      getTransformPtr(FilePath::fPath, file_idx, &trans_str);
      FilePath::setTransPtr(&trans_str);
   }

   ElementManager *element_man = ElementManager::create();
   ElementExport element_exp((char *)model_name.data(),goldenConn,element_man);

   StrUIMap kws_types;
   element_exp.getElementTypes(&kws_types);

   StrUIIter b = kws_types.begin(), e = kws_types.end(), iter;
   iter = kws_types.find(kw_name);
   if( iter == e )
   {
      element_type = b->second;
      kw_name = b->first;
   }
cout << "KW_NAME" << kw_name << endl;

   char buf[128];
   unsigned int total_elms = 1000;

   select_query = "select count(card_index) from `";
   select_query += model_name;
   select_query += "_ELEMENTS`";
   sprintf(buf, " where kw_type=%u;", element_type);
   select_query += buf;

cout << "COUNT QRY=" << select_query << endl;

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      delete goldenConn;
      return 2;
   }

   char **row = goldenConn->nextRow();
   total_elms = atoi(row[0]);
  
   if( !total_elms )
   {
cout << "WARNING: No elements available for model<" << argv[2] << ">\n";
      delete goldenConn;
      return 4;
   }

   //element_exp.dbReadElements(total_elms, offset, element_type, &kws_types);
   element_exp.dbReadElementsBySequence();

   DynaToBin dtob(argv[1], argv[2], element_man);
   dtob.write("element");

   FilePath::closeIDFile();
   FilePath::closeFile();
   ElementManager::reset();
   delete goldenConn;

   time(&t2);
   cout << "TIME FOR ELEMENT FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

