#include <iostream>
#include <time.h>
#include <set>
#include "hgmanager.h"
#include "hgexport.h"
#include "hgimport.h"
#include "myconnection.h"
#include "filepath.h"
#include "filegeneric.h"
#include "dynatobin.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: hg dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   FilePath::set(argv[1], argv[2]);
   unsigned int hg_type = HG_NEW_TYPE;
   string select_query, model_name, kw_name = "*HOURGLASS";

   if( argc > 3 )
   {
      hg_type = HOURGLASS;
      if( strstr(argv[3], "_TITL") )
         hg_type += TITLE_CARD;
   }

   int file_idx = getFileName(argv[2], model_name);Card::setFlag(SAVE_IDS|SAVE_REFERENCES);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_HOURGLASSS\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      delete goldenConn;
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
      cout << "WARNING: No hg table for model=" << argv[2] << endl;
      delete goldenConn;
      return 3;
   }

   TransformStr trans_str;
   if( file_idx )
   {
      getTransformPtr(FilePath::fPath, file_idx, &trans_str);
      FilePath::setTransPtr(&trans_str);
   }

   HgManager *hg_man = HgManager::create();
   HgExport hg_exp((char *)model_name.data(), goldenConn, hg_man);

   int num_hg = hg_exp.dbReadHgs();

   if( !num_hg )
   {
      cout << "WARNING: No hg available for model<" << argv[2] << ">\n";
      delete goldenConn;
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], hg_man);
   dtob.write("hourglass");

   FilePath::closeIDFile();
   FilePath::closeFile();
   HgManager::reset();
   delete goldenConn;

   time(&t2);
   cout << "TIME FOR HG FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

