#include <iostream>
#include <time.h>
#include <set>
#include "includemanager.h"
#include "includeexport.h"
#include "includeimport.h"
#include "myconnection.h"
#include "filepath.h"
#include "filegeneric.h"
#include "dynatobin.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: include dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   FilePath::set(argv[1], argv[2]);
   unsigned int include_type = INCLUDE_NEW_TYPE, include_id;
   string kw_name = "*INCLUDE", select_query, model_name;

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      include_type = IncludeImport::getIncludeTypeFromKeyword(
                                          kw_name.data(), &include_id);
   }

   int file_idx = getFileName(argv[2], model_name);Card::setFlag(SAVE_IDS|SAVE_REFERENCES);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_INCLUDES\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      delete goldenConn;
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
      cout << "WARNING: No include table for model=" << argv[2] << endl;
      delete goldenConn;
      return 3;
   }

   TransformStr trans_str;
   if( file_idx )
   {
      getTransformPtr(FilePath::fPath, file_idx, &trans_str);
      FilePath::setTransPtr(&trans_str);
   }

   IncludeManager *include_man = IncludeManager::create();
   IncludeExport include_exp((char *)model_name.data(), goldenConn,include_man);

   int num_include = include_exp.dbReadIncludes();

   if( !num_include )
   {
      cout << "WARNING: No include available for model<" << argv[2] << ">\n";
      delete goldenConn;
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], include_man);
   dtob.write("include");

   FilePath::closeIDFile();
   FilePath::closeFile();
   IncludeManager::reset();
   delete goldenConn;

   time(&t2);
   cout << "TIME FOR INCLUDE FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

