#include <iostream>
#include <time.h>
#include <set>
#include "interfacemanager.h"
#include "interfaceexport.h"
#include "interfaceimport.h"
#include "myconnection.h"
#include "filepath.h"
#include "filegeneric.h"
#include "dynatobin.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: interface dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   FilePath::set(argv[1], argv[2]);
   unsigned int interface_type = INTERFACE_NEW_TYPE, interface_id;
   string select_query, model_name, kw_name = "*INTERFACE";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      interface_type = InterfaceImport::getInterfaceTypeFromKeyword(
                                       kw_name.data(), &interface_id);
   }

   int file_idx = getFileName(argv[2], model_name);Card::setFlag(SAVE_IDS|SAVE_REFERENCES);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_INTERFACES\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      delete goldenConn;
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No interface table for model=" << argv[2] << endl;
      delete goldenConn;
      return 3;
   }

   TransformStr trans_str;
   if( file_idx )
   {
      getTransformPtr(FilePath::fPath, file_idx, &trans_str);
      FilePath::setTransPtr(&trans_str);
   }

   InterfaceManager *interface_man = InterfaceManager::create();
   InterfaceExport interface_exp((char *)model_name.data(), goldenConn, interface_man);

   int num_interface = interface_exp.dbReadInterfaces();

   if( !num_interface )
   {
cout << "WARNING: No interface available for model<" << argv[2] << ">\n";
      delete goldenConn;
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], interface_man);
   dtob.write("interface");

   FilePath::closeIDFile();
   FilePath::closeFile();
   InterfaceManager::reset();
   delete goldenConn;

   time(&t2);
   cout << "TIME FOR INTERFACE FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

