#include <iostream>
#include <time.h>
#include <set>
#include "loadmanager.h"
#include "loadexport.h"
#include "loadimport.h"
#include "myconnection.h"
#include "filepath.h"
#include "filegeneric.h"
#include "dynatobin.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: load dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   FilePath::set(argv[1], argv[2]);
   unsigned int load_type = LOAD_NEW_TYPE, load_id;
   string select_query, model_name, kw_name = "*LOAD";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      load_type = LoadImport::getLoadTypeFromKeyword(kw_name.data(), &load_id);
   }

   int file_idx = getFileName(argv[2], model_name);Card::setFlag(SAVE_IDS|SAVE_REFERENCES);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_LOADS\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      delete goldenConn;
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No load table for model=" << argv[2] << endl;
      delete goldenConn;
      return 3;
   }

   TransformStr trans_str;
   if( file_idx )
   {
      getTransformPtr(FilePath::fPath, file_idx, &trans_str);
      FilePath::setTransPtr(&trans_str);
   }

   LoadManager *load_man = LoadManager::create();
   LoadExport load_exp((char *)model_name.data(), goldenConn, load_man);

   int num_load = load_exp.dbReadLoads();

   if( !num_load )
   {
cout << "WARNING: No load available for model<" << argv[2] << ">\n";
      delete goldenConn;
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], load_man);
   dtob.write("load");

   FilePath::closeIDFile();
   FilePath::closeFile();
   LoadManager::reset();
   delete goldenConn;

   time(&t2);
   cout << "TIME FOR LOAD FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

