#include <iostream>
#include <time.h>
#include <set>
#include "nodmanager.h"
#include "nodexport.h"
#include "nodimport.h"
#include "myconnection.h"
#include "filepath.h"
#include "filegeneric.h"
#include "dynatobin.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: nod dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   FilePath::set(argv[1], argv[2]);
   unsigned int nod_type = NODE, nod_id, count = 1000, offset = 0;
   string select_query, model_name, kw_name = "*NODE";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      nod_type = NodImport::getNodTypeFromKeyword(kw_name.data(), &nod_id);
   }

   if( argc > 4 )
      count = atoi(argv[4]);
   if( argc > 5 )
      offset = atoi(argv[5]);

   int file_idx = getFileName(argv[2], model_name);Card::setFlag(SAVE_IDS|SAVE_REFERENCES);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_NODES\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      delete goldenConn;
      return 2;
   }

   if( !goldenConn->nextRow() )
   {
cout << "WARNING: No node table for model=" << argv[2] << endl;
      delete goldenConn;
      return 3;
   }

   select_query = "select count(card_index) from `";
   select_query += model_name;
   select_query += "_NODES`;";

cout << "COUNT QRY=" << select_query << endl;

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      delete goldenConn;
      return 2;
   }

   char **row = goldenConn->nextRow();
   unsigned int total_nodes = atoi(row[0]);
  
   if( !total_nodes )
   {
cout << "WARNING: No nodes available for model<" << argv[2] << ">\n";
      delete goldenConn;
      return 4;
   }

   TransformStr trans_str;
   if( file_idx )
   {
      getTransformPtr(FilePath::fPath, file_idx, &trans_str);
      FilePath::setTransPtr(&trans_str);
   }

   NodManager *nod_man = NodManager::create();
   NodExport nod_exp((char *)model_name.data(), goldenConn, nod_man);

   set<string> kw_list;
   nod_exp.dbReadNods(total_nodes, offset, nod_type, &kw_list);

   DynaToBin dtob(argv[1], argv[2], nod_man);
   dtob.write("nod");

   FilePath::closeIDFile();
   FilePath::closeFile();
   NodManager::reset();
   delete goldenConn;

   time(&t2);
   cout << "TIME FOR NODE FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

