#include <iostream>
#include <time.h>
#include <set>
#include "partcmanager.h"
#include "partcexport.h"
#include "partcimport.h"
#include "myconnection.h"
#include "filepath.h"
#include "filegeneric.h"
#include "dynatobin.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: partc dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   FilePath::set(argv[1], argv[2]);
   unsigned int partc_type = PARTC_NEW_TYPE, partc_bin;
   string select_query, model_name, kw_name = "*PART";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      partc_type = PartCImport::getPartCTypeFromKeyword(
                                        kw_name.data(), &partc_bin);
      if( partc_bin & (1 << PART) )
	 partc_type = partc_bin;
   }

   int file_idx = getFileName(argv[2], model_name);Card::setFlag(SAVE_IDS|SAVE_REFERENCES);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_PARTS\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      delete goldenConn;
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No partc table for model=" << argv[2] << endl;
      delete goldenConn;
      return 3;
   }

   TransformStr trans_str;
   if( file_idx )
   {
      getTransformPtr(FilePath::fPath, file_idx, &trans_str);
      FilePath::setTransPtr(&trans_str);
   }

   PartCManager *partc_man = PartCManager::create();
   PartCExport partc_exp((char *)model_name.data(), goldenConn, partc_man);

   int num_partc = partc_exp.dbReadPartCs();

   if( !num_partc )
   {
cout << "WARNING: No partc available for model<" << argv[2] << ">\n";
      delete goldenConn;
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], partc_man);
   dtob.write("part");

   FilePath::closeIDFile();
   FilePath::closeFile();
   PartCManager::reset();
   delete goldenConn;

   time(&t2);
   cout << "TIME FOR PART FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

