#include <iostream>
#include <time.h>
#include <set>
#include "railmanager.h"
#include "railexport.h"
#include "railimport.h"
#include "myconnection.h"
#include "filepath.h"
#include "filegeneric.h"
#include "dynatobin.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: rail dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   FilePath::set(argv[1], argv[2]);
   unsigned int rail_type = RAIL_NEW_TYPE, rail_id;
   string kw_name = "*RAIL", select_query, model_name;

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      rail_type = RailImport::getRailTypeFromKeyword(kw_name.data(), &rail_id);
   }

   int file_idx = getFileName(argv[2], model_name);Card::setFlag(SAVE_IDS|SAVE_REFERENCES);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_RAILS\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      delete goldenConn;
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No rail table for model=" << argv[2] << endl;
      delete goldenConn;
      return 3;
   }

   TransformStr trans_str;
   if( file_idx )
   {
      getTransformPtr(FilePath::fPath, file_idx, &trans_str);
      FilePath::setTransPtr(&trans_str);
   }

   RailManager *rail_man = RailManager::create();
   RailExport rail_exp((char *)model_name.data(), goldenConn, rail_man);

   int num_rail = rail_exp.dbReadRails();

   if( !num_rail )
   {
cout << "WARNING: No rail available for model<" << argv[2] << ">\n";
      delete goldenConn;
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], rail_man);
   dtob.write("rail");

   FilePath::closeIDFile();
   FilePath::closeFile();
   RailManager::reset();
   delete goldenConn;

   time(&t2);
   cout << "TIME FOR RAIL FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

