#include <iostream>
#include <time.h>
#include <set>
#include "sectionmanager.h"
#include "sectionexport.h"
#include "sectionimport.h"
#include "myconnection.h"
#include "filepath.h"
#include "filegeneric.h"
#include "dynatobin.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: section dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   FilePath::set(argv[1], argv[2]);
   unsigned int section_type = SECTION_NEW_TYPE, section_id;
   string kw_name = "*SECTION", select_query, model_name;

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      section_type = SectionImport::getSectionTypeFromKeyword(
                                           kw_name.data(), &section_id);
      if( strstr(kw_name.data(), "_TITL") )
         section_type += TITLE_CARD;
   }

   int file_idx = getFileName(argv[2], model_name);Card::setFlag(SAVE_IDS|SAVE_REFERENCES);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_SECTIONS\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      delete goldenConn;
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No section table for model=" << argv[2] << endl;
      delete goldenConn;
      return 3;
   }

   TransformStr trans_str;
   if( file_idx )
   {
      getTransformPtr(FilePath::fPath, file_idx, &trans_str);
      FilePath::setTransPtr(&trans_str);
   }

   SectionManager *section_man = SectionManager::create();
   SectionExport section_exp((char *)model_name.data(),goldenConn, section_man);

   int num_section = section_exp.dbReadSections();

   if( !num_section )
   {
cout << "WARNING: No section available for model<" << argv[2] << ">\n";
      delete goldenConn;
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], section_man);
   dtob.write("section");

   FilePath::closeIDFile();
   FilePath::closeFile();
   SectionManager::reset();
   delete goldenConn;

   time(&t2);
   cout << "TIME FOR SECTION FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

