#include <iostream>
#include <time.h>
#include <set>
#include "setmanager.h"
#include "setexport.h"
#include "setimport.h"
#include "myconnection.h"
#include "filepath.h"
#include "dynatobin.h"
#include "filegeneric.h"
#include "dynatobin.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: set dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   FilePath::set(argv[1], argv[2]);
   unsigned int set_type = SET_NEW_TYPE, set_id;
   string kw_name = "*SET", select_query, model_name;

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      set_type = SetImport::getSetTypeFromKeyword(kw_name.data(), &set_id);

      if( strstr(kw_name.data(), "_TITL") )
         set_type += TITLE_CARD;
   }

   int file_idx = getFileName(argv[2], model_name);Card::setFlag(SAVE_IDS|SAVE_REFERENCES);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_SETS\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      delete goldenConn;
      return 2;
   }

   if( !goldenConn->nextRow() )
   {
cout << "WARNING: No set table for model=" << argv[2] << endl;
      delete goldenConn;
      return 3;
   }

   TransformStr trans_str;
   if( file_idx )
   {
      getTransformPtr(FilePath::fPath, file_idx, &trans_str);
      FilePath::setTransPtr(&trans_str);
   }

   SetManager *set_man = SetManager::create();
   SetExport set_exp((char *)model_name.data(), goldenConn, set_man);

   int num_set = set_exp.dbReadSets();

   if( !num_set )
   {
cout << "WARNING: No set available for model<" << argv[2] << ">\n";
      delete goldenConn;
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], set_man);
   dtob.write("set");

   SetManager::reset();FilePath::closeIDFile();
   FilePath::closeFile();
   delete goldenConn;

   time(&t2);
   cout << "TIME FOR SET FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

