#include <iostream>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <libgen.h>
#include <sys/mman.h>
#include "bufio.h"
#include "fegetdb.h"
#include "manager_inc.h"
#include "export_inc.h"
#include "getincludes.h"
#include "myconnection.h"
#include "gentime.h"

unsigned int Card::contFlag = 0;
map<string, string> MyConnection::nvMap;

int exportEntities(const char *table_name, const char *out_file, GoldenConn *golden_conn)
{
   Manager           *man_ptr = NULL;
   string            kw_str;

   int wfd = open(out_file, O_RDWR|O_TRUNC|O_CREAT,
                        S_IRWXU|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH);

   if( wfd == -1 )
   {
      cout << "Unable to open file=" << out_file << endl;
      return 1;
   }

   FeGetDB get_db(table_name, golden_conn);

   BufFilePtr wbf = BufFileOpenWrite(wfd);
   //BufFileWrite(wbf, "*KEYWORD\n", 9);

   for(int i = 0; i < 32; i++) 
   {
      switch(i)
      {
	 case 0:
            cout << "NUM CTRLS = " << get_db.getControlsFromDB() << endl;
	    man_ptr = ControlManager::create();
            man_ptr->toFile(wbf);
	    ControlManager::reset();
	    break;
	 case 1:
            cout << "NUM DBS = " << get_db.getDatabasesFromDB() << endl;
	    man_ptr = DatabaseManager::create();
            man_ptr->toFile(wbf);
	    DatabaseManager::reset();
	    break;
         case 2:
            cout << "NUM MATS = " << get_db.getMatsFromDB() << endl;
            man_ptr = MatManager::create();
            man_ptr->toFile(wbf);
	    MatManager::reset();
            break;
	 case 3:
            cout << "NUM SECTIONS = " << get_db.getSectionsFromDB() << endl;
	    man_ptr = SectionManager::create();
            man_ptr->toFile(wbf);
	    SectionManager::reset();
	    break;
	 case 4:
            cout << "NUM EOSS = " << get_db.getEossFromDB() << endl;
	    man_ptr = EosManager::create();
            man_ptr->toFile(wbf);
	    EosManager::reset();
	    break;
         case 5:
            cout << "NUM HGS = " << get_db.getHgsFromDB() << endl;
            man_ptr = HgManager::create();
            man_ptr->toFile(wbf);
	    HgManager::reset();
            break;
	 case 6:
            cout << "NUM PARTS = " << get_db.getPartCsFromDB() << endl;
	    man_ptr = PartCManager::create();
            man_ptr->toFile(wbf);
	    PartCManager::reset();
	    break;
         case 7:
            cout << "NUM NODES = " << get_db.getNodesFromDB() << endl;
	    man_ptr = NodManager::create();
            man_ptr->toFile(wbf);
	    NodManager::reset();
            break;
	 case 8:
            cout << "NUM ELEMENTS = " << get_db.getElementsFromDB() << endl;
	    man_ptr = ElementManager::create();
            man_ptr->toFile(wbf);
	    ElementManager::reset();
	    break;
	 case 9:
            cout << "NUM DEFINES = " << get_db.getDefinesFromDB() << endl;
	    man_ptr = DefineManager::create();
            man_ptr->toFile(wbf);
	    DefineManager::reset();
	    break;
	 case 10:
            cout << "NUM CONSTRS = " << get_db.getConstsFromDB() << endl;
	    man_ptr = ConstManager::create();
            man_ptr->toFile(wbf);
	    ConstManager::reset();
	    break;
	 case 11:
            cout << "NUM CONTACTS = " << get_db.getContactsFromDB() << endl;
	    man_ptr = ContactManager::create();
            man_ptr->toFile(wbf);
	    ContactManager::reset();
	    break;
	 case 12:
            cout << "NUM AIRBAGS = " << get_db.getAirbagsFromDB() << endl;
	    man_ptr = AirbagManager::create();
            man_ptr->toFile(wbf);
	    AirbagManager::reset();
	    break;
	 case 13:
            cout << "NUM ALES = " << get_db.getAlesFromDB() << endl;
	    man_ptr = ALEManager::create();
            man_ptr->toFile(wbf);
	    ALEManager::reset();
	    break;
         case 14:
            cout << "NUM BDRYS = " << get_db.getBoundarysFromDB() << endl;
            man_ptr = BdryManager::create();
            man_ptr->toFile(wbf);
	    BdryManager::reset();
            break;
	 case 15:
            cout << "NUM COMPS = " << get_db.getComponentsFromDB() << endl;
	    man_ptr = CompManager::create();
            man_ptr->toFile(wbf);
	    CompManager::reset();
	    break;
	 case 16:
            cout << "NUM DAMPS = " << get_db.getDampingsFromDB() << endl;
	    man_ptr = DampingManager::create();
            man_ptr->toFile(wbf);
	    DampingManager::reset();
	    break;
	 case 17:
            cout << "NUM DEFORMS = " << get_db.getDeformsFromDB() << endl;
	    man_ptr = DeformManager::create();
            man_ptr->toFile(wbf);
	    DeformManager::reset();
	    break;
	 case 18:
            cout << "NUM EFS = " << get_db.getEfsFromDB() << endl;
	    man_ptr = EFManager::create();
            man_ptr->toFile(wbf);
	    EFManager::reset();
	    break;
	 case 19:
            cout << "NUM INCLUDES = " << get_db.getIncludesFromDB() << endl;
	    man_ptr = IncludeManager::create();
            man_ptr->toFile(wbf);
	    IncludeManager::reset();
	    break;
	 case 20:
            cout << "NUM INITIAL = " << get_db.getInitialsFromDB() << endl;
	    man_ptr = InitialManager::create();
            man_ptr->toFile(wbf);
	    InitialManager::reset();
	    break;
	 case 21:
            cout << "NUM INTEG = " << get_db.getIntegrationsFromDB() << endl;
	    man_ptr = IntegrationManager::create();
            man_ptr->toFile(wbf);
	    IntegrationManager::reset();
	    break;
	 case 22:
            cout << "NUM INTERFACE = " << get_db.getInterfacesFromDB() << endl;
	    man_ptr = InterfaceManager::create();
            man_ptr->toFile(wbf);
	    InterfaceManager::reset();
	    break;
         case 23:
            cout << "NUM LOADS = " << get_db.getLoadsFromDB() << endl;
            man_ptr = LoadManager::create();
            man_ptr->toFile(wbf);
	    LoadManager::reset();
            break;
	 case 24:
            cout << "NUM PARAMS = " << get_db.getParametersFromDB() << endl;
	    man_ptr = ParameterManager::create();
            man_ptr->toFile(wbf);
	    ParameterManager::reset();
	    break;
	 case 25:
            cout << "NUM PERTUBS = " << get_db.getPerturbsFromDB() << endl;
	    man_ptr = PerturbManager::create();
            man_ptr->toFile(wbf);
	    PerturbManager::reset();
	    break;
	 case 26:
            cout << "NUM RAILS = " << get_db.getRailsFromDB() << endl;
	    man_ptr = RailManager::create();
            man_ptr->toFile(wbf);
	    RailManager::reset();
	    break;
	 case 27:
            cout << "NUM RIGIDS = " << get_db.getRigidwallsFromDB() << endl;
	    man_ptr = RigidwallManager::create();
            man_ptr->toFile(wbf);
	    RigidwallManager::reset();
	    break;
	 case 28:
            cout << "NUM SENSORS = " << get_db.getSensorsFromDB() << endl;
	    man_ptr = SensorManager::create();
            man_ptr->toFile(wbf);
	    SensorManager::reset();
	    break;
	 case 29:
            cout << "NUM SETS = " << get_db.getSetsFromDB() << endl;
	    man_ptr = SetManager::create();
            man_ptr->toFile(wbf);
	    SetManager::reset();
	    break;
         case 30:
            cout << "NUM USERS = " << get_db.getUsersFromDB() << endl;
            man_ptr = UserManager::create();
            man_ptr->toFile(wbf);
	    UserManager::reset();
            break;
         case 31:
            cout << "NUM TERMS = " << get_db.getTermsFromDB() << endl;
            man_ptr = TermManager::create();
            man_ptr->toFile(wbf);
	    TermManager::reset();
            break;
      }

   }

   BufFileWrite(wbf, "*END\n", 5);

   BufFileClose(wbf, 1);
   close(wfd);

   return 0;
}

int main(int argc, char *argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: dbtodyna dir_name model_name\n";
      return 1;
   }

   GoldenConn *golden_conn = MyConnection::get();

   if( !golden_conn )
      return 1;

   char file_name[512], *dir_buf, dir[512];
   vector<string> files_list, tables_list;

   GetIncludesDB inc_db(argv[2], golden_conn);
   int num_incs = inc_db.fetchTablesAndFiles(&tables_list, &files_list);

cout << "NUM INCS=" << files_list.size() << endl;
cout << "NUM TABS=" << tables_list.size() << endl;

   Card::setFlag(SAVE_CARDS_FIELDS);
   for(int i = 0; i < num_incs; i++)
   {
cout << "FILE NAME=" << files_list[i] << endl;
cout << "TAB NAME=" <<  tables_list[i] << endl;
      sprintf(file_name, "%s/%s/%s", argv[1], argv[2], files_list[i].data());
      dir_buf = dirname(file_name);
cout << "DIR BUF=" << dir_buf << endl;
      if( access(dir_buf, W_OK) < 0 )
      {
         //mkdir(dir_buf, 0755);
         sprintf(dir, "mkdir -p %s", dir_buf);
cout << dir << endl;
         system(dir);
      }
      sprintf(file_name, "%s/%s/%s", argv[1], argv[2], files_list[i].data());
      exportEntities(tables_list[i].data(), file_name, golden_conn);
   }

   delete golden_conn;
}

