#include <iostream>
#include <time.h>
#include <set>
#include "airbagmanager.h"
#include "abexport.h"
#include "abimport.h"
#include "dbtohtmlgen.h"
#include "dynatobin.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: airbag dir_name model_name" << endl;
      return 1;
   }

   time_t	t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_airbag.php"; 
   FILE *fp = fopen(file_name.data(), "w");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      delete goldenConn;
      return 1;
   }

   unsigned int ab_type = AB_NEW_TYPE;
   int ab_id;
   string select_query, model_name, kw_name = "*AIRBAG";
   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      ab_type = ABImport::getAirbagTypeFromKeyword(kw_name.data(), &ab_id);
   }

   AirbagManager::reset();

   getFileName(argv[2], model_name);Card::setFlag(SAVE_CARDS_FIELDS);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_AIRBAGS\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*AIRBAG");
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No ab table for model=" << argv[2] << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*AIRBAG");
      return 3;
   }

   AirbagManager *ab_man = AirbagManager::create();
   ABExport ab_exp((char *)model_name.data(), goldenConn, ab_man);

   int num_ab = ab_exp.dbReadAirbags();

   if( !num_ab )
   {
cout << "WARNING: No ab available for model<" << argv[2] << ">\n";
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*AIRBAG");
      return 4;
   }

   unsigned int total = 0, edit_index = 0;
   string html_str, edit_str = "<?php\nfunction loadData($kw_short, $kw)\n{\n";
   ImportObject *imp_obj = NULL;

   if( argc > 6 )
      edit_index = atoi(argv[6]);

cout << "EDIT ID=" << edit_index << endl;

   DBToHtml dbtohtml(ab_man);
   imp_obj = dbtohtml.getJSCode(ab_type, kw_name, html_str, total, edit_index, &edit_str);
   edit_str += "}\n?>\n";
cout << "EDIT=" << edit_str << endl;

   if( imp_obj )
   {
      DynaToBin dtob(argv[1], argv[2], ab_man);
      dtob.write("airbag");
   }

   AirbagManager::reset();

   fputs(html_str.data(), fp);
   fclose(fp);
   delete goldenConn;

   file_name = argv[1];
   file_name += "/data.php";
   fp = fopen(file_name.data(), "w");
   fputs(edit_str.data(), fp);
   fclose(fp);

   time(&t2);
   cout << "TIME TAKEN TO READ DATA FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

