#include <iostream>
#include <time.h>
#include <set>
#include "definemanager.h"
#include "defineexport.h"
#include "defineimport.h"
#include "dbtohtmlgen.h"
#include "myconnection.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: define dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_define.php"; 
   FILE *fp = fopen(file_name.data(), "w");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      delete goldenConn;
      return 1;
   }

   unsigned int define_type = DEFINE_NEW_TYPE, define_id;
   string select_query, model_name, kw_name = "*DEFINE";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      define_type = DefineImport::getDefineTypeFromKeyword(
                                           kw_name.data(), &define_id);
      if( strstr(kw_name.data(), "_TITL") )
         define_type += TITLE_CARD; 
   }

   DefineManager::reset();
   getFileName(argv[2], model_name);Card::setFlag(SAVE_CARDS_FIELDS);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_DEFINES\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*DEFINE");
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No define table for model=" << argv[2] << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*DEFINE");
      return 3;
   }

   DefineManager *define_man = DefineManager::create();
   DefineExport define_exp((char *)model_name.data(), goldenConn, define_man);

   int num_define = define_exp.dbReadDefines();

cout << "NUM DEFINES=" << num_define << endl;

   if( !num_define )
   {
cout << "WARNING: No define available for model<" << argv[2] << ">\n";
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*DEFINE");
      return 4;
   }

   unsigned int total = 0, edit_index = 0;
   string html_str, edit_str = "<?php\nfunction loadData($kw_short, $kw)\n{\n";

   if( argc > 6 )
      edit_index = atoi(argv[6]);

cout << "EDIT ID=" << edit_index << endl;

   DBToHtml dbtohtml(define_man);
   dbtohtml.getJSCode(define_type, kw_name, html_str, total, edit_index, &edit_str);
   edit_str += "}\n?>\n";
cout << "EDIT=" << edit_str << endl;

   DefineManager::reset();

   fputs(html_str.data(), fp);
   fclose(fp);
   delete goldenConn;

   file_name = argv[1];
   file_name += "/data.php";
   fp = fopen(file_name.data(), "w");
   fputs(edit_str.data(), fp);
   fclose(fp);

   time(&t2);
   cout << "TIME FOR DEFINE FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

