#include <iostream>
#include <time.h>
#include <set>
#include "elementmanager.h"
#include "elementexport.h"
#include "elementimport.h"
#include "dbtohtmlgen.h"
#include "myconnection.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: element dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;
   
   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_element.php"; 
   FILE *fp = fopen(file_name.data(), "w");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      delete goldenConn;
      return 1;
   }

   unsigned int element_type = ELEMENT_NEW_TYPE, element_id, count=1000, offset=0;
   string select_query, model_name, kw_name = "*ELEMENT";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      element_type = ElementImport::getElementTypeFromKeyword(
                                            kw_name.data(), &element_id);
   }

   if( argc > 4 )
      count = atoi(argv[4]);

   if( argc > 5 )
      offset = atoi(argv[5]);

   ElementManager::reset();
   getFileName(argv[2], model_name);Card::setFlag(SAVE_CARDS_FIELDS);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_ELEMENTS\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*ELEMENT");
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No element table for model=" << argv[2] << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*ELEMENT");
      return 3;
   }

   ElementManager *element_man = ElementManager::create();
   ElementExport element_exp((char *)model_name.data(),goldenConn,element_man);

   StrUIMap kws_types;
   element_exp.getElementTypes(&kws_types);

   StrUIIter b = kws_types.begin(), e = kws_types.end(), iter;
   iter = kws_types.find(kw_name);
   if( iter == e )
   {
      element_type = b->second;
      kw_name = b->first;
   }
cout << "KW_NAME" << kw_name << endl;

   char buf[128];
   unsigned int total_elms = COUNT_LIMIT;

   select_query = "select count(card_index) from `";
   select_query += model_name;
   select_query += "_ELEMENTS`";
   sprintf(buf, " where kw_type=%u;", element_type);
   select_query += buf;

cout << "COUNT QRY=" << select_query << endl;

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*ELEMENT");
      return 2;
   }

   char **row = goldenConn->nextRow();
   total_elms = atoi(row[0]);
  
   if( !total_elms )
   {
cout << "WARNING: No elements available for model<" << argv[2] << ">\n";
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*ELEMENT");
      return 4;
   }

   element_exp.dbReadElements(count, offset, element_type, &kws_types);

   unsigned int edit_index = 0;
   string html_str, edit_str = "<?php\nfunction loadData($kw_short, $kw)\n{\n";

   if( argc > 6 )
      edit_index = atoi(argv[6]);

cout << "EDIT ID=" << edit_index << endl;

   DBToHtml dbtohtml(element_man, &kws_types);
   dbtohtml.getJSCode(element_type, kw_name, html_str, total_elms, edit_index, &edit_str);
   edit_str += "}\n?>\n";
cout << "EDIT=" << edit_str << endl;

   ElementManager::reset();

   fputs(html_str.data(), fp);
   fclose(fp);
   delete goldenConn;

   file_name = argv[1];
   file_name += "/data.php";
   fp = fopen(file_name.data(), "w");
   fputs(edit_str.data(), fp);
   fclose(fp);

   time(&t2);
   cout << "TIME FOR ELEMENT FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

