#include <iostream>
#include <time.h>
#include <set>
#include "partcmanager.h"
#include "partcexport.h"
#include "partcimport.h"
#include "dbtohtmlgen.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: partc dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_part.php"; 
   FILE *fp = fopen(file_name.data(), "w");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      delete goldenConn;
      return 1;
   }

   unsigned int partc_type = PARTC_NEW_TYPE, partc_bin;
   string select_query, model_name, kw_name = "*PART";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      partc_type = PartCImport::getPartCTypeFromKeyword(
                                        kw_name.data(), &partc_bin);
      if( partc_bin & (1 << PART) )
	 partc_type = partc_bin;
   }

   PartCManager::reset();
   getFileName(argv[2], model_name);Card::setFlag(SAVE_CARDS_FIELDS);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_PARTS\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*PART");
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No partc table for model=" << argv[2] << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*PART");
      return 3;
   }

   PartCManager *partc_man = PartCManager::create();
   PartCExport partc_exp((char *)model_name.data(), goldenConn, partc_man);

   int num_partc = partc_exp.dbReadPartCs();

   if( !num_partc )
   {
cout << "WARNING: No partc available for model<" << argv[2] << ">\n";
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*PART");
      return 4;
   }

   unsigned int total = 0, edit_index = 0;
   string html_str, edit_str = "<?php\nfunction loadData($kw_short, $kw)\n{\n";

   if( argc > 6 )
      edit_index = atoi(argv[6]);

cout << "EDIT ID=" << edit_index << endl;

   DBToHtml dbtohtml(partc_man);
   dbtohtml.getJSCode(partc_type, kw_name, html_str, total, edit_index, &edit_str);
   edit_str += "}\n?>\n";
cout << "EDIT=" << edit_str << endl;

   PartCManager::reset();

   fputs(html_str.data(), fp);
   fclose(fp);
   delete goldenConn;

   file_name = argv[1];
   file_name += "/data.php";
   fp = fopen(file_name.data(), "w");
   fputs(edit_str.data(), fp);
   fclose(fp);

   time(&t2);
   cout << "TIME FOR PART FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

