#include <iostream>
#include <time.h>
#include <set>
#include "railmanager.h"
#include "railexport.h"
#include "railimport.h"
#include "dbtohtmlgen.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: rail dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_rail.php"; 
   FILE *fp = fopen(file_name.data(), "w");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      delete goldenConn;
      return 1;
   }

   unsigned int rail_type = RAIL_NEW_TYPE, rail_id;
   string kw_name = "*RAIL", select_query, model_name;

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      rail_type = RailImport::getRailTypeFromKeyword(kw_name.data(), &rail_id);
   }

   RailManager::reset();
   getFileName(argv[2], model_name);Card::setFlag(SAVE_CARDS_FIELDS);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_RAILS\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*RAIL");
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No rail table for model=" << argv[2] << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*RAIL");
      return 3;
   }

   RailManager *rail_man = RailManager::create();
   RailExport rail_exp((char *)model_name.data(), goldenConn, rail_man);

   int num_rail = rail_exp.dbReadRails();

   if( !num_rail )
   {
cout << "WARNING: No rail available for model<" << argv[2] << ">\n";
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*RAIL");
      return 4;
   }

   unsigned int total = 0, edit_index = 0;
   string html_str, edit_str = "<?php\nfunction loadData($kw_short, $kw)\n{\n";

   if( argc > 6 )
      edit_index = atoi(argv[6]);

cout << "EDIT ID=" << edit_index << endl;

   DBToHtml dbtohtml(rail_man);
   dbtohtml.getJSCode(rail_type, kw_name, html_str, total, edit_index, &edit_str);
   edit_str += "}\n?>\n";
cout << "EDIT=" << edit_str << endl;

   RailManager::reset();

   fputs(html_str.data(), fp);
   fclose(fp);
   delete goldenConn;

   file_name = argv[1];
   file_name += "/data.php";
   fp = fopen(file_name.data(), "w");
   fputs(edit_str.data(), fp);
   fclose(fp);

   time(&t2);
   cout << "TIME FOR RAIL FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

