#include <iostream>
#include <time.h>
#include <set>
#include "setmanager.h"
#include "setexport.h"
#include "setimport.h"
#include "dbtohtmlgen.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: set dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_set.php"; 
   FILE *fp = fopen(file_name.data(), "w");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      delete goldenConn;
      return 1;
   }

   unsigned int set_type = SET_NEW_TYPE, set_id;
   string kw_name = "*SET", select_query, model_name;

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      set_type = SetImport::getSetTypeFromKeyword(kw_name.data(), &set_id);

      if( strstr(kw_name.data(), "_TITL") )
         set_type += TITLE_CARD;
   }

   SetManager::reset();
   getFileName(argv[2], model_name);
   //Card::setFlag(SAVE_CARDS_FIELDS|SAVE_IDS);
   Card::setFlag(SAVE_CARDS_FIELDS);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_SETS\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*SET");
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No set table for model=" << argv[2] << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*SET");
      return 3;
   }

   SetManager *set_man = SetManager::create();
   SetExport set_exp((char *)model_name.data(), goldenConn, set_man);

   int num_set = set_exp.dbReadSets();

   if( !num_set )
   {
cout << "WARNING: No set available for model<" << argv[2] << ">\n";
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*SET");
      return 4;
   }

   unsigned int total = 0, edit_index = 0;
   string html_str, edit_str = "<?php\nfunction loadData($kw_short, $kw)\n{\n";
   ImportObject *imp_obj = NULL;

   if( argc > 6 )
      edit_index = atoi(argv[6]);

cout << "EDIT ID=" << edit_index << endl;

   DBToHtml dbtohtml(set_man);
   imp_obj = dbtohtml.getJSCode(set_type, kw_name, html_str, total, edit_index, &edit_str);
   edit_str += "}\n?>\n";
cout << "EDIT=" << edit_str << endl;

   if( imp_obj )
   {
   }

   SetManager::reset();

   fputs(html_str.data(), fp);
   fclose(fp);
   delete goldenConn;

   file_name = argv[1];
   file_name += "/data.php";
   fp = fopen(file_name.data(), "w");
   fputs(edit_str.data(), fp);
   fclose(fp);

   time(&t2);
   cout << "TIME FOR SET FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

