#include <iostream>
#include <time.h>
#include <set>
#include "termmanager.h"
#include "termexport.h"
#include "termimport.h"
#include "dbtohtmlgen.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: term dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_termination.php"; 
   FILE *fp = fopen(file_name.data(), "w");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      delete goldenConn;
      return 1;
   }

   unsigned int term_type = TERM_NEW_TYPE, term_id;
   string select_query, model_name, kw_name = "*TERMINATION";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      term_type = TermImport::getTermTypeFromKeyword(kw_name.data(), &term_id);
   }

   TermManager::reset();
   getFileName(argv[2], model_name);Card::setFlag(SAVE_CARDS_FIELDS);
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_TERMINATIONS\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*TERMINATION");
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No term table for model=" << argv[2] << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*TERMINATION");
      return 3;
   }

   TermManager *term_man = TermManager::create();
   TermExport term_exp((char *)model_name.data(), goldenConn, term_man);

   int num_term = term_exp.dbReadTerms();

   if( !num_term )
   {
cout << "WARNING: No term available for model<" << argv[2] << ">\n";
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*TERMINATION");
      return 4;
   }

   unsigned int total = 0, edit_index = 0;
   string html_str, edit_str = "<?php\nfunction loadData($kw_short, $kw)\n{\n";

   if( argc > 6 )
      edit_index = atoi(argv[6]);

cout << "EDIT ID=" << edit_index << endl;

   DBToHtml dbtohtml(term_man);
   dbtohtml.getJSCode(term_type, kw_name, html_str, total, edit_index, &edit_str);
   edit_str += "}\n?>\n";
cout << "EDIT=" << edit_str << endl;

   TermManager::reset();

   fputs(html_str.data(), fp);
   fclose(fp);
   delete goldenConn;

   file_name = argv[1];
   file_name += "/data.php";
   fp = fopen(file_name.data(), "w");
   fputs(edit_str.data(), fp);
   fclose(fp);

   time(&t2);
   cout << "TIME FOR TERM FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

