#include <iostream>
#include <time.h>
#include <set>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "airbagmanager.h"
#include "abimport.h"
#include "bufio.h"
#include "dynatobin.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: airbag dir_name model_name" << endl;
      return 1;
   }

   time_t	t1, t2;
   time(&t1);

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_airbag_lsd.php";
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int ab_type = AB_NEW_TYPE;
   int ab_id;
   string select_query, model_name, kw_name = "*AIRBAG";
   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      ab_type = ABImport::getAirbagTypeFromKeyword(kw_name.data(), &ab_id);
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   AirbagManager *ab_man = AirbagManager::create();
    
   ABImport ab_imp(fp, &data_loc, ab_man);

   int num_ab = ab_imp.readAirbags();

   if( !num_ab )
   {
cout << "WARNING: No ab available for model<" << argv[2] << ">\n";
      fclose(fp);
      AirbagManager::reset();
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], ab_man);
   dtob.write("airbag");

   AirbagManager::reset();
   fclose(fp);

   time(&t2);
   cout << "TIME TAKEN TO READ DATA = " << difftime(t2, t1) << endl;

   return 0;
}

