#include <iostream>
#include <time.h>
#include <set>
#include "alemanager.h"
#include "aleimport.h"
#include "dataloc.h"
#include "dynatobin.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: ale dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_ale_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int ale_type = ALE_NEW_TYPE, ale_id;
   string select_query, model_name, kw_name = "*ALE";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      ale_type = ALEImport::getALETypeFromKeyword(kw_name.data(), &ale_id);
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   ALEManager *ale_man = ALEManager::create();
   ALEImport ale_imp(fp, &data_loc, ale_man);

   int num_ale = ale_imp.readALEs();

   if( !num_ale )
   {
cout << "WARNING: No ale available for model<" << argv[2] << ">\n";
      fclose(fp);
      ALEManager::reset();
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], ale_man);
   dtob.write("ale");

   ALEManager::reset();
   fclose(fp);

   time(&t2);
   cout << "TIME FOR ALE FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

