#include <iostream>
#include <time.h>
#include <set>
#include "bdrymanager.h"
#include "bdryimport.h"
#include "dynatobin.h"
#include "dataloc.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: boundary dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_boundary_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int bdry_type = BDRY_NEW_TYPE, bdry_id;
   string select_query, model_name, kw_name = "*BOUNDARY";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      bdry_type = BdryImport::getBdryTypeFromKeyword(kw_name.data(), &bdry_id);
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   BdryManager *man_ptr = BdryManager::create();
   BdryImport bdry_imp(fp, &data_loc, man_ptr);

   int num_bdry = bdry_imp.readBdrys();

   if( !num_bdry )
   {
cout << "WARNING: No boundary kws available for model<" << argv[2] << ">\n";
      fclose(fp);
      BdryManager::reset();
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], man_ptr);
   dtob.write("boundary");

   BdryManager::reset();
   fclose(fp);

   time(&t2);
   cout << "TIME FOR BDRY FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

