#include <iostream>
#include <time.h>
#include <set>
#include "compmanager.h"
#include "compimport.h"
#include "dynatobin.h"
#include "dataloc.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: component dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_component_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int comp_type = COMP_NEW_TYPE, comp_id;
   string select_query, kw_name = "*COMPONENT";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      comp_type = CompImport::getCompTypeFromKeyword(kw_name.data(), &comp_id);
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   CompManager *comp_man = CompManager::create();
   CompImport comp_imp(fp, &data_loc, comp_man);

   int num_comp = comp_imp.readComps();

   if( !num_comp )
   {
cout << "WARNING: No component available for model<" << argv[2] << ">\n";
      fclose(fp);
      CompManager::reset();
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], comp_man);
   dtob.write("component");

   CompManager::reset();
   fclose(fp);

   time(&t2);
   cout << "TIME FOR COMPONENTS FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

