#include <iostream>
#include <time.h>
#include <set>
#include "constmanager.h"
#include "constimport.h"
#include "dynatobin.h"
#include "dataloc.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: constrained dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_constrained_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int const_type = CONST_NEW_TYPE, const_id;
   string select_query, model_name, kw_name = "*CONSTRAINED";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      const_type = ConstImport::getConstTypeFromKeyword(
                                           kw_name.data(), &const_id);
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   ConstManager *const_man = ConstManager::create();
   ConstImport const_imp(fp, &data_loc, const_man);

   int num_const = const_imp.readConsts();

   if( !num_const )
   {
cout << "WARNING: No constrained available for model<" << argv[2] << ">\n";
      ConstManager::reset();
      fclose(fp);
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], const_man);
   dtob.write("constrained");

   ConstManager::reset();
   fclose(fp);

   time(&t2);
   cout << "TIME FOR CONSTRAINED FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

