#include <iostream>
#include <time.h>
#include <set>
#include "contactmanager.h"
#include "contactimport.h"
#include "dynatobin.h"
#include "dataloc.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: contact dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_contact_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int contact_type = CONTACT_NEW_TYPE, contact_id;
   string select_query, model_name, kw_name = "*CONTACT";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      contact_type = ContactImport::getContactTypeFromKeyword(
                                           kw_name.data(), &contact_id);
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   ContactManager *contact_man = ContactManager::create();
   ContactImport contact_imp(fp, &data_loc, contact_man);

   int num_contact = contact_imp.readContacts();

   if( !num_contact )
   {
cout << "WARNING: No contact available for model<" << argv[2] << ">\n";
      ContactManager::reset();
      fclose(fp);
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], contact_man);
   dtob.write("contact");

   ContactManager::reset();
   fclose(fp);

   time(&t2);
   cout << "TIME FOR CONTACTS FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

