#include <iostream>
#include <time.h>
#include <set>
#include "controlmanager.h"
#include "dataloc.h"
#include "controlimport.h"
#include "dynatobin.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: control dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_control_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int control_type = CONTROL_NEW_TYPE, control_id;
   string kw_name = "*CONTROL";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      control_type = ControlImport::getControlTypeFromKeyword(
                                         kw_name.data(), &control_id);
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   ControlManager *control_man = ControlManager::create();
   ControlImport control_imp(fp, &data_loc, control_man);

   int num_control = control_imp.readControls();

   if( !num_control )
   {
cout << "WARNING: No control available for model<" << argv[2] << ">\n";
      ControlManager::reset();
      fclose(fp);
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], control_man);
   dtob.write("control");

   ControlManager::reset();
   fclose(fp);

   time(&t2);
   cout << "TIME FOR CONTROLS FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

