#include <iostream>
#include <time.h>
#include <set>
#include "dampingmanager.h"
#include "dampingimport.h"
#include "dynatobin.h"
#include "dataloc.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: damping dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_damping_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int damping_type = DAMPING_NEW_TYPE, damping_id;
   string kw_name = "*DAMPING";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      damping_type = DampingImport::getDampingTypeFromKeyword(
                                           kw_name.data(), &damping_id);
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   DampingManager *damping_man = DampingManager::create();
   DampingImport damping_imp(fp, &data_loc, damping_man);

   int num_damping = damping_imp.readDampings();

   if( !num_damping )
   {
cout << "WARNING: No damping available for model<" << argv[2] << ">\n";
      DampingManager::reset();
      fclose(fp);
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], damping_man);
   dtob.write("damping");

   DampingManager::reset();
   fclose(fp);

   time(&t2);
   cout << "TIME FOR DAMPING FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

