#include <iostream>
#include <time.h>
#include <set>
#include "databasemanager.h"
#include "databaseimport.h"
#include "dynatobin.h"
#include "dataloc.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: database dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_database_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int database_type = DATABASE_NEW_TYPE, database_id;
   string kw_name = "*DATABASE";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      database_type = DatabaseImport::getDatabaseTypeFromKeyword(
                                        kw_name.data(), &database_id);
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   DatabaseManager *database_man = DatabaseManager::create();
   DatabaseImport database_imp(fp, &data_loc, database_man);

   int num_database = database_imp.readDatabases();

   if( !num_database )
   {
cout << "WARNING: No database available for model<" << argv[2] << ">\n";
      DatabaseManager::reset();
      fclose(fp);
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], database_man);
   dtob.write("database");

   DatabaseManager::reset();
   fclose(fp);

   time(&t2);
   cout << "TIME FOR DATABASE FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

