#include <iostream>
#include <time.h>
#include <set>
#include "definemanager.h"
#include "defineimport.h"
#include "dynatobin.h"
#include "dataloc.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: define dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_define_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int define_type = DEFINE_NEW_TYPE, define_id;
   string kw_name = "*DEFINE";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      define_type = DefineImport::getDefineTypeFromKeyword(
                                           kw_name.data(), &define_id);
      if( strstr(kw_name.data(), "_TITL") )
         define_type += TITLE_CARD; 
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   DefineManager *define_man = DefineManager::create();
   DefineImport define_imp(fp, &data_loc, define_man);

   int num_define = define_imp.readDefines();

cout << "NUM DEFINES=" << num_define << endl;

   if( !num_define )
   {
cout << "WARNING: No define available for model<" << argv[2] << ">\n";
      DefineManager::reset();
      fclose(fp);
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], define_man);
   dtob.write("define");

   DefineManager::reset();
   fclose(fp);

   time(&t2);
   cout << "TIME FOR DEFINE FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

