#include <iostream>
#include <time.h>
#include <set>
#include "deformmanager.h"
#include "deformimport.h"
#include "dynatobin.h"
#include "dataloc.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: deform dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_deformable_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int deform_type = DEFORM_NEW_TYPE, deform_id;
   string kw_name = "*DEFORMABLE";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      deform_type = DeformImport::getDeformTypeFromKeyword(
                                           kw_name.data(), &deform_id);
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   DeformManager *deform_man = DeformManager::create();
   DeformImport deform_imp(fp, &data_loc, deform_man);

   int num_deform = deform_imp.readDeforms();

   if( !num_deform )
   {
cout << "WARNING: No deform available for model<" << argv[2] << ">\n";
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], deform_man);
   dtob.write("deform");

   DeformManager::reset();
   fclose(fp);

   time(&t2);
   cout << "TIME FOR DEFORM FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

