#include <iostream>
#include <time.h>
#include <set>
#include "efmanager.h"
#include "efimport.h"
#include "dynatobin.h"
#include "dataloc.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: ef dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_ef_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int ef_type = EF_NEW_TYPE, ef_id;
   string kw_name = "*EF";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      ef_type = EFImport::getEFTypeFromKeyword(kw_name.data(), &ef_id);
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   EFManager *ef_man = EFManager::create();
   EFImport ef_imp(fp, &data_loc, ef_man);

   int num_ef = ef_imp.readEFs();

   if( !num_ef )
   {
cout << "WARNING: No ef available for model<" << argv[2] << ">\n";
      EFManager::reset();
      fclose(fp);
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], ef_man);
   dtob.write("ef");

   EFManager::reset();
   fclose(fp);

   time(&t2);
   cout << "TIME FOR EF FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

