#include <iostream>
#include <time.h>
#include <set>
#include "elementmanager.h"
#include "elementimport.h"
#include "dynatobin.h"
#include "dataloc.h"
#include "filepath.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: element dir_name model_name" << endl;
      return 1;
   }

   time_t	t1, t2;
   time(&t1);

   FilePath::set(argv[1], argv[2]);
   string path = "rm -f ";
   path += argv[1];
   path += "/*.bin";
   system(path.data());

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_element_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   ElementManager *element_man = ElementManager::create();
   ElementImport element_imp(fp, &data_loc, element_man);
   unsigned int num_elms = element_imp.readElements();

   if( !num_elms )
   {
cout << "WARNING: No elements available for model<" << argv[2] << ">\n";
      fclose(fp);
      ElementManager::reset();
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], element_man);
   dtob.write("element");

   ElementManager::reset();
   fclose(fp);
   FilePath::closeFile();

   time(&t2);
   cout << "TOAL TIME FOR ELEMENT = " << difftime(t2, t1) << endl;

   return 0;
}

