#include <iostream>
#include <time.h>
#include <set>
#include "eosmanager.h"
#include "eosexport.h"
#include "eosimport.h"
#include "dynatobin.h"
#include "dataloc.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: eos dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_eos_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int eos_type = EOS_NEW_TYPE, eos_id;
   string select_query, model_name, kw_name = "*EOS";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      eos_type = EosImport::getEosTypeFromKeyword(kw_name.data(), &eos_id);
      if( strstr(kw_name.data(), "_TITL") )
         eos_type += TITLE_CARD;
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   EosManager *eos_man = EosManager::create();
   EosImport eos_imp(fp, &data_loc, eos_man);

   int num_eos = eos_imp.readEoss();

   if( !num_eos )
   {
cout << "WARNING: No eos available for model<" << argv[2] << ">\n";
      EosManager::reset();
      fclose(fp);
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], eos_man);
   dtob.write("eos");

   EosManager::reset();
   fclose(fp);

   time(&t2);
   cout << "TIME FOR EOS FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

