#include "dynatobin.h"
#include "airbagmanager.h"
#include "card.h"

int DynaToBin::write(const char *ent_name, vector<unsigned int> *idx_list)
{
   vector<ImportObject *> & imp_list = manPtr->getImportObjectList();
   
   if( !imp_list.size() )
   {
cout << "WARNING: No referred entities\n";
      return 5;
   }

   string file_name = dirName;
   file_name += "/";
   file_name += modelName;
   if( access(file_name.data(), W_OK) )
      mkdir(file_name.data(), 0755);
   file_name += "/";
   file_name += ent_name;
   file_name += "_display.bin";
   int wfd = open(file_name.data(), O_RDWR|O_TRUNC|O_CREAT,
                        S_IRWXU|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH);
   if( wfd < 0 )
   {
      cout << "Unable to open file for writing\n";
      return 6;
   }

   BufFilePtr buf_ptr = BufFileOpenWrite(wfd);
    
   unsigned int len, i, j;
   ImportObject *imp_obj = NULL;
   vector<KWTypeIDPtr> *kw_id_list;

   if( !idx_list )
   {
      len = imp_list.size();
      BufFileWrite(buf_ptr, (char *)&len, sizeof(int));
      for(i = 0; i < imp_list.size(); i++)
      {
	 imp_obj = imp_list[i];
cout << "KW=" << imp_obj->getKeyword() << endl;
	 kw_id_list = imp_obj->getKWTypeIDList();
	 len = kw_id_list->size();
cout << "NUM STRs=" << len << endl;
	 BufFileWrite(buf_ptr, (char *)&len, sizeof(int));
         for(j = 0; j < kw_id_list->size(); j++)
	    BufFileWrite(buf_ptr, (char *)(*kw_id_list)[j],sizeof(KWTypeIDStr));
      }
   }
   else
   {
      len = idx_list->size();
      BufFileWrite(buf_ptr, (char *)&len, sizeof(int));
      for(i = 0; i < idx_list->size(); i++)
      {
	 imp_obj = imp_list[(*idx_list)[i]];
	 kw_id_list = imp_obj->getKWTypeIDList();
	 len = kw_id_list->size();
cout << "NUM STRs=" << len << endl;
	 BufFileWrite(buf_ptr, (char *)&len, sizeof(int));
         for(j = 0; j < kw_id_list->size(); j++)
	    BufFileWrite(buf_ptr, (char *)(*kw_id_list)[j],sizeof(KWTypeIDStr));
      }
   }

   BufFileClose(buf_ptr, 1);
   close(wfd);

   return 0;
}

