#include <iostream>
#include <time.h>
#include <set>
#include "hgmanager.h"
#include "hgexport.h"
#include "hgimport.h"
#include "dynatobin.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: hg dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_hourglass_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int hg_type = HG_NEW_TYPE;
   string select_query, model_name, kw_name = "*HOURGLASS";

   if( argc > 3 )
   {
      hg_type = HOURGLASS;
      if( strstr(argv[3], "_TITL") )
         hg_type += TITLE_CARD;
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   HgManager *hg_man = HgManager::create();
   HgImport hg_imp(fp, &data_loc, hg_man);

   int num_hg = hg_imp.readHgs();

   if( !num_hg )
   {
      cout << "WARNING: No hg available for model<" << argv[2] << ">\n";
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], hg_man);
   dtob.write("hourglass");

   HgManager::reset();
   fclose(fp);

   time(&t2);
   cout << "TIME FOR HG FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

