#include <iostream>
#include <time.h>
#include <set>
#include "includemanager.h"
#include "includeexport.h"
#include "includeimport.h"
#include "dynatobin.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: include dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_include_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int include_type = INCLUDE_NEW_TYPE, include_id;
   string kw_name = "*INCLUDE";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      include_type = IncludeImport::getIncludeTypeFromKeyword(
                                          kw_name.data(), &include_id);
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   IncludeManager *include_man = IncludeManager::create();
   IncludeImport include_imp(fp, &data_loc,include_man);

   int num_include = include_imp.readIncludes();

   if( !num_include )
   {
      cout << "WARNING: No include available for model<" << argv[2] << ">\n";
      IncludeManager::reset();
      fclose(fp);
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], include_man);
   dtob.write("include");

   IncludeManager::reset();
   fclose(fp);

   time(&t2);
   cout << "TIME FOR INCLUDE FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

