#include <iostream>
#include <time.h>
#include <set>
#include "initialmanager.h"
#include "initialimport.h"
#include "dynatobin.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: initial dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_initial_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int initial_type = INITIAL_NEW_TYPE, initial_id;
   string kw_name = "*INITIAL";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      initial_type = InitialImport::getInitialTypeFromKeyword(
                                        kw_name.data(), &initial_id);
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   InitialManager *initial_man = InitialManager::create();
   InitialImport initial_imp(fp, &data_loc, initial_man);

   int num_initial = initial_imp.readInitials();

   if( !num_initial )
   {
cout << "WARNING: No initial available for model<" << argv[2] << ">\n";
      InitialManager::reset();
      fclose(fp);
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], initial_man);
   dtob.write("initial");

   InitialManager::reset();
   fclose(fp);

   time(&t2);
   cout << "TIME FOR INITIAL FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

