#include <iostream>
#include <time.h>
#include <set>
#include "nodmanager.h"
#include "nodexport.h"
#include "nodimport.h"
#include "dynatobin.h"
#include "myconnection.h"
#include "dbtohtmlgen.h"
#include "dataloc.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: nod dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_node_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      delete goldenConn;
      return 1;
   }

   unsigned int nod_type = NODE, nod_id, count = 1000, offset = 0;
   string select_query, model_name, kw_name = "*NODE";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      nod_type = NodImport::getNodTypeFromKeyword(kw_name.data(), &nod_id);
   }

   if( argc > 4 )
      count = atoi(argv[4]);
   if( argc > 5 )
      offset = atoi(argv[5]);

   NodManager::reset();
   model_name = argv[2];
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_NODES\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*NODE");
      return 2;
   }

   if( !goldenConn->nextRow() )
   {
cout << "WARNING: No node table for model=" << argv[2] << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*NODE");
      return 3;
   }

   select_query = "select count(card_index) from `";
   select_query += model_name;
   select_query += "_NODES`;";

cout << "COUNT QRY=" << select_query << endl;

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*NODE");
      return 2;
   }

   char **row = goldenConn->nextRow();
   unsigned int total_nodes = atoi(row[0]);
  
   if( !total_nodes )
   {
cout << "WARNING: No nodes available for model<" << argv[2] << ">\n";
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*NODE");
      return 4;
   }

   NodManager *nod_man = NodManager::create();
   DataLoc data_loc(fp);
   NodImport nod_imp(fp, &data_loc, nod_man);

   set<string> kw_list;
   //nod_imp.readNods(count, offset, nod_type, &kw_list);
   nod_imp.readNods();

   unsigned int edit_index = 0;
   string html_str, edit_str = "<?php\nfunction loadData($kw_short, $kw)\n{\n";

   if( argc > 6 )
      edit_index = atoi(argv[6]);

cout << "EDIT ID=" << edit_index << endl;

   DBToHtml dbtohtml(nod_man);
   dbtohtml.getJSCode(nod_type, kw_name, html_str, total_nodes, edit_index, &edit_str);
   edit_str += "}\n?>\n";
cout << "EDIT=" << edit_str << endl;

   NodManager::reset();

   fputs(html_str.data(), fp);
   fclose(fp);
   delete goldenConn;

   file_name = argv[1];
   file_name += "/data_lsd.php";
   fp = fopen(file_name.data(), "rb");
   fputs(edit_str.data(), fp);
   fclose(fp);

   time(&t2);
   cout << "TIME FOR NODE FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

