#include <iostream>
#include <time.h>
#include <set>
#include "partcmanager.h"
#include "partcimport.h"
#include "dynatobin.h"
#include "filepath.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: partc dir_name model_name" << endl;
      return 1;
   }

   time_t	t1, t2;
   time(&t1);

   FilePath::set(argv[1], argv[2]);
   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_part_lsd.php";
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int partc_type = PARTC_NEW_TYPE, partc_bin;
   string select_query, model_name, kw_name = "*PART";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      partc_type = PartCImport::getPartCTypeFromKeyword(
                                        kw_name.data(), &partc_bin);
      if( partc_bin & (1 << PART) )
	 partc_type = partc_bin;
   }

   //for save_references closeFile and save_ids closeIDFile is used
   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   PartCManager *partc_man = PartCManager::create();
   PartCImport partc_imp(fp, &data_loc, partc_man);

   int num_partc = partc_imp.readPartCs();

   if( !num_partc )
   {
cout << "WARNING: No parts available for model<" << argv[2] << ">\n";
      PartCManager::reset();
      fclose(fp);
      return 4;
   }

cout << "NUM PARTS=" << num_partc << endl;

   DynaToBin dtob(argv[1], argv[2], partc_man);
   dtob.write("part");

   PartCManager::reset();
   fclose(fp);
   FilePath::closeFile();

   time(&t2);
   cout << "TIME FOR PART FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

