#include <iostream>
#include <time.h>
#include <set>
#include "setmanager.h"
#include "setimport.h"
#include "dataloc.h"
#include "dynatobin.h"

using namespace std;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: set dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_set_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      return 1;
   }

   unsigned int set_type = SET_NEW_TYPE, set_id;
   string kw_name = "*SET";

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      set_type = SetImport::getSetTypeFromKeyword(kw_name.data(), &set_id);

      if( strstr(kw_name.data(), "_TITL") )
         set_type += TITLE_CARD;
   }

   Card::setFlag(SAVE_REFERENCES);
   DataLoc data_loc(fp);

   SetManager *set_man = SetManager::create();
   SetImport set_imp(fp, &data_loc, set_man);

   int num_set = set_imp.readSets();

cout << "NUM SETS=" << num_set << endl;
cout << "NUM SETS=" << set_man->length() << endl;

   if( !num_set )
   {
cout << "WARNING: No set available for model<" << argv[2] << ">\n";
      return 4;
   }

   DynaToBin dtob(argv[1], argv[2], set_man);
   dtob.write("set");

   SetManager::reset();

   fclose(fp);

   time(&t2);
   cout << "TIME FOR SET FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

