#include <iostream>
#include <time.h>
#include <set>
#include "usermanager.h"
#include "userexport.h"
#include "userimport.h"
#include "dynatobin.h"
#include "myconnection.h"
#include "dbtohtmlgen.h"
#include "dataloc.h"

using namespace std;
map<string, string> MyConnection::nvMap;
unsigned int Card::contFlag = 0;

int main(int argc, char* argv[])
{
   if( argc < 3 )
   {
      cout << "Usage: user dir_name model_name" << endl;
      return 1;
   }

   time_t			t1, t2;
   time(&t1);

   GoldenConn *goldenConn = MyConnection::get();

   if( !goldenConn )
      return 1;

   string file_name = argv[1];
   file_name += "/";
   file_name += argv[2];
   file_name += "_user_lsd.php"; 
   FILE *fp = fopen(file_name.data(), "rb");

   if( !fp )
   {
      cout << "Unable to open the file " << file_name << endl;
      delete goldenConn;
      return 1;
   }

   unsigned int kw_type = USER_NEW_TYPE, user_id;
   string kw_name = "*USER", select_query, model_name;

   if( argc > 3 )
   {
      kw_name = "*";
      kw_name += argv[3];
      kw_type = UserImport::getUserTypeFromKeyword(kw_name.data(), &user_id);
   }

   UserManager::reset();

   model_name = argv[2];
   model_name += "__";

   select_query = "show table status like \'";
   select_query += model_name;
   select_query += "_USERS\';";

   if( goldenConn->executeQuery( select_query.data() ) )
   {
      cout << goldenConn->error() << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*USER");
      return 2;
   }

   if( !goldenConn->nextRow() ) 
   {
cout << "WARNING: No user table for model=" << argv[2] << endl;
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*USER");
      return 3;
   }

   UserManager *man_ptr = UserManager::create();
   DataLoc data_loc(fp);
   UserImport user_imp(fp, &data_loc, man_ptr);

   int num_user = user_imp.readUsers();

   if( !num_user )
   {
cout << "WARNING: No user available for model<" << argv[2] << ">\n";
      DBToHtml::cleanAndWriteBlankPage(argv[1], goldenConn, fp, "*USER");
      return 4;
   }

   unsigned int total = 0, edit_index = 0;
   string html_str, edit_str = "<?php\nfunction loadData($kw_short, $kw)\n{\n";

   if( argc > 6 )
      edit_index = atoi(argv[6]);

cout << "EDIT ID=" << edit_index << endl;

   DBToHtml dbtohtml(man_ptr);
   dbtohtml.getJSCode(kw_type, kw_name, html_str, total, edit_index, &edit_str);
   edit_str += "}\n?>\n";
cout << "EDIT=" << edit_str << endl;

   UserManager::reset();

   fputs(html_str.data(), fp);
   fclose(fp);
   delete goldenConn;

   file_name = argv[1];
   file_name += "/data_lsd.php";
   fp = fopen(file_name.data(), "rb");
   fputs(edit_str.data(), fp);
   fclose(fp);

   time(&t2);
   cout << "TIME FOR USER FROM DB= " << difftime(t2, t1) << endl;

   return 0;
}

