#include <sqlite3.h>

#include <map>
#include <string>
#include <vector>

using namespace std;

typedef map<string, int> 		StrIntMap;
typedef pair<string, int> 		StrIntPair;
typedef map<string, int>::iterator 	StrIntIterator;

class MySqlite
{
public:
    MySqlite(const char *fileName);    
    ~MySqlite();
    int PrepareStatement(const char *stmt);
    int Bind(int paramNum, int intValue, int qryIndex);
    int Bind(int paramNum, double dblValue, int qryIndex);
    int Bind(int paramNum, const char *strValue, int strLen, int qryIndex);
    int Bind(int paramNum, int qryIndex);
    const char *GetColumnValue(int qryIndex, int colIndex);
    int Execute(int qryIndex);
    int Reset(int qryIndex);
    int GetOpenStatus()
    {
        return m_OpenStatus;
    }
    
    sqlite3_int64 GetLastRowId();
    int IsKeywordExists(const char *kwName, int kwLen);

private:
    string   m_FileName;
    sqlite3  *m_MySqlite;
    int      m_OpenStatus;
    int      m_StmtStatus;
    int      m_BindStatus;
    int      m_ExeStatus;
    int      m_SelKWIndex;
    vector<sqlite3_stmt *> m_StmtArray;
    StrIntMap              m_StmtMap;
};

