#include "dbabadvancedale.hpp"
#include "dbabale.hpp"
#include "dbabinteraction.hpp"
#include "dbabreferencegeometry.hpp"
#include "dbabrefgeometrybirth.hpp"
#include "dbabrefgeobirthrdt.hpp"
#include "dbabrefgeometryrdt.hpp"
#include "dbabshellrefgeometry.hpp"
#include "exptypemap.h"
#include "abexport.h"

void ABExport::initExportABALETypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_ADVANCED_ALE, importDBABAdvancedALE) );
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_ALE, importDBABALE) );
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_INTERACTION, importDBABInteraction) );
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_REFERENCE_GEOMETRY, importDBABReferenceGeometry) );
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_REFERENCE_GEOMETRY_BIRTH, importDBABRefGeometryBirth) );
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_REFERENCE_GEOMETRY_BIRTH_RDT, importDBABRefGeoBirthRDT) );
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_REFERENCE_GEOMETRY_RDT, importDBABRefGeometryRDT) );
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_SHELL_REFERENCE_GEOMETRY, importDBABShellRefGeometry) );
}
