#include "dbabadiabaticgasmodel.hpp"
#include "dbablinearfluid.hpp"
#include "dbabloadcurve.hpp"
#include "dbabsimplemodel.hpp"
#include "dbabsimplepressurevolume.hpp"
#include "exptypemap.h"
#include "abexport.h"

void ABExport::initExportSimpleTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_ADIABATIC_GAS_MODEL, importDBABAdiabaticGasModel) );
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_ADIABATIC_GAS_MODEL_ID, importDBABAdiabaticGasModel) );
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_LINEAR_FLUID, importDBABLinearFluid) );
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_LINEAR_FLUID_ID, importDBABLinearFluid) );
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_LOAD_CURVE, importDBABLoadCurve) );
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_LOAD_CURVE_ID, importDBABLoadCurve) );
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_SIMPLE_AIRBAG_MODEL, importDBABSimpleModel) );
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_SIMPLE_AIRBAG_MODEL_ID, importDBABSimpleModel) );
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_SIMPLE_PRESSURE_VOLUME, importDBABSimplePressureVolume) );
   expTypeFuncMap.insert( expTypeFuncPair(AIRBAG_SIMPLE_PRESSURE_VOLUME_ID, importDBABSimplePressureVolume) );
}
