#ifndef _DBABWANGNEFSKEMULTIPLEJETTINGCM_H_
#define _DBABWANGNEFSKEMULTIPLEJETTINGCM_H_

#include "manager.h"
#include "dispexport.h"
#include "dbabwangnefskemultiplejetting.h"

/** Class used for getting data from database for *AIRBAG_WANG_NEFSKE_MULTIPLE_JETTING_CM
  * keyword */

class DBABWangNefskeMultipleJettingCM : public DBABWangNefskeMultipleJetting
{
public:
/** Class constructor for creating the objects.
  * \param gold_conn GoldenConn object to access database
  * \param imp_obj ImportObject pointer to hold data
  */
   DBABWangNefskeMultipleJettingCM(GoldenConn *gold_conn, ImportObject *imp_obj) : DBABWangNefskeMultipleJetting (gold_conn, imp_obj)
   {
   }

/** Class destructor for releasing the memory in the object.
  */
   virtual ~DBABWangNefskeMultipleJettingCM()
   {
   }

public:
/** Function to get CMCard details for *AIRBAG_WANG_NEFSKE_MULTIPLE_JETTING_CM
  * keyword from database */
   void dbReadCMCard(unsigned int loop_count = (1 << 31))
   {
      const char *fields[] = {"NREACT",};
      unsigned int field_types[] = {DATA_INT, };
      numFields = 1;
      unsigned int field_widths[] = {10, };
      wordArray = goldenConn->nextCard();
      if( !wordArray )
      {
         numFields = 0;
         return;
      }
      if( Card::isFlagOn(SAVE_IDS) && !impObj->cardCount )
         addIDToFile(wordArray, 0, AIRBAG, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         if( loop_count & (1<<31) )
            cardObj = new DBCard("CMCard");
         else
         {
            char name_buf[64];
            sprintf(name_buf,"%s_%d","CMCard",loop_count);
            cardObj = new DBCard(name_buf);
         }
         ((DBCard *)cardObj)->index = atoi(wordArray[0]);
         cardObj->addFields(numFields, field_types, field_widths, fields, &wordArray[2]);
         impObj->addCard(cardObj);
      }
      impObj->cardCount++;
   }

/** Function to import all the cards of keyword *AIRBAG_WANG_NEFSKE_MULTIPLE_JETTING_CM
  * from database */
   unsigned int importDBABWangNefskeMultipleJettingCM()
   {
      importDBABWangNefskeMultipleJetting();
      dbReadCMCard();
      return 0;
   }
};

#endif

