#include "dbalefsiprojection.hpp"
#include "dbalefsiswitchmmg.hpp"
#include "dbalemultimatgroup.hpp"
#include "dbalerefsyscurve.hpp"
#include "dbalerefsysgroup.hpp"
#include "dbalerefsysnode.hpp"
#include "dbalerefsysswitch.hpp"
#include "dbalesmoothing.hpp"
#include "dbaletanktest.hpp"
#include "dbaleupswitch.hpp"
#include "exptypemap.h"
#include "aleexport.h"

void ALEExport::initExportAleTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(ALE_FSI_PROJECTION, importDBAleFsiProjection) );
   expTypeFuncMap.insert( expTypeFuncPair(ALE_FSI_SWITCH_MMG, importDBAleFsiSwitchMmg) );
   expTypeFuncMap.insert( expTypeFuncPair(ALE_FSI_SWITCH_MMG_ID, importDBAleFsiSwitchMmg) );
   expTypeFuncMap.insert( expTypeFuncPair(ALE_FSI_SWITCH_MMG_TITLE, importDBAleFsiSwitchMmg) );
   expTypeFuncMap.insert( expTypeFuncPair(ALE_MULTI_MATERIAL_GROUP, importDBAleMultiMatGroup) );
   expTypeFuncMap.insert( expTypeFuncPair(ALE_REFERENCE_SYSTEM_CURVE, importDBAleRefSysCurve) );
   expTypeFuncMap.insert( expTypeFuncPair(ALE_REFERENCE_SYSTEM_GROUP, importDBAleRefSysGroup) );
   expTypeFuncMap.insert( expTypeFuncPair(ALE_REFERENCE_SYSTEM_NODE, importDBAleRefSysNode) );
   expTypeFuncMap.insert( expTypeFuncPair(ALE_REFERENCE_SYSTEM_SWITCH, importDBAleRefSysSwitch) );
   expTypeFuncMap.insert( expTypeFuncPair(ALE_SMOOTHING, importDBAleSmoothing) );
   expTypeFuncMap.insert( expTypeFuncPair(ALE_TANK_TEST, importDBAleTankTest) );
   expTypeFuncMap.insert( expTypeFuncPair(ALE_UP_SWITCH, importDBAleUpSwitch) );
}
