#include "dbbemacoustic.hpp"
#include "dbbemcontrol.hpp"
#include "dbbemflow.hpp"
#include "dbbemsymmetry.hpp"
#include "dbbemneighbor.hpp"
#include "dbbemwake.hpp"
#include "exptypemap.h"
#include "bdryexport.h"

void BdryExport::initExportBEMTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(BOUNDARY_ELEMENT_METHOD_ACOUSTIC, importDBBEMAcoustic) );
   expTypeFuncMap.insert( expTypeFuncPair(BOUNDARY_ELEMENT_METHOD_CONTROL, importDBBEMControl) );
   expTypeFuncMap.insert( expTypeFuncPair(BOUNDARY_ELEMENT_METHOD_FLOW, importDBBEMFlow) );
   expTypeFuncMap.insert( expTypeFuncPair(BOUNDARY_ELEMENT_METHOD_SYMMETRY, importDBBEMSymmetry) );
   expTypeFuncMap.insert( expTypeFuncPair(BOUNDARY_ELEMENT_METHOD_NEIGHBOR, importDBBEMNeighbor) );
   expTypeFuncMap.insert( expTypeFuncPair(BOUNDARY_ELEMENT_METHOD_WAKE, importDBBEMWake) );
}
