#include "dbbdryacousticcoupling.hpp"
#include "dbbdryambienteos.hpp"
#include "dbbdrycyclic.hpp"
#include "dbbdrymcol.hpp"
#include "dbbdrypresaccelrigid.hpp"
#include "dbbdryslidingplane.hpp"
#include "dbbdrysymfailure.hpp"
#include "dbbdryusasurface.hpp"
#include "exptypemap.h"
#include "bdryexport.h"

void BdryExport::initExportSimpleTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(BOUNDARY_ACOUSTIC_COUPLING, importDBBdryAcousticCoupling) );
   expTypeFuncMap.insert( expTypeFuncPair(BOUNDARY_AMBIENT_EOS, importDBBdryAmbientEOS) );
   expTypeFuncMap.insert( expTypeFuncPair(BOUNDARY_CYCLIC, importDBBdryCyclic) );
   expTypeFuncMap.insert( expTypeFuncPair(BOUNDARY_MCOL, importDBBdryMCOL) );
   expTypeFuncMap.insert( expTypeFuncPair(BOUNDARY_PRESCRIBED_ACCELEROMETER_RIGID, importDBBdryPresAccelRigid) );
   expTypeFuncMap.insert( expTypeFuncPair(BOUNDARY_SLIDING_PLANE, importDBBdrySlidingPlane) );
   expTypeFuncMap.insert( expTypeFuncPair(BOUNDARY_SYMMETRY_FAILURE, importDBBdrySymFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(BOUNDARY_USA_SURFACE, importDBBdryUsaSurface) );
}
