#include "dbcomponentgebod.hpp"
#include "dbcomponentgebodjoint.hpp"
#include "dbcomponenthybridiii.hpp"
#include "dbcomponenthybridiiijoint.hpp"
#include "exptypemap.h"
#include "compexport.h"

void CompExport::initExportCompTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_GEBOD_CHILD, importDBComponentGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_GEBOD_FEMALE, importDBComponentGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_GEBOD_JOINT_LEFT_ANKLE, importDBComponentGebodJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_GEBOD_JOINT_LEFT_ELBOW, importDBComponentGebodJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_GEBOD_JOINT_LEFT_HIP, importDBComponentGebodJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_GEBOD_JOINT_LEFT_KNEE, importDBComponentGebodJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_GEBOD_JOINT_LEFT_SHOULDER, importDBComponentGebodJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_GEBOD_JOINT_LOWER_NECK, importDBComponentGebodJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_GEBOD_JOINT_PELVIS, importDBComponentGebodJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_GEBOD_JOINT_RIGHT_ANKLE, importDBComponentGebodJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_GEBOD_JOINT_RIGHT_ELBOW, importDBComponentGebodJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_GEBOD_JOINT_RIGHT_HIP, importDBComponentGebodJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_GEBOD_JOINT_RIGHT_KNEE, importDBComponentGebodJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_GEBOD_JOINT_RIGHT_SHOULDER, importDBComponentGebodJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_GEBOD_JOINT_UPPER_NECK, importDBComponentGebodJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_GEBOD_JOINT_WAIST, importDBComponentGebodJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_GEBOD_MALE, importDBComponentGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII, importDBComponentHybridIII) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_LEFT_ANKLE, importDBComponentHybridIIIJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_LEFT_ELBOW, importDBComponentHybridIIIJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_LEFT_HIP, importDBComponentHybridIIIJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_LEFT_KNEE, importDBComponentHybridIIIJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_LEFT_KNEE_SLIDER, importDBComponentHybridIIIJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_LEFT_SHOULDER, importDBComponentHybridIIIJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_LEFT_WRIST, importDBComponentHybridIIIJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_LOWER_NECK, importDBComponentHybridIIIJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_LUMBAR, importDBComponentHybridIIIJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_RIGHT_ANKLE, importDBComponentHybridIIIJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_RIGHT_ELBOW, importDBComponentHybridIIIJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_RIGHT_HIP, importDBComponentHybridIIIJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_RIGHT_KNEE, importDBComponentHybridIIIJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_RIGHT_KNEE_SLIDER, importDBComponentHybridIIIJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_RIGHT_SHOULDER, importDBComponentHybridIIIJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_RIGHT_WRIST, importDBComponentHybridIIIJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_STERNUM, importDBComponentHybridIIIJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(COMPONENT_HYBRIDIII_JOINT_UPPER_NECK, importDBComponentHybridIIIJoint) );
}
