#include "dbconstlagrangesolid.hpp"
#include "dbconstlinearglobal.hpp"
#include "dbconstlinearlocal.hpp"
#include "dbconstlocal.hpp"
#include "dbconstrigidbodies.hpp"
#include "dbconstrigidbodystoppers.hpp"
#include "exptypemap.h"
#include "constexport.h"

void ConstExport::initExportCouplingTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_LAGRANGE_IN_SOLID, importDBConstLagrangeSolid) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_LAGRANGE_IN_SOLID_EDGE, importDBConstLagrangeSolid) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_LAGRANGE_IN_SOLID_EDGE_TITLE, importDBConstLagrangeSolid) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_LAGRANGE_IN_SOLID_TITLE, importDBConstLagrangeSolid) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_LINEAR_GLOBAL, importDBConstLinearGlobal) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_LINEAR_LOCAL, importDBConstLinearLocal) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_LOCAL, importDBConstLocal) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_RIGID_BODIES, importDBConstRigidBodies) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_RIGID_BODY_STOPPERS, importDBConstRigidBodyStoppers) );
}
