#include "dbconstjointlocalfailure.hpp"
#include "dbconstjoint.hpp"
#include "dbconstjointmotor.hpp"
#include "dbconstjointmotorlocalfailure.hpp"
#include "exptypemap.h"
#include "constexport.h"

void ConstExport::initExportJointTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_ID_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_ID_FAILURE_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_ID_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_ID_LOCAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_FAILURE_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_FAILURE_ID_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_FAILURE_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_FAILURE_LOCAL_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL, importDBConstJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_ID, importDBConstJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_LOCAL_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_LOCAL_ID_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_LOCAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_LOCAL_FAILURE_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_GEARS, importDBConstJointMotor) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_GEARS_ID, importDBConstJointMotor) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_GEARS_ID_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_GEARS_ID_FAILURE_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_GEARS_ID_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_GEARS_ID_LOCAL_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_GEARS_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_GEARS_FAILURE_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_GEARS_FAILURE_ID_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_GEARS_FAILURE_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_GEARS_FAILURE_LOCAL_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_GEARS_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_GEARS_LOCAL_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_GEARS_LOCAL_ID_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_GEARS_LOCAL_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_GEARS_LOCAL_FAILURE_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_LOCKING, importDBConstJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_LOCKING_ID, importDBConstJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_LOCKING_ID_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_LOCKING_ID_FAILURE_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_LOCKING_ID_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_LOCKING_ID_LOCAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_LOCKING_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_LOCKING_FAILURE_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_LOCKING_FAILURE_ID_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_LOCKING_FAILURE_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_LOCKING_FAILURE_LOCAL_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_LOCKING_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_LOCKING_LOCAL_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_LOCKING_LOCAL_ID_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_LOCKING_LOCAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_LOCKING_LOCAL_FAILURE_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PLANAR_ID_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PLANAR_ID_FAILURE_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PLANAR_ID_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PLANAR_ID_LOCAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PLANAR, importDBConstJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PLANAR_ID, importDBConstJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PLANAR_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PLANAR_FAILURE_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PLANAR_FAILURE_ID_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PLANAR_FAILURE_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PLANAR_FAILURE_LOCAL_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PLANAR_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PLANAR_LOCAL_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PLANAR_LOCAL_ID_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PLANAR_LOCAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PLANAR_LOCAL_FAILURE_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PULLEY, importDBConstJointMotor) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PULLEY_ID, importDBConstJointMotor) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PULLEY_ID_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PULLEY_ID_FAILURE_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PULLEY_ID_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PULLEY_ID_LOCAL_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PULLEY_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PULLEY_FAILURE_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PULLEY_FAILURE_ID_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PULLEY_FAILURE_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PULLEY_FAILURE_LOCAL_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PULLEY_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PULLEY_LOCAL_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PULLEY_LOCAL_ID_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PULLEY_LOCAL_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_PULLEY_LOCAL_FAILURE_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION, importDBConstJointMotor) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_ID, importDBConstJointMotor) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_ID_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_ID_FAILURE_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_ID_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_ID_LOCAL_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_FAILURE_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_FAILURE_ID_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_FAILURE_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_FAILURE_LOCAL_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_LOCAL_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_LOCAL_ID_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_LOCAL_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_LOCAL_FAILURE_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_REVOLUTE_ID_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_REVOLUTE_ID_FAILURE_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_REVOLUTE_ID_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_REVOLUTE_ID_LOCAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_REVOLUTE_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_REVOLUTE_FAILURE_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_REVOLUTE_FAILURE_ID_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_REVOLUTE_FAILURE_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_REVOLUTE_FAILURE_LOCAL_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_REVOLUTE_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_REVOLUTE_LOCAL_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_REVOLUTE_LOCAL_ID_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_REVOLUTE_LOCAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_REVOLUTE_LOCAL_FAILURE_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_REVOLUTE, importDBConstJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_REVOLUTE_ID, importDBConstJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR, importDBConstJointMotor) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_ID, importDBConstJointMotor) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_ID_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_ID_FAILURE_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_ID_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_ID_LOCAL_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_FAILURE_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_FAILURE_ID_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_FAILURE_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_FAILURE_LOCAL_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_LOCAL_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_LOCAL_ID_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_LOCAL_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_LOCAL_FAILURE_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SCREW, importDBConstJointMotor) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SCREW_ID, importDBConstJointMotor) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SCREW_ID_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SCREW_ID_FAILURE_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SCREW_ID_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SCREW_ID_LOCAL_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SCREW_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SCREW_FAILURE_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SCREW_FAILURE_ID_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SCREW_FAILURE_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SCREW_FAILURE_LOCAL_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SCREW_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SCREW_LOCAL_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SCREW_LOCAL_ID_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SCREW_LOCAL_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SCREW_LOCAL_FAILURE_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SPHERICAL_ID_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SPHERICAL_ID_FAILURE_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SPHERICAL_ID_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SPHERICAL_ID_LOCAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SPHERICAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SPHERICAL_FAILURE_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SPHERICAL_FAILURE_ID_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SPHERICAL_FAILURE_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SPHERICAL_FAILURE_LOCAL_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SPHERICAL, importDBConstJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SPHERICAL_ID, importDBConstJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SPHERICAL_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SPHERICAL_LOCAL_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SPHERICAL_LOCAL_ID_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SPHERICAL_LOCAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_SPHERICAL_LOCAL_FAILURE_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL, importDBConstJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_ID, importDBConstJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_ID_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_ID_FAILURE_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_ID_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_ID_LOCAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_FAILURE_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_FAILURE_ID_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_FAILURE_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_FAILURE_LOCAL_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_LOCAL_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_LOCAL_ID_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_LOCAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_LOCAL_FAILURE_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR, importDBConstJointMotor) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_ID, importDBConstJointMotor) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_ID_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_ID_FAILURE_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_ID_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_ID_LOCAL_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_FAILURE_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_FAILURE_ID_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_FAILURE_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_FAILURE_LOCAL_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_LOCAL, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_LOCAL_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_LOCAL_ID_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_LOCAL_FAILURE, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_LOCAL_FAILURE_ID, importDBConstJointMotorLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_ID_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_ID_FAILURE_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_ID_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_ID_LOCAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_FAILURE_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_FAILURE_ID_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_FAILURE_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_FAILURE_LOCAL_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_LOCAL_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_LOCAL_ID_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_LOCAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_LOCAL_FAILURE_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_UNIVERSAL, importDBConstJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_ID, importDBConstJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY, importDBConstJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_ID, importDBConstJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_ID_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_ID_FAILURE_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_ID_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_ID_LOCAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_FAILURE_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_FAILURE_ID_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_FAILURE_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_FAILURE_LOCAL_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_LOCAL, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_LOCAL_ID, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_LOCAL_ID_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_LOCAL_FAILURE, importDBConstJointLocalFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_LOCAL_FAILURE_ID, importDBConstJointLocalFailure) );
}
