#include "dbconstnodalrigidbody.hpp"
#include "dbconstnodalrigidbodyinertia.hpp"
#include "dbconstnodalrigidbodyspc.hpp"
#include "dbconstnodalrigidbodyspcinertia.hpp"
#include "dbconstnodeset.hpp"
#include "dbconstpoints.hpp"
#include "exptypemap.h"
#include "constexport.h"

void ConstExport::initExportNodalTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_NODAL_RIGID_BODY_TITLE, importDBConstNodalRigidBody) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_NODAL_RIGID_BODY, importDBConstNodalRigidBody) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_NODAL_RIGID_BODY_INERTIA, importDBConstNodalRigidBodyInertia) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_NODAL_RIGID_BODY_INERTIA_TITLE, importDBConstNodalRigidBodyInertia) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_NODAL_RIGID_BODY_SPC, importDBConstNodalRigidBodySpc) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_NODAL_RIGID_BODY_SPC_TITLE, importDBConstNodalRigidBodySpc) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_NODAL_RIGID_BODY_SPC_INERTIA, importDBConstNodalRigidBodySpcInertia) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_NODAL_RIGID_BODY_SPC_INERTIA_TITLE, importDBConstNodalRigidBodySpcInertia) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_NODE_SET, importDBConstNodeSet) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_NODE_SET_ID, importDBConstNodeSet) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_POINTS, importDBConstPoints) );
}
