#include "dbconstadapt.hpp"
#include "dbconsteuler.hpp"
#include "dbconstextranodes.hpp"
#include "dbconstglobal.hpp"
#include "dbconstinterpolation.hpp"
#include "dbconstinterpollocal.hpp"
#include "exptypemap.h"
#include "constexport.h"

void ConstExport::initExportSimpleTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_ADAPTIVITY, importDBConstAdapt) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_EULER_IN_EULER, importDBConstEuler) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_EXTRA_NODES_NODE, importDBConstExtraNodes) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_EXTRA_NODES_SET, importDBConstExtraNodes) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_GLOBAL, importDBConstGlobal) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_INTERPOLATION, importDBConstInterpolation) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_INTERPOLATION_LOCAL, importDBConstInterpolLocal) );
}
