#ifndef _DBCONSTTIEDNODESFAIL_H_
#define _DBCONSTTIEDNODESFAIL_H_

#include "manager.h"
#include "dispexport.h"
#include "getdbbase.h"

/** Class used for getting data from database for *CONSTRAINED_TIED_NODES_FAILURE
  * keyword */

class DBConstTiedNodesFail : public GetDBBase
{
public:
/** Class constructor for creating the objects.
  * \param gold_conn GoldenConn object to access database
  * \param imp_obj ImportObject pointer to hold data
  */
   DBConstTiedNodesFail(GoldenConn *gold_conn, ImportObject *imp_obj) : GetDBBase (gold_conn, imp_obj)
   {
   }

/** Class destructor for releasing the memory in the object.
  */
   virtual ~DBConstTiedNodesFail()
   {
   }

public:
/** Function to get NodeSet details for *CONSTRAINED_TIED_NODES_FAILURE
  * keyword from database */
   void dbReadNodeSet(unsigned int loop_count = (1 << 31))
   {
      const char *fields[] = {"NSID","EPPF","ETYPE",};
      unsigned int field_types[] = {DATA_INT, DATA_DOUBLE, DATA_INT, };
      numFields = 3;
      unsigned int field_widths[] = {10, 10, 10, };
      wordArray = goldenConn->nextCard();
      if( !wordArray )
      {
         numFields = 0;
         return;
      }
      if( Card::isFlagOn(SAVE_IDS) && !impObj->cardCount )
         addIDToFile(wordArray, 0, CONST, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         if( loop_count & (1<<31) )
            cardObj = new DBCard("NodeSet");
         else
         {
            char name_buf[64];
            sprintf(name_buf,"%s_%d","NodeSet",loop_count);
            cardObj = new DBCard(name_buf);
         }
         ((DBCard *)cardObj)->index = atoi(wordArray[0]);
         cardObj->addFields(numFields, field_types, field_widths, fields, &wordArray[2]);
         impObj->addCard(cardObj);
      }
      impObj->cardCount++;
   }

/** Function to import all the cards of keyword *CONSTRAINED_TIED_NODES_FAILURE
  * from database */
   unsigned int importDBConstTiedNodesFail()
   {
      dbReadNodeSet();
      return 0;
   }
};

#endif

