#include "dbconstjointstiffflextorsion.hpp"
#include "dbconstjointstiffgeneral.hpp"
#include "dbconstjointstifftranslation.hpp"
#include "dbconstshelltosolid.hpp"
#include "dbconstspline.hpp"
#include "dbconsttiebreak.hpp"
#include "dbconsttiednodesfail.hpp"
#include "exptypemap.h"
#include "constexport.h"

void ConstExport::initExportStiffnessTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_STIFFNESS_FLEXION_TORSION, importDBConstJointStiffFlexTorsion) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_STIFFNESS_GENERALIZED, importDBConstJointStiffGeneral) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_JOINT_STIFFNESS_TRANSLATIONAL, importDBConstJointStiffTranslation) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_SHELL_TO_SOLID, importDBConstShellToSolid) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_SPLINE, importDBConstSpline) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_TIE_BREAK, importDBConstTieBreak) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_TIED_NODES_FAILURE, importDBConstTiedNodesFail) );
}
