#ifndef _DBCONSTGENWELDBUTT_H_
#define _DBCONSTGENWELDBUTT_H_

#include "manager.h"
#include "dispexport.h"
#include "dbconstgenweld.h"

/** Class used for getting data from database for *CONSTRAINED_GENERALIZED_WELD_BUTT
  * keyword */

class DBConstGenWeldButt : public DBConstGenWeld
{
public:
/** Class constructor for creating the objects.
  * \param gold_conn GoldenConn object to access database
  * \param imp_obj ImportObject pointer to hold data
  */
   DBConstGenWeldButt(GoldenConn *gold_conn, ImportObject *imp_obj) : DBConstGenWeld (gold_conn, imp_obj)
   {
   }

/** Class destructor for releasing the memory in the object.
  */
   virtual ~DBConstGenWeldButt()
   {
   }

public:
/** Function to get Butt details for *CONSTRAINED_GENERALIZED_WELD_BUTT
  * keyword from database */
   void dbReadButt(unsigned int loop_count = (1 << 31))
   {
      const char *fields[] = {"TFAIL","EPSF","SIGY","BETA","L","D","LT",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 7;
      unsigned int field_widths[] = {10, 10, 10, 10, 10, 10, 10, };
      wordArray = goldenConn->nextCard();
      if( !wordArray )
      {
         numFields = 0;
         return;
      }
      if( Card::isFlagOn(SAVE_IDS) && !impObj->cardCount )
         addIDToFile(wordArray, 0, CONST, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         if( loop_count & (1<<31) )
            cardObj = new DBCard("Butt");
         else
         {
            char name_buf[64];
            sprintf(name_buf,"%s_%d","Butt",loop_count);
            cardObj = new DBCard(name_buf);
         }
         ((DBCard *)cardObj)->index = atoi(wordArray[0]);
         cardObj->addFields(numFields, field_types, field_widths, fields, &wordArray[2]);
         impObj->addCard(cardObj);
      }
      impObj->cardCount++;
   }

/** Function to import all the cards of keyword *CONSTRAINED_GENERALIZED_WELD_BUTT
  * from database */
   unsigned int importDBConstGenWeldButt()
   {
      importDBConstGenWeld();
      dbReadButt();
      return 0;
   }
};

#endif

