#include "dbconstbuttweld.hpp"
#include "dbconstgenweldbutt.hpp"
#include "dbconstgenweldcombined.hpp"
#include "dbconstgenweldcrossfillet.hpp"
#include "dbconstgenweldfillet.hpp"
#include "dbconstgenweldspot.hpp"
#include "dbconstrivet.hpp"
#include "dbconstspotweld.hpp"
#include "dbconstspotweldfilter.hpp"
#include "exptypemap.h"
#include "constexport.h"

void ConstExport::initExportWeldTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_BUTT_WELD, importDBConstButtWeld) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_GENERALIZED_WELD_BUTT, importDBConstGenWeldButt) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_GENERALIZED_WELD_BUTT_ID, importDBConstGenWeldButt) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_GENERALIZED_WELD_COMBINED, importDBConstGenWeldCombined) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_GENERALIZED_WELD_COMBINED_ID, importDBConstGenWeldCombined) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_GENERALIZED_WELD_CROSS_FILLET, importDBConstGenWeldCrossFillet) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_GENERALIZED_WELD_CROSS_FILLET_ID, importDBConstGenWeldCrossFillet) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_GENERALIZED_WELD_FILLET, importDBConstGenWeldFillet) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_GENERALIZED_WELD_FILLET_ID, importDBConstGenWeldFillet) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_GENERALIZED_WELD_SPOT, importDBConstGenWeldSpot) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_GENERALIZED_WELD_SPOT_ID, importDBConstGenWeldSpot) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_RIVET, importDBConstRivet) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_RIVET_ID, importDBConstRivet) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_SPOTWELD, importDBConstSpotWeld) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_SPOTWELD_ID, importDBConstSpotWeld) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_SPOTWELD_ID_FILTERED_FORCE, importDBConstSpotWeldFilter) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_SPOTWELD_FILTERED_FORCE, importDBConstSpotWeldFilter) );
   expTypeFuncMap.insert( expTypeFuncPair(CONSTRAINED_SPOTWELD_FILTERED_FORCE_ID, importDBConstSpotWeldFilter) );
}
