#include "dbcard4autosurfacetiebreak.hpp"
#include "dbcard4constsurface.hpp"
#include "dbcard4drawbead.hpp"
#include "dbcard4drawbeadinit.hpp"
#include "dbcard4erodingsurface.hpp"
#include "dbcard4surfinter.hpp"
#include "dbcard4rigidtorigid.hpp"
#include "dbcard4surftosurfjoint.hpp"
#include "dbcard4tiebreaksurface.hpp"
#include "dbcard4tiebreaksurftosurf.hpp"
#include "exptypemap.h"
#include "card4export.h"

void Card4Export::initExportCard4TypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_AUTOMATIC_ONE_WAY_SURFACE_TO_SURFACE_TIEBREAK, importDBCard4AutoSurfaceTiebreak) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_AUTOMATIC_SURFACE_TO_SURFACE_TIEBREAK, importDBCard4AutoSurfaceTiebreak) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_CONSTRAINT_NODES_TO_SURFACE, importDBCard4ConstSurface) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_CONSTRAINT_SURFACE_TO_SURFACE, importDBCard4ConstSurface) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_DRAWBEAD, importDBCard4Drawbead) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_DRAWBEAD_INITIALIZE, importDBCard4DrawbeadInit) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_ERODING_NODES_TO_SURFACE, importDBCard4ErodingSurface) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_ERODING_SINGLE_SURFACE, importDBCard4ErodingSurface) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_ERODING_SURFACE_TO_SURFACE, importDBCard4ErodingSurface) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_NODES_TO_SURFACE_INTERFERENCE, importDBCard4SurfInter) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_ONE_WAY_SURFACE_TO_SURFACE_INTERFERENCE, importDBCard4SurfInter) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_RIGID_BODY_ONE_WAY_TO_RIGID_BODY, importDBCard4RigidToRigid) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_RIGID_BODY_TWO_WAY_TO_RIGID_BODY, importDBCard4RigidToRigid) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_RIGID_NODES_TO_RIGID_BODY, importDBCard4RigidToRigid) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_SURFACE_TO_SURFACE_CONTRACTION_JOINT, importDBCard4SurfToSurfJoint) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_SURFACE_TO_SURFACE_INTERFERENCE, importDBCard4SurfInter) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_TIEBREAK_NODES_ONLY, importDBCard4TiebreakSurface) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_TIEBREAK_NODES_TO_SURFACE, importDBCard4TiebreakSurface) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_TIEBREAK_SURFACE_TO_SURFACE, importDBCard4TiebreakSurfToSurf) );
}
