#include "dbcontact_1d.hpp"
#include "dbcontactautomove.hpp"
#include "dbcontactcoupling.hpp"
#include "dbcontactentity.hpp"
#include "dbcontactgebod.hpp"
#include "dbcontactguidedcable.hpp"
#include "dbcontactinterior.hpp"
#include "dbcontactrigidsurface.hpp"
#include "exptypemap.h"
#include "contactexport.h"

void ContactExport::initExportSimpleTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_1D, importDBContact_1D) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_AUTO_MOVE, importDBContactAutoMove) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_COUPLING, importDBContactCoupling) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_ENTITY, importDBContactEntity) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_HEAD, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_LEFT_FOOT, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_LEFT_HAND, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_LEFT_LOWER_ARM, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_LEFT_LOWER_LEG, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_LEFT_SHOULDER, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_LEFT_UPPER_ARM, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_LEFT_UPPER_LEG, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_LOWER_TORSO, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_MIDDLE_TORSO, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_NECK, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_RIGHT_FOOT, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_RIGHT_HAND, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_RIGHT_LOWER_ARM, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_RIGHT_LOWER_LEG, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_RIGHT_SHOULDER, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_RIGHT_UPPER_ARM, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_RIGHT_UPPER_LEG, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GEBOD_UPPER_TORSO, importDBContactGebod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GUIDED_CABLE, importDBContactGuidedCable) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GUIDED_CABLE_ID, importDBContactGuidedCable) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GUIDED_CABLE_SET, importDBContactGuidedCable) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_GUIDED_CABLE_SET_ID, importDBContactGuidedCable) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_INTERIOR, importDBContactInterior) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTACT_RIGID_SURFACE, importDBContactRigidSurface) );
}
