#include "dbcontrolaccuracy.hpp"
#include "dbcontroladapstep.hpp"
#include "dbcontroladaptive.hpp"
#include "dbcontroladaptivecurve.hpp"
#include "dbcontrolale.hpp"
#include "dbcontrolcoarsen.hpp"
#include "dbcontroldynamicrelaxation.hpp"
#include "nocards.hpp"
#include "exptypemap.h"
#include "controlexport.h"

void ControlExport::initExportAdaptTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_ACCURACY, importDBControlAccuracy) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_ADAPSTEP, importDBControlAdapstep) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_ADAPTIVE, importDBControlAdaptive) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_ADAPTIVE_CURVE, importDBControlAdaptiveCurve) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_ALE, importDBControlAle) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_COARSEN, importDBControlCoarsen) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_DYNAMIC_RELAXATION, importDBControlDynamicRelaxation) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_EXPLOSIVE_SHADOW, importDBNoCards) );
}
