#include "dbcontrolremeshing.hpp"
#include "dbcontrolrigid.hpp"
#include "dbcontrolshell.hpp"
#include "dbcontrolsolid.hpp"
#include "dbcontrolsolution.hpp"
#include "dbcontrolsph.hpp"
#include "dbcontrolspotweldbeam.hpp"
#include "dbcontrolstagedconstruction.hpp"
#include "nocards.hpp"
#include "exptypemap.h"
#include "controlexport.h"

void ControlExport::initExportElementTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_REMESHING, importDBControlRemeshing) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_RIGID, importDBControlRigid) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_SHELL, importDBControlShell) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_SOLID, importDBControlSolid) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_SOLUTION, importDBControlSolution) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_SPH, importDBControlSph) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_SPOTWELD_BEAM, importDBControlSpotweldBeam) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_STAGED_CONSTRUCTION, importDBControlStagedConstruction) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_STRUCTURED, importDBNoCards) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_STRUCTURED_TERM, importDBNoCards) );
}
