#include "dbcontrolcpu.hpp"
#include "dbcontrolformingposition.hpp"
#include "dbcontrolformingprojection.hpp"
#include "dbcontrolformingtemplate.hpp"
#include "dbcontrolformingtravel.hpp"
#include "dbcontrolforminguser.hpp"
#include "dbcontroloutput.hpp"
#include "dbcontrolparallel.hpp"
#include "nocards.hpp"
#include "exptypemap.h"
#include "controlexport.h"

void ControlExport::initExportFormingTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_CPU, importDBControlCpu) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_FORMING_POSITION, importDBControlFormingPosition) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_FORMING_PROJECTION, importDBControlFormingProjection) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_FORMING_TEMPLATE, importDBControlFormingTemplate) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_FORMING_TRAVEL, importDBControlFormingTravel) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_FORMING_USER, importDBControlFormingUser) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_OUTPUT, importDBControlOutput) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_PARALLEL, importDBControlParallel) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_SUBCYCLE, importDBNoCards) );
}
