#include "dbcontrolimplicitauto.hpp"
#include "dbcontrolimplicitbuckle.hpp"
#include "dbcontrolimplicitdynamics.hpp"
#include "dbcontrolimplicitinertiarelief.hpp"
#include "dbcontrolimplicitjoints.hpp"
#include "dbcontrolimplicitmodes.hpp"
#include "dbcontrolimplicitsolver.hpp"
#include "dbcontrolimplicitstabilization.hpp"
#include "dbcontrolimplicittermination.hpp"
#include "exptypemap.h"
#include "controlexport.h"

void ControlExport::initExportImplicitTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_IMPLICIT_AUTO, importDBControlImplicitAuto) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_IMPLICIT_BUCKLE, importDBControlImplicitBuckle) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_IMPLICIT_DYNAMICS, importDBControlImplicitDynamics) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_IMPLICIT_INERTIA_RELIEF, importDBControlImplicitInertiaRelief) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_IMPLICIT_JOINTS, importDBControlImplicitJoints) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_IMPLICIT_MODES, importDBControlImplicitModes) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_IMPLICIT_SOLVER, importDBControlImplicitSolver) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_IMPLICIT_STABILIZATION, importDBControlImplicitStabilization) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_IMPLICIT_TERMINATION, importDBControlImplicitTermination) );
}
