#ifndef _DBCONTROLMPPDECOMPOSITIONCONTACTISOLATE_H_
#define _DBCONTROLMPPDECOMPOSITIONCONTACTISOLATE_H_

#include "manager.h"
#include "dispexport.h"
#include "getdbbase.h"

/** Class used for getting data from database for *CONTROL_MPP_DECOMPOSITION_CONTACT_ISOLATE
  * keyword */

class DBControlMppDecompositionContactIsolate : public GetDBBase
{
public:
/** Class constructor for creating the objects.
  * \param gold_conn GoldenConn object to access database
  * \param imp_obj ImportObject pointer to hold data
  */
   DBControlMppDecompositionContactIsolate(GoldenConn *gold_conn, ImportObject *imp_obj) : GetDBBase (gold_conn, imp_obj)
   {
   }

/** Class destructor for releasing the memory in the object.
  */
   virtual ~DBControlMppDecompositionContactIsolate()
   {
   }

public:
/** Function to get Card details for *CONTROL_MPP_DECOMPOSITION_CONTACT_ISOLATE
  * keyword from database */
   void dbReadCard(unsigned int loop_count = (1 << 31))
   {
      const char *fields[] = {"ID1","ID2","ID3","ID4","ID5",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, };
      unsigned int field_indices[] = {0, 1, 2, 3, 4, };
      unsigned int man_types[] = {CONTACT, CONTACT, CONTACT, CONTACT, CONTACT, };
      unsigned int kw_types[] = {9999, 9999, 9999, 9999, 9999, };
      unsigned int num_indices = 5;
      numFields = 5;
      unsigned int field_widths[] = {10, 10, 10, 10, 10, };
      wordArray = goldenConn->nextCard();
      if( !wordArray )
      {
         numFields = 0;
         return;
      }
      if( Card::isFlagOn(SAVE_IDS) && !impObj->cardCount )
         addIDToFile(wordArray, 0, CONTROL, impObj);
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(&wordArray[2], num_indices, field_indices, man_types, kw_types, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         if( loop_count & (1<<31) )
            cardObj = new DBCard("Card");
         else
         {
            char name_buf[64];
            sprintf(name_buf,"%s_%d","Card",loop_count);
            cardObj = new DBCard(name_buf);
         }
         ((DBCard *)cardObj)->index = atoi(wordArray[0]);
         cardObj->addFields(numFields, field_types, field_widths, fields, &wordArray[2]);
         impObj->addCard(cardObj);
      }
      impObj->cardCount++;
   }

/** Function to import all the cards of keyword *CONTROL_MPP_DECOMPOSITION_CONTACT_ISOLATE
  * from database */
   unsigned int importDBControlMppDecompositionContactIsolate()
   {
      dbReadCard();
      return 0;
   }
};

#endif

