#include "nocards.hpp"
#include "dbcontrolmppdecompositioncontactdistribute.hpp"
#include "dbcontrolmppdecompositioncontactisolate.hpp"
#include "dbcontrolmppdecompositionfile.hpp"
#include "dbcontrolmppdecompositionmethod.hpp"
#include "dbcontrolmppdecompositionnumproc.hpp"
#include "dbcontrolmppdecompositiontransformation.hpp"
#include "dbcontrolnonlocal.hpp"
#include "exptypemap.h"
#include "controlexport.h"

void ControlExport::initExportMppTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_MPP_DECOMPOSITION_AUTOMATIC, importDBNoCards) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_MPP_DECOMPOSITION_CHECK_SPEED, importDBNoCards) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_MPP_DECOMPOSITION_CONTACT_DISTRIBUTE, importDBControlMppDecompositionContactDistribute) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_MPP_DECOMPOSITION_CONTACT_ISOLATE, importDBControlMppDecompositionContactIsolate) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_MPP_DECOMPOSITION_FILE, importDBControlMppDecompositionFile) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_MPP_DECOMPOSITION_METHOD, importDBControlMppDecompositionMethod) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_MPP_DECOMPOSITION_NUMPROC, importDBControlMppDecompositionNumproc) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_MPP_DECOMPOSITION_SHOW, importDBNoCards) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_MPP_DECOMPOSITION_TRANSFORMATION, importDBControlMppDecompositionTransformation) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_MPP_IO_NOD3DUMP, importDBNoCards) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_MPP_IO_NODUMP, importDBNoCards) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_MPP_IO_NOFULL, importDBNoCards) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_MPP_IO_SWAPBYTES, importDBNoCards) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_NONLOCAL, importDBControlNonlocal) );
}
