#include "dbcontrolbulkviscosity.hpp"
#include "nocards.hpp"
#include "dbcontrolcheckshell.hpp"
#include "dbcontrolcontact.hpp"
#include "dbcontrolcoupling.hpp"
#include "dbcontrolefg.hpp"
#include "dbcontrolenergy.hpp"
#include "dbcontrolhourglass.hpp"
#include "exptypemap.h"
#include "controlexport.h"

void ControlExport::initExportSimpleTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_BULK_VISCOSITY, importDBControlBulkViscosity) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_CHECK, importDBNoCards) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_CHECK_SHELL, importDBControlCheckShell) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_CONTACT, importDBControlContact) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_COUPLING, importDBControlCoupling) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_EFG, importDBControlEfg) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_ENERGY, importDBControlEnergy) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_HOURGLASS, importDBControlHourglass) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_HOURGLASS_936, importDBControlHourglass) );
}
