#include "dbcontrolimpliciteigenvalue.hpp"
#include "dbcontrolimplicitgeneral.hpp"
#include "dbcontrolimplicitsolution.hpp"
#include "dbcontroltermination.hpp"
#include "dbcontrolthermalnonlinear.hpp"
#include "dbcontrolthermalsolver.hpp"
#include "dbcontrolthermaltimestep.hpp"
#include "dbcontroltimestep.hpp"
#include "exptypemap.h"
#include "controlexport.h"

void ControlExport::initExportThermalTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_IMPLICIT_EIGENVALUE, importDBControlImplicitEigenvalue) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_IMPLICIT_GENERAL, importDBControlImplicitGeneral) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_IMPLICIT_SOLUTION, importDBControlImplicitSolution) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_TERMINATION, importDBControlTermination) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_THERMAL_NONLINEAR, importDBControlThermalNonlinear) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_THERMAL_SOLVER, importDBControlThermalSolver) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_THERMAL_TIMESTEP, importDBControlThermalTimestep) );
   expTypeFuncMap.insert( expTypeFuncPair(CONTROL_TIMESTEP, importDBControlTimestep) );
}
