#ifndef _DBDATABASEBINARYD3PLOT_H_
#define _DBDATABASEBINARYD3PLOT_H_

#include "manager.h"
#include "dispexport.h"
#include "dbdatabasebinary.h"

/** Class used for getting data from database for *DATABASE_BINARY_D3PLOT
  * keyword */

class DBDatabaseBinaryD3plot : public DBDatabaseBinary
{
public:
/** Class constructor for creating the objects.
  * \param gold_conn GoldenConn object to access database
  * \param imp_obj ImportObject pointer to hold data
  */
   DBDatabaseBinaryD3plot(GoldenConn *gold_conn, ImportObject *imp_obj) : DBDatabaseBinary (gold_conn, imp_obj)
   {
   }

/** Class destructor for releasing the memory in the object.
  */
   virtual ~DBDatabaseBinaryD3plot()
   {
   }

public:
/** Function to get D3plotCard details for *DATABASE_BINARY_D3PLOT
  * keyword from database */
   void dbReadD3plotCard(unsigned int loop_count = (1 << 31))
   {
      const char *fields[] = {"IOOPT",};
      unsigned int field_types[] = {DATA_INT, };
      numFields = 1;
      unsigned int field_widths[] = {10, };
      wordArray = goldenConn->nextCard();
      if( !wordArray )
      {
         numFields = 0;
         return;
      }
      if( Card::isFlagOn(SAVE_IDS) && !impObj->cardCount )
         addIDToFile(wordArray, 0, DATABASE, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         if( loop_count & (1<<31) )
            cardObj = new DBCard("D3plotCard");
         else
         {
            char name_buf[64];
            sprintf(name_buf,"%s_%d","D3plotCard",loop_count);
            cardObj = new DBCard(name_buf);
         }
         ((DBCard *)cardObj)->index = atoi(wordArray[0]);
         cardObj->addFields(numFields, field_types, field_widths, fields, &wordArray[2]);
         impObj->addCard(cardObj);
      }
      impObj->cardCount++;
   }

/** Function to import all the cards of keyword *DATABASE_BINARY_D3PLOT
  * from database */
   unsigned int importDBDatabaseBinaryD3plot()
   {
      importDBDatabaseBinary();
      dbReadD3plotCard();
      return 0;
   }
};

#endif

