#ifndef _DBDATABASEEXTENT_H_
#define _DBDATABASEEXTENT_H_

#include "manager.h"
#include "dispexport.h"
#include "getdbbase.h"

/** Class used for getting data from database for *DATABASE_EXTENT_AVS
  * keyword */

class DBDatabaseExtent : public GetDBBase
{
public:
/** Class constructor for creating the objects.
  * \param gold_conn GoldenConn object to access database
  * \param imp_obj ImportObject pointer to hold data
  */
   DBDatabaseExtent(GoldenConn *gold_conn, ImportObject *imp_obj) : GetDBBase (gold_conn, imp_obj)
   {
   }

/** Class destructor for releasing the memory in the object.
  */
   virtual ~DBDatabaseExtent()
   {
   }

public:
/** Function to get ExtentCard details for *DATABASE_EXTENT_AVS
  * keyword from database */
   void dbReadExtentCard(unsigned int loop_count = (1 << 31))
   {
      const char *fields[] = {"VTYPE","COMP",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, };
      numFields = 2;
      unsigned int field_widths[] = {10, 10, };
      wordArray = goldenConn->nextCard();
      if( !wordArray )
      {
         numFields = 0;
         return;
      }
      if( Card::isFlagOn(SAVE_IDS) && !impObj->cardCount )
         addIDToFile(wordArray, 0, DATABASE, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         if( loop_count & (1<<31) )
            cardObj = new DBCard("ExtentCard");
         else
         {
            char name_buf[64];
            sprintf(name_buf,"%s_%d","ExtentCard",loop_count);
            cardObj = new DBCard(name_buf);
         }
         ((DBCard *)cardObj)->index = atoi(wordArray[0]);
         cardObj->addFields(numFields, field_types, field_widths, fields, &wordArray[2]);
         impObj->addCard(cardObj);
      }
      impObj->cardCount++;
   }

/** Function to import all the cards of keyword *DATABASE_EXTENT_AVS
  * from database */
   unsigned int importDBDatabaseExtent()
   {
      dbReadExtentCard();
      return 0;
   }
};

#endif

