#include "dbdatabasehistorynode.hpp"
#include "dbdatabasehistorynodeid.hpp"
#include "dbdatabasehistorynodelocal.hpp"
#include "dbdatabasehistorynodelocalid.hpp"
#include "exptypemap.h"
#include "databaseexport.h"

void DatabaseExport::initExportHistryTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_BEAM, importDBDatabaseHistoryNode) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_BEAM_ID, importDBDatabaseHistoryNodeId) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_BEAM_SET, importDBDatabaseHistoryNode) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_DISCRETE, importDBDatabaseHistoryNode) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_DISCRETE_ID, importDBDatabaseHistoryNodeId) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_DISCRETE_SET, importDBDatabaseHistoryNode) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_NODE, importDBDatabaseHistoryNode) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_NODE_ID, importDBDatabaseHistoryNodeId) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_NODE_LOCAL, importDBDatabaseHistoryNodeLocal) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_NODE_LOCAL_ID, importDBDatabaseHistoryNodeLocalId) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_NODE_SET, importDBDatabaseHistoryNode) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_NODE_SET_LOCAL, importDBDatabaseHistoryNodeLocal) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_SEATBELT, importDBDatabaseHistoryNode) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_SEATBELT_ID, importDBDatabaseHistoryNodeId) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_SHELL, importDBDatabaseHistoryNode) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_SHELL_ID, importDBDatabaseHistoryNodeId) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_SHELL_SET, importDBDatabaseHistoryNode) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_SOLID, importDBDatabaseHistoryNode) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_SOLID_ID, importDBDatabaseHistoryNodeId) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_SOLID_SET, importDBDatabaseHistoryNode) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_SPH, importDBDatabaseHistoryNode) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_SPH_SET, importDBDatabaseHistoryNode) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_TSHELL, importDBDatabaseHistoryNode) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_TSHELL_ID, importDBDatabaseHistoryNodeId) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_HISTORY_TSHELL_SET, importDBDatabaseHistoryNode) );
}
