#include "dbdatabaseabstat.hpp"
#include "dbdatabasefsi.hpp"
#include "dbdatabasefsisensor.hpp"
#include "exptypemap.h"
#include "databaseexport.h"

void DatabaseExport::initExportOptionTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_AVSFLT, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_BNDOUT, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_DCFAIL, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_DEFGEO, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_DEFORC, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_ELOUT, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_FSI, importDBDatabaseFsi) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_FSI_SENSOR, importDBDatabaseFsiSensor) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_GCEOUT, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_GLSTAT, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_GLSTAT_MASS_PROPERTIES, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_H3OUT, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_JNTFORC, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_MATSUM, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_MOVIE, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_MPGS, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_NCFORC, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_NODFOR, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_NODOUT, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_ABSTAT, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_RBDOUT, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_RCFORC, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_RWFORC, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_SBTOUT, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_SECFORC, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_SLEOUT, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_SPCFORC, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_SPHOUT, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_SSSTAT, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_SSSTAT_MASS_PROPERTIES, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_SWFORC, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_TPRINT, importDBDatabaseAbstat) );
   expTypeFuncMap.insert( expTypeFuncPair(DATABASE_TRHIST, importDBDatabaseAbstat) );
}
