#ifndef _DBDEFINEHEXSPOTWELDASSEMBLYN_H_
#define _DBDEFINEHEXSPOTWELDASSEMBLYN_H_

#include "manager.h"
#include "dispexport.h"
#include "dbdefinehexspotweldassembly.h"

/** Class used for getting data from database for *DEFINE_HEX_SPOTWELD_ASSEMBLY_N
  * keyword */

class DBDefineHexSpotweldAssemblyN : public DBDefineHexSpotweldAssembly
{
public:
/** Class constructor for creating the objects.
  * \param gold_conn GoldenConn object to access database
  * \param imp_obj ImportObject pointer to hold data
  */
   DBDefineHexSpotweldAssemblyN(GoldenConn *gold_conn, ImportObject *imp_obj) : DBDefineHexSpotweldAssembly (gold_conn, imp_obj)
   {
   }

/** Class destructor for releasing the memory in the object.
  */
   virtual ~DBDefineHexSpotweldAssemblyN()
   {
   }

public:
/** Function to get Card3 details for *DEFINE_HEX_SPOTWELD_ASSEMBLY_N
  * keyword from database */
   void dbReadCard3(unsigned int loop_count = (1 << 31))
   {
      const char *fields[] = {"EID9","EID10","EID11","EID12","EID13","EID14","EID15","EID16",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, };
      unsigned int field_indices[] = {0, 1, 2, 3, 4, 5, 6, 7, };
      unsigned int man_types[] = {ELEMENT, ELEMENT, ELEMENT, ELEMENT, ELEMENT, ELEMENT, ELEMENT, ELEMENT, };
      unsigned int kw_types[] = {SOLID, SOLID, SOLID, SOLID, SOLID, SOLID, SOLID, SOLID, };
      unsigned int num_indices = 8;
      numFields = 8;
      unsigned int field_widths[] = {10, 10, 10, 10, 10, 10, 10, 10, };
      wordArray = goldenConn->nextCard();
      if( !wordArray )
      {
         numFields = 0;
         return;
      }
      if( Card::isFlagOn(SAVE_IDS) && !impObj->cardCount )
         addIDToFile(wordArray, 0, DEFINE, impObj);
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(&wordArray[2], num_indices, field_indices, man_types, kw_types, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         if( loop_count & (1<<31) )
            cardObj = new DBCard("Card3");
         else
         {
            char name_buf[64];
            sprintf(name_buf,"%s_%d","Card3",loop_count);
            cardObj = new DBCard(name_buf);
         }
         ((DBCard *)cardObj)->index = atoi(wordArray[0]);
         cardObj->addFields(numFields, field_types, field_widths, fields, &wordArray[2]);
         impObj->addCard(cardObj);
      }
      impObj->cardCount++;
   }

/** Function to import all the cards of keyword *DEFINE_HEX_SPOTWELD_ASSEMBLY_N
  * from database */
   unsigned int importDBDefineHexSpotweldAssemblyN()
   {
      importDBDefineHexSpotweldAssembly();
      int num = 0;
      sscanf(impObj->getKeyword().data(), "*DEFINE_HEX_SPOTWELD_ASSEMBLY_%d", &num);
      if( num > 8 )
      {
         dbReadCard3();
      }
      return 0;
   }
};

#endif

