#include <iostream>
#include <algorithm>
#include "generic.h"
#include "eftype.h"
#include "efexport.h"
#include <stdlib.h>

using namespace std;

EFExport::EFExport
(
   char         *model_name,
   GoldenConn   *gold_conn,
   EFManager    *ef_man
)
{
   modelName = model_name;
   efManPtr = ef_man;
   goldenConn = gold_conn;

}

int EFExport::getKeywordFromType
    (
       unsigned int kw_type,
       string & key_word
    )
{
   switch(kw_type)
   {
      case EF_CONTROL:
	 key_word = "*EF_CONTROL";
	 break;
      case EF_GRID:
	 key_word = "*EF_GRID";
	 break;
      case EF_MATERIAL:
	 key_word = "*EF_MATERIAL";
	 break;
      case EF_TOGGLES:
	 key_word = "*EF_TOGGLES";
	 break;
      case EF_NEW_TYPE:
      default:
         return 1;
   }
   return 0;
}

unsigned int EFExport::dbReadEFs()
{
   char         **row_data, buf[16];
   unsigned int	i, num_efs = 0, total_efs = 0, num_kw_types = 0;
   expTypeFuncIterator eexp_iter = expTypeFuncMap.end(), exp_iter;

   string       qry = "select kw_type from ", kw_str;
   string table_name = "`" + modelName + "_EFS`";
   qry += table_name;
   qry += " group by kw_type;";

cout << "KW QRY = " << qry << endl;

   if( goldenConn->executeQuery( qry.data() ) )
      return 0;

   num_kw_types = goldenConn->numRows();

   if( !num_kw_types )
      return 0;

   unsigned int *kw_types = new unsigned int[num_kw_types];

   for(i = 0; i < num_kw_types; i++)
   {
      row_data = goldenConn->nextRow();
      kw_types[i] = atoi( row_data[0] );
cout << "KW EF TYPE = " << kw_types[i] << endl;
   }

   for(i = 0; i < num_kw_types; i++)
   {
      qry = "select * from ";
      qry += table_name;
      qry += " where kw_type=";
      sprintf(buf, "%u", kw_types[i]);
      qry += buf;
      qry += " order by card_index;";

cout << "EF QRY = " << qry << endl;

      if( getKeywordFromType(kw_types[i], kw_str) )
         continue;

cout << "EF KW = " << kw_str << endl;

      if( goldenConn->executeQuery( qry.data() ) )
	 break;

      exp_iter = expTypeFuncMap.find(kw_types[i]);

      if( exp_iter == eexp_iter )
      {
	 cout << "EF TYPE NOT FOUND" << endl;
         continue;
      }

      num_efs = 0;
      while( goldenConn->rowsLeft() )
      {
	 impObj = new ExportObject((char *)kw_str.data(), kw_types[i]);
         goldenConn->clearFlag(KW_DATA_END);
	 (exp_iter->second)(goldenConn, impObj);
         if( impObj->cardCount )
         {
	    efManPtr->add(kw_str.data(), impObj);
	    num_efs++;
         }
         else
            delete impObj;
      }

      total_efs += num_efs;
   }

   delete kw_types;

   return total_efs;
}

