#include "dbelementbeam.hpp"
#include "dbelementbeamoffset.hpp"
#include "dbelementbeamorientation.hpp"
#include "dbelementbeampid.hpp"
#include "dbelementbeamscalar.hpp"
#include "dbelementbeamscalr.hpp"
#include "dbelementbeamsection.hpp"
#include "dbelementbeamthickness.hpp"
#include "dbelementbeamwarpage.hpp"
#include "exptypemap.h"
#include "elementexport.h"

void ElementExport::initExportBeamTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_BEAM, importDBElementBeam) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_BEAM_OFFSET, importDBElementBeamOffset) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_BEAM_ORIENTATION, importDBElementBeamOrientation) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_BEAM_PID, importDBElementBeamPid) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_BEAM_SCALAR, importDBElementBeamScalar) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_BEAM_SCALR, importDBElementBeamScalr) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_BEAM_SECTION, importDBElementBeamSection) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_BEAM_THICKNESS, importDBElementBeamThickness) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_BEAM_WARPAGE, importDBElementBeamWarpage) );
}
