#include "dbelementshell.hpp"
#include "dbelementshellthickness.hpp"
#include "dbelementshelldof.hpp"
#include "dbelementshelloffset.hpp"
#include "dbelementshellsourcesink.hpp"
#include "dbelementsolid.hpp"
#include "dbelementsoliddof.hpp"
#include "dbelementsolidortho.hpp"
#include "dbelementtshell.hpp"
#include "exptypemap.h"
#include "elementexport.h"

void ElementExport::initExportShellTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_SHELL, importDBElementShell) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_SHELL_BETA, importDBElementShellThickness) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_SHELL_DOF, importDBElementShellDof) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_SHELL_MCD, importDBElementShellThickness) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_SHELL_OFFSET, importDBElementShellOffset) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_SHELL_SOURCE_SINK, importDBElementShellSourceSink) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_SHELL_THICKNESS, importDBElementShellThickness) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_SOLID, importDBElementSolid) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_SOLID_DOF, importDBElementSolidDof) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_SOLID_ORTHO, importDBElementSolidOrtho) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_TSHELL, importDBElementTshell) );
}
