#ifndef _DBELEMENTINERTIAOFFSET_H_
#define _DBELEMENTINERTIAOFFSET_H_

#include "manager.h"
#include "dispexport.h"
#include "dbelementinertia.h"

/** Class used for getting data from database for *ELEMENT_INERTIA_OFFSET
  * keyword */

class DBElementInertiaOffset : public DBElementInertia
{
public:
/** Class constructor for creating the objects.
  * \param gold_conn GoldenConn object to access database
  * \param imp_obj ImportObject pointer to hold data
  */
   DBElementInertiaOffset(GoldenConn *gold_conn, ImportObject *imp_obj) : DBElementInertia (gold_conn, imp_obj)
   {
   }

/** Class destructor for releasing the memory in the object.
  */
   virtual ~DBElementInertiaOffset()
   {
   }

public:
/** Function to get Card3 details for *ELEMENT_INERTIA_OFFSET
  * keyword from database */
   void dbReadCard3(unsigned int loop_count = (1 << 31))
   {
      const char *fields[] = {"X-OFF","Y-OFF","Z-OFF",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 3;
      unsigned int field_widths[] = {10, 10, 10, };
      wordArray = goldenConn->nextCard();
      if( !wordArray )
      {
         numFields = 0;
         return;
      }
      if( Card::isFlagOn(SAVE_IDS) && !impObj->cardCount )
         addIDToFile(wordArray, 0, ELEMENT, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         if( loop_count & (1<<31) )
            cardObj = new DBCard("Card3");
         else
         {
            char name_buf[64];
            sprintf(name_buf,"%s_%d","Card3",loop_count);
            cardObj = new DBCard(name_buf);
         }
         ((DBCard *)cardObj)->index = atoi(wordArray[0]);
         cardObj->addFields(numFields, field_types, field_widths, fields, &wordArray[2]);
         impObj->addCard(cardObj);
      }
      impObj->cardCount++;
   }

/** Function to import all the cards of keyword *ELEMENT_INERTIA_OFFSET
  * from database */
   unsigned int importDBElementInertiaOffset()
   {
      importDBElementInertia();
      dbReadCard3();
      return 0;
   }
};

#endif

