#include "dbelementdirectmatrixinput.hpp"
#include "dbelementdiscrete.hpp"
#include "dbelementinertia.hpp"
#include "dbelementinertiaoffset.hpp"
#include "dbelementmass.hpp"
#include "dbelementmasspart.hpp"
#include "dbelementplotel.hpp"
#include "dbelementsph.hpp"
#include "dbelementtrim.hpp"
#include "exptypemap.h"
#include "elementexport.h"

void ElementExport::initExportSimpleTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_DIRECT_MATRIX_INPUT, importDBElementDirectMatrixInput) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_DISCRETE, importDBElementDiscrete) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_INERTIA, importDBElementInertia) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_INERTIA_OFFSET, importDBElementInertiaOffset) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_MASS, importDBElementMass) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_MASS_NODE_SET, importDBElementMass) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_MASS_PART, importDBElementMassPart) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_MASS_PART_SET, importDBElementMassPart) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_PLOTEL, importDBElementPlotel) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_SPH, importDBElementSph) );
   expTypeFuncMap.insert( expTypeFuncPair(ELEMENT_TRIM, importDBElementTrim) );
}
