#include "dbeosgruneisen.hpp"
#include "dbeoslinearpolynomial.hpp"
#include "dbeoslinearpolynomialwithenergyleak.hpp"
#include "dbeosratioofpolynomials.hpp"
#include "dbeossacktuesday.hpp"
#include "exptypemap.h"
#include "eosexport.h"

void EosExport::initExportPolyTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(EOS_GRUNEISEN, importDBEosGruneisen) );
   expTypeFuncMap.insert( expTypeFuncPair(EOS_LINEAR_POLYNOMIAL, importDBEosLinearPolynomial) );
   expTypeFuncMap.insert( expTypeFuncPair(EOS_LINEAR_POLYNOMIAL_WITH_ENERGY_LEAK, importDBEosLinearPolynomialWithEnergyLeak) );
   expTypeFuncMap.insert( expTypeFuncPair(EOS_RATIO_OF_POLYNOMIALS, importDBEosRatioOfPolynomials) );
   expTypeFuncMap.insert( expTypeFuncPair(EOS_SACK_TUESDAY, importDBEosSackTuesday) );
}
