#ifndef _CONTACT_EXPORT_OBJECT_H_
#define _CONTACT_EXPORT_OBJECT_H_

#include "dbcard.h"

/** Class to store the *CONTACT keywords data from database. The contact types
  * are stored using bits in an integer. So the *CONTACT objects have one more
  * variable to store the bit type of information
  */
class ContactExportObject : public ExportObject
{
public:
   /** Constructor to create this object
     * \param keyword Name of contact keyword
     * \param contact_type Type of contact to be used
     * \param contact_bin_type An interger that stores the contact type in bits
     */
   ContactExportObject
   (
      char *keyword, 
      unsigned int & contact_type,
      unsigned int & contact_bin_type
   ) : ExportObject(keyword, contact_type), contactBinType(contact_bin_type)
   {
   }
public:
   /** Stores the contact type in bit form */
   unsigned int contactBinType;
};

#endif

