#ifndef _EXP_TITLE_H_
#define _EXP_TITLE_H_

#include "getdbbase.h"

/** Class to store the *_TITLE and *TITLE data from database
  */
class DBTitle : public GetDBBase
{
public:
   /** Constructor to create this object.
     * \param gold_conn Connection object to connect to database
     * \param imp_obj ImportObject pointer to store the data from database
     */
   DBTitle(GoldenConn *gold_conn, ImportObject *imp_obj) : GetDBBase(gold_conn, imp_obj)
   {
   }

   /** Constructor to create this object.
     * \param gold_conn Connection object to connect to database
     */
   DBTitle(GoldenConn *gold_conn) : GetDBBase(gold_conn, NULL)
   {
   }

   ~DBTitle()
   {
   }

   /** Function to read data from database for *_TITLE and *TITLE keywords
     * \param imp_obj ImportObject pointer to store the data
     */
   void readCard(ImportObject *imp_obj)
   {
      impObj = imp_obj;
      readCard();
   }

   /** Function to read data from database for *_TITLE and *TITLE keywords
     */
   void readCard()
   {
      const char *fields[] = {"TITLE",};
      unsigned int field_types[] = {DATA_CHAR_ARRAY, };
      numFields = 1;
      unsigned int field_widths[] = {80, };
      wordArray = goldenConn->nextCard();
      if( !wordArray )
      {
         numFields = 0;
         return;
      }
      cardObj = new DBCard("TitleCard");
      ((DBCard *)cardObj)->index = atoi(wordArray[0]);
      cardObj->addFields(numFields, field_types, field_widths, 
                                               fields, &wordArray[2]);
      impObj->addCard(cardObj);
      impObj->cardCount++;
   }
};

#endif

