#include <iostream>
#include <algorithm>
#include "generic.h"
#include "hgtype.h"
#include "hgexport.h"
#include "dbhourglass.h"
#include "exptitle.h"
#include <stdlib.h>

using namespace std;

HgExport::HgExport
(
   char         *model_name,
   GoldenConn   *gold_conn,
   HgManager    *hg_man
)
{
   modelName = model_name;
   hgManPtr = hg_man;
   goldenConn = gold_conn;
}

unsigned int HgExport::dbReadHgs()
{
   char         **row_data, buf[16];
   unsigned int	i, num_hgs = 0, total_hgs = 0, num_kw_types = 0;
   expTypeFuncIterator eexp_iter = expTypeFuncMap.end(), exp_iter;

   string       qry = "select kw_type from ", kw_str;
   string table_name = "`" + modelName + "_HOURGLASSS`";
   qry += table_name;
   qry += " group by kw_type;";

cout << "KW QRY = " << qry << endl;

   if( goldenConn->executeQuery( qry.data() ) )
      return 0;

   num_kw_types = goldenConn->numRows();

   if( !num_kw_types )
      return 0;

   unsigned int *kw_types = new unsigned int[num_kw_types];

   for(i = 0; i < num_kw_types; i++)
   {
      row_data = goldenConn->nextRow();
      kw_types[i] = atoi( row_data[0] );
cout << "KW HG TYPE = " << kw_types[i] << endl;
   }

   const unsigned int HOURGLASS_TITLE = HOURGLASS + TITLE_CARD; 

   for(i = 0; i < num_kw_types; i++)
   {
      switch(kw_types[i])
      {
	 case HOURGLASS:
            kw_str = "*HOURGLASS";
	    break;
	 case HOURGLASS_TITLE:
            kw_str = "*HOURGLASS_TITLE";
	    break;
	 default:
	    cout << "HG TYPE NOT FOUND" << endl;
	    continue;
      }

      qry = "select * from ";
      qry += table_name;
      qry += " where kw_type=";
      sprintf(buf, "%u", kw_types[i]);
      qry += buf;
      qry += " order by card_index;";

cout << "HG QRY = " << qry << endl;

      if( goldenConn->executeQuery( qry.data() ) )
	 break;

      DBTitle title(goldenConn);

      num_hgs = 0;
      while( goldenConn->rowsLeft() )
      {
         impObj = new ExportObject((char *)kw_str.data(), kw_types[i]);
         goldenConn->clearFlag(KW_DATA_END);
	 switch(kw_types[i])
	 {
	    case HOURGLASS_TITLE:
               title.readCard(impObj);
               break;
	 }

	 DBHourglass hg(goldenConn, impObj); 
	 hg.importDBHourglass();
	 if( impObj->cardCount )
	 {
	    hgManPtr->add(kw_str.data(), impObj);
	    num_hgs++;
	 }
	 else
	    delete impObj;
      }

      total_hgs += num_hgs;
   }

   delete kw_types;

   return total_hgs;
}

