#ifndef _Hourglass_h_
#define _Hourglass_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

class Hourglass : public ImportBase
{
public:
   /** Default constructor for creating this object
     * \param data_line Pointer to the file data line by line
     * \param imp_obj Object to store the imported data
     */
   Hourglass(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

   virtual ~Hourglass()
   {
   }

public:

   /** Reads the first card data of *HOURGLASS keyword */
   void readCard1()
   {
      char *fields[] = {"HGID","IHQ","QM","IBQ","Q1","Q2","QB/VDC","QW",};
      unsigned int field_types[] = {DATA_CHAR_ARRAY, DATA_INT, DATA_DOUBLE, DATA_INT, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 8;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_IDS) )
         addIDToFile(wordArray, 0, HG, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

   /** Imports the *HOURGLASS keyword from LSDYNA native file */
   unsigned int importHourglass()
   {
      readCard1();
      return 0;
   }
};

#endif

