#ifndef _DBINCLUDECOMPENSATIONDESIREDBLANKSHAPE_H_
#define _DBINCLUDECOMPENSATIONDESIREDBLANKSHAPE_H_

#include "manager.h"
#include "dispexport.h"
#include "getdbbase.h"

/** Class used for getting data from database for *INCLUDE_COMPENSATION_DESIRED_BLANK_SHAPE
  * keyword */

class DBIncludeCompensationDesiredBlankShape : public GetDBBase
{
public:
/** Class constructor for creating the objects.
  * \param gold_conn GoldenConn object to access database
  * \param imp_obj ImportObject pointer to hold data
  */
   DBIncludeCompensationDesiredBlankShape(GoldenConn *gold_conn, ImportObject *imp_obj) : GetDBBase (gold_conn, imp_obj)
   {
   }

/** Class destructor for releasing the memory in the object.
  */
   virtual ~DBIncludeCompensationDesiredBlankShape()
   {
   }

public:
/** Function to get Card3 details for *INCLUDE_COMPENSATION_DESIRED_BLANK_SHAPE
  * keyword from database */
   void dbReadCard3(unsigned int loop_count = (1 << 31))
   {
      const char *fields[] = {"FILENAME",};
      unsigned int field_types[] = {DATA_CHAR_ARRAY, };
      numFields = 1;
      unsigned int field_widths[] = {80, };
      wordArray = goldenConn->nextCard();
      if( !wordArray )
      {
         numFields = 0;
         return;
      }
      if( Card::isFlagOn(SAVE_IDS) && !impObj->cardCount )
         addIDToFile(wordArray, 0, INC, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         if( loop_count & (1<<31) )
            cardObj = new DBCard("Card3");
         else
         {
            char name_buf[64];
            sprintf(name_buf,"%s_%d","Card3",loop_count);
            cardObj = new DBCard(name_buf);
         }
         ((DBCard *)cardObj)->index = atoi(wordArray[0]);
         cardObj->addFields(numFields, field_types, field_widths, fields, &wordArray[2]);
         impObj->addCard(cardObj);
      }
      impObj->cardCount++;
   }

/** Function to import all the cards of keyword *INCLUDE_COMPENSATION_DESIRED_BLANK_SHAPE
  * from database */
   unsigned int importDBIncludeCompensationDesiredBlankShape()
   {
      dbReadCard3();
      return 0;
   }
};

#endif

