#include "dbinitialstressbeam.hpp"
#include "dbinitialstressdepth.hpp"
#include "dbinitialstresssection.hpp"
#include "dbinitialstressshell.hpp"
#include "dbinitialstresssolid.hpp"
#include "dbinitialstresstshell.hpp"
#include "exptypemap.h"
#include "initialexport.h"

void InitialExport::initExportStressTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(INITIAL_STRESS_BEAM, importDBInitialStressBeam) );
   expTypeFuncMap.insert( expTypeFuncPair(INITIAL_STRESS_DEPTH, importDBInitialStressDepth) );
   expTypeFuncMap.insert( expTypeFuncPair(INITIAL_STRESS_SECTION, importDBInitialStressSection) );
   expTypeFuncMap.insert( expTypeFuncPair(INITIAL_STRESS_SHELL, importDBInitialStressShell) );
   expTypeFuncMap.insert( expTypeFuncPair(INITIAL_STRESS_SHELL_SET, importDBInitialStressShell) );
   expTypeFuncMap.insert( expTypeFuncPair(INITIAL_STRESS_SOLID, importDBInitialStressSolid) );
   expTypeFuncMap.insert( expTypeFuncPair(INITIAL_STRESS_TSHELL, importDBInitialStressTshell) );
}
