#include "dbinterfacecompensationnew.hpp"
#include "dbinterfacecomponentnode.hpp"
#include "dbinterfacejoy.hpp"
#include "dbinterfacelinkingdiscretenodenode.hpp"
#include "dbinterfacelinkingedge.hpp"
#include "dbinterfacelinkingsegment.hpp"
#include "dbinterfacespringbacklsdynathickness.hpp"
#include "exptypemap.h"
#include "interfaceexport.h"

void InterfaceExport::initExportInterfaceTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(INTERFACE_COMPENSATION_NEW, importDBInterfaceCompensationNew) );
   expTypeFuncMap.insert( expTypeFuncPair(INTERFACE_COMPONENT_NODE, importDBInterfaceComponentNode) );
   expTypeFuncMap.insert( expTypeFuncPair(INTERFACE_COMPONENT_SEGMENT, importDBInterfaceComponentNode) );
   expTypeFuncMap.insert( expTypeFuncPair(INTERFACE_JOY, importDBInterfaceJoy) );
   expTypeFuncMap.insert( expTypeFuncPair(INTERFACE_LINKING_DISCRETE_NODE_NODE, importDBInterfaceLinkingDiscreteNodeNode) );
   expTypeFuncMap.insert( expTypeFuncPair(INTERFACE_LINKING_DISCRETE_NODE_SET, importDBInterfaceLinkingDiscreteNodeNode) );
   expTypeFuncMap.insert( expTypeFuncPair(INTERFACE_LINKING_EDGE, importDBInterfaceLinkingEdge) );
   expTypeFuncMap.insert( expTypeFuncPair(INTERFACE_LINKING_SEGMENT, importDBInterfaceLinkingSegment) );
   expTypeFuncMap.insert( expTypeFuncPair(INTERFACE_SPRINGBACK_LSDYNA_NOTHICKNESS, importDBInterfaceSpringbackLsdynaThickness) );
   expTypeFuncMap.insert( expTypeFuncPair(INTERFACE_SPRINGBACK_LSDYNA_THICKNESS, importDBInterfaceSpringbackLsdynaThickness) );
   expTypeFuncMap.insert( expTypeFuncPair(INTERFACE_SPRINGBACK_NASTRAN_NOTHICKNESS, importDBInterfaceSpringbackLsdynaThickness) );
   expTypeFuncMap.insert( expTypeFuncPair(INTERFACE_SPRINGBACK_NASTRAN_THICKNESS, importDBInterfaceSpringbackLsdynaThickness) );
   expTypeFuncMap.insert( expTypeFuncPair(INTERFACE_SPRINGBACK_SEAMLESS_NOTHICKNESS, importDBInterfaceSpringbackLsdynaThickness) );
   expTypeFuncMap.insert( expTypeFuncPair(INTERFACE_SPRINGBACK_SEAMLESS_THICKNESS, importDBInterfaceSpringbackLsdynaThickness) );
}
