#ifndef _DBKEYWORDID_H_
#define _DBKEYWORDID_H_

#include "manager.h"
#include "dispexport.h"
#include "getdbbase.h"

/** Class used for getting data from database for *KEYWORD_ID
  * keyword */

class DBKeywordID : public GetDBBase
{
public:
/** Class constructor for creating the objects.
  * \param gold_conn GoldenConn object to access database
  * \param imp_obj ImportObject pointer to hold data
  */
   DBKeywordID(GoldenConn *gold_conn, ImportObject *imp_obj) : GetDBBase (gold_conn, imp_obj)
   {
   }

/** Class destructor for releasing the memory in the object.
  */
   virtual ~DBKeywordID()
   {
   }

public:
/** Function to get Card1 details for *KEYWORD_ID
  * keyword from database */
   void dbReadCard1(unsigned int loop_count = (1 << 31))
   {
      const char *fields[] = {"PROJECT","NUM","STAGE",};
      unsigned int field_types[] = {DATA_CHAR_ARRAY, DATA_CHAR_ARRAY, DATA_CHAR_ARRAY, };
      numFields = 3;
      unsigned int field_widths[] = {20, 20, 40, };
      wordArray = goldenConn->nextCard();
      if( !wordArray )
      {
         numFields = 0;
         return;
      }
      if( Card::isFlagOn(SAVE_IDS) && !impObj->cardCount )
         addIDToFile(wordArray, 0, KW, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         if( loop_count & (1<<31) )
            cardObj = new DBCard("Card1");
         else
         {
            char name_buf[64];
            sprintf(name_buf,"%s_%d","Card1",loop_count);
            cardObj = new DBCard(name_buf);
         }
         ((DBCard *)cardObj)->index = atoi(wordArray[0]);
         cardObj->addFields(numFields, field_types, field_widths, fields, &wordArray[2]);
         impObj->addCard(cardObj);
      }
      impObj->cardCount++;
   }

/** Function to import all the cards of keyword *KEYWORD_ID
  * from database */
   unsigned int importDBKeywordID()
   {
      dbReadCard1();
      return 0;
   }
};

#endif

