#include <iostream>
#include <algorithm>
#include "generic.h"
#include "keywordtype.h"
#include "keywordexport.h"
#include "exptitle.h"
#include <stdlib.h>

using namespace std;

KeywordExport::KeywordExport
(
   char         *model_name,
   GoldenConn   *gold_conn,
   ControlManager    *control_man
)
{
   modelName = model_name;
   controlManPtr = control_man;
   goldenConn = gold_conn;

   initExportKeywordTypesAndFunctions();
}

int KeywordExport::getKeywordFromType
    (
       unsigned int kw_type,
       string & key_word
    )
{
   switch(kw_type)
   {
      case KEYWORD:
	 key_word = "*KEYWORD";
	 break;
      case TITLE_CARD:
	 key_word = "*TITLE";
	 break;
      case KEYWORD_ID:
	 key_word = "*KEYWORD_ID";
	 break;
      case KEYWORD_NEW_TYPE:
      default:
         return 1;
   }
   return 0;
}

unsigned int KeywordExport::dbReadKWAndTitle()
{
   char         **row_data, buf[128];
   unsigned int	i, num_kw_types = 0;
   expTypeFuncIterator eexp_iter = expTypeFuncMap.end(), exp_iter;

   string       qry = "select kw_type from ", kw_str;
   string table_name = "`" + modelName + "_CONTROLS`";
   qry += table_name;
   qry += " where kw_type >= ";
   sprintf(buf, "%u group by kw_type;", KEYWORD);
   qry += buf;

cout << "KW QRY = " << qry << endl;

   if( goldenConn->executeQuery( qry.data() ) )
      return 0;

   num_kw_types = goldenConn->numRows();

cout << "NUM KW TYPES=" << num_kw_types << endl;

   if( !num_kw_types )
      return 0;

   unsigned int *kw_types = new unsigned int[num_kw_types];

   for(i = 0; i < num_kw_types; i++)
   {
      row_data = goldenConn->nextRow();
      kw_types[i] = atoi( row_data[0] );
cout << "KW CONTROL TYPE = " << kw_types[i] << endl;
   }

   for(i = 0; i < num_kw_types; i++)
   {
      qry = "select * from ";
      qry += table_name;
      qry += " where kw_type=";
      sprintf(buf, "%u", kw_types[i]);
      qry += buf;
      qry += " order by card_index;";

cout << "*KEYWORD QRY = " << qry << endl;

      if( getKeywordFromType(kw_types[i], kw_str) )
         continue;

cout << "KW = " << kw_str << endl;

      if( goldenConn->executeQuery( qry.data() ) )
	 break;

      if( kw_types[i] == TITLE_CARD )
      {
         DBTitle title(goldenConn);
         impObj = new ExportObject((char *)kw_str.data(), kw_types[i]);
         goldenConn->clearFlag(KW_DATA_END);
         title.readCard(impObj);

	 if( impObj->cardCount || ((ExportObject *)impObj)->noCardsIndex )
         {
	    controlManPtr->add(kw_str.data(), impObj);
         }
	 else
         {
	    delete impObj;
         }

         continue;
      }

      exp_iter = expTypeFuncMap.find(kw_types[i]);

      if( exp_iter == eexp_iter )
      {
	 cout << "KEYWORD TYPE NOT FOUND" << endl;
         continue;
      }

      while( goldenConn->rowsLeft() )
      {
         impObj = new ExportObject((char *)kw_str.data(), kw_types[i]);
         goldenConn->clearFlag(KW_DATA_END);
	 (exp_iter->second)(goldenConn, impObj);
         //to take care of kws with no cards Feb21 2010
cout << ((ExportObject *)impObj)->noCardsIndex << endl;
	 if( impObj->cardCount || ((ExportObject *)impObj)->noCardsIndex )
	    controlManPtr->add(kw_str.data(), impObj);
	 else
	    delete impObj;
      }
   }

   vector<ImportObject *> & impobj_list = controlManPtr->getImportObjectList();
   cout << "NUM=" << impobj_list.size() << endl;

   delete kw_types;

   return 1;
}

