#include "dbloadbodygeneralized.hpp"
#include "dbloadbodyparts.hpp"
#include "dbloadbodyporous.hpp"
#include "dbloadbodyx.hpp"
#include "dbloadgravitypart.hpp"
#include "dbloadremovepart.hpp"
#include "dbloadstiffenpart.hpp"
#include "exptypemap.h"
#include "loadexport.h"

void LoadExport::initExportBodyTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_BODY_GENERALIZED, importDBLoadBodyGeneralized) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_BODY_PARTS, importDBLoadBodyParts) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_BODY_POROUS, importDBLoadBodyPorous) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_BODY_RX, importDBLoadBodyX) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_BODY_RY, importDBLoadBodyX) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_BODY_RZ, importDBLoadBodyX) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_BODY_X, importDBLoadBodyX) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_BODY_Y, importDBLoadBodyX) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_BODY_Z, importDBLoadBodyX) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_GRAVITY_PART, importDBLoadGravityPart) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_REMOVE_PART, importDBLoadRemovePart) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_STIFFEN_PART, importDBLoadStiffenPart) );
}
