#include "dbloadbeamelement.hpp"
#include "dbloadheatgenerationset.hpp"
#include "dbloadmovingpressure.hpp"
#include "dbloadrigidbody.hpp"
#include "dbloadshellelement.hpp"
#include "dbloadsuperplasticforming.hpp"
#include "dbloadsurfacestress.hpp"
#include "exptypemap.h"
#include "loadexport.h"

void LoadExport::initExportElementTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_BEAM_ELEMENT, importDBLoadBeamElement) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_BEAM_SET, importDBLoadBeamElement) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_HEAT_GENERATION_SET, importDBLoadHeatGenerationSet) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_HEAT_GENERATION_SOLID, importDBLoadHeatGenerationSet) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_MOVING_PRESSURE, importDBLoadMovingPressure) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_RIGID_BODY, importDBLoadRigidBody) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_SHELL_ELEMENT, importDBLoadShellElement) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_SHELL_ELEMENT_ID, importDBLoadShellElement) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_SHELL_SET, importDBLoadShellElement) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_SHELL_SET_ID, importDBLoadShellElement) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_SUPERPLASTIC_FORMING, importDBLoadSuperplasticForming) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_SURFACE_STRESS, importDBLoadSurfaceStress) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_SURFACE_STRESS_SET, importDBLoadSurfaceStress) );
}
