#include "dbloadheatcontroller.hpp"
#include "dbloadmotionnode.hpp"
#include "dbloadnodepoint.hpp"
#include "dbloadsegment.hpp"
#include "dbloadsegmentnonuniform.hpp"
#include "dbloadsegmentset.hpp"
#include "dbloadsegmentsetnonuniform.hpp"
#include "exptypemap.h"
#include "loadexport.h"

void LoadExport::initExportSegmentTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_HEAT_CONTROLLER, importDBLoadHeatController) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_MOTION_NODE, importDBLoadMotionNode) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_NODE_POINT, importDBLoadNodePoint) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_NODE_SET, importDBLoadNodePoint) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_SEGMENT, importDBLoadSegment) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_SEGMENT_ID, importDBLoadSegment) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_SEGMENT_NONUNIFORM, importDBLoadSegmentNonuniform) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_SEGMENT_NONUNIFORM_ID, importDBLoadSegmentNonuniform) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_SEGMENT_SET, importDBLoadSegmentSet) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_SEGMENT_SET_ID, importDBLoadSegmentSet) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_SEGMENT_SET_NONUNIFORM, importDBLoadSegmentSetNonuniform) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_SEGMENT_SET_NONUNIFORM_ID, importDBLoadSegmentSetNonuniform) );
}
