#include "dbloadaleconvection.hpp"
#include "dbloadblast.hpp"
#include "dbloadbrode.hpp"
#include "dbloaddensitydepth.hpp"
#include "dbloadmask.hpp"
#include "dbloadssa.hpp"
#include "dbloadvolumeloss.hpp"
#include "exptypemap.h"
#include "loadexport.h"

void LoadExport::initExportSimpleTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_ALE_CONVECTION, importDBLoadAleConvection) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_ALE_CONVECTION_ID, importDBLoadAleConvection) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_BLAST, importDBLoadBlast) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_BRODE, importDBLoadBrode) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_DENSITY_DEPTH, importDBLoadDensityDepth) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_MASK, importDBLoadMask) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_SSA, importDBLoadSsa) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_VOLUME_LOSS, importDBLoadVolumeLoss) );
}
