#include "dbloadthermalconstant.hpp"
#include "dbloadthermalconstantnode.hpp"
#include "dbloadthermalloadcurve.hpp"
#include "nocards.hpp"
#include "dbloadthermalvariable.hpp"
#include "dbloadthermalvariablenode.hpp"
#include "dbloadthermalvariableshell.hpp"
#include "exptypemap.h"
#include "loadexport.h"

void LoadExport::initExportThermalTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_THERMAL_CONSTANT, importDBLoadThermalConstant) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_THERMAL_CONSTANT_NODE, importDBLoadThermalConstantNode) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_THERMAL_LOAD_CURVE, importDBLoadThermalLoadCurve) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_THERMAL_TOPAZ, importDBNoCards) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_THERMAL_VARIABLE, importDBLoadThermalVariable) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_THERMAL_VARIABLE_NODE, importDBLoadThermalVariableNode) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_THERMAL_VARIABLE_SHELL, importDBLoadThermalVariableShell) );
   expTypeFuncMap.insert( expTypeFuncPair(LOAD_THERMAL_VARIABLE_SHELL_SET, importDBLoadThermalVariableShell) );
}
