#include "dbmatalegasmixture.hpp"
#include "dbmatalevacuum.hpp"
#include "dbmataleviscous.hpp"
#include "dbmatjohnsonholmquistceramics.hpp"
#include "dbmatjohnsonholmquistconcrete.hpp"
#include "dbmatjointedrock.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportAleTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ALE_GAS_MIXTURE, importDBMatAleGasMixture) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ALE_VACUUM, importDBMatAleVacuum) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ALE_VISCOUS, importDBMatAleViscous) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_JOHNSON_HOLMQUIST_CERAMICS, importDBMatJohnsonHolmquistCeramics) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_JOHNSON_HOLMQUIST_CONCRETE, importDBMatJohnsonHolmquistConcrete) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_JOINTED_ROCK, importDBMatJointedRock) );
}
