#include "dbmatfldtransverselyanisotropic.hpp"
#include "dbmatisotropicelasticfailure.hpp"
#include "dbmatisotropicelasticplastic.hpp"
#include "dbmatresultantanisotropic.hpp"
#include "dbmattransverselyanisotropicelasticplastic.hpp"
#include "dbmattransverselyanisotropicelasticplasticechange.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportAnisotropicTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_FLD_TRANSVERSELY_ANISOTROPIC, importDBMatFldTransverselyAnisotropic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ISOTROPIC_ELASTIC_FAILURE, importDBMatIsotropicElasticFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ISOTROPIC_ELASTIC_PLASTIC, importDBMatIsotropicElasticPlastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_RESULTANT_ANISOTROPIC, importDBMatResultantAnisotropic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_TRANSVERSELY_ANISOTROPIC_ELASTIC_PLASTIC, importDBMatTransverselyAnisotropicElasticPlastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_TRANSVERSELY_ANISOTROPIC_ELASTIC_PLASTIC_ECHANGE, importDBMatTransverselyAnisotropicElasticPlasticEchange) );
}
