#include "dbmat3parameterbarlat.hpp"
#include "dbmatbarlatanisotropicplasticity.hpp"
#include "dbmatbarlatyld2000.hpp"
#include "dbmatbarlatyld96.hpp"
#include "dbmatfld3parameterbarlat.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportBarlatTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_3_PARAMETER_BARLAT, importDBMat3ParameterBarlat) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_BARLAT_ANISOTROPIC_PLASTICITY, importDBMatBarlatAnisotropicPlasticity) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_BARLAT_YLD2000, importDBMatBarlatYld2000) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_BARLAT_YLD96, importDBMatBarlatYld96) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_FLD_3_PARAMETER_BARLAT, importDBMatFld3ParameterBarlat) );
}
