#include "dbmatadderosion.hpp"
#include "dbmataddthermalexpansion.hpp"
#include "dbmatbilkhuduboisfoam.hpp"
#include "dbmatblatzkofoam.hpp"
#include "dbmatblatzkorubber.hpp"
#include "dbmatbrittledamage.hpp"
#include "dbmatforcelimited.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportBlatzTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ADD_EROSION, importDBMatAddErosion) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ADD_THERMAL_EXPANSION, importDBMatAddThermalExpansion) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_BILKHU_DUBOIS_FOAM, importDBMatBilkhuDuboisFoam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_BLATZ_KO_FOAM, importDBMatBlatzKoFoam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_BLATZ_KO_RUBBER, importDBMatBlatzKoRubber) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_BRITTLE_DAMAGE, importDBMatBrittleDamage) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_FORCE_LIMITED, importDBMatForceLimited) );
}
