#include "dbmatcompositedirect.hpp"
#include "dbmatcompositelayup.hpp"
#include "dbmatcompositematrix.hpp"
#include "dbmatcompositemsc.hpp"
#include "dbmatcompositemscdmg.hpp"
#include "dbmatdeshpandefleckfoam.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportCompoTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_COMPOSITE_DIRECT, importDBMatCompositeDirect) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_COMPOSITE_LAYUP, importDBMatCompositeLayup) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_COMPOSITE_MATRIX, importDBMatCompositeMatrix) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_COMPOSITE_MSC, importDBMatCompositeMsc) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_COMPOSITE_MSC_DMG, importDBMatCompositeMscDmg) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_DESHPANDE_FLECK_FOAM, importDBMatDeshpandeFleckFoam) );
}
