#ifndef _DBMATCOMPOSITEMSCDMG_H_
#define _DBMATCOMPOSITEMSCDMG_H_

#include "manager.h"
#include "dispexport.h"
#include "dbmatcompositemsc.h"

/** Class used for getting data from database for *MAT_COMPOSITE_MSC_DMG
  * keyword */

class DBMatCompositeMscDmg : public DBMatCompositeMsc
{
public:
/** Class constructor for creating the objects.
  * \param gold_conn GoldenConn object to access database
  * \param imp_obj ImportObject pointer to hold data
  */
   DBMatCompositeMscDmg(GoldenConn *gold_conn, ImportObject *imp_obj) : DBMatCompositeMsc (gold_conn, imp_obj)
   {
   }

/** Class destructor for releasing the memory in the object.
  */
   virtual ~DBMatCompositeMscDmg()
   {
   }

public:
/** Function to get Card8 details for *MAT_COMPOSITE_MSC_DMG
  * keyword from database */
   void dbReadCard8(unsigned int loop_count = (1 << 31))
   {
      const char *fields[] = {"AM2","AM3","AM4","CERATE2","CERATE3","CERATE4",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 6;
      unsigned int field_widths[] = {10, 10, 10, 10, 10, 10, };
      wordArray = goldenConn->nextCard();
      if( !wordArray )
      {
         numFields = 0;
         return;
      }
      if( Card::isFlagOn(SAVE_IDS) && !impObj->cardCount )
         addIDToFile(wordArray, 0, MAT, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         if( loop_count & (1<<31) )
            cardObj = new DBCard("Card8");
         else
         {
            char name_buf[64];
            sprintf(name_buf,"%s_%d","Card8",loop_count);
            cardObj = new DBCard(name_buf);
         }
         ((DBCard *)cardObj)->index = atoi(wordArray[0]);
         cardObj->addFields(numFields, field_types, field_widths, fields, &wordArray[2]);
         impObj->addCard(cardObj);
      }
      impObj->cardCount++;
   }

/** Function to import all the cards of keyword *MAT_COMPOSITE_MSC_DMG
  * from database */
   unsigned int importDBMatCompositeMscDmg()
   {
      importDBMatCompositeMsc();
      dbReadCard8();
      return 0;
   }
};

#endif

