#include "dbmatgeneraljointdiscretebeam.hpp"
#include "dbmathydraulicgasdamperdiscretebeam.hpp"
#include "dbmatlinearelasticdiscretebeam.hpp"
#include "dbmatnonlinearelasticdiscretebeam.hpp"
#include "dbmatnonlinearplasticdiscretebeam.hpp"
#include "dbmatsiddamperdiscretebeam.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportDiscreteTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_GENERAL_JOINT_DISCRETE_BEAM, importDBMatGeneralJointDiscreteBeam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_HYDRAULIC_GAS_DAMPER_DISCRETE_BEAM, importDBMatHydraulicGasDamperDiscreteBeam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_LINEAR_ELASTIC_DISCRETE_BEAM, importDBMatLinearElasticDiscreteBeam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_NONLINEAR_ELASTIC_DISCRETE_BEAM, importDBMatNonlinearElasticDiscreteBeam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_NONLINEAR_PLASTIC_DISCRETE_BEAM, importDBMatNonlinearPlasticDiscreteBeam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SID_DAMPER_DISCRETE_BEAM, importDBMatSidDamperDiscreteBeam) );
}
