#include "dbmatelastic.hpp"
#include "dbmatelasticfluid.hpp"
#include "dbmatelasticplastichydro.hpp"
#include "dbmatelasticplasticthermal.hpp"
#include "dbmatelasticwithviscosity.hpp"
#include "dbmatelasticwithviscositycurve.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportElasticTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ELASTIC, importDBMatElastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ELASTIC_FLUID, importDBMatElasticFluid) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ELASTIC_PLASTIC_HYDRO, importDBMatElasticPlasticHydro) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ELASTIC_PLASTIC_HYDRO_SPALL, importDBMatElasticPlasticHydro) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ELASTIC_PLASTIC_THERMAL, importDBMatElasticPlasticThermal) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ELASTIC_WITH_VISCOSITY, importDBMatElasticWithViscosity) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ELASTIC_WITH_VISCOSITY_CURVE, importDBMatElasticWithViscosityCurve) );
}
