#include "dbmatcellularrubber.hpp"
#include "dbmatclosedcellfoam.hpp"
#include "dbmatcrushablefoam.hpp"
#include "dbmatfrazernashrubbermodel.hpp"
#include "dbmatfuchangfoam.hpp"
#include "dbmatstrainratedependentplasticity.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportFoamTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_CELLULAR_RUBBER, importDBMatCellularRubber) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_CLOSED_CELL_FOAM, importDBMatClosedCellFoam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_CRUSHABLE_FOAM, importDBMatCrushableFoam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_FRAZER_NASH_RUBBER_MODEL, importDBMatFrazerNashRubberModel) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_FU_CHANG_FOAM, importDBMatFuChangFoam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_STRAIN_RATE_DEPENDENT_PLASTICITY, importDBMatStrainRateDependentPlasticity) );
}
