#include "dbmatemmi.hpp"
#include "dbmatpolymer.hpp"
#include "dbmatrambergosgood.hpp"
#include "dbmatshapememory.hpp"
#include "dbmatsimplifiedjohnsoncook.hpp"
#include "dbmattrip.hpp"
#include "dbmatviscousfoam.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportGeneralTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_EMMI, importDBMatEmmi) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_POLYMER, importDBMatPolymer) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_RAMBERG_OSGOOD, importDBMatRambergOsgood) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SHAPE_MEMORY, importDBMatShapeMemory) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SIMPLIFIED_JOHNSON_COOK, importDBMatSimplifiedJohnsonCook) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_TRIP, importDBMatTrip) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_VISCOUS_FOAM, importDBMatViscousFoam) );
}
