#include "dbmatbrainlinearviscoelastic.hpp"
#include "dbmatelasticviscoplasticthermal.hpp"
#include "dbmatgeneralspringdiscretebeam.hpp"
#include "dbmatthermoelastoviscoplasticcreep.hpp"
#include "dbmatviscoelastichillfoam.hpp"
#include "dbmatviscoelasticthermal.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportGensprTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_BRAIN_LINEAR_VISCOELASTIC, importDBMatBrainLinearViscoelastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ELASTIC_VISCOPLASTIC_THERMAL, importDBMatElasticViscoplasticThermal) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_GENERAL_SPRING_DISCRETE_BEAM, importDBMatGeneralSpringDiscreteBeam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_THERMO_ELASTO_VISCOPLASTIC_CREEP, importDBMatThermoElastoViscoplasticCreep) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_VISCOELASTIC_HILL_FOAM, importDBMatViscoelasticHillFoam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_VISCOELASTIC_THERMAL, importDBMatViscoelasticThermal) );
}
