#include "dbmatgurson.hpp"
#include "dbmatgursonjc.hpp"
#include "dbmatgursonrcdc.hpp"
#include "dbmathill3r.hpp"
#include "dbmathillfoam.hpp"
#include "dbmatinvhyperbolicsin.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportGursonTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_GURSON, importDBMatGurson) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_GURSON_JC, importDBMatGursonJc) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_GURSON_RCDC, importDBMatGursonRcdc) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_HILL_3R, importDBMatHill3r) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_HILL_FOAM, importDBMatHillFoam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_INV_HYPERBOLIC_SIN, importDBMatInvHyperbolicSin) );
}
