#include "dbmatanisotropicelastic.hpp"
#include "dbmathoneycomb.hpp"
#include "dbmatjohnsoncook.hpp"
#include "dbmatlowdensityfoam.hpp"
#include "dbmatlowdensityviscousfoam.hpp"
#include "dbmatrigid.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportHoneyTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ANISOTROPIC_ELASTIC, importDBMatAnisotropicElastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_HONEYCOMB, importDBMatHoneycomb) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_JOHNSON_COOK, importDBMatJohnsonCook) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_LOW_DENSITY_FOAM, importDBMatLowDensityFoam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_LOW_DENSITY_VISCOUS_FOAM, importDBMatLowDensityViscousFoam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_RIGID, importDBMatRigid) );
}
