#include "dbmatgasmixture.hpp"
#include "dbmatlowdensitysyntheticfoam.hpp"
#include "dbmatlowdensitysyntheticfoamwithfailure.hpp"
#include "dbmatmodifiedcrushablefoam.hpp"
#include "dbmattransverselyisotropiccrushablefoam.hpp"
#include "dbmatvacuum.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportLowdenseTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_GAS_MIXTURE, importDBMatGasMixture) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_LOW_DENSITY_SYNTHETIC_FOAM, importDBMatLowDensitySyntheticFoam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_LOW_DENSITY_SYNTHETIC_FOAM_ORTHO, importDBMatLowDensitySyntheticFoam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_LOW_DENSITY_SYNTHETIC_FOAM_ORTHO_WITH_FAILURE, importDBMatLowDensitySyntheticFoamWithFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_LOW_DENSITY_SYNTHETIC_FOAM_WITH_FAILURE, importDBMatLowDensitySyntheticFoamWithFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_MODIFIED_CRUSHABLE_FOAM, importDBMatModifiedCrushableFoam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_TRANSVERSELY_ISOTROPIC_CRUSHABLE_FOAM, importDBMatTransverselyIsotropicCrushableFoam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_VACUUM, importDBMatVacuum) );
}
