#ifndef _DBMATMODIFIEDPIECEWISELINEARPLASTICITYRATE_H_
#define _DBMATMODIFIEDPIECEWISELINEARPLASTICITYRATE_H_

#include "manager.h"
#include "dispexport.h"
#include "dbmatmodifiedpiecewiselinearplasticity.h"

/** Class used for getting data from database for *MAT_MODIFIED_PIECEWISE_LINEAR_PLASTICITY_RATE
  * keyword */

class DBMatModifiedPiecewiseLinearPlasticityRate : public DBMatModifiedPiecewiseLinearPlasticity
{
public:
/** Class constructor for creating the objects.
  * \param gold_conn GoldenConn object to access database
  * \param imp_obj ImportObject pointer to hold data
  */
   DBMatModifiedPiecewiseLinearPlasticityRate(GoldenConn *gold_conn, ImportObject *imp_obj) : DBMatModifiedPiecewiseLinearPlasticity (gold_conn, imp_obj)
   {
   }

/** Class destructor for releasing the memory in the object.
  */
   virtual ~DBMatModifiedPiecewiseLinearPlasticityRate()
   {
   }

public:
/** Function to get Card5 details for *MAT_MODIFIED_PIECEWISE_LINEAR_PLASTICITY_RATE
  * keyword from database */
   void dbReadCard5(unsigned int loop_count = (1 << 31))
   {
      const char *fields[] = {"LCTSRF",};
      unsigned int field_types[] = {DATA_INT, };
      unsigned int field_indices[] = {0, };
      unsigned int man_types[] = {DEFINE, };
      unsigned int kw_types[] = {CURVE, };
      unsigned int num_indices = 1;
      numFields = 1;
      unsigned int field_widths[] = {10, };
      wordArray = goldenConn->nextCard();
      if( !wordArray )
      {
         numFields = 0;
         return;
      }
      if( Card::isFlagOn(SAVE_IDS) && !impObj->cardCount )
         addIDToFile(wordArray, 0, MAT, impObj);
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(&wordArray[2], num_indices, field_indices, man_types, kw_types, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         if( loop_count & (1<<31) )
            cardObj = new DBCard("Card5");
         else
         {
            char name_buf[64];
            sprintf(name_buf,"%s_%d","Card5",loop_count);
            cardObj = new DBCard(name_buf);
         }
         ((DBCard *)cardObj)->index = atoi(wordArray[0]);
         cardObj->addFields(numFields, field_types, field_widths, fields, &wordArray[2]);
         impObj->addCard(cardObj);
      }
      impObj->cardCount++;
   }

/** Function to import all the cards of keyword *MAT_MODIFIED_PIECEWISE_LINEAR_PLASTICITY_RATE
  * from database */
   unsigned int importDBMatModifiedPiecewiseLinearPlasticityRate()
   {
      importDBMatModifiedPiecewiseLinearPlasticity();
      dbReadCard5();
      return 0;
   }
};

#endif

