#include "dbmatkinematichardeningtransverselyanisotropic.hpp"
#include "dbmatmohrcoulomb.hpp"
#include "dbmatmomentcurvaturebeam.hpp"
#include "dbmatmuscle.hpp"
#include "dbmatorthotropicsmearedcrack.hpp"
#include "dbmatpitzercrushablefoam.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportMohrTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_KINEMATIC_HARDENING_TRANSVERSELY_ANISOTROPIC, importDBMatKinematicHardeningTransverselyAnisotropic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_MOHR_COULOMB, importDBMatMohrCoulomb) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_MOMENT_CURVATURE_BEAM, importDBMatMomentCurvatureBeam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_MUSCLE, importDBMatMuscle) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ORTHOTROPIC_SMEARED_CRACK, importDBMatOrthotropicSmearedCrack) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_PITZER_CRUSHABLE_FOAM, importDBMatPitzerCrushableFoam) );
}
