#include "dbmatnonlinearorthotropic.hpp"
#include "dbmatorthoelasticplastic.hpp"
#include "dbmatorthotropicelastic.hpp"
#include "dbmatorthotropicthermal.hpp"
#include "dbmatsimplifiedjohnsoncookorthotropicdamage.hpp"
#include "dbmattemperaturedependentorthotropic.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportOrthoTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_NONLINEAR_ORTHOTROPIC, importDBMatNonlinearOrthotropic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ORTHO_ELASTIC_PLASTIC, importDBMatOrthoElasticPlastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ORTHOTROPIC_ELASTIC, importDBMatOrthotropicElastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ORTHOTROPIC_THERMAL, importDBMatOrthotropicThermal) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SIMPLIFIED_JOHNSON_COOK_ORTHOTROPIC_DAMAGE, importDBMatSimplifiedJohnsonCookOrthotropicDamage) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_TEMPERATURE_DEPENDENT_ORTHOTROPIC, importDBMatTemperatureDependentOrthotropic) );
}
