#include "dbmatcablediscretebeam.hpp"
#include "dbmatgeologiccapmodel.hpp"
#include "dbmatgeplasticsrate2000a.hpp"
#include "dbmathighexplosiveburn.hpp"
#include "dbmatorientedcrack.hpp"
#include "dbmatpseudotensor.hpp"
#include "dbmatuserdefinedmaterialmodels.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportOthersTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_CABLE_DISCRETE_BEAM, importDBMatCableDiscreteBeam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_GEOLOGIC_CAP_MODEL, importDBMatGeologicCapModel) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_GEPLASTIC_SRATE_2000a, importDBMatGeplasticSrate2000a) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_HIGH_EXPLOSIVE_BURN, importDBMatHighExplosiveBurn) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ORIENTED_CRACK, importDBMatOrientedCrack) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_PSEUDO_TENSOR, importDBMatPseudoTensor) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_USER_DEFINED_MATERIAL_MODELS, importDBMatUserDefinedMaterialModels) );
}
