#include "dbmatpiecewiselinearplasticity.hpp"
#include "dbmatplasticgreennaghdirate.hpp"
#include "dbmatplastickinematic.hpp"
#include "dbmatplasticitypolymer.hpp"
#include "dbmatplasticitywithdamage.hpp"
#include "dbmatplasticitywithdamageorthorcdc.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportPlasticTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_PIECEWISE_LINEAR_PLASTICITY, importDBMatPiecewiseLinearPlasticity) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_PLASTIC_GREEN_NAGHDI_RATE, importDBMatPlasticGreenNaghdiRate) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_PLASTIC_KINEMATIC, importDBMatPlasticKinematic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_PLASTICITY_POLYMER, importDBMatPlasticityPolymer) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_PLASTICITY_WITH_DAMAGE, importDBMatPlasticityWithDamage) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_PLASTICITY_WITH_DAMAGE_ORTHO, importDBMatPlasticityWithDamage) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_PLASTICITY_WITH_DAMAGE_ORTHO_RCDC, importDBMatPlasticityWithDamageOrthoRcdc) );
}
