#include "dbmatanisotropicelasticplastic.hpp"
#include "dbmatfiniteelasticstrainplasticity.hpp"
#include "dbmatlayeredlinearplasticity.hpp"
#include "dbmatplasticitycompressiontension.hpp"
#include "dbmatplasticitycompressiontensioneos.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportPlasticityTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ANISOTROPIC_ELASTIC_PLASTIC, importDBMatAnisotropicElasticPlastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_FINITE_ELASTIC_STRAIN_PLASTICITY, importDBMatFiniteElasticStrainPlasticity) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_LAYERED_LINEAR_PLASTICITY, importDBMatLayeredLinearPlasticity) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_PLASTICITY_COMPRESSION_TENSION, importDBMatPlasticityCompressionTension) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_PLASTICITY_COMPRESSION_TENSION_EOS, importDBMatPlasticityCompressionTensionEos) );
}
