#include "dbmatconcretebeam.hpp"
#include "dbmatconcreteec2.hpp"
#include "dbmatsamp1.hpp"
#include "dbmatschwermurraycapmodel.hpp"
#include "dbmatseatbelt.hpp"
#include "dbmatspecialorthotropic.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportSeatbeltTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_CONCRETE_BEAM, importDBMatConcreteBeam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_CONCRETE_EC2, importDBMatConcreteEc2) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SAMP_1, importDBMatSamp1) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SCHWER_MURRAY_CAP_MODEL, importDBMatSchwerMurrayCapModel) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SEATBELT, importDBMatSeatbelt) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SPECIAL_ORTHOTROPIC, importDBMatSpecialOrthotropic) );
}
