#include "dbmatcorusvegter.hpp"
#include "dbmathearttissue.hpp"
#include "dbmatlungtissue.hpp"
#include "dbmatmccormick.hpp"
#include "dbmatseismicbeam.hpp"
#include "dbmatseismicisolator.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportSeismicTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_CORUS_VEGTER, importDBMatCorusVegter) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_HEART_TISSUE, importDBMatHeartTissue) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_LUNG_TISSUE, importDBMatLungTissue) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_MCCORMICK, importDBMatMccormick) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SEISMIC_BEAM, importDBMatSeismicBeam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SEISMIC_ISOLATOR, importDBMatSeismicIsolator) );
}
