#include "dbmatratesensitivecompositefabric.hpp"
#include "dbmatratesensitivepolymer.hpp"
#include "dbmatrcbeam.hpp"
#include "dbmatrcshearwall.hpp"
#include "dbmatwtmstm.hpp"
#include "dbmatwtmstmplc.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportSensitiveTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_RATE_SENSITIVE_COMPOSITE_FABRIC, importDBMatRateSensitiveCompositeFabric) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_RATE_SENSITIVE_POLYMER, importDBMatRateSensitivePolymer) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_RC_BEAM, importDBMatRcBeam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_RC_SHEAR_WALL, importDBMatRcShearWall) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_WTM_STM, importDBMatWtmStm) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_WTM_STM_PLC, importDBMatWtmStmPlc) );
}
