#include "dbmathyperelasticrubber.hpp"
#include "dbmatsimplifiedrubberfoam.hpp"
#include "dbmatsimplifiedrubberfoamwithfailure.hpp"
#include "dbmatsimplifiedrubberwithdamage.hpp"
#include "dbmatsoilbrick.hpp"
#include "dbmatsteelconcentricbrace.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportSimpleTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_HYPERELASTIC_RUBBER, importDBMatHyperelasticRubber) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SIMPLIFIED_RUBBER_FOAM, importDBMatSimplifiedRubberFoam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SIMPLIFIED_RUBBER_FOAM_WITH_FAILURE, importDBMatSimplifiedRubberFoamWithFailure) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SIMPLIFIED_RUBBER_WITH_DAMAGE, importDBMatSimplifiedRubberWithDamage) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SOIL_BRICK, importDBMatSoilBrick) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_STEEL_CONCENTRIC_BRACE, importDBMatSteelConcentricBrace) );
}
