#include "dbmathystereticsoil.hpp"
#include "dbmatsoilandfoam.hpp"
#include "dbmatsteinberg.hpp"
#include "dbmatsteinberglund.hpp"
#include "dbmatthermaluserdefined.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportSoilTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_HYSTERETIC_SOIL, importDBMatHystereticSoil) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SOIL_AND_FOAM, importDBMatSoilAndFoam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SOIL_AND_FOAM_FAILURE, importDBMatSoilAndFoam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_STEINBERG, importDBMatSteinberg) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_STEINBERG_LUND, importDBMatSteinbergLund) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_THERMAL_USER_DEFINED, importDBMatThermalUserDefined) );
}
