#include "dbmatanisotropicplastic.hpp"
#include "dbmatfabric.hpp"
#include "dbmatspringelastic.hpp"
#include "dbmatspringelastoplastic.hpp"
#include "dbmatspringgeneralnonlinear.hpp"
#include "dbmatspringmaxwell.hpp"
#include "dbmatspringnonlinearelastic.hpp"
#include "dbmatspringsquatshearwall.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportSpringTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ANISOTROPIC_PLASTIC, importDBMatAnisotropicPlastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_FABRIC, importDBMatFabric) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SPRING_ELASTIC, importDBMatSpringElastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SPRING_ELASTOPLASTIC, importDBMatSpringElastoplastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SPRING_GENERAL_NONLINEAR, importDBMatSpringGeneralNonlinear) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SPRING_MAXWELL, importDBMatSpringMaxwell) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SPRING_NONLINEAR_ELASTIC, importDBMatSpringNonlinearElastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SPRING_SQUAT_SHEARWALL, importDBMatSpringSquatShearwall) );
}
