#include "dbmatacoustic.hpp"
#include "dbmatelasticspringdiscretebeam.hpp"
#include "dbmatinelasticspringdiscretebeam.hpp"
#include "dbmatisotropicsmearedcrack.hpp"
#include "dbmatsofttissue.hpp"
#include "dbmatsofttissuevisco.hpp"
#include "dbmatsoilconcrete.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportSpringdisTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ACOUSTIC, importDBMatAcoustic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ELASTIC_SPRING_DISCRETE_BEAM, importDBMatElasticSpringDiscreteBeam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_INELASTIC_SPRING_DISCRETE_BEAM, importDBMatInelasticSpringDiscreteBeam) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ISOTROPIC_SMEARED_CRACK, importDBMatIsotropicSmearedCrack) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SOFT_TISSUE, importDBMatSoftTissue) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SOFT_TISSUE_VISCO, importDBMatSoftTissueVisco) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SOIL_CONCRETE, importDBMatSoilConcrete) );
}
