#include "dbmatthermalisotropic.hpp"
#include "dbmatthermalisotropicphasechange.hpp"
#include "dbmatthermalisotropictd.hpp"
#include "dbmatthermalisotropictdlc.hpp"
#include "dbmatthermalorthotropic.hpp"
#include "dbmatthermalorthotropictd.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportThermalTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_THERMAL_ISOTROPIC, importDBMatThermalIsotropic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_THERMAL_ISOTROPIC_PHASE_CHANGE, importDBMatThermalIsotropicPhaseChange) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_THERMAL_ISOTROPIC_TD, importDBMatThermalIsotropicTd) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_THERMAL_ISOTROPIC_TD_LC, importDBMatThermalIsotropicTdLc) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_THERMAL_ORTHOTROPIC, importDBMatThermalOrthotropic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_THERMAL_ORTHOTROPIC_TD, importDBMatThermalOrthotropicTd) );
}
