#include "dbmatgeneralviscoelastic.hpp"
#include "dbmatkelvinmaxwellviscoelastic.hpp"
#include "dbmatorthotropicviscoelastic.hpp"
#include "dbmatplasticnonlinearkinematic.hpp"
#include "dbmatquasilinearviscoelastic.hpp"
#include "dbmatviscoelastic.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportViscoelasticTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_GENERAL_VISCOELASTIC, importDBMatGeneralViscoelastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_KELVIN_MAXWELL_VISCOELASTIC, importDBMatKelvinMaxwellViscoelastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ORTHOTROPIC_VISCOELASTIC, importDBMatOrthotropicViscoelastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_PLASTIC_NONLINEAR_KINEMATIC, importDBMatPlasticNonlinearKinematic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_QUASILINEAR_VISCOELASTIC, importDBMatQuasilinearViscoelastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_VISCOELASTIC, importDBMatViscoelastic) );
}
