#include "dbmatanisotropicthermoelastic.hpp"
#include "dbmatanisotropicviscoplastic.hpp"
#include "dbmatarrudaboycerubber.hpp"
#include "dbmatspringinelastic.hpp"
#include "dbmatspringmuscle.hpp"
#include "dbmatspringtrilineardegrading.hpp"
#include "exptypemap.h"
#include "matexport.h"

void MatExport::initExportViscoplasticTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ANISOTROPIC_THERMOELASTIC, importDBMatAnisotropicThermoelastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ANISOTROPIC_VISCOPLASTIC, importDBMatAnisotropicViscoplastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_ARRUDA_BOYCE_RUBBER, importDBMatArrudaBoyceRubber) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SPRING_INELASTIC, importDBMatSpringInelastic) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SPRING_MUSCLE, importDBMatSpringMuscle) );
   expTypeFuncMap.insert( expTypeFuncPair(MAT_SPRING_TRILINEAR_DEGRADING, importDBMatSpringTrilinearDegrading) );
}
