#ifndef _DBRIGIDWALLPLANARMOVING_H_
#define _DBRIGIDWALLPLANARMOVING_H_

#include "manager.h"
#include "dispexport.h"
#include "getdbbase.h"

/** Class used for getting data from database for *RIGIDWALL_PLANAR_MOVING
  * keyword */

class DBRigidwallPlanarMoving : public GetDBBase
{
public:
/** Class constructor for creating the objects.
  * \param gold_conn GoldenConn object to access database
  * \param imp_obj ImportObject pointer to hold data
  */
   DBRigidwallPlanarMoving(GoldenConn *gold_conn, ImportObject *imp_obj) : GetDBBase (gold_conn, imp_obj)
   {
   }

/** Class destructor for releasing the memory in the object.
  */
   virtual ~DBRigidwallPlanarMoving()
   {
   }

public:
/** Function to get CardD details for *RIGIDWALL_PLANAR_MOVING
  * keyword from database */
   void dbReadCardD(unsigned int loop_count = (1 << 31))
   {
      const char *fields[] = {"MASS","V0",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 2;
      unsigned int field_widths[] = {10, 10, };
      wordArray = goldenConn->nextCard();
      if( !wordArray )
      {
         numFields = 0;
         return;
      }
      if( Card::isFlagOn(SAVE_IDS) && !impObj->cardCount )
         addIDToFile(wordArray, 0, RIGIDWALL, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         if( loop_count & (1<<31) )
            cardObj = new DBCard("CardD");
         else
         {
            char name_buf[64];
            sprintf(name_buf,"%s_%d","CardD",loop_count);
            cardObj = new DBCard(name_buf);
         }
         ((DBCard *)cardObj)->index = atoi(wordArray[0]);
         cardObj->addFields(numFields, field_types, field_widths, fields, &wordArray[2]);
         impObj->addCard(cardObj);
      }
      impObj->cardCount++;
   }

/** Function to import all the cards of keyword *RIGIDWALL_PLANAR_MOVING
  * from database */
   unsigned int importDBRigidwallPlanarMoving()
   {
      dbReadCardD();
      return 0;
   }
};

#endif

