#include "dbsectiondiscrete.hpp"
#include "dbsectionpointsource.hpp"
#include "dbsectionpointsourcemixture.hpp"
#include "dbsectionshell.hpp"
#include "dbsectiontshell.hpp"
#include "exptypemap.h"
#include "sectionexport.h"

void SectionExport::initExportShellTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(SECTION_DISCRETE, importDBSectionDiscrete) );
   expTypeFuncMap.insert( expTypeFuncPair(SECTION_POINT_SOURCE, importDBSectionPointSource) );
   expTypeFuncMap.insert( expTypeFuncPair(SECTION_POINT_SOURCE_MIXTURE, importDBSectionPointSourceMixture) );
   expTypeFuncMap.insert( expTypeFuncPair(SECTION_SHELL, importDBSectionShell) );
   expTypeFuncMap.insert( expTypeFuncPair(SECTION_SHELL_ALE, importDBSectionShell) );
   expTypeFuncMap.insert( expTypeFuncPair(SECTION_SHELL_EFG, importDBSectionShell) );
   expTypeFuncMap.insert( expTypeFuncPair(SECTION_TSHELL, importDBSectionTshell) );
}
