#include "dbsensorcontrol.hpp"
#include "dbsensordefinecalcmath.hpp"
#include "dbsensordefineelement.hpp"
#include "dbsensordefineforce.hpp"
#include "dbsensordefinenode.hpp"
#include "dbsensorswitch.hpp"
#include "dbsensorswitchcalclogic.hpp"
#include "exptypemap.h"
#include "sensorexport.h"

void SensorExport::initExportSensorTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(SENSOR_CONTROL, importDBSensorControl) );
   expTypeFuncMap.insert( expTypeFuncPair(SENSOR_DEFINE_CALC_MATH, importDBSensorDefineCalcMath) );
   expTypeFuncMap.insert( expTypeFuncPair(SENSOR_DEFINE_ELEMENT, importDBSensorDefineElement) );
   expTypeFuncMap.insert( expTypeFuncPair(SENSOR_DEFINE_FORCE, importDBSensorDefineForce) );
   expTypeFuncMap.insert( expTypeFuncPair(SENSOR_DEFINE_NODE, importDBSensorDefineNode) );
   expTypeFuncMap.insert( expTypeFuncPair(SENSOR_SWITCH, importDBSensorSwitch) );
   expTypeFuncMap.insert( expTypeFuncPair(SENSOR_SWITCH_CALC_LOGIC, importDBSensorSwitchCalcLogic) );
}
