#include <iostream>
#include <algorithm>
#include "generic.h"
#include "settype.h"
#include "setexport.h"
#include "exptitle.h"
#include "setkwfromtype.h"
#include <stdlib.h>

using namespace std;

SetExport::SetExport
(
   char         *model_name,
   GoldenConn   *gold_conn,
   SetManager    *set_man
)
{
   modelName = model_name;
   setManPtr = set_man;
   goldenConn = gold_conn;
   

   initExportNodeTypesAndFunctions();
   initExportSimpleTypesAndFunctions();
   initExportPartTypesAndFunctions();
}

unsigned int SetExport::dbReadSets()
{
   char         **row_data, buf[16];
   unsigned int	i, num_sets = 0, total_sets = 0, num_kw_types = 0, kw_type;
   expTypeFuncIterator eexp_iter = expTypeFuncMap.end(), exp_iter;

   string       qry = "select kw_type from ", kw_str;
   string table_name = "`" + modelName + "_SETS`";
   qry += table_name;
   qry += " group by kw_type;";

cout << "KW QRY = " << qry << endl;

   if( goldenConn->executeQuery( qry.data() ) )
      return 0;

   num_kw_types = goldenConn->numRows();

   if( !num_kw_types )
      return 0;

   unsigned int *kw_types = new unsigned int[num_kw_types];

   for(i = 0; i < num_kw_types; i++)
   {
      row_data = goldenConn->nextRow();
      kw_types[i] = atoi( row_data[0] );
cout << "KW SET TYPE = " << kw_types[i] << endl;
   }

   for(i = 0; i < num_kw_types; i++)
   {
      if( getSetKeywordFromType(kw_types[i], kw_str) )
         continue;

cout << "SET KW = " << kw_str << endl;

      qry = "select * from ";
      qry += table_name;
      qry += " where kw_type=";
      sprintf(buf, "%u", kw_types[i]);
      qry += buf;
      qry += " order by card_index;";

cout << "SET QRY = " << qry << endl;

      if( goldenConn->executeQuery( qry.data() ) )
	 break;

      if( kw_types[i] < TITLE_CARD )
         kw_type = kw_types[i];
      else
         kw_type = kw_types[i] - TITLE_CARD;

      exp_iter = expTypeFuncMap.find(kw_type);

      if( exp_iter == eexp_iter )
      {
	 cout << "SET TYPE NOT FOUND" << endl;
         continue;
      }

      num_sets = 0;
      if( kw_types[i] < TITLE_CARD )
      {
	 while( goldenConn->rowsLeft() )
         {
            impObj = new ExportObject((char *)kw_str.data(), kw_types[i]);
            goldenConn->clearFlag(KW_DATA_END);
	    (exp_iter->second)(goldenConn, impObj);
	    if( impObj->cardCount )
	    {
	       setManPtr->add(kw_str.data(), impObj);
	       num_sets++;
	    }
	    else
	       delete impObj;
         }
      }
      else
      {
         DBTitle title(goldenConn);

	 while( goldenConn->rowsLeft() )
         {
            impObj = new ExportObject((char *)kw_str.data(), kw_types[i]);
            goldenConn->clearFlag(KW_DATA_END);
            title.readCard(impObj);
	    (exp_iter->second)(goldenConn, impObj);
	    if( impObj->cardCount )
	    {
	       setManPtr->add(kw_str.data(), impObj);
	       num_sets++;
	    }
	    else
	       delete impObj;
         }
      }

      total_sets += num_sets;
   }

   delete kw_types;

   return total_sets;
}

