#include "dbset2dsegment.hpp"
#include "dbsetelement.hpp"
#include "dbsetbeamadd.hpp"
#include "dbsetgeneral.hpp"
#include "dbsetgenerate.hpp"
#include "dbsetdiscreteadd.hpp"
#include "dbsetmultimaterialgrouplist.hpp"
#include "dbsetsegment.hpp"
#include "dbsetnodegeneral.hpp"
#include "dbsetshelladd.hpp"
#include "exptypemap.h"
#include "setexport.h"

void SetExport::initExportSimpleTypesAndFunctions()
{
   expTypeFuncMap.insert( expTypeFuncPair(SET_2D_SEGMENT, importDBSet2dSegment) );
   expTypeFuncMap.insert( expTypeFuncPair(SET_2D_SEGMENT_SET, importDBSet2dSegment) );
   expTypeFuncMap.insert( expTypeFuncPair(SET_BEAM, importDBSetElement) );
   expTypeFuncMap.insert( expTypeFuncPair(SET_BEAM_ADD, importDBSetBeamAdd) );
   expTypeFuncMap.insert( expTypeFuncPair(SET_BEAM_GENERAL, importDBSetGeneral) );
   expTypeFuncMap.insert( expTypeFuncPair(SET_BEAM_GENERATE, importDBSetGenerate) );
   expTypeFuncMap.insert( expTypeFuncPair(SET_DISCRETE, importDBSetElement) );
   expTypeFuncMap.insert( expTypeFuncPair(SET_DISCRETE_ADD, importDBSetDiscreteAdd) );
   expTypeFuncMap.insert( expTypeFuncPair(SET_DISCRETE_GENERAL, importDBSetGeneral) );
   expTypeFuncMap.insert( expTypeFuncPair(SET_DISCRETE_GENERATE, importDBSetGenerate) );
   expTypeFuncMap.insert( expTypeFuncPair(SET_MULTI_MATERIAL_GROUP_LIST, importDBSetMultiMaterialGroupList) );
   expTypeFuncMap.insert( expTypeFuncPair(SET_SEGMENT, importDBSetSegment) );
   expTypeFuncMap.insert( expTypeFuncPair(SET_SEGMENT_GENERAL, importDBSetNodeGeneral) );
   expTypeFuncMap.insert( expTypeFuncPair(SET_SOLID, importDBSetElement) );
   expTypeFuncMap.insert( expTypeFuncPair(SET_SOLID_ADD, importDBSetShellAdd) );
   expTypeFuncMap.insert( expTypeFuncPair(SET_SOLID_GENERAL, importDBSetGeneral) );
   expTypeFuncMap.insert( expTypeFuncPair(SET_SOLID_GENERATE, importDBSetGenerate) );
}
