#include <iostream>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <libgen.h>
#include "filegeneric.h"
#include "filepath.h"
#include <boost/functional/hash.hpp>

using namespace std;
using namespace boost;

char FilePath::dirName[128] = "";
char FilePath::modelName[128] = "";
char FilePath::fPath[256] = "";
int FilePath::fileDes = -1;
int FilePath::idFileDes = -1;
int FilePath::indexFileDes = -1;
unsigned int FilePath::pID = 0;
BufFilePtr FilePath::bufPtr = NULL;
BufFilePtr FilePath::idBufPtr = NULL;
BufFilePtr FilePath::indexBufPtr = NULL;
TransformPtr FilePath::transPtr = NULL;

int writeFile(const char *file_name, void *array, size_t size)
{
   int wfd = open(file_name, O_RDWR|O_TRUNC|O_CREAT, 
			S_IRWXU|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH);
   if( wfd < 0 )
   {
      fprintf(stderr, "Unable to open file for writing\n");
      return 1;
   }

   if( lseek(wfd, size-1, SEEK_SET) == -1 )
   {
      fprintf(stderr, "seek error\n");
      close(wfd);
      return 2;
   }

   if( write(wfd, "", 1) != 1 )
   {
      fprintf(stderr, "write error\n");
      close(wfd);
      return 3;
   }

   char *m_file = (char *)mmap(0, size, 
	       PROT_READ | PROT_WRITE, MAP_FILE | MAP_SHARED, wfd, 0);  
   memcpy(m_file, array, size);
   munmap(m_file, size);
   close(wfd);

   return 0;
}

void changeBackSlash(char *path)
{
   unsigned int i = 0;

   while(path[i] != '\0')
   {
      if( path[i] == '\\')
         path[i] = '/';
      i++;
   }
}

void removeChars(char *file_name)
{
   unsigned int len = strlen(file_name), i = 0;
   while(file_name[i] != '\0')
   {
      switch(file_name[i])
      {
	 //case '-':
	 //case '_':
	 case '&':
	 case '.':
	 case '/':
	 {
	    if( !i )
	    {
	       memcpy(&file_name[i], &file_name[i+1], len-1);
	       len--;
	    }
	    else
	    {
	       memcpy(&file_name[i], &file_name[i+1], len-1-i);
	       len--;
	    }

	    file_name[len] = '\0';
	 }
	 break;
	 default:
	    i++;
	 break;
      }
   }
printf("i=%d len=%d\n", i, len);

   file_name[i] = '\0';
}

char *getMainTableNameFromFile(char *path, unsigned int *out_table_id)
{
printf("PATH=%s\n", path);
   boost::hash<string> string_hash;
   size_t table_hash = string_hash(path);
   char 	hashBuf[64];
   sprintf(hashBuf, "%zu", table_hash);

   if(out_table_id) 
      *out_table_id = table_hash;

   printf("HASH FILE NAE=%s\n", hashBuf);

   return strdup(hashBuf);

   /*unsigned int i = 0;
   while(path[i] != '\0')
   {
      if(path[i] == '\\')
         path[i] = '/';
      i++;
   }

   char *file = strdup(path);
   char *dot = strrchr(file, '.');
   if( dot )
      *dot = '\0';

   char *file_name = basename(file);

   removeChars(file_name);
   int len = strlen(file_name);
   if( len > 40 ) //table name length in mysql is 64. entity+___=15;
   {
      len = 40;
      file_name[len] = '\0';
   }
printf("FILE NAE=%s\n", file_name);

   strcpy(file, file_name);
   int hashLen = strlen(hashBuf);
   int fileLen = strlen(file_name);
   if(fileLen < 40)
   {
       string newFile = file_name;
       free(file);
       file = (char *)malloc(sizeof(char) * 40);
       sprintf(file, "%s_%s", newFile.data(), hashBuf);
   }
   else    
       strncpy(&file[fileLen-hashLen], hashBuf, hashLen);
printf("HASH FILE NAE=%s\n", file);
   //memcpy(file, file_name, len);

   string fileName = path, subStr;
   size_t underScorePos = fileName.rfind('_');
   if(underScorePos != string::npos)
   {
      size_t newPos = fileName.rfind('_', underScorePos-1);
      if(newPos != string::npos && isdigit(fileName[newPos+1]))
         subStr = fileName.substr(newPos+1, underScorePos-newPos-1);
      else
         subStr = fileName.substr(underScorePos+1, fileName.size()-underScorePos);
cout << "SUBSTR=" << subStr << endl;
      if(!subStr.empty() && isdigit(subStr[0]) && out_table_id)
      {
         *out_table_id = atoi(subStr.data());
      }
   }

   return file;*/
}

char *getTableNameFromFile(char *path, unsigned int *table_id, const char *parent_dir)
{
printf("PATH=%s\n", path);
   /*unsigned int i = 0;

   while(path[i] != '\0')
   {
      if(path[i] == '\\')
         path[i] = '/';
      i++;
   }

   char *file = strdup(path);
   char *dot = strrchr(file, '.');
   if( dot )
      *dot = '\0';

   removeChars(file);

   unsigned int sec_len = strlen(file);
   if( sec_len > 20 )
   {
      unsigned int len = 20, len1 = sec_len-len;
      char *ptr = file;
      while(*ptr != '\0')
      {
	 *ptr = *(file + len1);
	 ptr++;
	 len1++;
      }
      sec_len = len;
      file[sec_len] = '\0';
   }*/

   char *file = NULL;
   if(table_id)
   {
       boost::hash<string> string_hash;
       string new_path = path;
       if(parent_dir)
       {
       new_path = parent_dir;
       new_path += "/";
       new_path += path;
       }
       size_t   longHash = string_hash(new_path);
       *table_id = longHash;
       char fileBuf[256];
       sprintf(fileBuf, "%zu", longHash);
    cout << "FILE NAME=" << new_path << " HASH=" << *table_id << endl;
       /*sprintf(fileBuf, "%s_%u", file, *table_id);
       free(file);*/
       file = strdup(fileBuf);
   }

   return file;
}

char *getCombinedTableName(const char *first, const char *second)
{
   char *main_str = strdup(first);
   char *sec_str = strdup(second);

   unsigned int first_len = strlen(first);
   unsigned int sec_len = strlen(second);
printf("FLEN=%u SLEN=%u\n", first_len, sec_len);
  
   if( first_len > 20 )
   {
      first_len = 20;
      main_str[first_len] = '\0';
   }

   if( sec_len > 20 )
   {
      unsigned int len = 20, len1 = sec_len-len;
      char *ptr = sec_str;
      while(*ptr != '\0')
      {
	 *ptr = *(sec_str + len1);
	 ptr++;
	 len1++;
      }
      sec_len = len;
      sec_str[sec_len] = '\0';
   }

printf("F=%s S=%s\n", main_str, sec_str);

   char 	strBuf[256];
   sprintf(strBuf, "%s_%s", main_str, sec_str);
   char *comb = new char[strlen(strBuf)+1];
   strcpy(comb, strBuf);

   free(main_str);
   free(sec_str);

   return comb;
}

int getFileName(const char *file_name, string & ret_name)
{
   int file_idx = 0;

   ret_name = file_name;
   if( !strstr(file_name, "MAIN") )
   {
      char dup_name[128];
      strcpy(dup_name, file_name);
      char *ptr = strrchr(dup_name, '_');
      if( ptr )
      {
	 ptr++;
	 file_idx = atoi(ptr);
	 ptr--;
	 *ptr = '\0';
      }
      ret_name = dup_name;
   }

   return file_idx;
}

//https://stackoverflow.com/questions/2336242/recursive-mkdir-system-call-on-unix
void _mkdir(const char *dir) {
        char tmp[256];
        char *p = NULL;
        size_t len;

        snprintf(tmp, sizeof(tmp),"%s",dir);
        len = strlen(tmp);
        if(tmp[len - 1] == '/')
                tmp[len - 1] = 0;
        for(p = tmp + 1; *p; p++)
                if(*p == '/') {
                        *p = 0;
                        mkdir(tmp, S_IRWXU);
                        *p = '/';
                }
        mkdir(tmp, S_IRWXU);
}
