#include <iostream>
#include "filegeneric.h"
#include <boost/filesystem/path.hpp>
#include <boost/filesystem.hpp>
#include <boost/functional/hash.hpp>

using namespace boost::filesystem;

int main(int argc, char *argv[])
{
    path filePath(argv[1]);
    if(!exists(filePath))
    {
        cout << "File <" << argv[1] << "> not found" << endl;
	return 0;
    }
    path absPath = canonical(filePath);
    path currentPath = current_path();
    cout << "ABSPATH=" << absPath.c_str() << endl;
    cout << "CURPATH=" << currentPath.c_str() << endl;
    boost::hash<string> string_hash;
    size_t table_hash = string_hash(absPath.c_str());
    int int_hash = (int)table_hash;
    cout << "SIZE HASH=" << table_hash << endl;
    cout << "INT HASH=" << int_hash << endl;
    cout << "PARENT PATH=" << absPath.parent_path().filename() << endl;
    return 1;
}
