#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/mman.h>
#include "transform.h"

int getTransformPtr(const char *dir, int trans_idx, TransformPtr tptr)
{
   char buf[256];
   struct stat statbuf;
   sprintf(buf, "%s/transform", dir);
   int fd = open(buf, O_RDONLY);
   memset(tptr, 0, sizeof(TransformStr));

   if( fd < 0 )
   {
      cout << "Transform file=" << buf << " not found\n";
      return 1;
   }

   if( fstat(fd, &statbuf) < 0 )
   {
      cout << "Unable to stat file " << buf << endl;
      return 2;
   }
cout << "BLOCK SIZE in TRANSFORM=" << statbuf.st_blksize << endl;
cout << "NUM BLOCK =" << statbuf.st_blocks << endl;

   TransformStr *base = (TransformStr *)mmap(0, statbuf.st_size, 
                                        PROT_READ, MAP_SHARED, fd, 0);
   if( !base )
   {
      cout << "MMAP error for file " << buf << endl;
      return 3;
   }

   int num_trans = statbuf.st_size/sizeof(TransformStr);

   if( trans_idx >= num_trans )
   {
      cout << "Transform index is out of bounds\n";
      return 4;
   }

   memcpy(tptr, &base[trans_idx], sizeof(TransformStr));

   return 0;
}
