#ifndef _TRANSFORM_H_
#define _TRANSFORM_H_

#include <iostream>
#include <map>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

using namespace std;

/** Stores the information of *DEFINE_TRANSFORMATION keyword */
typedef struct _TransformStr
{
   int fileIndex; /** Index of file for which this data is to be applied */ 
   /** offset for IDs of node, element, part, material, section etc */
   int idnoff, ideoff, idpoff, idmoff, idsoff, idfoff, iddoff, idroff;
   /** Rotations in x, y and z directions */
   float rotAngle, rX, rY, rZ;
   /** Scale in x, y and z directions */
   float sX, sY, sZ;
   /** Translation in x, y and z directions */
   float tX, tY, tZ;
}
  TransformStr, *TransformPtr;

/** Denotes a 3D point */
typedef struct _PointStr
{
   /** Coordinates */
   float x, y, z;
}
  PointStr, *PointPtr;

typedef map<int, PointStr> PointMap;
typedef pair<int, PointStr> PointPair;
typedef map<int, PointStr>::iterator PointMapIter;

/** Fetches the Transformation information from tranform file based its
  * index
  * \param dir Name of directory
  * \param trans_idx Index of tranform object
  * \param tptr Transform Object pointer is filled
  * \return Returns 0 on success else greater than 0
  */
int getTransformPtr(const char *dir, int trans_idx, TransformPtr tptr);

#endif

