#include "abadvancedale.hpp"
#include "abale.hpp"
#include "abinteraction.hpp"
#include "abreferencegeometry.hpp"
#include "abrefgeometrybirth.hpp"
#include "abrefgeobirthrdt.hpp"
#include "abrefgeometryrdt.hpp"
#include "abshellrefgeometry.hpp"
#include "typemap.h"
#include "abimport.h"

void ABImport::initABALETypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(AIRBAG_ADVANCED_ALE, importABAdvancedALE) );
   typeFuncMap.insert( typeFuncPair(AIRBAG_ALE, importABALE) );
   typeFuncMap.insert( typeFuncPair(AIRBAG_INTERACTION, importABInteraction) );
   typeFuncMap.insert( typeFuncPair(AIRBAG_REFERENCE_GEOMETRY, importABReferenceGeometry) );
   typeFuncMap.insert( typeFuncPair(AIRBAG_REFERENCE_GEOMETRY_BIRTH, importABRefGeometryBirth) );
   typeFuncMap.insert( typeFuncPair(AIRBAG_REFERENCE_GEOMETRY_BIRTH_RDT, importABRefGeoBirthRDT) );
   typeFuncMap.insert( typeFuncPair(AIRBAG_REFERENCE_GEOMETRY_RDT, importABRefGeometryRDT) );
   typeFuncMap.insert( typeFuncPair(AIRBAG_SHELL_REFERENCE_GEOMETRY, importABShellRefGeometry) );
}
