#include "abadiabaticgasmodel.hpp"
#include "ablinearfluid.hpp"
#include "abloadcurve.hpp"
#include "absimplemodel.hpp"
#include "absimplepressurevolume.hpp"
#include "typemap.h"
#include "abimport.h"

void ABImport::initSimpleTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(AIRBAG_ADIABATIC_GAS_MODEL, importABAdiabaticGasModel) );
   typeFuncMap.insert( typeFuncPair(AIRBAG_ADIABATIC_GAS_MODEL_ID, importABAdiabaticGasModel) );
   typeFuncMap.insert( typeFuncPair(AIRBAG_LINEAR_FLUID, importABLinearFluid) );
   typeFuncMap.insert( typeFuncPair(AIRBAG_LINEAR_FLUID_ID, importABLinearFluid) );
   typeFuncMap.insert( typeFuncPair(AIRBAG_LOAD_CURVE, importABLoadCurve) );
   typeFuncMap.insert( typeFuncPair(AIRBAG_LOAD_CURVE_ID, importABLoadCurve) );
   typeFuncMap.insert( typeFuncPair(AIRBAG_SIMPLE_AIRBAG_MODEL, importABSimpleModel) );
   typeFuncMap.insert( typeFuncPair(AIRBAG_SIMPLE_AIRBAG_MODEL_ID, importABSimpleModel) );
   typeFuncMap.insert( typeFuncPair(AIRBAG_SIMPLE_PRESSURE_VOLUME, importABSimplePressureVolume) );
   typeFuncMap.insert( typeFuncPair(AIRBAG_SIMPLE_PRESSURE_VOLUME_ID, importABSimplePressureVolume) );
}
