#ifndef _ABWangNefskeJettingCM_h_
#define _ABWangNefskeJettingCM_h_

#include "manager.h"
#include "dispexport.h"
#include "abwangnefskejetting.h"

/** This class is used for importing *AIRBAG_WANG_NEFSKE_JETTING_CM keyword
  * from LSDYNA native file */

class ABWangNefskeJettingCM : public ABWangNefskeJetting
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ABWangNefskeJettingCM(DataLine *data_line, ImportObject *imp_obj) : ABWangNefskeJetting (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ABWangNefskeJettingCM()
   {
   }

public:
/** Function to import CMCard details for *AIRBAG_WANG_NEFSKE_JETTING_CM
  * keyword from file */
   void readCMCard()
   {
      const char *fields[] = {"NREACT",};
      unsigned int field_types[] = {DATA_INT, };
      numFields = 1;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("CMCard");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *AIRBAG_WANG_NEFSKE_JETTING_CM
  * from LSDYNA native file */
   unsigned int importABWangNefskeJettingCM()
   {
      importABWangNefskeJetting();
      readCMCard();
      return 0;
   }
};

#endif

