#ifndef _ABWangNefskePop_h_
#define _ABWangNefskePop_h_

#include "manager.h"
#include "dispexport.h"
#include "abwangnefske.h"

/** This class is used for importing *AIRBAG_WANG_NEFSKE_POP keyword
  * from LSDYNA native file */

class ABWangNefskePop : public ABWangNefske
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ABWangNefskePop(DataLine *data_line, ImportObject *imp_obj) : ABWangNefske (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ABWangNefskePop()
   {
   }

public:
/** Function to import PopCard details for *AIRBAG_WANG_NEFSKE_POP
  * keyword from file */
   void readPopCard()
   {
      const char *fields[] = {"TDP","AXP","AYP","AZP","AMAGP","TDURP","TDA","RBIDP",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_INT, };
      numFields = 8;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("PopCard");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *AIRBAG_WANG_NEFSKE_POP
  * from LSDYNA native file */
   unsigned int importABWangNefskePop()
   {
      importABWangNefske();
      readPopCard();
      return 0;
   }
};

#endif

