#ifndef _AleMultiMatGroup_h_
#define _AleMultiMatGroup_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *ALE_MULTI_MATERIAL_GROUP keyword
  * from LSDYNA native file */

class AleMultiMatGroup : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   AleMultiMatGroup(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~AleMultiMatGroup()
   {
   }

public:
/** Function to import SetInfo details for *ALE_MULTI_MATERIAL_GROUP
  * keyword from file */
   void readSetInfo()
   {
      const char *fields[] = {"SID","IDTYPE",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, };
      numFields = 2;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_IDS) )
         addIDToFile(wordArray, 0, ALE, impObj);

      if( Card::isFlagOn(SAVE_REFERENCES) )
         airbagVentHoleFind(wordArray, numFields, 0, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("SetInfo");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *ALE_MULTI_MATERIAL_GROUP
  * from LSDYNA native file */
   unsigned int importAleMultiMatGroup()
   {
      readSetInfo();
      while(numFields)
      {
         readSetInfo();
      }
      return 0;
   }
};

#endif

