#include "alefsiprojection.hpp"
#include "alefsiswitchmmg.hpp"
#include "alemultimatgroup.hpp"
#include "alerefsyscurve.hpp"
#include "alerefsysgroup.hpp"
#include "alerefsysnode.hpp"
#include "alerefsysswitch.hpp"
#include "alesmoothing.hpp"
#include "aletanktest.hpp"
#include "aleupswitch.hpp"
#include "typemap.h"
#include "aleimport.h"

void ALEImport::initAleTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(ALE_FSI_PROJECTION, importAleFsiProjection) );
   typeFuncMap.insert( typeFuncPair(ALE_FSI_SWITCH_MMG, importAleFsiSwitchMmg) );
   typeFuncMap.insert( typeFuncPair(ALE_FSI_SWITCH_MMG_ID, importAleFsiSwitchMmg) );
   typeFuncMap.insert( typeFuncPair(ALE_FSI_SWITCH_MMG_TITLE, importAleFsiSwitchMmg) );
   typeFuncMap.insert( typeFuncPair(ALE_MULTI_MATERIAL_GROUP, importAleMultiMatGroup) );
   typeFuncMap.insert( typeFuncPair(ALE_REFERENCE_SYSTEM_CURVE, importAleRefSysCurve) );
   typeFuncMap.insert( typeFuncPair(ALE_REFERENCE_SYSTEM_GROUP, importAleRefSysGroup) );
   typeFuncMap.insert( typeFuncPair(ALE_REFERENCE_SYSTEM_NODE, importAleRefSysNode) );
   typeFuncMap.insert( typeFuncPair(ALE_REFERENCE_SYSTEM_SWITCH, importAleRefSysSwitch) );
   typeFuncMap.insert( typeFuncPair(ALE_SMOOTHING, importAleSmoothing) );
   typeFuncMap.insert( typeFuncPair(ALE_TANK_TEST, importAleTankTest) );
   typeFuncMap.insert( typeFuncPair(ALE_UP_SWITCH, importAleUpSwitch) );
}
