#include "bemacoustic.hpp"
#include "bemcontrol.hpp"
#include "bemflow.hpp"
#include "bemsymmetry.hpp"
#include "bemneighbor.hpp"
#include "bemwake.hpp"
#include "typemap.h"
#include "bdryimport.h"

void BdryImport::initBEMTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(BOUNDARY_ELEMENT_METHOD_ACOUSTIC, importBEMAcoustic) );
   typeFuncMap.insert( typeFuncPair(BOUNDARY_ELEMENT_METHOD_CONTROL, importBEMControl) );
   typeFuncMap.insert( typeFuncPair(BOUNDARY_ELEMENT_METHOD_FLOW, importBEMFlow) );
   typeFuncMap.insert( typeFuncPair(BOUNDARY_ELEMENT_METHOD_SYMMETRY, importBEMSymmetry) );
   typeFuncMap.insert( typeFuncPair(BOUNDARY_ELEMENT_METHOD_NEIGHBOR, importBEMNeighbor) );
   typeFuncMap.insert( typeFuncPair(BOUNDARY_ELEMENT_METHOD_WAKE, importBEMWake) );
}
