#ifndef _BdryAmbientEOS_h_
#define _BdryAmbientEOS_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *BOUNDARY_AMBIENT_EOS keyword
  * from LSDYNA native file */

class BdryAmbientEOS : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   BdryAmbientEOS(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~BdryAmbientEOS()
   {
   }

public:
/** Function to import PartCard details for *BOUNDARY_AMBIENT_EOS
  * keyword from file */
   void readPartCard()
   {
      const char *fields[] = {"PID","LCID1","LCID2",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, };
      unsigned int field_indices[] = {0, 1, 2, };
      unsigned int man_types[] = {PARTC, DEFINE, DEFINE, };
      unsigned int kw_types[] = {9999, CURVE, CURVE, };
      unsigned int num_indices = 3;
      numFields = 3;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("PartCard");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *BOUNDARY_AMBIENT_EOS
  * from LSDYNA native file */
   unsigned int importBdryAmbientEOS()
   {
      readPartCard();
      return 0;
   }
};

#endif

