#include "bdryacousticcoupling.hpp"
#include "bdryambienteos.hpp"
#include "bdrycyclic.hpp"
#include "bdrymcol.hpp"
#include "bdrypresaccelrigid.hpp"
#include "bdryslidingplane.hpp"
#include "bdrysymfailure.hpp"
#include "bdryusasurface.hpp"
#include "typemap.h"
#include "bdryimport.h"

void BdryImport::initSimpleTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(BOUNDARY_ACOUSTIC_COUPLING, importBdryAcousticCoupling) );
   typeFuncMap.insert( typeFuncPair(BOUNDARY_AMBIENT_EOS, importBdryAmbientEOS) );
   typeFuncMap.insert( typeFuncPair(BOUNDARY_CYCLIC, importBdryCyclic) );
   typeFuncMap.insert( typeFuncPair(BOUNDARY_MCOL, importBdryMCOL) );
   typeFuncMap.insert( typeFuncPair(BOUNDARY_PRESCRIBED_ACCELEROMETER_RIGID, importBdryPresAccelRigid) );
   typeFuncMap.insert( typeFuncPair(BOUNDARY_SLIDING_PLANE, importBdrySlidingPlane) );
   typeFuncMap.insert( typeFuncPair(BOUNDARY_SYMMETRY_FAILURE, importBdrySymFailure) );
   typeFuncMap.insert( typeFuncPair(BOUNDARY_USA_SURFACE, importBdryUsaSurface) );
}
