#include "componentgebod.hpp"
#include "componentgebodjoint.hpp"
#include "componenthybridiii.hpp"
#include "componenthybridiiijoint.hpp"
#include "typemap.h"
#include "compimport.h"

void CompImport::initCompTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(COMPONENT_GEBOD_CHILD, importComponentGebod) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_GEBOD_FEMALE, importComponentGebod) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_GEBOD_JOINT_LEFT_ANKLE, importComponentGebodJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_GEBOD_JOINT_LEFT_ELBOW, importComponentGebodJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_GEBOD_JOINT_LEFT_HIP, importComponentGebodJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_GEBOD_JOINT_LEFT_KNEE, importComponentGebodJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_GEBOD_JOINT_LEFT_SHOULDER, importComponentGebodJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_GEBOD_JOINT_LOWER_NECK, importComponentGebodJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_GEBOD_JOINT_PELVIS, importComponentGebodJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_GEBOD_JOINT_RIGHT_ANKLE, importComponentGebodJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_GEBOD_JOINT_RIGHT_ELBOW, importComponentGebodJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_GEBOD_JOINT_RIGHT_HIP, importComponentGebodJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_GEBOD_JOINT_RIGHT_KNEE, importComponentGebodJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_GEBOD_JOINT_RIGHT_SHOULDER, importComponentGebodJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_GEBOD_JOINT_UPPER_NECK, importComponentGebodJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_GEBOD_JOINT_WAIST, importComponentGebodJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_GEBOD_MALE, importComponentGebod) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII, importComponentHybridIII) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_LEFT_ANKLE, importComponentHybridIIIJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_LEFT_ELBOW, importComponentHybridIIIJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_LEFT_HIP, importComponentHybridIIIJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_LEFT_KNEE, importComponentHybridIIIJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_LEFT_KNEE_SLIDER, importComponentHybridIIIJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_LEFT_SHOULDER, importComponentHybridIIIJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_LEFT_WRIST, importComponentHybridIIIJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_LOWER_NECK, importComponentHybridIIIJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_LUMBAR, importComponentHybridIIIJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_RIGHT_ANKLE, importComponentHybridIIIJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_RIGHT_ELBOW, importComponentHybridIIIJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_RIGHT_HIP, importComponentHybridIIIJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_RIGHT_KNEE, importComponentHybridIIIJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_RIGHT_KNEE_SLIDER, importComponentHybridIIIJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_RIGHT_SHOULDER, importComponentHybridIIIJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_RIGHT_WRIST, importComponentHybridIIIJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_STERNUM, importComponentHybridIIIJoint) );
   typeFuncMap.insert( typeFuncPair(COMPONENT_HYBRIDIII_JOINT_UPPER_NECK, importComponentHybridIIIJoint) );
}
