#include "constlagrangesolid.hpp"
#include "constlinearglobal.hpp"
#include "constlinearlocal.hpp"
#include "constlocal.hpp"
#include "constrigidbodies.hpp"
#include "constrigidbodystoppers.hpp"
#include "typemap.h"
#include "constimport.h"

void ConstImport::initCouplingTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_LAGRANGE_IN_SOLID, importConstLagrangeSolid) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_LAGRANGE_IN_SOLID_EDGE, importConstLagrangeSolid) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_LAGRANGE_IN_SOLID_EDGE_TITLE, importConstLagrangeSolid) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_LAGRANGE_IN_SOLID_TITLE, importConstLagrangeSolid) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_LINEAR_GLOBAL, importConstLinearGlobal) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_LINEAR_LOCAL, importConstLinearLocal) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_LOCAL, importConstLocal) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_RIGID_BODIES, importConstRigidBodies) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_RIGID_BODY_STOPPERS, importConstRigidBodyStoppers) );
}
