#include "constjointlocalfailure.hpp"
#include "constjoint.hpp"
#include "constjointmotor.hpp"
#include "constjointmotorlocalfailure.hpp"
#include "typemap.h"
#include "constimport.h"

void ConstImport::initJointTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_ID_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_ID_FAILURE_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_ID_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_ID_LOCAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_FAILURE_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_FAILURE_ID_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_FAILURE_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_FAILURE_LOCAL_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL, importConstJoint) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_ID, importConstJoint) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_LOCAL_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_LOCAL_ID_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_LOCAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CYLINDRICAL_LOCAL_FAILURE_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_GEARS, importConstJointMotor) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_GEARS_ID, importConstJointMotor) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_GEARS_ID_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_GEARS_ID_FAILURE_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_GEARS_ID_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_GEARS_ID_LOCAL_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_GEARS_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_GEARS_FAILURE_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_GEARS_FAILURE_ID_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_GEARS_FAILURE_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_GEARS_FAILURE_LOCAL_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_GEARS_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_GEARS_LOCAL_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_GEARS_LOCAL_ID_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_GEARS_LOCAL_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_GEARS_LOCAL_FAILURE_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_LOCKING, importConstJoint) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_LOCKING_ID, importConstJoint) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_LOCKING_ID_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_LOCKING_ID_FAILURE_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_LOCKING_ID_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_LOCKING_ID_LOCAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_LOCKING_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_LOCKING_FAILURE_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_LOCKING_FAILURE_ID_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_LOCKING_FAILURE_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_LOCKING_FAILURE_LOCAL_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_LOCKING_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_LOCKING_LOCAL_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_LOCKING_LOCAL_ID_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_LOCKING_LOCAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_LOCKING_LOCAL_FAILURE_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PLANAR_ID_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PLANAR_ID_FAILURE_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PLANAR_ID_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PLANAR_ID_LOCAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PLANAR, importConstJoint) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PLANAR_ID, importConstJoint) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PLANAR_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PLANAR_FAILURE_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PLANAR_FAILURE_ID_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PLANAR_FAILURE_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PLANAR_FAILURE_LOCAL_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PLANAR_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PLANAR_LOCAL_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PLANAR_LOCAL_ID_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PLANAR_LOCAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PLANAR_LOCAL_FAILURE_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PULLEY, importConstJointMotor) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PULLEY_ID, importConstJointMotor) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PULLEY_ID_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PULLEY_ID_FAILURE_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PULLEY_ID_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PULLEY_ID_LOCAL_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PULLEY_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PULLEY_FAILURE_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PULLEY_FAILURE_ID_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PULLEY_FAILURE_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PULLEY_FAILURE_LOCAL_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PULLEY_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PULLEY_LOCAL_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PULLEY_LOCAL_ID_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PULLEY_LOCAL_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_PULLEY_LOCAL_FAILURE_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION, importConstJointMotor) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_ID, importConstJointMotor) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_ID_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_ID_FAILURE_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_ID_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_ID_LOCAL_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_FAILURE_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_FAILURE_ID_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_FAILURE_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_FAILURE_LOCAL_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_LOCAL_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_LOCAL_ID_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_LOCAL_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_RACK_AND_PINION_LOCAL_FAILURE_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_REVOLUTE_ID_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_REVOLUTE_ID_FAILURE_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_REVOLUTE_ID_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_REVOLUTE_ID_LOCAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_REVOLUTE_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_REVOLUTE_FAILURE_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_REVOLUTE_FAILURE_ID_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_REVOLUTE_FAILURE_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_REVOLUTE_FAILURE_LOCAL_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_REVOLUTE_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_REVOLUTE_LOCAL_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_REVOLUTE_LOCAL_ID_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_REVOLUTE_LOCAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_REVOLUTE_LOCAL_FAILURE_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_REVOLUTE, importConstJoint) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_REVOLUTE_ID, importConstJoint) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR, importConstJointMotor) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_ID, importConstJointMotor) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_ID_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_ID_FAILURE_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_ID_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_ID_LOCAL_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_FAILURE_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_FAILURE_ID_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_FAILURE_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_FAILURE_LOCAL_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_LOCAL_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_LOCAL_ID_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_LOCAL_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_ROTATIONAL_MOTOR_LOCAL_FAILURE_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SCREW, importConstJointMotor) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SCREW_ID, importConstJointMotor) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SCREW_ID_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SCREW_ID_FAILURE_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SCREW_ID_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SCREW_ID_LOCAL_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SCREW_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SCREW_FAILURE_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SCREW_FAILURE_ID_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SCREW_FAILURE_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SCREW_FAILURE_LOCAL_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SCREW_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SCREW_LOCAL_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SCREW_LOCAL_ID_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SCREW_LOCAL_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SCREW_LOCAL_FAILURE_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SPHERICAL_ID_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SPHERICAL_ID_FAILURE_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SPHERICAL_ID_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SPHERICAL_ID_LOCAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SPHERICAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SPHERICAL_FAILURE_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SPHERICAL_FAILURE_ID_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SPHERICAL_FAILURE_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SPHERICAL_FAILURE_LOCAL_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SPHERICAL, importConstJoint) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SPHERICAL_ID, importConstJoint) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SPHERICAL_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SPHERICAL_LOCAL_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SPHERICAL_LOCAL_ID_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SPHERICAL_LOCAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_SPHERICAL_LOCAL_FAILURE_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL, importConstJoint) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_ID, importConstJoint) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_ID_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_ID_FAILURE_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_ID_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_ID_LOCAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_FAILURE_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_FAILURE_ID_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_FAILURE_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_FAILURE_LOCAL_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_LOCAL_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_LOCAL_ID_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_LOCAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_LOCAL_FAILURE_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR, importConstJointMotor) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_ID, importConstJointMotor) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_ID_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_ID_FAILURE_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_ID_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_ID_LOCAL_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_FAILURE_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_FAILURE_ID_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_FAILURE_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_FAILURE_LOCAL_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_LOCAL, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_LOCAL_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_LOCAL_ID_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_LOCAL_FAILURE, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_TRANSLATIONAL_MOTOR_LOCAL_FAILURE_ID, importConstJointMotorLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_ID_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_ID_FAILURE_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_ID_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_ID_LOCAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_FAILURE_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_FAILURE_ID_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_FAILURE_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_FAILURE_LOCAL_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_LOCAL_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_LOCAL_ID_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_LOCAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_LOCAL_FAILURE_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_UNIVERSAL, importConstJoint) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_UNIVERSAL_ID, importConstJoint) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY, importConstJoint) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_ID, importConstJoint) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_ID_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_ID_FAILURE_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_ID_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_ID_LOCAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_FAILURE_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_FAILURE_ID_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_FAILURE_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_FAILURE_LOCAL_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_LOCAL, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_LOCAL_ID, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_LOCAL_ID_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_LOCAL_FAILURE, importConstJointLocalFailure) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_JOINT_CONSTANT_VELOCITY_LOCAL_FAILURE_ID, importConstJointLocalFailure) );
}
