#include "constnodalrigidbody.hpp"
#include "constnodalrigidbodyinertia.hpp"
#include "constnodalrigidbodyspc.hpp"
#include "constnodalrigidbodyspcinertia.hpp"
#include "constnodeset.hpp"
#include "constpoints.hpp"
#include "typemap.h"
#include "constimport.h"

void ConstImport::initNodalTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_NODAL_RIGID_BODY_TITLE, importConstNodalRigidBody) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_NODAL_RIGID_BODY, importConstNodalRigidBody) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_NODAL_RIGID_BODY_INERTIA, importConstNodalRigidBodyInertia) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_NODAL_RIGID_BODY_INERTIA_TITLE, importConstNodalRigidBodyInertia) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_NODAL_RIGID_BODY_SPC, importConstNodalRigidBodySpc) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_NODAL_RIGID_BODY_SPC_TITLE, importConstNodalRigidBodySpc) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_NODAL_RIGID_BODY_SPC_INERTIA, importConstNodalRigidBodySpcInertia) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_NODAL_RIGID_BODY_SPC_INERTIA_TITLE, importConstNodalRigidBodySpcInertia) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_NODE_SET, importConstNodeSet) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_NODE_SET_ID, importConstNodeSet) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_POINTS, importConstPoints) );
}
