#ifndef _ConstExtraNodes_h_
#define _ConstExtraNodes_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *CONSTRAINED_EXTRA_NODES_NODE keyword
  * from LSDYNA native file */

class ConstExtraNodes : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ConstExtraNodes(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ConstExtraNodes()
   {
   }

public:
/** Function to import PartSet details for *CONSTRAINED_EXTRA_NODES_NODE
  * keyword from file */
   void readPartSet()
   {
      const char *fields[] = {"PID","NID/NSID","IFLAG",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, };
      numFields = 3;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         constExtraNodes(wordArray, numFields, 0, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("PartSet");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONSTRAINED_EXTRA_NODES_NODE
  * from LSDYNA native file */
   unsigned int importConstExtraNodes()
   {
      readPartSet();
      while(numFields)
      {
         readPartSet();
      }
      return 0;
   }
};

#endif

