#ifndef _ConstGlobal_h_
#define _ConstGlobal_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *CONSTRAINED_GLOBAL keyword
  * from LSDYNA native file */

class ConstGlobal : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ConstGlobal(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ConstGlobal()
   {
   }

public:
/** Function to import Global details for *CONSTRAINED_GLOBAL
  * keyword from file */
   void readGlobal()
   {
      const char *fields[] = {"TC","RC","DIR","X","Y","Z",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 6;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Global");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONSTRAINED_GLOBAL
  * from LSDYNA native file */
   unsigned int importConstGlobal()
   {
      readGlobal();
      return 0;
   }
};

#endif

