#ifndef _ConstShellToSolid_h_
#define _ConstShellToSolid_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *CONSTRAINED_SHELL_TO_SOLID keyword
  * from LSDYNA native file */

class ConstShellToSolid : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ConstShellToSolid(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ConstShellToSolid()
   {
   }

public:
/** Function to import Nodes details for *CONSTRAINED_SHELL_TO_SOLID
  * keyword from file */
   void readNodes()
   {
      const char *fields[] = {"NID","NSID",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, };
      numFields = 2;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Nodes");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONSTRAINED_SHELL_TO_SOLID
  * from LSDYNA native file */
   unsigned int importConstShellToSolid()
   {
      readNodes();
      return 0;
   }
};

#endif

