#ifndef _ConstTieBreak_h_
#define _ConstTieBreak_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *CONSTRAINED_TIE_BREAK keyword
  * from LSDYNA native file */

class ConstTieBreak : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ConstTieBreak(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ConstTieBreak()
   {
   }

public:
/** Function to import NodeSet details for *CONSTRAINED_TIE_BREAK
  * keyword from file */
   void readNodeSet()
   {
      const char *fields[] = {"SNSID","MNSID","EPPF",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_DOUBLE, };
      numFields = 3;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("NodeSet");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONSTRAINED_TIE_BREAK
  * from LSDYNA native file */
   unsigned int importConstTieBreak()
   {
      readNodeSet();
      return 0;
   }
};

#endif

