#ifndef _ConstTiedNodesFail_h_
#define _ConstTiedNodesFail_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *CONSTRAINED_TIED_NODES_FAILURE keyword
  * from LSDYNA native file */

class ConstTiedNodesFail : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ConstTiedNodesFail(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ConstTiedNodesFail()
   {
   }

public:
/** Function to import NodeSet details for *CONSTRAINED_TIED_NODES_FAILURE
  * keyword from file */
   void readNodeSet()
   {
      const char *fields[] = {"NSID","EPPF","ETYPE",};
      unsigned int field_types[] = {DATA_INT, DATA_DOUBLE, DATA_INT, };
      numFields = 3;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("NodeSet");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONSTRAINED_TIED_NODES_FAILURE
  * from LSDYNA native file */
   unsigned int importConstTiedNodesFail()
   {
      readNodeSet();
      return 0;
   }
};

#endif

