#ifndef _ConstButtWeld_h_
#define _ConstButtWeld_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *CONSTRAINED_BUTT_WELD keyword
  * from LSDYNA native file */

class ConstButtWeld : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ConstButtWeld(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ConstButtWeld()
   {
   }

public:
/** Function to import Slave details for *CONSTRAINED_BUTT_WELD
  * keyword from file */
   void readSlave()
   {
      const char *fields[] = {"SNSID","MNSID","EPPF","SIGF","BETA",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 5;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Slave");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONSTRAINED_BUTT_WELD
  * from LSDYNA native file */
   unsigned int importConstButtWeld()
   {
      readSlave();
      return 0;
   }
};

#endif

