#ifndef _ConstGenWeldButt_h_
#define _ConstGenWeldButt_h_

#include "manager.h"
#include "dispexport.h"
#include "constgenweld.h"

/** This class is used for importing *CONSTRAINED_GENERALIZED_WELD_BUTT keyword
  * from LSDYNA native file */

class ConstGenWeldButt : public ConstGenWeld
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ConstGenWeldButt(DataLine *data_line, ImportObject *imp_obj) : ConstGenWeld (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ConstGenWeldButt()
   {
   }

public:
/** Function to import Butt details for *CONSTRAINED_GENERALIZED_WELD_BUTT
  * keyword from file */
   void readButt()
   {
      const char *fields[] = {"TFAIL","EPSF","SIGY","BETA","L","D","LT",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 7;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Butt");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONSTRAINED_GENERALIZED_WELD_BUTT
  * from LSDYNA native file */
   unsigned int importConstGenWeldButt()
   {
      importConstGenWeld();
      readButt();
      return 0;
   }
};

#endif

