#ifndef _ConstGenWeldFillet_h_
#define _ConstGenWeldFillet_h_

#include "manager.h"
#include "dispexport.h"
#include "constgenweld.h"

/** This class is used for importing *CONSTRAINED_GENERALIZED_WELD_FILLET keyword
  * from LSDYNA native file */

class ConstGenWeldFillet : public ConstGenWeld
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ConstGenWeldFillet(DataLine *data_line, ImportObject *imp_obj) : ConstGenWeld (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ConstGenWeldFillet()
   {
   }

public:
/** Function to import Fillet details for *CONSTRAINED_GENERALIZED_WELD_FILLET
  * keyword from file */
   void readFillet()
   {
      const char *fields[] = {"TFAIL","EPSF","SIGF","BETA","L","W","A","ALPHA",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 8;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Fillet");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONSTRAINED_GENERALIZED_WELD_FILLET
  * from LSDYNA native file */
   unsigned int importConstGenWeldFillet()
   {
      importConstGenWeld();
      readFillet();
      return 0;
   }
};

#endif

