#ifndef _ConstGenWeldSpot_h_
#define _ConstGenWeldSpot_h_

#include "manager.h"
#include "dispexport.h"
#include "constgenweld.h"

/** This class is used for importing *CONSTRAINED_GENERALIZED_WELD_SPOT keyword
  * from LSDYNA native file */

class ConstGenWeldSpot : public ConstGenWeld
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ConstGenWeldSpot(DataLine *data_line, ImportObject *imp_obj) : ConstGenWeld (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ConstGenWeldSpot()
   {
   }

public:
/** Function to import SpotWeld details for *CONSTRAINED_GENERALIZED_WELD_SPOT
  * keyword from file */
   void readSpotWeld()
   {
      const char *fields[] = {"TFAIL","EPSF","SN","SS","N","M",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 6;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("SpotWeld");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONSTRAINED_GENERALIZED_WELD_SPOT
  * from LSDYNA native file */
   unsigned int importConstGenWeldSpot()
   {
      importConstGenWeld();
      readSpotWeld();
      return 0;
   }
};

#endif

