#ifndef _ConstSpotWeldFilter_h_
#define _ConstSpotWeldFilter_h_

#include "manager.h"
#include "dispexport.h"
#include "constspotweld.h"

/** This class is used for importing *CONSTRAINED_SPOTWELD_FILTERED_FORCE keyword
  * from LSDYNA native file */

class ConstSpotWeldFilter : public ConstSpotWeld
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ConstSpotWeldFilter(DataLine *data_line, ImportObject *imp_obj) : ConstSpotWeld (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ConstSpotWeldFilter()
   {
   }

public:
/** Function to import Filter details for *CONSTRAINED_SPOTWELD_FILTERED_FORCE
  * keyword from file */
   void readFilter()
   {
      const char *fields[] = {"NF","TW",};
      unsigned int field_types[] = {DATA_INT, DATA_DOUBLE, };
      numFields = 2;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Filter");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONSTRAINED_SPOTWELD_FILTERED_FORCE
  * from LSDYNA native file */
   unsigned int importConstSpotWeldFilter()
   {
      importConstSpotWeld();
      readFilter();
      return 0;
   }
};

#endif

