#include "constbuttweld.hpp"
#include "constgenweldbutt.hpp"
#include "constgenweldcombined.hpp"
#include "constgenweldcrossfillet.hpp"
#include "constgenweldfillet.hpp"
#include "constgenweldspot.hpp"
#include "constrivet.hpp"
#include "constspotweld.hpp"
#include "constspotweldfilter.hpp"
#include "typemap.h"
#include "constimport.h"

void ConstImport::initWeldTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_BUTT_WELD, importConstButtWeld) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_GENERALIZED_WELD_BUTT, importConstGenWeldButt) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_GENERALIZED_WELD_BUTT_ID, importConstGenWeldButt) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_GENERALIZED_WELD_COMBINED, importConstGenWeldCombined) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_GENERALIZED_WELD_COMBINED_ID, importConstGenWeldCombined) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_GENERALIZED_WELD_CROSS_FILLET, importConstGenWeldCrossFillet) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_GENERALIZED_WELD_CROSS_FILLET_ID, importConstGenWeldCrossFillet) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_GENERALIZED_WELD_FILLET, importConstGenWeldFillet) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_GENERALIZED_WELD_FILLET_ID, importConstGenWeldFillet) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_GENERALIZED_WELD_SPOT, importConstGenWeldSpot) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_GENERALIZED_WELD_SPOT_ID, importConstGenWeldSpot) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_RIVET, importConstRivet) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_RIVET_ID, importConstRivet) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_SPOTWELD, importConstSpotWeld) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_SPOTWELD_ID, importConstSpotWeld) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_SPOTWELD_ID_FILTERED_FORCE, importConstSpotWeldFilter) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_SPOTWELD_FILTERED_FORCE, importConstSpotWeldFilter) );
   typeFuncMap.insert( typeFuncPair(CONSTRAINED_SPOTWELD_FILTERED_FORCE_ID, importConstSpotWeldFilter) );
}
