#ifndef _Card4DrawbeadInit_h_
#define _Card4DrawbeadInit_h_

#include "manager.h"
#include "dispexport.h"
#include "card4drawbead.h"

/** This class is used for importing *CONTACT_DRAWBEAD_INITIALIZE keyword
  * from LSDYNA native file */

class Card4DrawbeadInit : public Card4Drawbead
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   Card4DrawbeadInit(DataLine *data_line, ImportObject *imp_obj) : Card4Drawbead (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~Card4DrawbeadInit()
   {
   }

public:
/** Function to import PlasticStrain details for *CONTACT_DRAWBEAD_INITIALIZE
  * keyword from file */
   void readPlasticStrain()
   {
      const char *fields[] = {"LCEPS","TSCALE","LCEPS2","OFFSET",};
      unsigned int field_types[] = {DATA_INT, DATA_DOUBLE, DATA_INT, DATA_DOUBLE, };
      unsigned int field_indices[] = {0, 2, };
      unsigned int man_types[] = {DEFINE, DEFINE, };
      unsigned int kw_types[] = {CURVE, CURVE, };
      unsigned int num_indices = 2;
      numFields = 4;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("PlasticStrain");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONTACT_DRAWBEAD_INITIALIZE
  * from LSDYNA native file */
   unsigned int importCard4DrawbeadInit()
   {
      importCard4Drawbead();
      readPlasticStrain();
      return 0;
   }
};

#endif

