#include "contact_1d.hpp"
#include "contactautomove.hpp"
#include "contactcoupling.hpp"
#include "contactentity.hpp"
#include "contactgebod.hpp"
#include "contactguidedcable.hpp"
#include "contactinterior.hpp"
#include "contactrigidsurface.hpp"
#include "typemap.h"
#include "contactimport.h"

void ContactImport::initSimpleTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(CONTACT_1D, importContact_1D) );
   typeFuncMap.insert( typeFuncPair(CONTACT_AUTO_MOVE, importContactAutoMove) );
   typeFuncMap.insert( typeFuncPair(CONTACT_COUPLING, importContactCoupling) );
   typeFuncMap.insert( typeFuncPair(CONTACT_ENTITY, importContactEntity) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_HEAD, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_LEFT_FOOT, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_LEFT_HAND, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_LEFT_LOWER_ARM, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_LEFT_LOWER_LEG, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_LEFT_SHOULDER, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_LEFT_UPPER_ARM, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_LEFT_UPPER_LEG, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_LOWER_TORSO, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_MIDDLE_TORSO, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_NECK, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_RIGHT_FOOT, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_RIGHT_HAND, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_RIGHT_LOWER_ARM, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_RIGHT_LOWER_LEG, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_RIGHT_SHOULDER, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_RIGHT_UPPER_ARM, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_RIGHT_UPPER_LEG, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GEBOD_UPPER_TORSO, importContactGebod) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GUIDED_CABLE, importContactGuidedCable) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GUIDED_CABLE_ID, importContactGuidedCable) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GUIDED_CABLE_SET, importContactGuidedCable) );
   typeFuncMap.insert( typeFuncPair(CONTACT_GUIDED_CABLE_SET_ID, importContactGuidedCable) );
   typeFuncMap.insert( typeFuncPair(CONTACT_INTERIOR, importContactInterior) );
   typeFuncMap.insert( typeFuncPair(CONTACT_RIGID_SURFACE, importContactRigidSurface) );
}
