#include "controlaccuracy.hpp"
#include "controladapstep.hpp"
#include "controladaptive.hpp"
#include "controladaptivecurve.hpp"
#include "controlale.hpp"
#include "controlcoarsen.hpp"
#include "controldynamicrelaxation.hpp"
#include "nocards.hpp"
#include "typemap.h"
#include "controlimport.h"

void ControlImport::initAdaptTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(CONTROL_ACCURACY, importControlAccuracy) );
   typeFuncMap.insert( typeFuncPair(CONTROL_ADAPSTEP, importControlAdapstep) );
   typeFuncMap.insert( typeFuncPair(CONTROL_ADAPTIVE, importControlAdaptive) );
   typeFuncMap.insert( typeFuncPair(CONTROL_ADAPTIVE_CURVE, importControlAdaptiveCurve) );
   typeFuncMap.insert( typeFuncPair(CONTROL_ALE, importControlAle) );
   typeFuncMap.insert( typeFuncPair(CONTROL_COARSEN, importControlCoarsen) );
   typeFuncMap.insert( typeFuncPair(CONTROL_DYNAMIC_RELAXATION, importControlDynamicRelaxation) );
   typeFuncMap.insert( typeFuncPair(CONTROL_EXPLOSIVE_SHADOW, importNoCards) );
}
