#ifndef _ControlAdapstep_h_
#define _ControlAdapstep_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *CONTROL_ADAPSTEP keyword
  * from LSDYNA native file */

class ControlAdapstep : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ControlAdapstep(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ControlAdapstep()
   {
   }

public:
/** Function to import Card1 details for *CONTROL_ADAPSTEP
  * keyword from file */
   void readCard1()
   {
      const char *fields[] = {"FACTIN","DFACTR",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 2;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONTROL_ADAPSTEP
  * from LSDYNA native file */
   unsigned int importControlAdapstep()
   {
      readCard1();
      return 0;
   }
};

#endif

