#ifndef _ControlStagedConstruction_h_
#define _ControlStagedConstruction_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *CONTROL_STAGED_CONSTRUCTION keyword
  * from LSDYNA native file */

class ControlStagedConstruction : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ControlStagedConstruction(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ControlStagedConstruction()
   {
   }

public:
/** Function to import Card details for *CONTROL_STAGED_CONSTRUCTION
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"TSTART","STGS","STGE","ACCEL","FACT","STREF",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_INT, DATA_INT, DATA_DOUBLE, DATA_DOUBLE, DATA_INT, };
      numFields = 6;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONTROL_STAGED_CONSTRUCTION
  * from LSDYNA native file */
   unsigned int importControlStagedConstruction()
   {
      readCard();
      return 0;
   }
};

#endif

