#include "controlremeshing.hpp"
#include "controlrigid.hpp"
#include "controlshell.hpp"
#include "controlsolid.hpp"
#include "controlsolution.hpp"
#include "controlsph.hpp"
#include "controlspotweldbeam.hpp"
#include "controlstagedconstruction.hpp"
#include "nocards.hpp"
#include "typemap.h"
#include "controlimport.h"

void ControlImport::initElementTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(CONTROL_REMESHING, importControlRemeshing) );
   typeFuncMap.insert( typeFuncPair(CONTROL_RIGID, importControlRigid) );
   typeFuncMap.insert( typeFuncPair(CONTROL_SHELL, importControlShell) );
   typeFuncMap.insert( typeFuncPair(CONTROL_SOLID, importControlSolid) );
   typeFuncMap.insert( typeFuncPair(CONTROL_SOLUTION, importControlSolution) );
   typeFuncMap.insert( typeFuncPair(CONTROL_SPH, importControlSph) );
   typeFuncMap.insert( typeFuncPair(CONTROL_SPOTWELD_BEAM, importControlSpotweldBeam) );
   typeFuncMap.insert( typeFuncPair(CONTROL_STAGED_CONSTRUCTION, importControlStagedConstruction) );
   typeFuncMap.insert( typeFuncPair(CONTROL_STRUCTURED, importNoCards) );
   typeFuncMap.insert( typeFuncPair(CONTROL_STRUCTURED_TERM, importNoCards) );
}
