#include "controlcpu.hpp"
#include "controlformingposition.hpp"
#include "controlformingprojection.hpp"
#include "controlformingtemplate.hpp"
#include "controlformingtravel.hpp"
#include "controlforminguser.hpp"
#include "controloutput.hpp"
#include "controlparallel.hpp"
#include "nocards.hpp"
#include "typemap.h"
#include "controlimport.h"

void ControlImport::initFormingTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(CONTROL_CPU, importControlCpu) );
   typeFuncMap.insert( typeFuncPair(CONTROL_FORMING_POSITION, importControlFormingPosition) );
   typeFuncMap.insert( typeFuncPair(CONTROL_FORMING_PROJECTION, importControlFormingProjection) );
   typeFuncMap.insert( typeFuncPair(CONTROL_FORMING_TEMPLATE, importControlFormingTemplate) );
   typeFuncMap.insert( typeFuncPair(CONTROL_FORMING_TRAVEL, importControlFormingTravel) );
   typeFuncMap.insert( typeFuncPair(CONTROL_FORMING_USER, importControlFormingUser) );
   typeFuncMap.insert( typeFuncPair(CONTROL_OUTPUT, importControlOutput) );
   typeFuncMap.insert( typeFuncPair(CONTROL_PARALLEL, importControlParallel) );
   typeFuncMap.insert( typeFuncPair(CONTROL_SUBCYCLE, importNoCards) );
}
