#ifndef _ControlImplicitTermination_h_
#define _ControlImplicitTermination_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *CONTROL_IMPLICIT_TERMINATION keyword
  * from LSDYNA native file */

class ControlImplicitTermination : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ControlImplicitTermination(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ControlImplicitTermination()
   {
   }

public:
/** Function to import Card details for *CONTROL_IMPLICIT_TERMINATION
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"DELTAU",};
      unsigned int field_types[] = {DATA_DOUBLE, };
      numFields = 1;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONTROL_IMPLICIT_TERMINATION
  * from LSDYNA native file */
   unsigned int importControlImplicitTermination()
   {
      readCard();
      return 0;
   }
};

#endif

