#include "controlimplicitauto.hpp"
#include "controlimplicitbuckle.hpp"
#include "controlimplicitdynamics.hpp"
#include "controlimplicitinertiarelief.hpp"
#include "controlimplicitjoints.hpp"
#include "controlimplicitmodes.hpp"
#include "controlimplicitsolver.hpp"
#include "controlimplicitstabilization.hpp"
#include "controlimplicittermination.hpp"
#include "typemap.h"
#include "controlimport.h"

void ControlImport::initImplicitTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(CONTROL_IMPLICIT_AUTO, importControlImplicitAuto) );
   typeFuncMap.insert( typeFuncPair(CONTROL_IMPLICIT_BUCKLE, importControlImplicitBuckle) );
   typeFuncMap.insert( typeFuncPair(CONTROL_IMPLICIT_DYNAMICS, importControlImplicitDynamics) );
   typeFuncMap.insert( typeFuncPair(CONTROL_IMPLICIT_INERTIA_RELIEF, importControlImplicitInertiaRelief) );
   typeFuncMap.insert( typeFuncPair(CONTROL_IMPLICIT_JOINTS, importControlImplicitJoints) );
   typeFuncMap.insert( typeFuncPair(CONTROL_IMPLICIT_MODES, importControlImplicitModes) );
   typeFuncMap.insert( typeFuncPair(CONTROL_IMPLICIT_SOLVER, importControlImplicitSolver) );
   typeFuncMap.insert( typeFuncPair(CONTROL_IMPLICIT_STABILIZATION, importControlImplicitStabilization) );
   typeFuncMap.insert( typeFuncPair(CONTROL_IMPLICIT_TERMINATION, importControlImplicitTermination) );
}
