#ifndef _ControlMppDecompositionContactIsolate_h_
#define _ControlMppDecompositionContactIsolate_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *CONTROL_MPP_DECOMPOSITION_CONTACT_ISOLATE keyword
  * from LSDYNA native file */

class ControlMppDecompositionContactIsolate : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ControlMppDecompositionContactIsolate(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ControlMppDecompositionContactIsolate()
   {
   }

public:
/** Function to import Card details for *CONTROL_MPP_DECOMPOSITION_CONTACT_ISOLATE
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"ID1","ID2","ID3","ID4","ID5",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, };
      unsigned int field_indices[] = {0, 1, 2, 3, 4, };
      unsigned int man_types[] = {CONTACT, CONTACT, CONTACT, CONTACT, CONTACT, };
      unsigned int kw_types[] = {9999, 9999, 9999, 9999, 9999, };
      unsigned int num_indices = 5;
      numFields = 5;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONTROL_MPP_DECOMPOSITION_CONTACT_ISOLATE
  * from LSDYNA native file */
   unsigned int importControlMppDecompositionContactIsolate()
   {
      readCard();
      return 0;
   }
};

#endif

