#ifndef _ControlMppDecompositionFile_h_
#define _ControlMppDecompositionFile_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *CONTROL_MPP_DECOMPOSITION_FILE keyword
  * from LSDYNA native file */

class ControlMppDecompositionFile : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ControlMppDecompositionFile(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ControlMppDecompositionFile()
   {
   }

public:
/** Function to import Card details for *CONTROL_MPP_DECOMPOSITION_FILE
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"Name",};
      unsigned int field_types[] = {DATA_CHAR_ARRAY, };
      numFields = 1;
      unsigned int field_widths[] = {80, };
      strBuff = dataLine->readNextCard(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, field_widths, fields, strBuff);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONTROL_MPP_DECOMPOSITION_FILE
  * from LSDYNA native file */
   unsigned int importControlMppDecompositionFile()
   {
      readCard();
      return 0;
   }
};

#endif

