#include "nocards.hpp"
#include "controlmppdecompositioncontactdistribute.hpp"
#include "controlmppdecompositioncontactisolate.hpp"
#include "controlmppdecompositionfile.hpp"
#include "controlmppdecompositionmethod.hpp"
#include "controlmppdecompositionnumproc.hpp"
#include "controlmppdecompositiontransformation.hpp"
#include "controlnonlocal.hpp"
#include "typemap.h"
#include "controlimport.h"

void ControlImport::initMppTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(CONTROL_MPP_DECOMPOSITION_AUTOMATIC, importNoCards) );
   typeFuncMap.insert( typeFuncPair(CONTROL_MPP_DECOMPOSITION_CHECK_SPEED, importNoCards) );
   typeFuncMap.insert( typeFuncPair(CONTROL_MPP_DECOMPOSITION_CONTACT_DISTRIBUTE, importControlMppDecompositionContactDistribute) );
   typeFuncMap.insert( typeFuncPair(CONTROL_MPP_DECOMPOSITION_CONTACT_ISOLATE, importControlMppDecompositionContactIsolate) );
   typeFuncMap.insert( typeFuncPair(CONTROL_MPP_DECOMPOSITION_FILE, importControlMppDecompositionFile) );
   typeFuncMap.insert( typeFuncPair(CONTROL_MPP_DECOMPOSITION_METHOD, importControlMppDecompositionMethod) );
   typeFuncMap.insert( typeFuncPair(CONTROL_MPP_DECOMPOSITION_NUMPROC, importControlMppDecompositionNumproc) );
   typeFuncMap.insert( typeFuncPair(CONTROL_MPP_DECOMPOSITION_SHOW, importNoCards) );
   typeFuncMap.insert( typeFuncPair(CONTROL_MPP_DECOMPOSITION_TRANSFORMATION, importControlMppDecompositionTransformation) );
   typeFuncMap.insert( typeFuncPair(CONTROL_MPP_IO_NOD3DUMP, importNoCards) );
   typeFuncMap.insert( typeFuncPair(CONTROL_MPP_IO_NODUMP, importNoCards) );
   typeFuncMap.insert( typeFuncPair(CONTROL_MPP_IO_NOFULL, importNoCards) );
   typeFuncMap.insert( typeFuncPair(CONTROL_MPP_IO_SWAPBYTES, importNoCards) );
   typeFuncMap.insert( typeFuncPair(CONTROL_NONLOCAL, importControlNonlocal) );
}
