#include "controlbulkviscosity.hpp"
#include "nocards.hpp"
#include "controlcheckshell.hpp"
#include "controlcontact.hpp"
#include "controlcoupling.hpp"
#include "controlefg.hpp"
#include "controlenergy.hpp"
#include "controlhourglass.hpp"
#include "typemap.h"
#include "controlimport.h"

void ControlImport::initSimpleTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(CONTROL_BULK_VISCOSITY, importControlBulkViscosity) );
   typeFuncMap.insert( typeFuncPair(CONTROL_CHECK, importNoCards) );
   typeFuncMap.insert( typeFuncPair(CONTROL_CHECK_SHELL, importControlCheckShell) );
   typeFuncMap.insert( typeFuncPair(CONTROL_CONTACT, importControlContact) );
   typeFuncMap.insert( typeFuncPair(CONTROL_COUPLING, importControlCoupling) );
   typeFuncMap.insert( typeFuncPair(CONTROL_EFG, importControlEfg) );
   typeFuncMap.insert( typeFuncPair(CONTROL_ENERGY, importControlEnergy) );
   typeFuncMap.insert( typeFuncPair(CONTROL_HOURGLASS, importControlHourglass) );
   typeFuncMap.insert( typeFuncPair(CONTROL_HOURGLASS_936, importControlHourglass) );
}
