#ifndef _ControlImplicitGeneral_h_
#define _ControlImplicitGeneral_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *CONTROL_IMPLICIT_GENERAL keyword
  * from LSDYNA native file */

class ControlImplicitGeneral : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ControlImplicitGeneral(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ControlImplicitGeneral()
   {
   }

public:
/** Function to import Card details for *CONTROL_IMPLICIT_GENERAL
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"IMFLAG","DT0","IMFORM","NSBS","IGS","CNSTN","FORM","ZERO_V",};
      unsigned int field_types[] = {DATA_INT, DATA_DOUBLE, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, };
      numFields = 8;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         controlGeneralFind(wordArray, numFields, 0, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONTROL_IMPLICIT_GENERAL
  * from LSDYNA native file */
   unsigned int importControlImplicitGeneral()
   {
      readCard();
      return 0;
   }
};

#endif

