#ifndef _ControlTermination_h_
#define _ControlTermination_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *CONTROL_TERMINATION keyword
  * from LSDYNA native file */

class ControlTermination : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ControlTermination(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ControlTermination()
   {
   }

public:
/** Function to import Card details for *CONTROL_TERMINATION
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"ENDTIM","ENDCYC","DTMIN","ENDENG","ENDMAS",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_INT, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 5;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *CONTROL_TERMINATION
  * from LSDYNA native file */
   unsigned int importControlTermination()
   {
      readCard();
      return 0;
   }
};

#endif

