#include "controlimpliciteigenvalue.hpp"
#include "controlimplicitgeneral.hpp"
#include "controlimplicitsolution.hpp"
#include "controltermination.hpp"
#include "controlthermalnonlinear.hpp"
#include "controlthermalsolver.hpp"
#include "controlthermaltimestep.hpp"
#include "controltimestep.hpp"
#include "typemap.h"
#include "controlimport.h"

void ControlImport::initThermalTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(CONTROL_IMPLICIT_EIGENVALUE, importControlImplicitEigenvalue) );
   typeFuncMap.insert( typeFuncPair(CONTROL_IMPLICIT_GENERAL, importControlImplicitGeneral) );
   typeFuncMap.insert( typeFuncPair(CONTROL_IMPLICIT_SOLUTION, importControlImplicitSolution) );
   typeFuncMap.insert( typeFuncPair(CONTROL_TERMINATION, importControlTermination) );
   typeFuncMap.insert( typeFuncPair(CONTROL_THERMAL_NONLINEAR, importControlThermalNonlinear) );
   typeFuncMap.insert( typeFuncPair(CONTROL_THERMAL_SOLVER, importControlThermalSolver) );
   typeFuncMap.insert( typeFuncPair(CONTROL_THERMAL_TIMESTEP, importControlThermalTimestep) );
   typeFuncMap.insert( typeFuncPair(CONTROL_TIMESTEP, importControlTimestep) );
}
