#ifndef _DampingFrequencyRange_h_
#define _DampingFrequencyRange_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *DAMPING_FREQUENCY_RANGE keyword
  * from LSDYNA native file */

class DampingFrequencyRange : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   DampingFrequencyRange(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~DampingFrequencyRange()
   {
   }

public:
/** Function to import Card details for *DAMPING_FREQUENCY_RANGE
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"CDAMP","FLOW","FHIGH","PSID",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_INT, };
      unsigned int field_indices[] = {3, };
      unsigned int man_types[] = {SET, };
      unsigned int kw_types[] = {PARTC, };
      unsigned int num_indices = 1;
      numFields = 4;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *DAMPING_FREQUENCY_RANGE
  * from LSDYNA native file */
   unsigned int importDampingFrequencyRange()
   {
      readCard();
      return 0;
   }
};

#endif

