#ifndef _DatabaseBinaryD3plot_h_
#define _DatabaseBinaryD3plot_h_

#include "manager.h"
#include "dispexport.h"
#include "databasebinary.h"

/** This class is used for importing *DATABASE_BINARY_D3PLOT keyword
  * from LSDYNA native file */

class DatabaseBinaryD3plot : public DatabaseBinary
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   DatabaseBinaryD3plot(DataLine *data_line, ImportObject *imp_obj) : DatabaseBinary (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~DatabaseBinaryD3plot()
   {
   }

public:
/** Function to import D3plotCard details for *DATABASE_BINARY_D3PLOT
  * keyword from file */
   void readD3plotCard()
   {
      const char *fields[] = {"IOOPT",};
      unsigned int field_types[] = {DATA_INT, };
      numFields = 1;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("D3plotCard");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *DATABASE_BINARY_D3PLOT
  * from LSDYNA native file */
   unsigned int importDatabaseBinaryD3plot()
   {
      importDatabaseBinary();
      readD3plotCard();
      return 0;
   }
};

#endif

