#ifndef _DatabaseBinaryD3prop_h_
#define _DatabaseBinaryD3prop_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *DATABASE_BINARY_D3PROP keyword
  * from LSDYNA native file */

class DatabaseBinaryD3prop : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   DatabaseBinaryD3prop(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~DatabaseBinaryD3prop()
   {
   }

public:
/** Function to import Card details for *DATABASE_BINARY_D3PROP
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"IFILE","IMATL","IWALL",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, };
      numFields = 3;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *DATABASE_BINARY_D3PROP
  * from LSDYNA native file */
   unsigned int importDatabaseBinaryD3prop()
   {
      readCard();
      return 0;
   }
};

#endif

