#ifndef _DatabaseHistoryNode_h_
#define _DatabaseHistoryNode_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *DATABASE_HISTORY_NODE keyword
  * from LSDYNA native file */

class DatabaseHistoryNode : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   DatabaseHistoryNode(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~DatabaseHistoryNode()
   {
   }

public:
/** Function to import Card details for *DATABASE_HISTORY_NODE
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"ID1","ID2","ID3","ID4","ID5","ID6","ID7","ID8",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, };
      numFields = 8;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         databaseHistoryFind(wordArray, numFields, 0, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *DATABASE_HISTORY_NODE
  * from LSDYNA native file */
   unsigned int importDatabaseHistoryNode()
   {
      readCard();
      while(numFields)
      {
         readCard();
      }
      return 0;
   }
};

#endif

