#ifndef _DatabaseHistoryNodeId_h_
#define _DatabaseHistoryNodeId_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *DATABASE_HISTORY_NODE_ID keyword
  * from LSDYNA native file */

class DatabaseHistoryNodeId : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   DatabaseHistoryNodeId(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~DatabaseHistoryNodeId()
   {
   }

public:
/** Function to import Card details for *DATABASE_HISTORY_NODE_ID
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"ID","HEADING",};
      unsigned int field_types[] = {DATA_INT, DATA_CHAR_ARRAY, };
      numFields = 2;
      unsigned int field_widths[] = {10, 70, };
      strBuff = dataLine->readNextCard(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         databaseHistoryIDFind(wordArray, numFields, 0, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, field_widths, fields, strBuff);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *DATABASE_HISTORY_NODE_ID
  * from LSDYNA native file */
   unsigned int importDatabaseHistoryNodeId()
   {
      readCard();
      while(numFields)
      {
         readCard();
      }
      return 0;
   }
};

#endif

