#ifndef _DatabaseHistoryNodeLocal_h_
#define _DatabaseHistoryNodeLocal_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *DATABASE_HISTORY_NODE_LOCAL keyword
  * from LSDYNA native file */

class DatabaseHistoryNodeLocal : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   DatabaseHistoryNodeLocal(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~DatabaseHistoryNodeLocal()
   {
   }

public:
/** Function to import Card details for *DATABASE_HISTORY_NODE_LOCAL
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"ID","CID","REF","HFO",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, DATA_INT, };
      numFields = 4;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         databaseHistoryLocalFind(wordArray, numFields, 0, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *DATABASE_HISTORY_NODE_LOCAL
  * from LSDYNA native file */
   unsigned int importDatabaseHistoryNodeLocal()
   {
      readCard();
      return 0;
   }
};

#endif

