#include "databasehistorynode.hpp"
#include "databasehistorynodeid.hpp"
#include "databasehistorynodelocal.hpp"
#include "databasehistorynodelocalid.hpp"
#include "typemap.h"
#include "databaseimport.h"

void DatabaseImport::initHistryTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_BEAM, importDatabaseHistoryNode) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_BEAM_ID, importDatabaseHistoryNodeId) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_BEAM_SET, importDatabaseHistoryNode) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_DISCRETE, importDatabaseHistoryNode) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_DISCRETE_ID, importDatabaseHistoryNodeId) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_DISCRETE_SET, importDatabaseHistoryNode) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_NODE, importDatabaseHistoryNode) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_NODE_ID, importDatabaseHistoryNodeId) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_NODE_LOCAL, importDatabaseHistoryNodeLocal) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_NODE_LOCAL_ID, importDatabaseHistoryNodeLocalId) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_NODE_SET, importDatabaseHistoryNode) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_NODE_SET_LOCAL, importDatabaseHistoryNodeLocal) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_SEATBELT, importDatabaseHistoryNode) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_SEATBELT_ID, importDatabaseHistoryNodeId) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_SHELL, importDatabaseHistoryNode) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_SHELL_ID, importDatabaseHistoryNodeId) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_SHELL_SET, importDatabaseHistoryNode) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_SOLID, importDatabaseHistoryNode) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_SOLID_ID, importDatabaseHistoryNodeId) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_SOLID_SET, importDatabaseHistoryNode) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_SPH, importDatabaseHistoryNode) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_SPH_SET, importDatabaseHistoryNode) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_TSHELL, importDatabaseHistoryNode) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_TSHELL_ID, importDatabaseHistoryNodeId) );
   typeFuncMap.insert( typeFuncPair(DATABASE_HISTORY_TSHELL_SET, importDatabaseHistoryNode) );
}
