#ifndef _DatabaseAdams_h_
#define _DatabaseAdams_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *DATABASE_ADAMS keyword
  * from LSDYNA native file */

class DatabaseAdams : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   DatabaseAdams(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~DatabaseAdams()
   {
   }

public:
/** Function to import Card details for *DATABASE_ADAMS
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"IFLAG","M_UNITS","L_UNITS","T_UNITS",};
      unsigned int field_types[] = {DATA_INT, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 4;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *DATABASE_ADAMS
  * from LSDYNA native file */
   unsigned int importDatabaseAdams()
   {
      readCard();
      return 0;
   }
};

#endif

