#ifndef _DefineBoxDrawbead_h_
#define _DefineBoxDrawbead_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *DEFINE_BOX_DRAWBEAD keyword
  * from LSDYNA native file */

class DefineBoxDrawbead : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   DefineBoxDrawbead(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~DefineBoxDrawbead()
   {
   }

public:
/** Function to import Card details for *DEFINE_BOX_DRAWBEAD
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"BOXID","PID","SID","IDIR","STYPE","RADIUS","CID",};
      unsigned int field_types[] = {DATA_INT, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_INT, DATA_DOUBLE, DATA_INT, };
      numFields = 7;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_IDS) )
         addIDToFile(wordArray, 0, DEFINE, impObj);

      if( Card::isFlagOn(SAVE_REFERENCES) )
         defineDrawbeadFind(wordArray, numFields, 1, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *DEFINE_BOX_DRAWBEAD
  * from LSDYNA native file */
   unsigned int importDefineBoxDrawbead()
   {
      readCard();
      return 0;
   }
};

#endif

