#ifndef _DefineCurveCompensation_h_
#define _DefineCurveCompensation_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *DEFINE_CURVE_COMPENSATION keyword
  * from LSDYNA native file */

class DefineCurveCompensation : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   DefineCurveCompensation(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~DefineCurveCompensation()
   {
   }

public:
/** Function to import Card1 details for *DEFINE_CURVE_COMPENSATION
  * keyword from file */
   void readCard1()
   {
      const char *fields[] = {"INOUT",};
      unsigned int field_types[] = {DATA_INT, };
      numFields = 1;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import Card2 details for *DEFINE_CURVE_COMPENSATION
  * keyword from file */
   void readCard2()
   {
      const char *fields[] = {"X","Y","Z",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 3;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card2");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *DEFINE_CURVE_COMPENSATION
  * from LSDYNA native file */
   unsigned int importDefineCurveCompensation()
   {
      readCard1();
      readCard2();
      return 0;
   }
};

#endif

