#ifndef _DefineCurveDrawbead_h_
#define _DefineCurveDrawbead_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *DEFINE_CURVE_DRAWBEAD keyword
  * from LSDYNA native file */

class DefineCurveDrawbead : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   DefineCurveDrawbead(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~DefineCurveDrawbead()
   {
   }

public:
/** Function to import Card details for *DEFINE_CURVE_DRAWBEAD
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"CID","TCTYPE","VID","PID","BLKID","PERCT",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, };
      unsigned int field_indices[] = {2, 3, };
      unsigned int man_types[] = {DEFINE, PARTC, };
      unsigned int kw_types[] = {VECTOR, 9999, };
      unsigned int num_indices = 2;
      numFields = 6;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *DEFINE_CURVE_DRAWBEAD
  * from LSDYNA native file */
   unsigned int importDefineCurveDrawbead()
   {
      readCard();
      return 0;
   }
};

#endif

