#ifndef _DefineSetAdaptive_h_
#define _DefineSetAdaptive_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *DEFINE_SET_ADAPTIVE keyword
  * from LSDYNA native file */

class DefineSetAdaptive : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   DefineSetAdaptive(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~DefineSetAdaptive()
   {
   }

public:
/** Function to import Card1 details for *DEFINE_SET_ADAPTIVE
  * keyword from file */
   void readCard1()
   {
      const char *fields[] = {"SETID","STYPE","ADPLVL","ADPSIZE",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, DATA_DOUBLE, };
      numFields = 4;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         defineAdaptiveFind(wordArray, numFields, 0, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *DEFINE_SET_ADAPTIVE
  * from LSDYNA native file */
   unsigned int importDefineSetAdaptive()
   {
      readCard1();
      return 0;
   }
};

#endif

