#ifndef _DefineHexSpotweldAssemblyN_h_
#define _DefineHexSpotweldAssemblyN_h_

#include "manager.h"
#include "dispexport.h"
#include "definehexspotweldassembly.h"

/** This class is used for importing *DEFINE_HEX_SPOTWELD_ASSEMBLY_N keyword
  * from LSDYNA native file */

class DefineHexSpotweldAssemblyN : public DefineHexSpotweldAssembly
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   DefineHexSpotweldAssemblyN(DataLine *data_line, ImportObject *imp_obj) : DefineHexSpotweldAssembly (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~DefineHexSpotweldAssemblyN()
   {
   }

public:
/** Function to import Card3 details for *DEFINE_HEX_SPOTWELD_ASSEMBLY_N
  * keyword from file */
   void readCard3()
   {
      const char *fields[] = {"EID9","EID10","EID11","EID12","EID13","EID14","EID15","EID16",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, };
      unsigned int field_indices[] = {0, 1, 2, 3, 4, 5, 6, 7, };
      unsigned int man_types[] = {ELEMENT, ELEMENT, ELEMENT, ELEMENT, ELEMENT, ELEMENT, ELEMENT, ELEMENT, };
      unsigned int kw_types[] = {SOLID, SOLID, SOLID, SOLID, SOLID, SOLID, SOLID, SOLID, };
      unsigned int num_indices = 8;
      numFields = 8;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card3");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *DEFINE_HEX_SPOTWELD_ASSEMBLY_N
  * from LSDYNA native file */
   unsigned int importDefineHexSpotweldAssemblyN()
   {
      importDefineHexSpotweldAssembly();
      int num = 0;
      sscanf(impObj->getKeyword().data(), "*DEFINE_HEX_SPOTWELD_ASSEMBLY_%d", &num);
      if( num > 8 )
      {
         readCard3();
      }
      return 0;
   }
};

#endif

