#ifndef _DefineSpotweldRuptureStress_h_
#define _DefineSpotweldRuptureStress_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *DEFINE_SPOTWELD_RUPTURE_STRESS keyword
  * from LSDYNA native file */

class DefineSpotweldRuptureStress : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   DefineSpotweldRuptureStress(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~DefineSpotweldRuptureStress()
   {
   }

public:
/** Function to import Card details for *DEFINE_SPOTWELD_RUPTURE_STRESS
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"PID","SRSIG","SIGTAU","ALPHA",};
      unsigned int field_types[] = {DATA_INT, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      unsigned int field_indices[] = {0, };
      unsigned int man_types[] = {PARTC, };
      unsigned int kw_types[] = {9999, };
      unsigned int num_indices = 1;
      numFields = 4;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *DEFINE_SPOTWELD_RUPTURE_STRESS
  * from LSDYNA native file */
   unsigned int importDefineSpotweldRuptureStress()
   {
      readCard();
      while(numFields)
      {
         readCard();
      }
      return 0;
   }
};

#endif

