#ifndef _EfGrid_h_
#define _EfGrid_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *EF_GRID keyword
  * from LSDYNA native file */

class EfGrid : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   EfGrid(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~EfGrid()
   {
   }

public:
/** Function to import Card1 details for *EF_GRID
  * keyword from file */
   void readCard1()
   {
      const char *fields[] = {"NGX","NGY","NGZ",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, };
      numFields = 3;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *EF_GRID
  * from LSDYNA native file */
   unsigned int importEfGrid()
   {
      readCard1();
      return 0;
   }
};

#endif

