#ifndef _ElementSeatbeltPretensioner_h_
#define _ElementSeatbeltPretensioner_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *ELEMENT_SEATBELT_PRETENSIONER keyword
  * from LSDYNA native file */

class ElementSeatbeltPretensioner : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ElementSeatbeltPretensioner(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ElementSeatbeltPretensioner()
   {
   }

public:
/** Function to import Card1 details for *ELEMENT_SEATBELT_PRETENSIONER
  * keyword from file */
   void readCard1()
   {
      const char *fields[] = {"SBPRID","SBPRTY","SBSID1","SBSID2","SBSID3","SBSID4",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, };
      unsigned int field_indices[] = {2, 3, 4, 5, };
      unsigned int man_types[] = {ELEMENT, ELEMENT, ELEMENT, ELEMENT, };
      unsigned int kw_types[] = {SBSENSOR, SBSENSOR, SBSENSOR, SBSENSOR, };
      unsigned int num_indices = 4;
      numFields = 6;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_IDS) )
         addIDToFile(wordArray, 0, ELEMENT, impObj);

      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import Card2 details for *ELEMENT_SEATBELT_PRETENSIONER
  * keyword from file */
   void readCard2()
   {
      const char *fields[] = {"SBRID","TIME","PTLCID","LMTFRC",};
      unsigned int field_types[] = {DATA_INT, DATA_DOUBLE, DATA_INT, DATA_DOUBLE, };
      numFields = 4;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         sbPretenFind(wordArray, numFields, 0, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card2");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *ELEMENT_SEATBELT_PRETENSIONER
  * from LSDYNA native file */
   unsigned int importElementSeatbeltPretensioner()
   {
      readCard1();
      readCard2();
      return 0;
   }
};

#endif

