#ifndef _ElementSeatbeltSlipring_h_
#define _ElementSeatbeltSlipring_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *ELEMENT_SEATBELT_SLIPRING keyword
  * from LSDYNA native file */

class ElementSeatbeltSlipring : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ElementSeatbeltSlipring(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ElementSeatbeltSlipring()
   {
   }

public:
/** Function to import Card1 details for *ELEMENT_SEATBELT_SLIPRING
  * keyword from file */
   void readCard1()
   {
      const char *fields[] = {"SBSRID","SBID1","SBID2","FC","SBRNID","LTIME","FCS",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, DATA_DOUBLE, DATA_INT, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 7;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_IDS) )
         addIDToFile(wordArray, 0, ELEMENT, impObj);

      if( Card::isFlagOn(SAVE_REFERENCES) )
         sbSlipringFind(wordArray, numFields, 4, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *ELEMENT_SEATBELT_SLIPRING
  * from LSDYNA native file */
   unsigned int importElementSeatbeltSlipring()
   {
      readCard1();
      return 0;
   }
};

#endif

