#ifndef _ElementShellDof_h_
#define _ElementShellDof_h_

#include "manager.h"
#include "dispexport.h"
#include "elementshell.h"

/** This class is used for importing *ELEMENT_SHELL_DOF keyword
  * from LSDYNA native file */

class ElementShellDof : public ElementShell
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ElementShellDof(DataLine *data_line, ImportObject *imp_obj) : ElementShell (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ElementShellDof()
   {
   }

public:
/** Function to import Card details for *ELEMENT_SHELL_DOF
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"UNUSED","UNUSED","NS1","NS2","NS3","NS4",};
      unsigned int field_types[] = {DATA_UNUSED, DATA_UNUSED, DATA_INT, DATA_INT, DATA_INT, DATA_INT, };
      unsigned int field_indices[] = {2, 3, 4, 5, };
      unsigned int man_types[] = {NOD, NOD, NOD, NOD, };
      unsigned int kw_types[] = {9999, 9999, 9999, 9999, };
      unsigned int num_indices = 4;
      numFields = 6;
      unsigned int field_widths[] = {8, 8, 8, 8, 8, 8, };
      strBuff = dataLine->readNextCard(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, field_widths, fields, strBuff);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *ELEMENT_SHELL_DOF
  * from LSDYNA native file */
   unsigned int importElementShellDof()
   {
      importElementShell();
      readCard();
      return 0;
   }
};

#endif

