#ifndef _ElementShellOffset_h_
#define _ElementShellOffset_h_

#include "manager.h"
#include "dispexport.h"
#include "elementshell.h"

/** This class is used for importing *ELEMENT_SHELL_OFFSET keyword
  * from LSDYNA native file */

class ElementShellOffset : public ElementShell
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ElementShellOffset(DataLine *data_line, ImportObject *imp_obj) : ElementShell (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ElementShellOffset()
   {
   }

public:
/** Function to import Card details for *ELEMENT_SHELL_OFFSET
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"OFFSET",};
      unsigned int field_types[] = {DATA_DOUBLE, };
      numFields = 1;
      unsigned int field_widths[] = {16, };
      strBuff = dataLine->readNextCard(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, field_widths, fields, strBuff);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *ELEMENT_SHELL_OFFSET
  * from LSDYNA native file */
   unsigned int importElementShellOffset()
   {
      importElementShell();
      readCard();
      return 0;
   }
};

#endif

