#ifndef _ElementShellSourceSink_h_
#define _ElementShellSourceSink_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *ELEMENT_SHELL_SOURCE_SINK keyword
  * from LSDYNA native file */

class ElementShellSourceSink : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ElementShellSourceSink(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ElementShellSourceSink()
   {
   }

public:
/** Function to import Card details for *ELEMENT_SHELL_SOURCE_SINK
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"NSSR","NSSK","PID",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, };
      unsigned int field_indices[] = {0, 1, 2, };
      unsigned int man_types[] = {SET, SET, PARTC, };
      unsigned int kw_types[] = {NOD, NOD, 9999, };
      unsigned int num_indices = 3;
      numFields = 3;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *ELEMENT_SHELL_SOURCE_SINK
  * from LSDYNA native file */
   unsigned int importElementShellSourceSink()
   {
      readCard();
      return 0;
   }
};

#endif

