#include "elementshell.hpp"
#include "elementshellthickness.hpp"
#include "elementshelldof.hpp"
#include "elementshelloffset.hpp"
#include "elementshellsourcesink.hpp"
#include "elementsolid.hpp"
#include "elementsoliddof.hpp"
#include "elementsolidortho.hpp"
#include "elementtshell.hpp"
#include "typemap.h"
#include "elementimport.h"

void ElementImport::initShellTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(ELEMENT_SHELL, importElementShell) );
   typeFuncMap.insert( typeFuncPair(ELEMENT_SHELL_BETA, importElementShellThickness) );
   typeFuncMap.insert( typeFuncPair(ELEMENT_SHELL_DOF, importElementShellDof) );
   typeFuncMap.insert( typeFuncPair(ELEMENT_SHELL_MCD, importElementShellThickness) );
   typeFuncMap.insert( typeFuncPair(ELEMENT_SHELL_OFFSET, importElementShellOffset) );
   typeFuncMap.insert( typeFuncPair(ELEMENT_SHELL_SOURCE_SINK, importElementShellSourceSink) );
   typeFuncMap.insert( typeFuncPair(ELEMENT_SHELL_THICKNESS, importElementShellThickness) );
   typeFuncMap.insert( typeFuncPair(ELEMENT_SOLID, importElementSolid) );
   typeFuncMap.insert( typeFuncPair(ELEMENT_SOLID_DOF, importElementSolidDof) );
   typeFuncMap.insert( typeFuncPair(ELEMENT_SOLID_ORTHO, importElementSolidOrtho) );
   typeFuncMap.insert( typeFuncPair(ELEMENT_TSHELL, importElementTshell) );
}
