#ifndef _ElementInertiaOffset_h_
#define _ElementInertiaOffset_h_

#include "manager.h"
#include "dispexport.h"
#include "elementinertia.h"

/** This class is used for importing *ELEMENT_INERTIA_OFFSET keyword
  * from LSDYNA native file */

class ElementInertiaOffset : public ElementInertia
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ElementInertiaOffset(DataLine *data_line, ImportObject *imp_obj) : ElementInertia (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ElementInertiaOffset()
   {
   }

public:
/** Function to import Card3 details for *ELEMENT_INERTIA_OFFSET
  * keyword from file */
   void readCard3()
   {
      const char *fields[] = {"X-OFF","Y-OFF","Z-OFF",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 3;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card3");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *ELEMENT_INERTIA_OFFSET
  * from LSDYNA native file */
   unsigned int importElementInertiaOffset()
   {
      importElementInertia();
      readCard3();
      return 0;
   }
};

#endif

