#include "eosgruneisen.hpp"
#include "eoslinearpolynomial.hpp"
#include "eoslinearpolynomialwithenergyleak.hpp"
#include "eosratioofpolynomials.hpp"
#include "eossacktuesday.hpp"
#include "typemap.h"
#include "eosimport.h"

void EosImport::initPolyTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(EOS_GRUNEISEN, importEosGruneisen) );
   typeFuncMap.insert( typeFuncPair(EOS_LINEAR_POLYNOMIAL, importEosLinearPolynomial) );
   typeFuncMap.insert( typeFuncPair(EOS_LINEAR_POLYNOMIAL_WITH_ENERGY_LEAK, importEosLinearPolynomialWithEnergyLeak) );
   typeFuncMap.insert( typeFuncPair(EOS_RATIO_OF_POLYNOMIALS, importEosRatioOfPolynomials) );
   typeFuncMap.insert( typeFuncPair(EOS_SACK_TUESDAY, importEosSackTuesday) );
}
