#ifndef _CONTACT_IMP_OBJ_H_
#define _CONTACT_IMP_OBJ_H_

#include "card.h"

/** Class to store the list of cards for *CONTACT keywords of LSDYNA. The data 
  * from LSDYNA native file or from the database is stored in this object in
  * the form of cards. In turn the card stores the field names and their values.
  * This object has one more member to store the type of *CONTACT keyword
  */
class ContactImportObject : public ImportObject
{
public:
   /** Constructor to create this object.
     * \param keyword Name of contact keyword
     * \param contact_type Type of *CONTACT as an enum
     * \param contact_bin_type An unsigned int to store the type of *CONTACT
     * by setting a bit for the given type of *CONTACT
     */
   ContactImportObject
   (
      char *keyword, 
      unsigned int & contact_type, 
      unsigned int & contact_bin_type
   ) : ImportObject(keyword, contact_type)
   {
      contactBinType = contact_bin_type;
   }

public:
   /** A flag to store the different contact types */
   unsigned int contactBinType;
};

#endif

