#include "generic.h"
#include "sectiontype.h"
#include "elementtype.h"
#include "definetype.h"
#include "sectionbeamtype.h"
#include "settype.h"
#include "termtype.h"
#include "mattype.h"
#include "bdrytype.h"
#include "databasetype.h"
#include "initialtype.h"
#include "consttype.h"
#include "interfacetype.h"
#include "loadtype.h"
#include "dispexport.h"
#include "mantypes.h"
#include "transform.h"
#include "filepath.h"

void addIDToFile
     (
        char         **field_list,
        unsigned int id_index,
        unsigned int man_type,
        ImportObject *imp_obj
     )
{
//cout << "CARD COUNT=" << imp_obj->cardCount << endl;
   //as this function is called from different cards of a particular keyword,
   //the IDs have to be saved only once. If called from first card, then second
   //card call should be ignored. suppose in airbag the id card calls this and
   //also the set card because the id card is optional
   //if( imp_obj->isFlagOn(IMPORT_DB) && imp_obj->cardCount )
   //   return;

   if( FilePath::idFileDes == -2 )
      return;

   char *id = field_list[id_index];
   const char *ent_name = "";

   Generic::RemoveLeadingAndTrailingBlanks(id);
   if( id[0] == '0' || id[0] == '\0' || iscntrl(id[0]) )
      return;

//   vector<unsigned int> *id_list = imp_obj->getIDList();
//   id_list->push_back(atoi(id));

   static unsigned int old_man = 999999;
   unsigned int id_offset = 0;

   if( !FilePath::idBufPtr || old_man != man_type )
   //if( old_man != man_type )
   {
      FilePath::closeIDFile();

      switch(man_type)
      {
	 case NOD:
	    ent_name = "node";
            id_offset = FilePath::transPtr ? FilePath::transPtr->idnoff : 0;
	    break;
	 case ELEMENT:
	    ent_name = "element";
            id_offset = FilePath::transPtr ? FilePath::transPtr->ideoff : 0;
	    break;
	 case DEFINE:
	    ent_name = "define";
            switch(imp_obj->getKeywordType())
            {
               case DEFINE_CURVE_FUNCTION:
               case DEFINE_TABLE:
                  id_offset=FilePath::transPtr ? FilePath::transPtr->idfoff : 0;
               break;
               default:
                  id_offset=FilePath::transPtr ? FilePath::transPtr->iddoff : 0;
               break;
            }
	    break;
	 case SECTION:
	    ent_name = "section";
            id_offset = FilePath::transPtr ? FilePath::transPtr->idroff : 0;
	    break;
	 case MAT:
	    ent_name = "mat";
            id_offset = FilePath::transPtr ? FilePath::transPtr->idmoff : 0;
	    break;
	 case EOS:
	    ent_name = "eos";
            id_offset = FilePath::transPtr ? FilePath::transPtr->idmoff : 0;
	    break;
	 case HG:
	    ent_name = "hourglass";
            id_offset = FilePath::transPtr ? FilePath::transPtr->idroff : 0;
	    break;
	 case PARTC:
	    ent_name = "part";
            id_offset = FilePath::transPtr ? FilePath::transPtr->idpoff : 0;
	    break;
	 case DAMPING:
	    ent_name = "damping";
	    break;
	 case COMP:
	    ent_name = "component";
	    break;
	 case EF:
	    ent_name = "ef";
	    break;
	 case PARAM:
	    ent_name = "parameter";
	    break;
	 case TERM:
	    ent_name = "termination";
	    break;
	 case DEFORM:
	    ent_name = "deformable";
	    break;
	 case SENSOR:
	    ent_name = "sensor";
	    break;
	 case INTERFACE:
	    ent_name = "interface";
	    break;
	 case INTEGRATION:
	    ent_name = "integration";
	    break;
	 case USER:
	    ent_name = "user";
	    break;
	 case CONTROL:
	    ent_name = "control";
	    break;
	 case AIRBAG:
	    ent_name = "airbag";
	    break;
	 case CONST:
	    ent_name = "constrained";
            switch(imp_obj->getKeywordType())
            {
	       case CONSTRAINED_NODE_SET_ID:
                  id_offset=FilePath::transPtr ? FilePath::transPtr->idpoff : 0;
               break;
            }
	    break;
	 case PERTURB:
	    ent_name = "perturbation";
	    break;
	 case SET:
	    ent_name = "set";
            id_offset = FilePath::transPtr ? FilePath::transPtr->idsoff : 0;
	    break;
	 case RIGIDWALL:
	    ent_name = "rigidwall";
	    break;
	 case CONTACT:
	    ent_name = "contact";
	    break;
	 case INC:
	    ent_name = "include";
	    break;
	 case DATABASE:
	    ent_name = "database";
	    break;
	 case INITIAL:
	    ent_name = "initial";
	    break;
	 case LOAD:
	    ent_name = "load";
	    break;
	 case BDRY:
	    ent_name = "boundary";
	    break;
	 case ALE:
	    ent_name = "ale";
	    break;
	 case RAIL:
	    ent_name = "rail";
	    break;
	 default:
	    cout << "MANAGER IS DIFFERENT\n";
      }

      char file_name[256];
      sprintf(file_name, "%s/%s.ids", FilePath::fPath, ent_name);
      FilePath::openIDFile(file_name);
   }

//cout << "ID=" << id << endl;

   switch(man_type)
   {
      case ELEMENT:
      {
         //here we are writing card_index, eid and pid
	 unsigned int ids[3] = {0, atoi(id), atoi(field_list[id_index+1])};
	 if( imp_obj->isFlagOn(IMPORT_DB) )
	    ids[0] = atoi(field_list[0]);
         if(FilePath::transPtr) 
         {
	    ids[1] += FilePath::transPtr->ideoff;
	    ids[2] += FilePath::transPtr->idpoff;
         }
         BufFileWrite(FilePath::idBufPtr, (char *)ids, sizeof(int) * 3);
      }
      break;
      default:
      {
         //here we are writing card_index, id, kw_type
	 unsigned int ids[3] = {0, atoi(id), 0};
	 if( imp_obj->isFlagOn(IMPORT_DB) )
	    ids[0] = atoi(field_list[0]);
         ids[1] += id_offset;
         ids[2] = imp_obj->getKeywordType();
//cout << "CIDX=" << ids[0] << " ID=" << ids[1] << " KWTYPE=" << ids[2] << endl;
         BufFileWrite(FilePath::idBufPtr, (char *)ids, sizeof(int) * 3);
      }
      break;
   }

   old_man = man_type;
}

void addIDToRefFile
     (
        char         **id_list,
        unsigned int & num_indices,
        unsigned int *field_indices,
        unsigned int *man_types,
        unsigned int *kw_types,
        ImportObject *imp_obj
     )
{
   unsigned int index = 0;//, flag = 0;
   //int sec_type = -1, mat_type = -1;
   char *id = NULL;
   vector<KWTypeIDPtr> *kw_type_id_list = imp_obj->getKWTypeIDList();
   KWTypeIDPtr kw_ptr;

   for(unsigned int i = 0; i < num_indices; i++)
   {
      index = field_indices[i];
      if( !id_list[index] )
         continue;

      id = id_list[index];

      Generic::RemoveLeadingAndTrailingBlanks(id);
      if( id[0] == '0' || id[0] == '\0' )
	 continue;

      if( id[0] == '-' )
         id++;

      if( !isdigit(id[0]) )
         continue;

//cout << "MAN=" << kw_ptr->kwShort << " KW=" << kw_ptr->kwType << " ID="
//     << kw_ptr->id << endl;
      
      kw_ptr = new KWTypeIDStr;
      kw_ptr->kwShort = man_types[i];
      kw_ptr->kwType = kw_types[i];
      kw_ptr->id = atoi(id);

      switch(man_types[i])
      {
	 case ELEMENT:
            kw_ptr->id += FilePath::transPtr ? FilePath::transPtr->ideoff : 0;
	    break;
	 case DEFINE:
            switch(imp_obj->getKeywordType())
            {
               case DEFINE_CURVE_FUNCTION:
               case DEFINE_TABLE:
               kw_ptr->id += FilePath::transPtr ? FilePath::transPtr->idfoff:0;
               break;
               default:
               kw_ptr->id += FilePath::transPtr ? FilePath::transPtr->iddoff:0;
               break;
            }
	    break;
	 case SECTION:
            kw_ptr->id += FilePath::transPtr ? FilePath::transPtr->idroff : 0;
            break;
	 case MAT:
            kw_ptr->id += FilePath::transPtr ? FilePath::transPtr->idmoff : 0;
            break;
	 case EOS:
            kw_ptr->id += FilePath::transPtr ? FilePath::transPtr->idmoff : 0;
	    break;
	 case HG:
            kw_ptr->id += FilePath::transPtr ? FilePath::transPtr->idroff : 0;
	    break;
	 case PARTC:
            kw_ptr->id += FilePath::transPtr ? FilePath::transPtr->idpoff : 0;
	    break;
	 case NOD:
            kw_ptr->id += FilePath::transPtr ? FilePath::transPtr->idnoff : 0;
	    break;
	 case DAMPING:
	    break;
	 case COMP:
	    break;
	 case EF:
	    break;
	 case PARAM:
	    break;
	 case TERM:
	    break;
	 case DEFORM:
	    break;
	 case SENSOR:
	    break;
	 case INTERFACE:
	    break;
	 case INTEGRATION:
	    break;
	 case USER:
	    break;
	 case CONTROL:
	    break;
	 case AIRBAG:
	    break;
	 case CONST:
	    break;
	 case PERTURB:
	    break;
	 case SET:
            kw_ptr->id += FilePath::transPtr ? FilePath::transPtr->idsoff : 0;
	    break;
	 case RIGIDWALL:
	    break;
	 case CONTACT:
	    break;
	 case INC:
	    break;
	 case DATABASE:
	    break;
	 case INITIAL:
	    break;
	 case LOAD:
	    break;
	 case BDRY:
	    break;
	 case ALE:
	    break;
	 case RAIL:
	    break;
         default:
            cout << "UNKNOWN MANAGER" << endl;
      }

      kw_type_id_list->push_back(kw_ptr);
   }

/*
   if( (flag & (1 << SECTION)) && (flag & (1 << MAT)) )
   {
      if( sec_type == -1 || mat_type == -1 )
         return;

      if( !validateMaterialForSectionType(mat_type, sec_type) )
      {
	 cout << "MATERIAL and SECTION are not matching for PART <"
	      << id_list[0] << ">" << endl;
      }
   }
*/
}

bool validateMaterialForSectionType
     (
        int mat_type, 
        int sec_type
     )
{
cout << "MAT TYPE = " << mat_type << endl;
cout << "SEC TYPE = " << sec_type << endl;

   switch(mat_type)
   {
      case MAT_ALE_GAS_MIXTURE:
      case MAT_ALE_VACUUM:
      case MAT_ALE_VISCOUS:
	 {
	    if( sec_type == SECTION_SOLID_ALE )
	       return true;
	    else
	       return false;
	 }
      case MAT_HILL_FOAM:
      case MAT_ANISOTROPIC_ELASTIC:
      case MAT_HONEYCOMB:
      case MAT_LOW_DENSITY_SYNTHETIC_FOAM:
      case MAT_LOW_DENSITY_SYNTHETIC_FOAM_ORTHO:
      case MAT_LOW_DENSITY_SYNTHETIC_FOAM_ORTHO_WITH_FAILURE:
      case MAT_LOW_DENSITY_SYNTHETIC_FOAM_WITH_FAILURE:
      case MAT_TRANSVERSELY_ISOTROPIC_CRUSHABLE_FOAM:
      case MAT_MODIFIED_HONEYCOMB:
      case MAT_MOHR_COULOMB:
      case MAT_ORTHOTROPIC_SMEARED_CRACK:
      case MAT_ORIENTED_CRACK:
      case MAT_HEART_TISSUE:
      case MAT_LUNG_TISSUE:
      case MAT_SOIL_BRICK:
      case MAT_ACOUSTIC:
      case MAT_CSCM:
      case MAT_SPOTWELD_DAIMLERCHRYSLER:
      case MAT_WOOD:
      case MAT_WOOD_FIR:
      case MAT_WOOD_PINE:
      case MAT_VISCOELASTIC_HILL_FOAM:
      case MAT_ARUP_ADHESIVE:
      case MAT_BRAIN_LINEAR_VISCOELASTIC:
      case MAT_COMPOSITE_FAILURE_SOLID_MODEL:
      case MAT_COHESIVE_ELASTIC:
      case MAT_COHESIVE_GENERAL:
      case MAT_COHESIVE_MIXED_MODE:
      case MAT_COHESIVE_TH:
      case MAT_JOINTED_ROCK:
      case MAT_COMPOSITE_MSC:
      case MAT_DRUCKER_PRAGER:
      case MAT_ADD_EROSION:
      case MAT_CSCM_CONCRETE:
	 {
	    if( sec_type == SECTION_SOLID )
	       return true;
	    else
	       return false;
	 }
      case MAT_FLD_3_PARAMETER_BARLAT:
      case MAT_COMPOSITE_DIRECT:
      case MAT_COMPOSITE_LAYUP:
      case MAT_COMPOSITE_MATRIX:
      case MAT_COMPOSITE_FAILURE_SHELL_MODEL:
      case MAT_ENHANCED_COMPOSITE_DAMAGE:
      case MAT_TRIP:
      case MAT_KINEMATIC_HARDENING_TRANSVERSELY_ANISOTROPIC:
      case MAT_ORTHO_ELASTIC_PLASTIC:
      case MAT_GEPLASTIC_SRATE_2000a:
      case MAT_PLASTICITY_POLYMER:
      case MAT_ANISOTROPIC_ELASTIC_PLASTIC:
      case MAT_LAYERED_LINEAR_PLASTICITY:
      case MAT_SPECIAL_ORTHOTROPIC:
      case MAT_CORUS_VEGTER:
      case MAT_RC_SHEAR_WALL:
      case MAT_FABRIC:
      case MAT_RESULTANT_ANISOTROPIC:
	 {
	    if( sec_type == SECTION_SHELL )
	       return true;
	    else
	       return false;
	 }
      case MAT_GENERAL_SPRING_DISCRETE_BEAM:
      case MAT_CABLE_DISCRETE_BEAM:
      case MAT_SEISMIC_ISOLATOR:
      case MAT_ELASTIC_SPRING_DISCRETE_BEAM:
      case MAT_INELASTIC_SPRING_DISCRETE_BEAM:
      case MAT_GENERAL_JOINT_DISCRETE_BEAM:
      case MAT_HYDRAULIC_GAS_DAMPER_DISCRETE_BEAM:
      case MAT_LINEAR_ELASTIC_DISCRETE_BEAM:
      case MAT_NONLINEAR_ELASTIC_DISCRETE_BEAM:
      case MAT_NONLINEAR_PLASTIC_DISCRETE_BEAM:
      case MAT_SID_DAMPER_DISCRETE_BEAM:
      case MAT_1DOF_GENERALIZED_SPRING:
      case MAT_ELASTIC_6DOF_SPRING_DISCRETE_BEAM:
      case MAT_GENERAL_NONLINEAR_1DOF_DISCRETE_BEAM:
      case MAT_GENERAL_NONLINEAR_6DOF_DISCRETE_BEAM:
      case MAT_INELASTIC_6DOF_SPRING_DISCRETE_BEAM:
	 {
	    if( sec_type == SECTION_BEAM_DISCRETE_OR_CABLE )
	       return true;
	    else
	       return false;
	 }
      case MAT_FLD_TRANSVERSELY_ANISOTROPIC:
      case MAT_TRANSVERSELY_ANISOTROPIC_ELASTIC_PLASTIC:
      case MAT_TRANSVERSELY_ANISOTROPIC_ELASTIC_PLASTIC_ECHANGE:
      case MAT_LAMINATED_GLASS:
      case MAT_3_PARAMETER_BARLAT:
      case MAT_BARLAT_YLD2000:
      case MAT_BARLAT_YLD96:
      case MAT_LAMINATED_COMPOSITE_FABRIC:
      case MAT_RATE_SENSITIVE_COMPOSITE_FABRIC:
      case MAT_WTM_STM:
      case MAT_WTM_STM_PLC:
      case MAT_ANISOTROPIC_PLASTIC:
      case MAT_ORTHOTROPIC_VISCOELASTIC:
      case MAT_HILL_3R:
	 {
	    if( sec_type == SECTION_SHELL || sec_type == SECTION_TSHELL )
	       return true;
	    else
	       return false;
	 }
      case MAT_DESHPANDE_FLECK_FOAM:
      case MAT_WINFRITH_CONCRETE:
      case MAT_WINFRITH_CONCRETE_REINFORCEMENT:
      case MAT_ELASTIC_FLUID:
      case MAT_CLOSED_CELL_FOAM:
      case MAT_FRAZER_NASH_RUBBER_MODEL:
      case MAT_POLYMER:
      case MAT_RAMBERG_OSGOOD:
      case MAT_VISCOUS_FOAM:
      case MAT_INV_HYPERBOLIC_SIN:
      case MAT_LOW_DENSITY_VISCOUS_FOAM:
      case MAT_GAS_MIXTURE:
      case MAT_MODIFIED_CRUSHABLE_FOAM:
      case MAT_VACUUM:
      case MAT_PITZER_CRUSHABLE_FOAM:
      case MAT_MCCORMICK:
      case MAT_RATE_SENSITIVE_POLYMER:
      case MAT_SOIL_CONCRETE:
      case MAT_ANISOTROPIC_THERMOELASTIC:
      case MAT_BRITTLE_DAMAGE:
	 {
	    if( sec_type == SECTION_SOLID || sec_type == SECTION_SOLID_ALE )
	       return true;
	    else
	       return false;
	 }
      case MAT_ISOTROPIC_ELASTIC_PLASTIC:
      case MAT_STRAIN_RATE_DEPENDENT_PLASTICITY:
      case MAT_BAMMAN:
      case MAT_BAMMAN_DAMAGE:
      case MAT_RATE_SENSITIVE_POWERLAW_PLASTICITY:
      case MAT_MODIFIED_ZERILLI_ARMSTRONG:
      case MAT_MTS:
      case MAT_PLASTICITY_COMPRESSION_TENSION:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_TSHELL || sec_type == SECTION_SPH ||
	       sec_type == SECTION_SPH_TENSOR || sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_POWER_LAW_PLASTICITY:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_TSHELL || sec_type == SECTION_SPH ||
	       sec_type == SECTION_SPH_TENSOR || sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_RESULTANT_PLASTICITY:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_BEAM_HUGHES_LIU )
	    return true;
	 else
	    return false;
      case MAT_ADD_THERMAL_EXPANSION:
	 return true;
      case MAT_BLATZ_KO_FOAM:
      case MAT_BLATZ_KO_RUBBER:
      case MAT_OGDEN_RUBBER:
      case MAT_PLASTIC_NONLINEAR_KINEMATIC:
	 {
	    if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
		  sec_type == SECTION_SOLID_ALE )
	       return true;
	    else
	       return false;
	 }
      case MAT_JOHNSON_HOLMQUIST_CERAMICS:
      case MAT_JOHNSON_HOLMQUIST_CONCRETE:
      case MAT_CONCRETE_DAMAGE_REL3:
      case MAT_GEOLOGIC_CAP_MODEL:
      case MAT_FINITE_ELASTIC_STRAIN_PLASTICITY:
      case MAT_ARRUDA_BOYCE_RUBBER:
      case MAT_SCHWER_MURRAY_CAP_MODEL:
	 if( sec_type == SECTION_SOLID || sec_type == SECTION_SPH || 
	    sec_type == SECTION_SPH_TENSOR || sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_DAMAGE_3:
	 if( sec_type == SECTION_SOLID || sec_type == SECTION_SHELL || 
	    sec_type == SECTION_TSHELL || sec_type == SECTION_BEAM_HUGHES_LIU )
	    return true;
	 else
	    return false;
      case MAT_ELASTIC:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_RESULTANT || 
	       sec_type == SECTION_BEAM_TRUSS_RESULTANT || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_SOLID || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_TUBULAR ||
	       sec_type == SECTION_TSHELL || sec_type == SECTION_SPH ||
	       sec_type == SECTION_SPH_TENSOR || sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_ELASTIC_PLASTIC_HYDRO:
      case MAT_ELASTIC_PLASTIC_HYDRO_SPALL:
      case MAT_STEINBERG:
      case MAT_STEINBERG_LUND:
      case MAT_ISOTROPIC_ELASTIC_FAILURE:
      case MAT_SOIL_AND_FOAM_FAILURE:
      case MAT_PSEUDO_TENSOR:
      case MAT_PLASTIC_GREEN_NAGHDI_RATE:
      case MAT_LOW_DENSITY_FOAM:
      case MAT_KELVIN_MAXWELL_VISCOELASTIC:
      case MAT_CRUSHABLE_FOAM:
      case MAT_CONCRETE_DAMAGE:
      case MAT_BILKHU_DUBOIS_FOAM:
      case MAT_HYSTERETIC_SOIL:
      case MAT_FU_CHANG_FOAM:
      case MAT_CELLULAR_RUBBER:
      case MAT_ISOTROPIC_SMEARED_CRACK:
      case MAT_FHWA_SOIL:
      case MAT_FHWA_SOIL_NEBRASKA:
      case MAT_EMMI:
      case MAT_PLASTICITY_COMPRESSION_TENSION_EOS:
      case MAT_SOIL_AND_FOAM:
      case MAT_HIGH_EXPLOSIVE_BURN:
	 if( sec_type == SECTION_SOLID || sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_SPH || sec_type == SECTION_SPH_TENSOR || 
	       sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_ELASTIC_PLASTIC_THERMAL:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_BEAM_TRUSS_RESULTANT || 
	       sec_type == SECTION_TSHELL )
	    return true;
	 else
	    return false;
      case MAT_ELASTIC_WITH_VISCOSITY:
      case MAT_ELASTIC_WITH_VISCOSITY_CURVE:
      case MAT_GENERAL_VISCOELASTIC:
      case MAT_HYPERELASTIC_RUBBER:
      case MAT_MODIFIED_JOHNSON_COOK:
      case MAT_VISCOELASTIC_THERMAL:
      case MAT_QUASILINEAR_VISCOELASTIC:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID || 
	    sec_type == SECTION_SOLID_ALE || sec_type == SECTION_SPH || 
	    sec_type == SECTION_SPH_TENSOR || sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_SHAPE_MEMORY:
      case MAT_UNIFIED_CREEP:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SPH || sec_type == SECTION_SPH_TENSOR || 
	       sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_SIMPLIFIED_JOHNSON_COOK:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_RESULTANT || 
	       sec_type == SECTION_BEAM_TRUSS_RESULTANT || 
	       sec_type == SECTION_TSHELL )
	    return true;
	 else
	    return false;
      case MAT_JOHNSON_COOK:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE || sec_type == SECTION_TSHELL || 
	       sec_type == SECTION_SPH || sec_type == SECTION_SPH_TENSOR || 
	       sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_RIGID:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_RESULTANT || 
	       sec_type == SECTION_BEAM_TRUSS_RESULTANT || 
	       sec_type == SECTION_TSHELL )
	    return true;
	 else
	    return false;
      case MAT_FORCE_LIMITED:
      case MAT_MODIFIED_FORCE_LIMITED:
      case MAT_MOMENT_CURVATURE_BEAM:
      case MAT_STEEL_CONCENTRIC_BRACE:
      case MAT_SEISMIC_BEAM:
	 if( sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_RESULTANT )
	    return true;
	 else
	    return false;
      case MAT_MOONEY_RIVLIN_RUBBER:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_TRUSS_RESULTANT )
	    return true;
	 else
	    return false;
      case MAT_NULL:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_RESULTANT || 
	       sec_type == SECTION_BEAM_TRUSS_RESULTANT || 
	       sec_type == SECTION_BEAM_DISCRETE_OR_CABLE || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_SOLID || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_TUBULAR ||
	       sec_type == SECTION_SPH || sec_type == SECTION_SPH_TENSOR || 
	       sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_MUSCLE:
	 if( sec_type == SECTION_BEAM_TRUSS_RESULTANT )
	    return true;
	 else
	    return false;
      case MAT_ORTHOTROPIC_ELASTIC:
      case MAT_ORTHOTROPIC_THERMAL:
      case MAT_COMPOSITE_DAMAGE:
      case MAT_TEMPERATURE_DEPENDENT_ORTHOTROPIC:
      case MAT_BARLAT_ANISOTROPIC_PLASTICITY:
      case MAT_PLASTICITY_WITH_DAMAGE:
      case MAT_PLASTICITY_WITH_DAMAGE_ORTHO:
      case MAT_PLASTICITY_WITH_DAMAGE_ORTHO_RCDC:
      case MAT_SIMPLIFIED_JOHNSON_COOK_ORTHOTROPIC_DAMAGE:
      case MAT_DAMAGE_1:
      case MAT_DAMAGE_2:
      case MAT_MODIFIED_PIECEWISE_LINEAR_PLASTICITY:
      case MAT_MODIFIED_PIECEWISE_LINEAR_PLASTICITY_RATE:
	 if( sec_type == SECTION_SOLID || sec_type == SECTION_SHELL ||
	       sec_type == SECTION_TSHELL )
	    return true;
	 else
	    return false;
      case MAT_USER_DEFINED_MATERIAL_MODELS:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_BEAM_TRUSS_RESULTANT || 
	       sec_type == SECTION_BEAM_DISCRETE_OR_CABLE || 
	       sec_type == SECTION_TSHELL || 
	       sec_type == SECTION_SPH || sec_type == SECTION_SPH_TENSOR || 
	       sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_PIECEWISE_LINEAR_PLASTICITY:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_TSHELL || sec_type == SECTION_SPH ||
	       sec_type == SECTION_SPH_TENSOR || sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_PLASTIC_KINEMATIC:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_BEAM_TRUSS_RESULTANT || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_SOLID || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_TUBULAR ||
	       sec_type == SECTION_TSHELL || sec_type == SECTION_SPH ||
	       sec_type == SECTION_SPH_TENSOR || sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_CONCRETE_EC2:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_BEAM_HUGHES_LIU )
	    return true;
	 else
	    return false;
      case MAT_SEATBELT:
	 if( sec_type == SECTION_SEATBELT )
	    return true;
	 else
	    return false;
      case MAT_CONCRETE_BEAM:
      case MAT_RC_BEAM:
         {
	    if( sec_type == SECTION_BEAM_HUGHES_LIU )
	       return true;
	    else
	       return false;
         }
      case MAT_NONLINEAR_ORTHOTROPIC:
      case MAT_SOFT_TISSUE:
      case MAT_SOFT_TISSUE_VISCO:
      case MAT_ELASTIC_VISCOPLASTIC_THERMAL:
      case MAT_GURSON:
      case MAT_GURSON_JC:
      case MAT_GURSON_RCDC:
      case MAT_COMPOSITE_MSC_DMG:
      case MAT_SIMPLIFIED_RUBBER_FOAM:
      case MAT_SIMPLIFIED_RUBBER_FOAM_WITH_FAILURE:
      case MAT_SIMPLIFIED_RUBBER_WITH_DAMAGE:
      case MAT_SAMP_1:
      case MAT_THERMO_ELASTO_VISCOPLASTIC_CREEP:
      case MAT_NONLOCAL:
	 {
	    if( sec_type == SECTION_SOLID || sec_type == SECTION_SHELL )
	       return true;
	    else
	       return false;
	 }
      case MAT_DAMPER_NONLINEAR_VISCOUS:
      case MAT_DAMPER_VISCOUS:
      case MAT_SPRING_INELASTIC:
      case MAT_SPRING_MUSCLE:
      case MAT_SPRING_TRILINEAR_DEGRADING:
      case MAT_SPRING_ELASTIC:
      case MAT_SPRING_ELASTOPLASTIC:
      case MAT_SPRING_GENERAL_NONLINEAR:
      case MAT_SPRING_MAXWELL:
      case MAT_SPRING_NONLINEAR_ELASTIC:
      case MAT_SPRING_SQUAT_SHEARWALL:
	 {
	    if( sec_type == SECTION_DISCRETE )
	       return true;
	    else
	       return false;
	 }
      case MAT_THERMAL_ISOTROPIC:
      case MAT_THERMAL_ISOTROPIC_PHASE_CHANGE:
      case MAT_THERMAL_ISOTROPIC_TD:
      case MAT_THERMAL_ISOTROPIC_TD_LC:
      case MAT_THERMAL_ORTHOTROPIC:
      case MAT_THERMAL_ORTHOTROPIC_TD:
      case MAT_THERMAL_USER_DEFINED:
	 return true;
      case MAT_VISCOELASTIC:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_HUGHES_LIU ||
	       sec_type == SECTION_SPH || sec_type == SECTION_SPH_TENSOR ||
	       sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_ANISOTROPIC_VISCOPLASTIC:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_TSHELL || sec_type == SECTION_SPH || 
	       sec_type == SECTION_SPH_TENSOR || sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_SPOTWELD:
      case MAT_SPOTWELD_DAMAGE_FAILURE:
	 {
	    if( sec_type == SECTION_BEAM_SPOTWELD || 
	       sec_type == SECTION_BEAM_HUGHES_LIU || sec_type == SECTION_SOLID)
	       return true;
	    else
	       return false;
	 }
   }

   return false;
}

void airbagFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int sid_type = atoi(field_list[id_index+1]),
		num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {SET, },
		kw_types[] = {SEGMENT, };

   switch(sid_type)
   {
      case 0:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types, 
						kw_types, imp_obj);
         }
         break;
      case 1:
         {
            kw_types[0] = PARTC;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }
}

void airbagVentHoleFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int sid_type = atoi(field_list[id_index+1]),
		num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {SET, },
		kw_types[] = {PARTC, };
 
   switch(sid_type)
   {
      case 0:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types, 
						kw_types, imp_obj);
         }
         break;
      case 1:
         {
            man_types[0] = PARTC;
            kw_types[0] = 9999;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 2:
         {
            man_types[0] = SET;
            kw_types[0] = SEGMENT;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }
}

void aleFsiFind
     (
        char         **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int lag_sid_type = atoi(field_list[id_index+2]), 
                ale_sid_type = atoi(field_list[id_index+3]), 
                num_indices = 1,
                field_indices[] = {id_index, },
                man_types[] = {SET, },
                kw_types[] = {PARTC, };
 
   switch(lag_sid_type)
   {
      case 0:
         addIDToRefFile(field_list, num_indices, field_indices, man_types, 
						kw_types, imp_obj);
         break;
      case 1:
         {
            man_types[0] = PARTC;
            kw_types[0] = 9999;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }

   field_indices[0] = id_index + 1;

   switch(ale_sid_type)
   {
      case 0:
         {
            man_types[0] = SET;
            kw_types[0] = PARTC;
            addIDToRefFile(field_list, num_indices, field_indices, man_types, 
						kw_types, imp_obj);
         }
         break;
      case 1:
         {
            man_types[0] = PARTC;
            kw_types[0] = 9999;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }

   if( num_fields > 4 )
   {
      //set id for ALE MMG
      field_indices[0] = id_index + 4;
      man_types[0] = SET;
      kw_types[0] = MMG;
      addIDToRefFile(field_list, num_indices, field_indices, 
                                               man_types, kw_types, imp_obj);
   }
}

void airbagAdvancedAle
     (
        char         **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int nx_or_ida = atoi(field_list[id_index]), 
                ny = atoi(field_list[id_index+1]), 
                nz = atoi(field_list[id_index+2]), 
                num_indices = 1,
                field_indices[] = {id_index, },
                man_types[] = {PARTC, },
                kw_types[] = {9999, };

   if( !ny && !nz && nx_or_ida )
   {
      addIDToRefFile(field_list, num_indices, field_indices, man_types, 
						kw_types, imp_obj);
   }
 
   for(unsigned int i = 4; i < 7; i++)
   {
      if( i >= num_fields )
         break;

      field_indices[0] = id_index+i;

      switch(i)
      {
	 case 4:
	    {
	       man_types[0] = ALE;
	       kw_types[0] = NOD;
	       addIDToRefFile(field_list, num_indices, field_indices, 
                           man_types, kw_types, imp_obj);
	    }
	    break;
	 case 5:
	    {
	       man_types[0] = NOD;
	       kw_types[0] = 9999;
	       addIDToRefFile(field_list, num_indices, field_indices, 
				man_types, kw_types, imp_obj);
	    }
	    break;
	 case 6:
	    {
	       man_types[0] = PARTC;
	       kw_types[0] = 9999;
	       addIDToRefFile(field_list, num_indices, field_indices, 
				man_types, kw_types, imp_obj);
	    }
	    break;
      }
   }
}

void aleRefGroupFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int sid_type = atoi(field_list[id_index+1]),
		num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {SET, },
		kw_types[] = {PARTC, };

   switch(sid_type)
   {
      case 0:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types, 
						kw_types, imp_obj);
         }
         break;
      case 1:
         {
            man_types[0] = PARTC;
            kw_types[0] = 9999;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 2:
         {
            man_types[0] = SET;
            kw_types[0] = NOD;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 3:
         {
            man_types[0] = SET;
            kw_types[0] = SEGMENT;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }

   unsigned int pr_type = atoi(field_list[id_index+2]);
   field_indices[0] = id_index + 3;

   switch(pr_type)
   {
      case 3:
         {
            man_types[0] = ALE;
            kw_types[0] = CURVE;
            addIDToRefFile(field_list, num_indices, field_indices, man_types, 
						kw_types, imp_obj);
         }
         break;
      case 5:
      case 7:
         {
            man_types[0] = ALE;
            kw_types[0] = NOD;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 6:
         {
            man_types[0] = ALE;
            kw_types[0] = SWITCH;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 9:
         {
            unsigned int pr_id = atoi(field_list[id_index+3]);
            if( pr_id )
            {
	       field_indices[0] = id_index + 3;
	       man_types[0] = SET;
	       kw_types[0] = PARTC;
	       addIDToRefFile(field_list, num_indices, field_indices, 
                                     man_types, kw_types, imp_obj);
            }

            if( num_fields > 4 )
            {
	       unsigned int bc_tran = atoi(field_list[id_index+4]);
	       if( bc_tran )
	       {
		  field_indices[0] = id_index + 4;
		  man_types[0] = ALE;
		  kw_types[0] = NOD;
		  addIDToRefFile(field_list, num_indices, field_indices, 
					man_types, kw_types, imp_obj);
	       }
            }

            if( num_fields > 7 )
            {
	       unsigned int icr_nid = atoi(field_list[id_index+7]);
	       if( icr_nid )
	       {
		  field_indices[0] = id_index + 7;
		  man_types[0] = NOD;
		  kw_types[0] = 9999;
		  addIDToRefFile(field_list, num_indices, field_indices, 
					man_types, kw_types, imp_obj);
	       }
            }
         }
         break;
   }
}

void aleUpSwitchFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{

   airbagFind(field_list, num_fields, id_index, imp_obj);

   unsigned int num_indices = 2,
		field_indices[] = {id_index + 2, id_index + 3, },
		man_types[] = {ALE, ALE, },
		kw_types[] = {MMG, MMG, };
 
   addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
}

void bemAcousticFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   airbagVentHoleFind(field_list, num_fields, id_index, imp_obj);

   unsigned int out_type = atoi(field_list[id_index + 4]),
                num_indices = 1,
		field_indices[] = {id_index + 3, },
		man_types[] = {SET, },
		kw_types[] = {NOD, };
 
   switch(out_type)
   {
      case 1:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types, 
						kw_types, imp_obj);
         }
         break;
      case 2:
         {
            kw_types[0] = SEGMENT;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }
   
   field_indices[0] = id_index + 2;
   man_types[0] = DEFINE;
   kw_types[0] = CURVE;
   addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
}

void bdrySphFlowFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   initialVelGenFind(field_list, num_fields, id_index, imp_obj);

   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {DEFINE, },
		kw_types[] = {CURVE, };

   if( num_fields > 4 )
   {
      field_indices[0] = id_index + 4;
      addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
   }
}

void bdryPresMotionFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int id_type = imp_obj->getKeywordType();
   
   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {NOD, },
		kw_types[] = {9999, };

   switch(id_type)
   {
      case BOUNDARY_PRESCRIBED_MOTION_NODE:
      case BOUNDARY_PRESCRIBED_MOTION_NODE_ID:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case BOUNDARY_PRESCRIBED_MOTION_SET:
      case BOUNDARY_PRESCRIBED_MOTION_SET_ID:
         {
            man_types[0] = SET;
            kw_types[0] = NOD;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case BOUNDARY_PRESCRIBED_MOTION_RIGID:
      case BOUNDARY_PRESCRIBED_MOTION_RIGID_ID:
      case BOUNDARY_PRESCRIBED_MOTION_RIGID_LOCAL:
      case BOUNDARY_PRESCRIBED_MOTION_RIGID_LOCAL_ID:
         {
            man_types[0] = PARTC;
            kw_types[0] = 9999;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }

   field_indices[0] = id_index + 3;
   man_types[0] = DEFINE;
   kw_types[0] = CURVE;
   addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);

   field_indices[0] = id_index + 5;
   man_types[0] = DEFINE;
   kw_types[0] = VECTOR;
   addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
}

void bdrySpcFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int id_type = imp_obj->getKeywordType();
   
   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {NOD, },
		kw_types[] = {9999, };

   switch(id_type)
   {
      case BOUNDARY_SPC_NODE:
      case BOUNDARY_SPC_NODE_ID:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case BOUNDARY_SPC_SET:
      case BOUNDARY_SPC_SET_ID:
         {
            man_types[0] = SET;
            kw_types[0] = NOD;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }

   field_indices[0] = id_index + 1;
   man_types[0] = DEFINE;
   kw_types[0] = COORDINATE;
   addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
}

void bdryTempFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int id_type = imp_obj->getKeywordType();

   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {NOD, },
		kw_types[] = {9999, };

   switch(id_type)
   {
      case BOUNDARY_TEMPERATURE_NODE:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case BOUNDARY_TEMPERATURE_SET:
         {
            man_types[0] = SET;
            kw_types[0] = NOD;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }

   field_indices[0] = id_index + 1;
   man_types[0] = DEFINE;
   kw_types[0] = CURVE;
   addIDToRefFile(field_list, num_indices, field_indices, man_types, kw_types, imp_obj);
}

void bdryThermalFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int sid_type = atoi(field_list[id_index+1]),
                num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {PARTC, },
		kw_types[] = {9999, };

   switch(sid_type)
   {
      case 1:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 2:
         {
            man_types[0] = SET;
            kw_types[0] = PARTC;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }

   unsigned int nid = atoi(field_list[id_index+2]);
   if( nid > 0 )
   {
      field_indices[0] = id_index + 2;
      man_types[0] = NOD;
      kw_types[0] = 9999;
      addIDToRefFile(field_list, num_indices, field_indices, 
                                                  man_types, kw_types, imp_obj);
   }

   if( num_fields > 7 )
   {
      nid = atoi(field_list[id_index+7]);
      if( nid > 0 )
      {
	 man_types[0] = NOD;
	 kw_types[0] = 9999;
	 field_indices[0] = id_index + 7;
	 addIDToRefFile(field_list, num_indices, field_indices, 
						      man_types, kw_types, imp_obj);
      }
   }
}

void constExtraNodes
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int sid_type = imp_obj->getKeywordType(),
                num_indices = 2,
		field_indices[] = {id_index, id_index+1},
		man_types[] = {PARTC, NOD},
		kw_types[] = {9999, 9999};

   switch(sid_type)
   {
      case CONSTRAINED_EXTRA_NODES_NODE:
      {
	 addIDToRefFile(field_list, num_indices, field_indices, man_types,
					     kw_types, imp_obj);
      }
      break;
      case CONSTRAINED_EXTRA_NODES_SET:
      {
	 man_types[1] = SET;
	 kw_types[1] = NOD;
	 addIDToRefFile(field_list, num_indices, field_indices, man_types,
					     kw_types, imp_obj);
      }
      break;
   }
}

void constJointFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int sid_type = atoi(field_list[id_index+1]),
                num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {PARTC, },
		kw_types[] = {9999, };

   switch(sid_type)
   {
      case 1:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 2:
         {
            man_types[0] = SET;
            kw_types[0] = PARTC;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }

   unsigned int nid = atoi(field_list[id_index+2]);
   if( nid > 0 )
   {
      field_indices[0] = id_index + 2;
      man_types[0] = NOD;
      kw_types[0] = 9999;
      addIDToRefFile(field_list, num_indices, field_indices, 
                                                  man_types, kw_types, imp_obj);
   }

   nid = atoi(field_list[id_index+7]);
   if( nid > 0 )
   {
      man_types[0] = NOD;
      kw_types[0] = 9999;
      field_indices[0] = id_index + 7;
      addIDToRefFile(field_list, num_indices, field_indices, 
                                                   man_types, kw_types, imp_obj);
   }
}

void contact2dAutoFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   int set_id;
   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {SET, },
		kw_types[] = {PARTC, };

   for(unsigned int i = 0; i < 2; i++)
   {
      set_id = atoi(field_list[i]);
      if( set_id > 0 )
      {
	 field_indices[0] = i;
	 man_types[0] = SET;
	 kw_types[0] = PARTC;
	 addIDToRefFile(field_list, num_indices, field_indices, man_types,
						   kw_types, imp_obj);
      }
      else if( set_id < 0 )
      {
	 field_indices[0] = i;
	 man_types[0] = SET;
	 kw_types[0] = NOD;
	 addIDToRefFile(field_list, num_indices, field_indices, man_types,
					     kw_types, imp_obj);
      }
   }
}

void contactFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int slave_type = atoi(field_list[id_index + 2]),
                master_type = atoi(field_list[id_index + 3]),
                num_indices = 1,
                field_indices[] = {id_index, },
                man_types[] = {SET, },
                kw_types[] = {SEGMENT, };

   switch(slave_type)
   {
      case 0:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 1:
         {
            man_types[0] = SET;
            kw_types[0] = SHELL;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 2:
      case 6:
         {
            man_types[0] = SET;
            kw_types[0] = PARTC;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 3:
         {
            man_types[0] = PARTC;
            kw_types[0] = 9999;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 4:
         {
            man_types[0] = SET;
            kw_types[0] = NOD;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }

   field_indices[0] = id_index + 1;

   switch(master_type)
   {
      case 0:
         {
            man_types[0] = SET;
            kw_types[0] = SEGMENT;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 1:
         {
            man_types[0] = SET;
            kw_types[0] = SHELL;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 2:
         {
            man_types[0] = SET;
            kw_types[0] = PARTC;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 3:
         {
            man_types[0] = PARTC;
            kw_types[0] = 9999;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }

   int sbid = atoi(field_list[id_index + 4]);
   if( sbid > 0 )
   {
      if( slave_type == 2 || slave_type == 3 )
      {
	 field_indices[0] = id_index + 4;
	 man_types[0] = DEFINE;
	 kw_types[0] = BOX;
	 addIDToRefFile(field_list, num_indices, field_indices, man_types,
						   kw_types, imp_obj);
      }
      else
         cout << "ERROR: SBOXID should be used for SSTYP 2 or 3 only" << endl;
   }
   else if ( sbid < 0 )
   {
	 field_indices[0] = id_index + 4;
	 man_types[0] = DEFINE;
	 kw_types[0] = VOLUME;
	 addIDToRefFile(field_list, num_indices, field_indices, man_types,
						  kw_types, imp_obj);
   }

   int mbid = atoi(field_list[id_index + 5]);
   if( mbid > 0 )
   {
      if( master_type == 2 || master_type == 3 )
      {
	 field_indices[0] = id_index + 5;
	 man_types[0] = DEFINE;
	 kw_types[0] = BOX;
	 addIDToRefFile(field_list, num_indices, field_indices, man_types,
						   kw_types, imp_obj);
      }
      else
         cout << "ERROR: MBOXID should be used for MSTYP 2 or 3 only" << endl;
   }
   else if ( mbid < 0 )
   {
      field_indices[0] = id_index + 5;
      man_types[0] = DEFINE;
      kw_types[0] = VOLUME;
      addIDToRefFile(field_list, num_indices, field_indices, man_types,
					       kw_types, imp_obj);
   }
}

void contactCouplingFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int stype = atoi(field_list[id_index + 1]),
                num_indices = 1,
                field_indices[] = {id_index, },
                man_types[] = {SET, },
                kw_types[] = {PARTC, };

   switch(stype)
   {
      case 0:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 1:
         {
            man_types[0] = SET;
            kw_types[0] = SHELL;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 2:
         {
            man_types[0] = SET;
            kw_types[0] = SOLID;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 3:
         {
            man_types[0] = SET;
            kw_types[0] = TSHELL;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }
}

void contactEntityFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int stype = atoi(field_list[id_index + 3]),
                num_indices = 1,
                field_indices[] = {id_index + 2, },
                man_types[] = {SET, },
                kw_types[] = {NOD, };

   switch(stype)
   {
      case 0:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 1:
         {
            man_types[0] = PARTC;
            kw_types[0] = 9999;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 2:
         {
            man_types[0] = SET;
            kw_types[0] = PARTC;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }

   field_indices[0] = id_index;
   man_types[0] = PARTC;
   kw_types[0] = 9999;
   addIDToRefFile(field_list, num_indices, field_indices, man_types, kw_types, imp_obj);

   int df = atoi(field_list[id_index + 5]);

   if( df < 0 )
   {
      field_indices[0] = id_index + 5;
      man_types[0] = DEFINE;
      kw_types[0] = CURVE;
      addIDToRefFile(field_list, num_indices, field_indices, 
                                                 man_types, kw_types, imp_obj);
   }
}

void contactGebodFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int stype = atoi(field_list[id_index + 2]),
                num_indices = 1,
                field_indices[] = {id_index + 1, },
                man_types[] = {SET, },
                kw_types[] = {NOD, };

   switch(stype)
   {
      case 0:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 1:
         {
            man_types[0] = PARTC;
            kw_types[0] = 9999;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 2:
         {
            man_types[0] = SET;
            kw_types[0] = PARTC;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }

   field_indices[0] = id_index;
   man_types[0] = COMP;
   kw_types[0] = 9999;
   addIDToRefFile(field_list, num_indices, field_indices, man_types, kw_types, imp_obj);

   int df = atoi(field_list[id_index + 4]);

   if( df < 0 )
   {
      field_indices[0] = id_index + 4;
      man_types[0] = DEFINE;
      kw_types[0] = CURVE;
      addIDToRefFile(field_list, num_indices, field_indices, 
                                                 man_types, kw_types, imp_obj);
   }
}

void contactGuidedFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   const char *kw = imp_obj->getKeyword().data();
   unsigned int num_indices = 1,
                field_indices[] = {id_index, },
                man_types[] = {SET, },
                kw_types[] = {NOD, };

   addIDToRefFile(field_list, num_indices, field_indices, man_types, kw_types, imp_obj);

   field_indices[0] = id_index + 1;

   if( strstr(kw, "SET") )
   {
      man_types[0] = SET;
      kw_types[0] = PARTC;
      addIDToRefFile(field_list, num_indices, field_indices, 
                                                 man_types, kw_types, imp_obj);
   }
   else
   {
      man_types[0] = PARTC;
      kw_types[0] = 9999;
      addIDToRefFile(field_list, num_indices, field_indices, 
                                                 man_types, kw_types, imp_obj);
   }
}

void controlCurveFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int sid_type = atoi(field_list[id_index+1]),
                num_indices = 1,
                field_indices[] = {id_index, },
                man_types[] = {SET, },
                kw_types[] = {SHELL, };

   switch(sid_type)
   {
      case 1:
         {
            addIDToRefFile(field_list, num_indices, field_indices, 
                                                     man_types, kw_types, imp_obj);
         }
         break;
      case 2:
         {
	    man_types[0] = SET;
	    kw_types[0] = PARTC;
	    addIDToRefFile(field_list, num_indices, field_indices, 
                                                     man_types, kw_types, imp_obj);
         }
         break;
    }
}

void controlTemplateFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int sid_type = atoi(field_list[id_index+6]),
		num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {SET, },
		kw_types[] = {PARTC, };
 
   switch(sid_type)
   {
      case 0:
	 {
	    man_types[0] = PARTC;
	    kw_types[0] = 9999;
	 }
	 break;
      case 1:
	 {
	    man_types[0] = SET;
	    kw_types[0] = PARTC;
	 }
	 break;
   }

   for(unsigned int i = 1; i < 6; i++)
   {
      if( i >= num_fields )
         break;
      field_indices[0] = id_index + i;
      addIDToRefFile(field_list, num_indices, field_indices, 
				man_types, kw_types, imp_obj);

   }
}

void controlUserFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int sid_type = atoi(field_list[id_index+1]),
		num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {SET, },
		kw_types[] = {PARTC, };
 
   switch(sid_type)
   {
      case 0:
	 {
	    man_types[0] = PARTC;
	    kw_types[0] = 9999;
	    addIDToRefFile(field_list, num_indices, field_indices,
                                                         man_types, kw_types, imp_obj);
	 }
	 break;
      case 1:
	 {
	    man_types[0] = SET;
	    kw_types[0] = PARTC;
	    addIDToRefFile(field_list, num_indices, field_indices,
                                                         man_types, kw_types, imp_obj);
	 }
	 break;
   }
}

void controlGeneralFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   int neg_id = atoi(field_list[id_index]);

   if( neg_id >= 0 )
      return;

   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {DEFINE, },
		kw_types[] = {CURVE, };
 
   addIDToRefFile(field_list, num_indices, field_indices, man_types, kw_types, imp_obj);
}

void databaseCSFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int sid_type = atoi(field_list[id_index+1]),
		num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {PARTC, },
		kw_types[] = {9999, };
 
   switch(sid_type)
   {
      case 0:
	 {
	    addIDToRefFile(field_list, num_indices, field_indices,
                                                         man_types, kw_types, imp_obj);
	 }
	 break;
      case 1:
	 {
	    man_types[0] = ELEMENT;
	    kw_types[0] = SBACCEL;
	    addIDToRefFile(field_list, num_indices, field_indices,
                                                         man_types, kw_types, imp_obj);
	 }
	 break;
      case 2:
	 {
	    man_types[0] = DEFINE;
	    kw_types[0] = COORDINATE;
	    addIDToRefFile(field_list, num_indices, field_indices,
                                                         man_types, kw_types, imp_obj);
	 }
	 break;
   }
}

void databaseCSSetFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {SET, },
		kw_types[] = {NOD, };
   addIDToRefFile(field_list, num_indices, field_indices, man_types, kw_types, imp_obj);

   if( num_fields > 1 )
   {
      kw_types[0] = SOLID;
      field_indices[0] = 1;
      addIDToRefFile(field_list, num_indices, field_indices, 
                                               man_types, kw_types, imp_obj);
   }

   if( num_fields > 2 )
   {
      kw_types[0] = BEAM;
      field_indices[0] = 2;
      addIDToRefFile(field_list, num_indices, field_indices, 
                                               man_types, kw_types, imp_obj);
   }

   if( num_fields > 3 )
   {
      kw_types[0] = SHELL;
      field_indices[0] = 3;
      addIDToRefFile(field_list, num_indices, field_indices, 
                                               man_types, kw_types, imp_obj);
   }

   if( num_fields > 4 )
   {
      kw_types[0] = TSHELL;
      field_indices[0] = 4;
      addIDToRefFile(field_list, num_indices, field_indices, 
                                               man_types, kw_types, imp_obj);
   }

   if( num_fields > 5 )
   {
      kw_types[0] = DISCRETE;
      field_indices[0] = 5;
      addIDToRefFile(field_list, num_indices, field_indices, 
                                               man_types, kw_types, imp_obj);
   }

   if( num_fields > 6 )
      databaseCSFind(field_list, num_fields, 6, imp_obj);
}

void databaseHistoryLocalFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   const char *kw = imp_obj->getKeyword().data();
   unsigned int num_indices = 1,
                field_indices[] = {id_index, },
                man_types[] = {SET, },
                kw_types[] = {NOD, };

   if( strstr(kw, "SET") )
   {
      addIDToRefFile(field_list, num_indices, field_indices, 
                                                 man_types, kw_types, imp_obj);
   }
   else
   {
      man_types[0] = NOD;
      kw_types[0] = 9999;
      addIDToRefFile(field_list, num_indices, field_indices, 
                                                 man_types, kw_types, imp_obj);
   }

   field_indices[0] = id_index + 1;
   man_types[0] = DEFINE;
   kw_types[0] = COORDINATE;
   addIDToRefFile(field_list, num_indices, field_indices, man_types, kw_types, imp_obj);
}

void databaseHistoryIDFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int id_type = imp_obj->getKeywordType();
   
   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {ELEMENT, },
		kw_types[] = {BEAM, };

   switch(id_type)
   {
      case DATABASE_HISTORY_BEAM:
      case DATABASE_HISTORY_BEAM_ID:
	 {
	    addIDToRefFile(field_list, num_indices, field_indices, 
				    man_types, kw_types, imp_obj);
	 }
	 break;
      case DATABASE_HISTORY_BEAM_SET:
	 {
	    man_types[0] = SET;
	    kw_types[0] = BEAM;
	    addIDToRefFile(field_list, num_indices, field_indices, 
				    man_types, kw_types, imp_obj);
	 }
	 break;
      case DATABASE_HISTORY_DISCRETE:
      case DATABASE_HISTORY_DISCRETE_ID:
	 {
	    man_types[0] = ELEMENT;
	    kw_types[0] = DISCRETE;
	    addIDToRefFile(field_list, num_indices, field_indices, 
				    man_types, kw_types, imp_obj);
	 }
	 break;
      case DATABASE_HISTORY_DISCRETE_SET:
	 {
	    man_types[0] = SET;
	    kw_types[0] = DISCRETE;
	    addIDToRefFile(field_list, num_indices, field_indices, 
				    man_types, kw_types, imp_obj);
	 }
	 break;
      case DATABASE_HISTORY_NODE:
      case DATABASE_HISTORY_NODE_ID:
	 {
	    man_types[0] = NOD;
	    kw_types[0] = 9999;
	    addIDToRefFile(field_list, num_indices, field_indices, 
				    man_types, kw_types, imp_obj);
	 }
	 break;
      case DATABASE_HISTORY_NODE_SET:
	 {
	    man_types[0] = SET;
	    kw_types[0] = NOD;
	    addIDToRefFile(field_list, num_indices, field_indices, 
				    man_types, kw_types, imp_obj);
	 }
	 break;
      case DATABASE_HISTORY_SEATBELT:
      case DATABASE_HISTORY_SEATBELT_ID:
	 {
	    man_types[0] = ELEMENT;
	    kw_types[0] = SBELEMENT;
	    addIDToRefFile(field_list, num_indices, field_indices, 
				    man_types, kw_types, imp_obj);
	 }
	 break;
      case DATABASE_HISTORY_SHELL:
      case DATABASE_HISTORY_SHELL_ID:
	 {
	    man_types[0] = ELEMENT;
	    kw_types[0] = SHELL;
	    addIDToRefFile(field_list, num_indices, field_indices, 
				    man_types, kw_types, imp_obj);
	 }
	 break;
      case DATABASE_HISTORY_SHELL_SET:
	 {
	    man_types[0] = SET;
	    kw_types[0] = SHELL;
	    addIDToRefFile(field_list, num_indices, field_indices, 
				    man_types, kw_types, imp_obj);
	 }
	 break;
      case DATABASE_HISTORY_SOLID:
      case DATABASE_HISTORY_SOLID_ID:
	 {
	    man_types[0] = ELEMENT;
	    kw_types[0] = SOLID;
	    addIDToRefFile(field_list, num_indices, field_indices, 
				    man_types, kw_types, imp_obj);
	 }
	 break;
      case DATABASE_HISTORY_SOLID_SET:
	 {
	    man_types[0] = SET;
	    kw_types[0] = SOLID;
	    addIDToRefFile(field_list, num_indices, field_indices, 
				    man_types, kw_types, imp_obj);
	 }
	 break;
      case DATABASE_HISTORY_SPH:
	 {
	    man_types[0] = ELEMENT;
	    kw_types[0] = SPH;
	    addIDToRefFile(field_list, num_indices, field_indices, 
				    man_types, kw_types, imp_obj);
	 }
	 break;
      case DATABASE_HISTORY_SPH_SET:
	 {
	    man_types[0] = SET;
	    kw_types[0] = SPH;
	    addIDToRefFile(field_list, num_indices, field_indices, 
				    man_types, kw_types, imp_obj);
	 }
	 break;
      case DATABASE_HISTORY_TSHELL:
      case DATABASE_HISTORY_TSHELL_ID:
	 {
	    man_types[0] = ELEMENT;
	    kw_types[0] = TSHELL;
	    addIDToRefFile(field_list, num_indices, field_indices, 
				    man_types, kw_types, imp_obj);
	 }
	 break;
      case DATABASE_HISTORY_TSHELL_SET:
	 {
	    man_types[0] = SET;
	    kw_types[0] = TSHELL;
	    addIDToRefFile(field_list, num_indices, field_indices, 
				man_types, kw_types, imp_obj);
	 }
	 break;
   }
}

void databaseHistoryFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   for(unsigned int i = 0; i < num_fields; i++)
      databaseHistoryIDFind(field_list, num_fields, id_index + i, imp_obj);
}

void databaseFsiFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   airbagVentHoleFind(field_list, num_fields, id_index, imp_obj);

   unsigned int num_indices = 1,
		field_indices[] = {id_index + 2, },
		man_types[] = {ALE, },
		kw_types[] = {SWITCH, };
   if( num_fields > 3 )
      addIDToRefFile(field_list, num_indices, field_indices, 
                                               man_types, kw_types, imp_obj);

   man_types[0] = LOAD;
   kw_types[0] = 9999;
   field_indices[0] = id_index + 3;
   if( num_fields > 4 )
      addIDToRefFile(field_list, num_indices, field_indices, 
                                               man_types, kw_types, imp_obj);
}

void defineAleBagFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   airbagVentHoleFind(field_list, num_fields, id_index, imp_obj);

   if( num_fields > 7 )
      airbagVentHoleFind(field_list, num_fields, id_index + 5, imp_obj);
}

void defineDTimesFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int kw_type = imp_obj->getKeywordType();
   unsigned int num_indices = 1,
                field_indices[] = {id_index, },
                man_types[] = {NOD, },
                kw_types[] = {9999, }, i;

   switch( kw_type )
   {
      case DEFINE_DEATH_TIMES_NODES:
         break;
      case DEFINE_DEATH_TIMES_RIGID:
	 man_types[0] = PARTC;
	 kw_types[0] = 9999;
         break;
      case DEFINE_DEATH_TIMES_SET:
	 man_types[0] = SET;
	 kw_types[0] = NOD;
         break;
   }

   for(i = 0; i < num_fields; i++)
   {
      field_indices[0] = id_index + i;
      addIDToRefFile(field_list, num_indices, field_indices, 
					man_types, kw_types, imp_obj);
   }
}

void defineDrawbeadFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int sid_type = atoi(field_list[id_index+3]),
		num_indices = 1,
		field_indices[] = {id_index + 1, },
		man_types[] = {SET, },
		kw_types[] = {PARTC, };
 
   switch(sid_type)
   {
      case 2:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 3:
         {
            man_types[0] = PARTC;
            kw_types[0] = 9999;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 4:
         {
            man_types[0] = SET;
            kw_types[0] = SEGMENT;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }

   man_types[0] = PARTC;
   kw_types[0] = 9999;
   field_indices[0] = id_index;
   addIDToRefFile(field_list, num_indices, field_indices,
                                               man_types, kw_types, imp_obj);

   if( num_fields > 6 )
   {
      man_types[0] = DEFINE;
      kw_types[0] = COORDINATE;
      field_indices[0] = id_index + 5;
      addIDToRefFile(field_list, num_indices, field_indices,
						  man_types, kw_types, imp_obj);
   }
}
 
void defineAdaptiveFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int sid_type = atoi(field_list[id_index+1]),
		num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {SET, },
		kw_types[] = {SHELL, };
 
   switch(sid_type)
   {
      case 1:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 2:
         {
            kw_types[0] = PARTC;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }
}
 
void sbPretenFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   int              pr_type = 0;
   vector<Card *> & cards_list = imp_obj->getCardList();
   Card             *card = cards_list[0];
   vector<Data *> & var_values = card->getVarValues();
   Data             *data = var_values[1];

   data->value(&pr_type);

   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {ELEMENT, },
		kw_types[] = {SBRETRACTOR, };
 
   switch(pr_type)
   {
      case 1:
      case 4:
      case 5:
      case 6:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 2:
      case 3:
         {
            kw_types[0] = DISCRETE;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }

   if( num_fields > 2 )
   {
      man_types[0] = DEFINE;
      kw_types[0] = CURVE;
      field_indices[0] = id_index + 2;
      addIDToRefFile(field_list, num_indices, field_indices,
						  man_types, kw_types, imp_obj);
   }
}
 
void sbRetractorFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   int sbr_nid = atoi(field_list[id_index]);
   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {SET, },
		kw_types[] = {NOD, };
 
   if( sbr_nid < 0 )
   {
      addIDToRefFile(field_list, num_indices, field_indices,
						  man_types, kw_types, imp_obj);
      man_types[0] = SET;
      kw_types[0] = SHELL;
      field_indices[0] = 1;
      addIDToRefFile(field_list, num_indices, field_indices,
						  man_types, kw_types, imp_obj);
   }
   else
   {
      man_types[0] = NOD;
      kw_types[0] = 9999;
      addIDToRefFile(field_list, num_indices, field_indices,
						  man_types, kw_types, imp_obj);
      man_types[0] = ELEMENT;
      kw_types[0] = SBELEMENT;
      field_indices[0] = 1;
      addIDToRefFile(field_list, num_indices, field_indices,
						  man_types, kw_types, imp_obj);
   }

   man_types[0] = ELEMENT;
   kw_types[0] = SBSENSOR;
   for(unsigned int i = 3; i < 7; i++)
   {
      field_indices[0] = i;
      addIDToRefFile(field_list, num_indices, field_indices,
					       man_types, kw_types, imp_obj);
   }
}
 
void sbSlipringFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   int sbr_nid = atoi(field_list[id_index]);
   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {SET, },
		kw_types[] = {NOD, };
 
   if( sbr_nid < 0 )
   {
      addIDToRefFile(field_list, num_indices, field_indices,
						  man_types, kw_types, imp_obj);
      man_types[0] = SET;
      kw_types[0] = SHELL;
      field_indices[0] = 1;
      addIDToRefFile(field_list, num_indices, field_indices,
						  man_types, kw_types, imp_obj);

      field_indices[0] = 2;
      addIDToRefFile(field_list, num_indices, field_indices,
						  man_types, kw_types, imp_obj);
   }
   else
   {
      man_types[0] = NOD;
      kw_types[0] = 9999;
      addIDToRefFile(field_list, num_indices, field_indices,
						  man_types, kw_types, imp_obj);
      man_types[0] = ELEMENT;
      kw_types[0] = SBELEMENT;
      field_indices[0] = 1;
      addIDToRefFile(field_list, num_indices, field_indices,
						  man_types, kw_types, imp_obj);

      field_indices[0] = 2;
      addIDToRefFile(field_list, num_indices, field_indices,
						  man_types, kw_types, imp_obj);
   }
}
 
void elementMassFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int kw_type = imp_obj->getKeywordType();

   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {NOD, },
		kw_types[] = {9999, };
 
   switch(kw_type)
   {
      case ELEMENT_MASS:
         addIDToRefFile(field_list, num_indices, field_indices,
						  man_types, kw_types, imp_obj);
         break;
      case ELEMENT_MASS_NODE_SET:
	 man_types[0] = SET;
	 kw_types[0] = NOD;
         addIDToRefFile(field_list, num_indices, field_indices,
						  man_types, kw_types, imp_obj);
         break;
      case ELEMENT_MASS_PART:
	 man_types[0] = PARTC;
	 kw_types[0] = 9999;
         addIDToRefFile(field_list, num_indices, field_indices,
						  man_types, kw_types, imp_obj);
         break;
      case ELEMENT_MASS_PART_SET:
	 man_types[0] = SET;
	 kw_types[0] = PARTC;
         addIDToRefFile(field_list, num_indices, field_indices,
						  man_types, kw_types, imp_obj);
         break;
   }

   if( num_fields > 3 )
   {
      man_types[0] = PARTC;
      kw_types[0] = 9999;
      field_indices[0] = 3;
      addIDToRefFile(field_list, num_indices, field_indices,
						     man_types, kw_types, imp_obj);
   }
}
 
void initialGasFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int sid_type = atoi(field_list[id_index+1]),
		num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {SET, },
		kw_types[] = {PARTC, };
 
   switch(sid_type)
   {
      case 0:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types, 
						kw_types, imp_obj);
         }
         break;
      case 1:
         {
            man_types[0] = PARTC;
            kw_types[0] = 9999;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }

   man_types[0] = ALE;
   kw_types[0] = MMG;
   field_indices[0] = id_index + 2;
   addIDToRefFile(field_list, num_indices, field_indices, man_types, kw_types, imp_obj);
}

void initialTempFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   int kw_type = imp_obj->getKeywordType();

   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {NOD, },
		kw_types[] = {9999, };
 
   switch(kw_type)
   {
      case INITIAL_TEMPERATURE_NODE:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types, 
						kw_types, imp_obj);
         }
         break;
      case INITIAL_TEMPERATURE_SET:
         {
            man_types[0] = SET;
            kw_types[0] = NOD;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }
}

void initialShellFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   int kw_type = imp_obj->getKeywordType();

   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {ELEMENT, },
		kw_types[] = {SHELL, };
 
   switch(kw_type)
   {
      case INITIAL_STRESS_SHELL:
      case LOAD_THERMAL_VARIABLE_SHELL:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types, 
						kw_types, imp_obj);
         }
         break;
      case INITIAL_STRESS_SHELL_SET:
      case LOAD_THERMAL_VARIABLE_SHELL_SET:
         {
            man_types[0] = SET;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }
}

void initialVelGenFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int sid_type = atoi(field_list[id_index+1]),
		num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {SET, },
		kw_types[] = {PARTC, };

   switch(sid_type)
   {
      case 1:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 2:
         {
            man_types[0] = PARTC;
            kw_types[0] = 9999;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 3:
         {
            kw_types[0] = NOD;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }
}

void initialVelocityFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {SET, },
		kw_types[] = {NOD, }, i;

   for(i = 0; i < 4; i++)
   {
      field_indices[0] = id_index + i;
      switch(i)
      {
	 case 0:
	 case 1:
	    {
	       addIDToRefFile(field_list, num_indices, field_indices, 
                                           man_types, kw_types, imp_obj);
	    }
	    break;
	 case 2:
	    {
               man_types[0] = DEFINE;
	       kw_types[0] = BOX;
	       addIDToRefFile(field_list, num_indices, field_indices, 
                                           man_types, kw_types, imp_obj);
	    }
	    break;
	 case 3:
	    {
               int irigid = atoi(field_list[id_index + 3]);
               if( irigid >= 1 )
               {
		  man_types[0] = SET;
		  kw_types[0] = PARTC;
	          addIDToRefFile(field_list, num_indices, field_indices, 
                                           man_types, kw_types, imp_obj);
               }
	    }
	    break;
      }
   }
}

void initialPartFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int kw_type = imp_obj->getKeywordType(),
                num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {PARTC, },
		kw_types[] = {9999, };

   switch(kw_type)
   {
      case INITIAL_VOID_PART:
      case LOAD_SURFACE_STRESS:
      case SET_2D_SEGMENT:
      case TERMINATION_DELETED_SHELLS:
	 {
	    addIDToRefFile(field_list, num_indices, field_indices, 
					man_types, kw_types, imp_obj);
	 }
	 break;
   }

   switch(kw_type)
   {
      case INITIAL_VOID_SET:
      case LOAD_SURFACE_STRESS_SET:
      case SET_2D_SEGMENT_SET:
      case TERMINATION_DELETED_SHELLS_SET:
	 {
	    man_types[0] = SET;
	    kw_types[0] = PARTC;
	    addIDToRefFile(field_list, num_indices, field_indices, 
					man_types, kw_types, imp_obj);
	 }
	 break;
   }
}

void interfaceNodeFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int kw_type = imp_obj->getKeywordType(),
                num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {SET, },
		kw_types[] = {NOD, };

   switch(kw_type)
   {
      case INTERFACE_COMPONENT_NODE:
	 {
	    addIDToRefFile(field_list, num_indices, field_indices, 
					man_types, kw_types, imp_obj);
	 }
	 break;
      case INTERFACE_COMPONENT_SEGMENT:
	 {
	    kw_types[0] = SEGMENT;
	    addIDToRefFile(field_list, num_indices, field_indices, 
					man_types, kw_types, imp_obj);
	 }
	 break;
   }
}

void interfaceLinkFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int kw_type = imp_obj->getKeywordType(),
                num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {NOD, },
		kw_types[] = {9999, };

   switch(kw_type)
   {
      case INTERFACE_LINKING_DISCRETE_NODE_NODE:
	 {
	    addIDToRefFile(field_list, num_indices, field_indices, 
					man_types, kw_types, imp_obj);
	 }
	 break;
      case INTERFACE_LINKING_DISCRETE_NODE_SET:
	 {
	    man_types[0] = SET;
	    kw_types[0] = NOD;
	    addIDToRefFile(field_list, num_indices, field_indices, 
					man_types, kw_types, imp_obj);
	 }
	 break;
   }

   field_indices[0] = id_index + 1;
   man_types[0] = INTERFACE;
   kw_types[0] = 9999;
   addIDToRefFile(field_list, num_indices, field_indices, 
			       man_types, kw_types, imp_obj);
}

void loadBeamFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int kw_type = imp_obj->getKeywordType(),
                num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {ELEMENT, },
		kw_types[] = {BEAM, };

   switch(kw_type)
   {
      case LOAD_BEAM_ELEMENT:
	 {
	    addIDToRefFile(field_list, num_indices, field_indices, 
					man_types, kw_types, imp_obj);
	 }
	 break;
      case LOAD_BEAM_SET:
	 {
	    man_types[0] = SET;
	    kw_types[0] = BEAM;
	    addIDToRefFile(field_list, num_indices, field_indices, 
					man_types, kw_types, imp_obj);
	 }
	 break;
   }
}

void loadHeatGenFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int kw_type = imp_obj->getKeywordType(),
                num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {ELEMENT, },
		kw_types[] = {SOLID, }, i;

   switch(kw_type)
   {
      case LOAD_HEAT_GENERATION_SOLID:
	 {
	    addIDToRefFile(field_list, num_indices, field_indices, 
					man_types, kw_types, imp_obj);
	 }
	 break;
      case LOAD_HEAT_GENERATION_SET:
	 {
	    man_types[0] = SET;
	    kw_types[0] = SOLID;
	    addIDToRefFile(field_list, num_indices, field_indices, 
					man_types, kw_types, imp_obj);
	 }
	 break;
   }

   man_types[0] = DEFINE;
   kw_types[0] = CURVE;
   field_indices[0] = id_index + 1;
   addIDToRefFile(field_list, num_indices, field_indices, 
			       man_types, kw_types, imp_obj);

   for(i = 3; i < 6; i++)
   {
      field_indices[0] = id_index + i;
      addIDToRefFile(field_list, num_indices, field_indices, 
				               man_types, kw_types, imp_obj);
   }
}

void loadMovingPressureFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int sid_type = atoi(field_list[id_index+1]),
		num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {SET, },
		kw_types[] = {SEGMENT, };

   switch(sid_type)
   {
      case 0:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types, 
						kw_types, imp_obj);
         }
         break;
      case 1:
         {
            man_types[0] = SET;
            kw_types[0] = SHELL;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 2:
         {
            man_types[0] = SET;
            kw_types[0] = PARTC;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
      case 3:
         {
            man_types[0] = PARTC;
            kw_types[0] = 9999;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }
}

void loadShellFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   int kw_type = imp_obj->getKeywordType();
   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {ELEMENT, },
		kw_types[] = {SHELL, };
 
   switch(kw_type)
   {
      case LOAD_SHELL_ELEMENT:
      case LOAD_SHELL_ELEMENT_ID:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types, 
						kw_types, imp_obj);
         }
         break;
      case LOAD_SHELL_SET_ID:
      case LOAD_SHELL_SET:
         {
            man_types[0] = SET;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }

   man_types[0] = DEFINE;
   kw_types[0] = CURVE;
   field_indices[0] = id_index + 1;
   addIDToRefFile(field_list, num_indices, field_indices, man_types, kw_types, imp_obj);
}

void loadNodeFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   int kw_type = imp_obj->getKeywordType(), dof = atoi(field_list[id_index+1]);
   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {NOD, },
		kw_types[] = {9999, }, i;
 
   switch(kw_type)
   {
      case LOAD_NODE_POINT:
         {
            addIDToRefFile(field_list, num_indices, field_indices, man_types, 
						kw_types, imp_obj);
         }
         break;
      case LOAD_NODE_SET:
         {
            man_types[0] = SET;
            kw_types[0] = NOD;
            addIDToRefFile(field_list, num_indices, field_indices, man_types,
						kw_types, imp_obj);
         }
         break;
   }

   man_types[0] = DEFINE;
   kw_types[0] = CURVE;
   field_indices[0] = id_index + 2;
   addIDToRefFile(field_list, num_indices, field_indices, man_types, kw_types, imp_obj);

   if( num_fields > 4 )
   {
      man_types[0] = DEFINE;
      kw_types[0] = COORDINATE;
      field_indices[0] = id_index + 4;
      addIDToRefFile(field_list, num_indices, field_indices, 
                                  man_types, kw_types, imp_obj);
   }

   if( dof == 4 || dof == 8 )
   {
      if( num_fields <= 5 )
      {
         cout << "ERROR: Nodes M1, M2, M3 must be defined for *LOAD_NODE" 
              << endl;
         return;
      }
      else if( num_fields > 7 )
      {
	 man_types[0] = NOD;
	 kw_types[0] = 9999;
         for(i = 5; i < 8; i++)
         {
	    field_indices[0] = id_index + i;
	    addIDToRefFile(field_list, num_indices, field_indices, 
				     man_types, kw_types, imp_obj);
         }
      }
   }
}

void sectionIntegrationFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   int kw_type = imp_obj->getKeywordType(), irid = atoi(field_list[id_index]);

   unsigned int num_indices = 1,
		field_indices[] = {id_index, },
		man_types[] = {INTEGRATION, },
		kw_types[] = {BEAM, };

   if( irid < 0 )
   {
      switch(kw_type)
      {
	 case SECTION_BEAM:
	    {
	       addIDToRefFile(field_list, num_indices, field_indices, 
                                           man_types, kw_types, imp_obj);
	    }
	    break;
	 case SECTION_SHELL:
	 case SECTION_SHELL_ALE:
	 case SECTION_SHELL_EFG:
	    {
	       kw_types[0] = SHELL;
	       addIDToRefFile(field_list, num_indices, field_indices, 
                                           man_types, kw_types, imp_obj);
	    }
	    break;
      }
   }
}

void sensorElementFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int num_indices = 1,
		field_indices[] = {id_index+1, },
		man_types[] = {ELEMENT, },
		kw_types[] = {BEAM, };

   char *ftype = field_list[id_index];

   if( ftype[0] == 'B' )
   {
      addIDToRefFile(field_list, num_indices, field_indices, 
					man_types, kw_types, imp_obj);
   }
   else if( ftype[1] == 'H' )
   {
      kw_types[0] = SHELL;
      addIDToRefFile(field_list, num_indices, field_indices, 
				  man_types, kw_types, imp_obj);
   }
   else if( ftype[1] == 'O' )
   {
      kw_types[0] = SOLID;
      addIDToRefFile(field_list, num_indices, field_indices, 
				  man_types, kw_types, imp_obj);
   }
   else if( ftype[0] == 'D' )
   {
      kw_types[0] = DISCRETE;
      addIDToRefFile(field_list, num_indices, field_indices, 
				  man_types, kw_types, imp_obj);
   }
   else
      cout << "ERROR: <" << ftype << "> element should not be used in SENSOR"
           << endl;
}

void sensorControlFind
     (
        char **field_list,
        unsigned int & ,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int num_indices = 1,
		field_indices[] = {id_index+1, },
		man_types[] = {ELEMENT, },
		kw_types[] = {DISCRETE, };

   char *ftype = field_list[id_index];

   if( ftype[0] == 'D' )
   {
      addIDToRefFile(field_list, num_indices, field_indices, 
					man_types, kw_types, imp_obj);
   }
   else if( ftype[0] == 'A' )
   {
      man_types[0] = AIRBAG;
      kw_types[0] = 9999;
      addIDToRefFile(field_list, num_indices, field_indices, 
				  man_types, kw_types, imp_obj);
   }
   else if( ftype[0] == 'P' )
   {
      man_types[0] = BDRY;
      kw_types[0] = MOTION;
      addIDToRefFile(field_list, num_indices, field_indices, 
				  man_types, kw_types, imp_obj);
   }
   else if( ftype[0] == 'J' )
   {
      if( ftype[5] == 'S' )
      {
	 man_types[0] = CONST;
	 kw_types[0] = STIFFNESS;
	 addIDToRefFile(field_list, num_indices, field_indices, 
				     man_types, kw_types, imp_obj);
      }
      else
      {
	 man_types[0] = CONST;
	 kw_types[0] = JOINT;
	 addIDToRefFile(field_list, num_indices, field_indices, 
				  man_types, kw_types, imp_obj);
      }
   }
   else if( ftype[0] == 'C' )
   {
      man_types[0] = CONTACT;
      kw_types[0] = 9999;
      addIDToRefFile(field_list, num_indices, field_indices, 
				  man_types, kw_types, imp_obj);
   }
   else if( ftype[0] == 'R' )
   {
      man_types[0] = RIGIDWALL;
      kw_types[0] = 9999;
      addIDToRefFile(field_list, num_indices, field_indices, 
				  man_types, kw_types, imp_obj);
   }
   else if( ftype[0] == 'S' )
   {
      if( ftype[2] == 'O' )
      {
	 man_types[0] = CONST;
	 kw_types[0] = POINTS;
	 addIDToRefFile(field_list, num_indices, field_indices, 
				     man_types, kw_types, imp_obj);
      }
      else
      {
	 man_types[0] = BDRY;
	 kw_types[0] = SPC;
	 addIDToRefFile(field_list, num_indices, field_indices, 
				  man_types, kw_types, imp_obj);
      }
   }
   else if( ftype[0] == 'X' )
   {
      man_types[0] = DATABASE;
      kw_types[0] = CS;
      addIDToRefFile(field_list, num_indices, field_indices, 
				  man_types, kw_types, imp_obj);
   }
   else
      cout << "ERROR: <" << ftype << "> control should not be used in SENSOR"
           << endl;
}

void sensorForceFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   sensorControlFind(field_list, num_fields, id_index, imp_obj);

   unsigned int num_indices = 1, field_indices[] = {id_index+2, },
		man_types[] = {DEFINE, }, kw_types[] = {VECTOR, };

   int vid = atoi(field_list[id_index+2]);

   if( vid )
   {
      addIDToRefFile(field_list, num_indices, field_indices, 
				     man_types, kw_types, imp_obj);
   }

   field_indices[0] = id_index + 3;
   man_types[0] = DEFINE;
   kw_types[0] = COORDINATE;
   addIDToRefFile(field_list, num_indices, field_indices, man_types, kw_types, imp_obj);
}

void setNodeAddFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int sid_type = atoi(field_list[id_index+1]), 
           num_indices = 0, 
           field_indices[] = {id_index, id_index+2, id_index+4, id_index+6,},
           man_types[] = {SET, SET, SET, SET, }, 
           kw_types[] = {NOD, NOD, NOD, NOD, }, i;

   for(i = 1; i < num_fields; i += 2)
   {
      sid_type = atoi(field_list[i]);

      switch(sid_type)
      {
         case 1:
            kw_types[num_indices] = NOD;
            break;
         case 2:
            kw_types[num_indices] = SHELL;
            break;
         case 3:
            kw_types[num_indices] = BEAM;
            break;
         case 4:
            kw_types[num_indices] = SOLID;
            break;
         case 5:
            kw_types[num_indices] = SEGMENT;
            break;
         case 6:
            kw_types[num_indices] = DISCRETE;
            break;
         case 7:
            kw_types[num_indices] = TSHELL;
            break;
      }

      num_indices++;
   }

   addIDToRefFile(field_list, num_indices, field_indices, man_types, kw_types, imp_obj);
}

void setGenFind
     (
        char **field_list,
        unsigned int & num_fields,
        unsigned int id_index,
        ImportObject *imp_obj
     )
{
   unsigned int num_indices = 0, 
            field_indices[] = {id_index, 2, 3, 4, 5, 6, 7,},
            man_types[] = {NOD, NOD, NOD, NOD, NOD, NOD, NOD,}, 
            kw_types[] = {9999, 9999, 9999, 9999, 9999, 9999, 9999, }, i;

   char *opt = field_list[0];

   if( opt[0] == 'N' || opt[1] == 'N' )
   {
      man_types[0] = NOD;
      kw_types[0] = 9999;
   }
   else if( opt[0] == 'E' || opt[1] == 'E' )
   {
      unsigned int kw_type = imp_obj->getKeywordType();
      man_types[0] = ELEMENT;
      switch(kw_type)
      {
	 switch(kw_type)
	 {
	    case ELEMENT_SHELL:
	    case ELEMENT_SHELL_BETA:
	    case ELEMENT_SHELL_DOF:
	    case ELEMENT_SHELL_MCD:
	    case ELEMENT_SHELL_OFFSET:
	    case ELEMENT_SHELL_SOURCE_SINK:
	    case ELEMENT_SHELL_THICKNESS:
	       {
                  kw_types[0] = SHELL;
	       }
	       break;
	    case ELEMENT_BEAM:
	    case ELEMENT_BEAM_OFFSET:
	    case ELEMENT_BEAM_ORIENTATION:
	    case ELEMENT_BEAM_PID:
	    case ELEMENT_BEAM_SCALAR:
	    case ELEMENT_BEAM_SCALR:
	    case ELEMENT_BEAM_SECTION:
	    case ELEMENT_BEAM_THICKNESS:
	    case ELEMENT_BEAM_WARPAGE:
	       {
                  kw_types[0] = BEAM;
	       }
	       break;
	    case ELEMENT_SEATBELT:
	       {
                  kw_types[0] = SBELEMENT;
	       }
	       break;
	    case ELEMENT_SEATBELT_ACCELEROMETER:
	       {
                  kw_types[0] = SBACCEL;
	       }
	       break;
	    case ELEMENT_SEATBELT_PRETENSIONER:
	       {
                  kw_types[0] = SBPRETEN;
	       }
	       break;
	    case ELEMENT_SEATBELT_RETRACTOR:
	       {
                  kw_types[0] = SBRETRACTOR;
	       }
	       break;
	    case ELEMENT_SEATBELT_SENSOR:
	       {
                  kw_types[0] = SBSENSOR;
	       }
	       break;
	    case ELEMENT_SEATBELT_SLIPRING:
	       {
                  kw_types[0] = SBSLIPRING;
	       }
	       break;
	    case ELEMENT_SOLID:
	    case ELEMENT_SOLID_DOF:
	    case ELEMENT_SOLID_ORTHO:
	       {
                  kw_types[0] = SOLID;
	       }
	       break;
	    case ELEMENT_TSHELL:
	       {
                  kw_types[0] = TSHELL;
	       }
	       break;
	    case ELEMENT_DISCRETE:
	       {
                  kw_types[0] = DISCRETE;
	       }
	       break;
	    case ELEMENT_INERTIA:
	    case ELEMENT_INERTIA_OFFSET:
	       {
                  kw_types[0] = INERTIA;
	       }
	       break;
	    case ELEMENT_MASS:
	    case ELEMENT_MASS_NODE_SET:
	    case ELEMENT_MASS_PART:
	    case ELEMENT_MASS_PART_SET:
	       {
                  kw_types[0] = MASS;
	       }
	       break;
	    case ELEMENT_PLOTEL:
	    case ELEMENT_SPH:
	    case ELEMENT_TRIM:
	    case ELEMENT_DIRECT_MATRIX_INPUT:
	    default:
	       {
                  kw_types[0] = 9999;
	       }
	       break;
	 }
      }
   }
   else if( opt[0] == 'P' || opt[1] == 'P' )
   {
      man_types[0] = PARTC;
      kw_types[0] = 9999;
   }
   else if( opt[0] == 'B' || opt[1] == 'B' )
   {
      man_types[0] = DEFINE;
      kw_types[0] = BOX;
   }

   for(i = 1; i < num_fields; i++)
   {
      man_types[i] = man_types[0];
      kw_types[i] = kw_types[0];
      num_indices++;
   }

   addIDToRefFile(field_list, num_indices, field_indices, man_types, kw_types, imp_obj);
}

void saveShellElements
     (
        char **field_list,
        unsigned int &,
        unsigned int ,
        ImportObject *
     )
{
   if( FilePath::fileDes == -2 )
      return;

   static unsigned int old_pid = 0;
   unsigned int new_pid = atoi(field_list[1]), node_ids[8], 
                num_nodes = 4, i, j, node_offset = 0;
   if( FilePath::transPtr )
   {
      new_pid += FilePath::transPtr->idpoff;
      node_offset = FilePath::transPtr->idnoff;
   }

   for(i = 2, j = 0; i < 6; i++, j++)
      node_ids[j] = atoi(field_list[i]) + node_offset;

   if(field_list[6] && field_list[6][0] != '\0' && field_list[6][0] != '0'
     && field_list[7] && field_list[7][0] != '\0' && field_list[7][0] != '0')
   {
      for(; i < 8; i++, j++)
         node_ids[j] = atoi(field_list[i]) + node_offset;
      num_nodes = 6;
   }

   if( field_list[8] && field_list[8][0] != '\0' && field_list[8][0] != '0' 
      && field_list[9] && field_list[9][0] != '\0' && field_list[9][0] != '0')
   {
      for(; i < 10; i++, j++)
         node_ids[j] = atoi(field_list[i]) + node_offset;
      num_nodes = 8;
   }

   if( old_pid != new_pid )
   {
      FilePath::closeFile();
      char file_name[256];
      sprintf(file_name, "%s/shell%d_pid_%d.bin", FilePath::fPath,
                                                  num_nodes, new_pid);
      FilePath::openFile(file_name);
   }

   BufFileWrite(FilePath::bufPtr, (char *)node_ids, sizeof(int) * num_nodes);
//cout << "NUM NODES=" << num_nodes << endl;

   old_pid = new_pid;
}

void saveSolidElements
     (
        char **field_list,
        unsigned int &,
        unsigned int ,
        ImportObject *
     )
{
   if( FilePath::fileDes == -2 )
      return;

   unsigned int n1 = 0, node_offset = 0;
   FilePath::pID = atoi(field_list[1]);
   if( FilePath::transPtr )
   {
      FilePath::pID += FilePath::transPtr->idpoff;
      node_offset = FilePath::transPtr->idnoff;
   }

   if( field_list[2] )
      n1 = atoi(field_list[2]) + node_offset;
   else
      return;

   static unsigned int old_pid = 0;
   unsigned int node_ids[8];

   if( FilePath::pID != old_pid || FilePath::bufPtr == NULL)
   {
      //opening of element indices file
      FilePath::closeFile(); 
      char file_name[256];
      sprintf(file_name, "%s/solid8_pid_%d.bin", FilePath::fPath, 
                                                      FilePath::pID);
      FilePath::openFile(file_name); 
   }

   node_ids[0] = n1;
   for(int i = 3, j = 1; i < 10; i++, j++)
      node_ids[j] = atoi(field_list[i]) + node_offset;

   BufFileWrite(FilePath::bufPtr, (char *)node_ids, sizeof(int) * 8);

   old_pid = FilePath::pID;
}

void saveSolidElements971
     (
        char **field_list,
        unsigned int & ,
        unsigned int ,
        ImportObject *
     )
{
   if( FilePath::fileDes == -2 )
      return;

   static unsigned int old_pid = 0;
   unsigned int node_ids[10], num_nodes = 8, node_offset = 0;

   if( FilePath::transPtr )
      node_offset = FilePath::transPtr->idnoff;

   for(int i = 0, j = 0; i < 8; i++, j++)
      node_ids[j] = atoi(field_list[i]) + node_offset;

   if( field_list[8] )
   {
      node_ids[8] = atoi(field_list[8]) + node_offset;
      node_ids[9] = atoi(field_list[9]) + node_offset;
      num_nodes = 10;
   }

   if( FilePath::pID != old_pid || FilePath::bufPtr == NULL )
   {
      char file_name[256];
      FilePath::closeFile(); 
      if( num_nodes == 8 )
         sprintf(file_name, "%s/solid8_pid_%d.bin", 
                                          FilePath::fPath, FilePath::pID);
      else
         sprintf(file_name, "%s/solid10_pid_%d.bin", 
                                          FilePath::fPath, FilePath::pID);
      FilePath::openFile(file_name); 
   }

   BufFileWrite(FilePath::bufPtr, (char *)node_ids, sizeof(int) * num_nodes);

   old_pid = FilePath::pID;
}

void saveTShells
     (
        char **field_list,
        unsigned int &,
        unsigned int ,
        ImportObject *
     )
{
   if( FilePath::fileDes == -2 )
      return;

   static unsigned int old_pid = 0; 
   unsigned int new_pid = atoi(field_list[1]), node_ids[8], node_offset = 0;

   if( FilePath::transPtr )
   {
      new_pid += FilePath::transPtr->idpoff;
      node_offset = FilePath::transPtr->idnoff;
   }

   if( old_pid != new_pid  || FilePath::bufPtr == NULL)
   {
      FilePath::closeFile(); 
      char file_name[256];
      sprintf(file_name, "%s/tshell8_pid_%d.bin", FilePath::fPath, new_pid);
      FilePath::openFile(file_name); 
   }

   for(int i = 2, j = 0; i < 10; i++, j++)
      node_ids[j] = atoi(field_list[i]) + node_offset;

   BufFileWrite(FilePath::bufPtr, (char *)node_ids, sizeof(int) * 8);

   old_pid = new_pid;
}

void saveDiscretes
     (
        char **field_list,
        unsigned int &,
        unsigned int ,
        ImportObject *
     )
{
   if( FilePath::fileDes == -2 )
      return;

   static unsigned int old_pid = 0; 
   unsigned int new_pid = atoi(field_list[1]), node_ids[3], 
                                       node_offset = 0, vid_offset = 0;
   if( FilePath::transPtr )
   {
      new_pid += FilePath::transPtr->idpoff;
      node_offset = FilePath::transPtr->idnoff;
      vid_offset = FilePath::transPtr->iddoff;
   }

   if( old_pid != new_pid  || FilePath::bufPtr == NULL)
   {
      FilePath::closeFile(); 
      char file_name[256];
      sprintf(file_name, "%s/disc3_pid_%d.bin", FilePath::fPath, new_pid);
      FilePath::openFile(file_name); 
   }

   int i, j;
   for(i = 2, j = 0; i < 4; i++, j++)
   {
      node_ids[j] = atoi(field_list[i]) + node_offset;
//cout << node_ids[j] << " ";
   }
//cout << endl;
   if( field_list[i] )
   {
      node_ids[j] = atoi(field_list[i]); //VID
      if( node_ids[j] )
         node_ids[j] += vid_offset;
   }
   else
      node_ids[j] = 0;

   BufFileWrite(FilePath::bufPtr, (char *)node_ids, sizeof(int) * 3);

   old_pid = new_pid;
}

void saveBeams
     (
        char **field_list,
        unsigned int &,
        unsigned int ,
        ImportObject *
     )
{
   if( FilePath::fileDes == -2 )
      return;

   static unsigned int old_pid = 0; 
   unsigned int new_pid = atoi(field_list[1]), node_ids[3], node_offset = 0;
   if( FilePath::transPtr )
   {
      new_pid += FilePath::transPtr->idpoff;
      node_offset = FilePath::transPtr->idnoff;
   }

   if( old_pid != new_pid  || FilePath::bufPtr == NULL)
   {
      FilePath::closeFile(); 
      char file_name[256];
      sprintf(file_name, "%s/beam3_pid_%d.bin", FilePath::fPath, new_pid);
      FilePath::openFile(file_name); 
   }

   node_ids[0] = atoi(field_list[2]) + node_offset;
   if( field_list[3] )
   {
      int id = atoi(field_list[3]);
      if( id < 0 )
         node_ids[1] = id * -1;
      else
         node_ids[1] = id;
      node_ids[1] += node_offset;
   }
   else
      node_ids[1] = node_ids[0];

   if( field_list[4] )
      node_ids[2] = atoi(field_list[4]) + node_offset;
   else
      node_ids[2] = 0;

   BufFileWrite(FilePath::bufPtr, (char *)node_ids, sizeof(int) * 3);

   old_pid = new_pid;
}

void saveSBAccelerometers
     (
        char **field_list,
        unsigned int &,
        unsigned int ,
        ImportObject *
     )
{
   if( FilePath::fileDes == -2 )
      return;

   unsigned int node_ids[3], node_offset = 0;
   if( FilePath::transPtr )
      node_offset = FilePath::transPtr->idnoff;

   for(int i = 1, j = 0; i < 4; i++, j++)
      node_ids[j] = atoi(field_list[i]) + node_offset;

   if( FilePath::fileDes == -1 )
   {
      FilePath::closeFile();
      char file_name[256];
      sprintf(file_name, "%s/sbaccel3.bin", FilePath::fPath);
      FilePath::openFile(file_name);
   }

   BufFileWrite(FilePath::bufPtr, (char *)node_ids, sizeof(int) * 3);
}

void saveSeatbelts
     (
        char **field_list,
        unsigned int &,
        unsigned int ,
        ImportObject *
     )
{
   if( FilePath::fileDes == -2 )
      return;

   static unsigned int old_pid = 0;
   //here num_nodes = 3 because this includes the retractor id
   unsigned int new_pid = atoi(field_list[1]), node_ids[5], 
                                            num_nodes = 3, node_offset = 0;
   if( FilePath::transPtr )
   {
      new_pid += FilePath::transPtr->idpoff;
      node_offset = FilePath::transPtr->idnoff;
   }

   int i, j;
   for(i = 2, j = 0; i < 4; i++, j++)
      node_ids[j] = atoi(field_list[i]) + node_offset;
   node_ids[j] = atoi(field_list[i]); //this is SRBID

   if( field_list[6] && field_list[7] )
   {
      for(i = 6, j = 3; i < 8; i++, j++)
	 node_ids[j] = atoi(field_list[i]) + node_offset;
      num_nodes = 5;
   }

   if( old_pid != new_pid  || FilePath::bufPtr == NULL)
   {
      FilePath::closeFile(); 
      char file_name[256];
      switch(num_nodes)
      {
         case 2:
            sprintf(file_name, "%s/seatbelt3_pid_%d.bin", FilePath::fPath, new_pid);
         break;
         case 4:
            sprintf(file_name, "%s/seatbelt5_pid_%d.bin", FilePath::fPath, new_pid);
         break;
      }
      FilePath::openFile(file_name);
   }

   BufFileWrite(FilePath::bufPtr, (char *)node_ids, sizeof(int) * num_nodes);

   old_pid = new_pid;
}

void saveElementIDs(char **field_list, ImportObject *imp_obj)
{
   //unsigned int indices[4] = {elm_cidx, elm_id, pid};
   unsigned int indices[3] = {0, atoi(field_list[0]), atoi(field_list[1])};
   if( imp_obj->isFlagOn(IMPORT_DB) )
   {
      char **ptr = field_list - 2;
      indices[0] = atoi(ptr[0]); //card index for element
   }
   else if( imp_obj->isFlagOn(IMPORT_DYNA) )
      indices[0] = 0;

   if( FilePath::transPtr )
   {
      indices[1] += FilePath::transPtr->ideoff;
      indices[2] += FilePath::transPtr->idpoff;
   }

   BufFileWrite(FilePath::indexBufPtr, (char *)indices, sizeof(int)*3);
}

