#ifndef _TITLE_H_
#define _TITLE_H_

#include "importbase.h"

/** Class to store the data related to *_TITLE and *TITLE keywords
  */
class Title : public ImportBase
{
public:
   /** Constructor to create this object
     * \param data_line Object to access the file data
     * \param imp_obj Object to store the keyword data from database or file
     */
   Title(DataLine *data_line, ImportObject *imp_obj) : ImportBase(data_line, imp_obj)
   {
   }

   ~Title()
   {
   }

   /** Reads the data card related to *_TITLE and *TITLE */
   void readCard()
   {
      const char *fields[] = {"TITLE",};
      unsigned int field_types[] = {DATA_CHAR_ARRAY, };
      numFields = 1;
      unsigned int field_widths[] = {80, };
      strBuff = dataLine->readNextCard(numFields);
      if( !numFields )
         return;
      cardObj = new Card("TitleCard");
      cardObj->addFields(numFields, field_types, field_widths, fields, strBuff);
      impObj->addCard(cardObj);
   }
};

#endif

