#ifndef _TYPE_MAP_H_
#define _TYPE_MAP_H_

#include "card.h"
#include "dataline.h"
#include <map>

using namespace std;

typedef unsigned int (*ImportFunctionPtr)(DataLine *, ImportObject *);
typedef std::pair<unsigned int, ImportFunctionPtr> typeFuncPair;
typedef std::map<unsigned int, ImportFunctionPtr>::iterator typeFuncIterator;

/** struct for comparing two keyword names */
struct KeyWordCompare : std::binary_function<string, char *, bool>
{
public:
    /** overloaded function for comparision of keywords
      * \param keyword Keyword to compare
      * \param to_compare Keyword to be compared 
      * \return Returns true if matches else false
      */
    bool operator () (const string & keyword, const char *to_compare) const
    {
       if( strstr(keyword.data(), to_compare) ) 
	  return true;
       else
	  return false;
    }
};

#endif

