#include <iostream>
#include <algorithm>
#include "generic.h"
#include "hgtype.h"
#include "hgimport.h"
#include "hourglass.h"
#include "title.h"
#include <stdlib.h>

using namespace std;

HgImport::HgImport
(
   FILE          *fp,
   DataLoc       *data_loc,
   HgManager    *hg_man
)
{
   filePtr = fp;
   hgManPtr = hg_man;
   dataLocPtr = data_loc;
   dataLine = NULL;
}

unsigned int HgImport::readHgs()
{
   char         new_kw[LINE_LEN];
   unsigned int	i = 0, hg_type = 0, num_hgs = 0, title_flag = 0;
   long		loc = 0L;
   VStringIterator   s = dataLocPtr->keywordList.begin(),
		     e = dataLocPtr->keywordList.end(), itr, 
		     pitr = dataLocPtr->keywordList.begin();

   dataLine = new DataLine(filePtr);

   while(true)
   {
      itr = find_if(pitr, e, bind2nd(KeyWordCompare (), "*HOUR"));

      if( itr == e )
	 break;

      pitr = itr+1;
      i = (unsigned int)(itr - s);
      loc = dataLocPtr->slocList[i];

      rewind(filePtr);

      if( fseek(filePtr, loc, SEEK_SET) )
      {
	 cout << "ERROR in locating the Hg cards" << endl;
	 break;
      }

      dataLine->clearFlag(KW_READ_END);

      char *str = dataLine->readNextCard(); //get the keyword
      Generic::RemoveLeadingAndTrailingBlanks( str );
cout << "KW = " << str << endl;

      hg_type = HOURGLASS;
      num_hgs++;

      strcpy(new_kw, str);

      dataLine->clearFlag(KW_READ_END);

      title_flag = 0;
      if( strstr(new_kw, "_TITL") )
      {
         title_flag = 1;
         hg_type += TITLE_CARD;
      }

      impObj = new ImportObject(str, hg_type);
      while(!dataLine->isFlagOn(KW_READ_END))
      {
         if( title_flag )
         {
            Title title(dataLine, impObj);
            title.readCard();
         }

	 Hourglass hg(dataLine, impObj);
	 hg.importHourglass();
      }
      sprintf(new_kw, "%s_%d", new_kw, num_hgs);
      hgManPtr->add(new_kw, impObj);
   }

   return num_hgs;
}

