#ifndef _IncludeCompensationBlankAfterSpringback_h_
#define _IncludeCompensationBlankAfterSpringback_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *INCLUDE_COMPENSATION_BLANK_AFTER_SPRINGBACK keyword
  * from LSDYNA native file */

class IncludeCompensationBlankAfterSpringback : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   IncludeCompensationBlankAfterSpringback(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~IncludeCompensationBlankAfterSpringback()
   {
   }

public:
/** Function to import Card2 details for *INCLUDE_COMPENSATION_BLANK_AFTER_SPRINGBACK
  * keyword from file */
   void readCard2()
   {
      const char *fields[] = {"FILENAME",};
      unsigned int field_types[] = {DATA_CHAR_ARRAY, };
      numFields = 1;
      unsigned int field_widths[] = {80, };
      strBuff = dataLine->readNextCard(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card2");
         cardObj->addFields(numFields, field_types, field_widths, fields, strBuff);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *INCLUDE_COMPENSATION_BLANK_AFTER_SPRINGBACK
  * from LSDYNA native file */
   unsigned int importIncludeCompensationBlankAfterSpringback()
   {
      readCard2();
      return 0;
   }
};

#endif

