#include "initialstressbeam.hpp"
#include "initialstressdepth.hpp"
#include "initialstresssection.hpp"
#include "initialstressshell.hpp"
#include "initialstresssolid.hpp"
#include "initialstresstshell.hpp"
#include "typemap.h"
#include "initialimport.h"

void InitialImport::initStressTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(INITIAL_STRESS_BEAM, importInitialStressBeam) );
   typeFuncMap.insert( typeFuncPair(INITIAL_STRESS_DEPTH, importInitialStressDepth) );
   typeFuncMap.insert( typeFuncPair(INITIAL_STRESS_SECTION, importInitialStressSection) );
   typeFuncMap.insert( typeFuncPair(INITIAL_STRESS_SHELL, importInitialStressShell) );
   typeFuncMap.insert( typeFuncPair(INITIAL_STRESS_SHELL_SET, importInitialStressShell) );
   typeFuncMap.insert( typeFuncPair(INITIAL_STRESS_SOLID, importInitialStressSolid) );
   typeFuncMap.insert( typeFuncPair(INITIAL_STRESS_TSHELL, importInitialStressTshell) );
}
