#ifndef _InitialVoidPart_h_
#define _InitialVoidPart_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *INITIAL_VOID_PART keyword
  * from LSDYNA native file */

class InitialVoidPart : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   InitialVoidPart(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~InitialVoidPart()
   {
   }

public:
/** Function to import Card1 details for *INITIAL_VOID_PART
  * keyword from file */
   void readCard1()
   {
      const char *fields[] = {"PSID/PID",};
      unsigned int field_types[] = {DATA_INT, };
      numFields = 1;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         initialPartFind(wordArray, numFields, 0, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *INITIAL_VOID_PART
  * from LSDYNA native file */
   unsigned int importInitialVoidPart()
   {
      readCard1();
      return 0;
   }
};

#endif

