#ifndef _InterfaceCompensationNew_h_
#define _InterfaceCompensationNew_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *INTERFACE_COMPENSATION_NEW keyword
  * from LSDYNA native file */

class InterfaceCompensationNew : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   InterfaceCompensationNew(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~InterfaceCompensationNew()
   {
   }

public:
/** Function to import Card details for *INTERFACE_COMPENSATION_NEW
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"METHOD","SL","SF","ELREF","PSIDm","UNDCT",};
      unsigned int field_types[] = {DATA_INT, DATA_DOUBLE, DATA_DOUBLE, DATA_INT, DATA_DOUBLE, DATA_DOUBLE, };
      unsigned int field_indices[] = {4, };
      unsigned int man_types[] = {SET, };
      unsigned int kw_types[] = {PARTC, };
      unsigned int num_indices = 1;
      numFields = 6;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *INTERFACE_COMPENSATION_NEW
  * from LSDYNA native file */
   unsigned int importInterfaceCompensationNew()
   {
      readCard();
      return 0;
   }
};

#endif

