#ifndef _InterfaceLinkingDiscreteNodeNode_h_
#define _InterfaceLinkingDiscreteNodeNode_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *INTERFACE_LINKING_DISCRETE_NODE_NODE keyword
  * from LSDYNA native file */

class InterfaceLinkingDiscreteNodeNode : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   InterfaceLinkingDiscreteNodeNode(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~InterfaceLinkingDiscreteNodeNode()
   {
   }

public:
/** Function to import Card details for *INTERFACE_LINKING_DISCRETE_NODE_NODE
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"NID/NSID","IFID",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, };
      numFields = 2;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         interfaceLinkFind(wordArray, numFields, 0, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *INTERFACE_LINKING_DISCRETE_NODE_NODE
  * from LSDYNA native file */
   unsigned int importInterfaceLinkingDiscreteNodeNode()
   {
      readCard();
      return 0;
   }
};

#endif

