#ifndef _InterfaceSpringbackLsdynaThickness_h_
#define _InterfaceSpringbackLsdynaThickness_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *INTERFACE_SPRINGBACK_LSDYNA_THICKNESS keyword
  * from LSDYNA native file */

class InterfaceSpringbackLsdynaThickness : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   InterfaceSpringbackLsdynaThickness(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~InterfaceSpringbackLsdynaThickness()
   {
   }

public:
/** Function to import Card1 details for *INTERFACE_SPRINGBACK_LSDYNA_THICKNESS
  * keyword from file */
   void readCard1()
   {
      const char *fields[] = {"PSID","NSHV","FTYPE","FTENSR",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, DATA_INT, };
      unsigned int field_indices[] = {0, };
      unsigned int man_types[] = {SET, };
      unsigned int kw_types[] = {PARTC, };
      unsigned int num_indices = 1;
      numFields = 4;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import Card2 details for *INTERFACE_SPRINGBACK_LSDYNA_THICKNESS
  * keyword from file */
   void readCard2()
   {
      const char *fields[] = {"NID","TC","RC",};
      unsigned int field_types[] = {DATA_INT, DATA_DOUBLE, DATA_DOUBLE, };
      unsigned int field_indices[] = {0, };
      unsigned int man_types[] = {NOD, };
      unsigned int kw_types[] = {9999, };
      unsigned int num_indices = 1;
      numFields = 3;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card2");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *INTERFACE_SPRINGBACK_LSDYNA_THICKNESS
  * from LSDYNA native file */
   unsigned int importInterfaceSpringbackLsdynaThickness()
   {
      readCard1();
      readCard2();
      return 0;
   }
};

#endif

