#include "interfacecompensationnew.hpp"
#include "interfacecomponentnode.hpp"
#include "interfacejoy.hpp"
#include "interfacelinkingdiscretenodenode.hpp"
#include "interfacelinkingedge.hpp"
#include "interfacelinkingsegment.hpp"
#include "interfacespringbacklsdynathickness.hpp"
#include "typemap.h"
#include "interfaceimport.h"

void InterfaceImport::initInterfaceTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(INTERFACE_COMPENSATION_NEW, importInterfaceCompensationNew) );
   typeFuncMap.insert( typeFuncPair(INTERFACE_COMPONENT_NODE, importInterfaceComponentNode) );
   typeFuncMap.insert( typeFuncPair(INTERFACE_COMPONENT_SEGMENT, importInterfaceComponentNode) );
   typeFuncMap.insert( typeFuncPair(INTERFACE_JOY, importInterfaceJoy) );
   typeFuncMap.insert( typeFuncPair(INTERFACE_LINKING_DISCRETE_NODE_NODE, importInterfaceLinkingDiscreteNodeNode) );
   typeFuncMap.insert( typeFuncPair(INTERFACE_LINKING_DISCRETE_NODE_SET, importInterfaceLinkingDiscreteNodeNode) );
   typeFuncMap.insert( typeFuncPair(INTERFACE_LINKING_EDGE, importInterfaceLinkingEdge) );
   typeFuncMap.insert( typeFuncPair(INTERFACE_LINKING_SEGMENT, importInterfaceLinkingSegment) );
   typeFuncMap.insert( typeFuncPair(INTERFACE_SPRINGBACK_LSDYNA_NOTHICKNESS, importInterfaceSpringbackLsdynaThickness) );
   typeFuncMap.insert( typeFuncPair(INTERFACE_SPRINGBACK_LSDYNA_THICKNESS, importInterfaceSpringbackLsdynaThickness) );
   typeFuncMap.insert( typeFuncPair(INTERFACE_SPRINGBACK_NASTRAN_NOTHICKNESS, importInterfaceSpringbackLsdynaThickness) );
   typeFuncMap.insert( typeFuncPair(INTERFACE_SPRINGBACK_NASTRAN_THICKNESS, importInterfaceSpringbackLsdynaThickness) );
   typeFuncMap.insert( typeFuncPair(INTERFACE_SPRINGBACK_SEAMLESS_NOTHICKNESS, importInterfaceSpringbackLsdynaThickness) );
   typeFuncMap.insert( typeFuncPair(INTERFACE_SPRINGBACK_SEAMLESS_THICKNESS, importInterfaceSpringbackLsdynaThickness) );
}
