#ifndef _KeywordID_h_
#define _KeywordID_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *KEYWORD_ID keyword
  * from LSDYNA native file */

class KeywordID : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   KeywordID(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~KeywordID()
   {
   }

public:
/** Function to import Card1 details for *KEYWORD_ID
  * keyword from file */
   void readCard1()
   {
      const char *fields[] = {"PROJECT","NUM","STAGE",};
      unsigned int field_types[] = {DATA_CHAR_ARRAY, DATA_CHAR_ARRAY, DATA_CHAR_ARRAY, };
      numFields = 3;
      unsigned int field_widths[] = {20, 20, 40, };
      strBuff = dataLine->readNextCard(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, field_widths, fields, strBuff);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *KEYWORD_ID
  * from LSDYNA native file */
   unsigned int importKeywordID()
   {
      readCard1();
      return 0;
   }
};

#endif

