#include <iostream>
#include <algorithm>
#include "generic.h"
#include "keywordimport.h"
#include "keywordtype.h"
#include "title.h"
#include <stdlib.h>

using namespace std;

KeywordImport::KeywordImport
(
   FILE          *fp,
   DataLoc       *data_loc,
   ControlManager *ctrl_man
)
{
   filePtr = fp;
   controlManPtr = ctrl_man;
   dataLocPtr = data_loc;
   dataLine = NULL;

   initKeywordTypesAndFunctions();
}

int KeywordImport::getTypeFromKeyword
	(
	   const char *key_word
	)
{
   if( strstr(key_word, "_ID") )
      return KEYWORD_ID;
   else if( strstr(key_word, "KEY") )
      return KEYWORD;
   else if( strstr(key_word, "TITLE") )
      return TITLE_CARD;

   return KEYWORD_NEW_TYPE;
}

unsigned int KeywordImport::readKWAndTitle()
{
   char         new_kw[LINE_LEN];
   unsigned int	i = 0, kw_type = KEYWORD;
   long		loc = 0L;
   VStringIterator   s = dataLocPtr->keywordList.begin(),
		     e = dataLocPtr->keywordList.end(), itr, 
		     pitr = dataLocPtr->keywordList.begin();
   typeFuncIterator  btype_iter = typeFuncMap.begin(),
                     etype_iter = typeFuncMap.end(), type_iter;

   dataLine = new DataLine(filePtr);

   itr = find_if(pitr, e, bind2nd(KeyWordCompare (), "*KEY"));

   if( itr != e )
   {
      pitr = itr+1;
      i = (unsigned int)(itr - s);
      loc = dataLocPtr->slocList[i];
      rewind(filePtr);
      if( !fseek(filePtr, loc, SEEK_SET) )
      {
	 dataLine->clearFlag(KW_READ_END);
	 char *str = dataLine->readNextCard(); //get the keyword
	 Generic::RemoveLeadingAndTrailingBlanks( str );
      cout << "*KEYWORD = " << str << endl;
	 strcpy(new_kw, str);
	 dataLine->clearFlag(KW_READ_END);

	 if( strstr(new_kw, "_ID") )
	    kw_type = KEYWORD_ID;

	 type_iter = typeFuncMap.find(kw_type);
	 if( type_iter != etype_iter )
	 {
	    impObj = new ImportObject(str, kw_type);
	    (type_iter->second)(dataLine, impObj);
	    controlManPtr->add(new_kw, impObj);
	 }
      }
   }

   pitr = dataLocPtr->keywordList.begin();
   itr = find_if(pitr, e, bind2nd(KeyWordCompare (), "*TIT"));

   if( itr != e )
   {
      pitr = itr+1;
      i = (unsigned int)(itr - s);
      loc = dataLocPtr->slocList[i];
      rewind(filePtr);
      if( !fseek(filePtr, loc, SEEK_SET) )
      {
	 dataLine->clearFlag(KW_READ_END);
	 char *str = dataLine->readNextCard(); //get the keyword
	 Generic::RemoveLeadingAndTrailingBlanks( str );
      cout << "TITLE = " << str << endl;
	 strcpy(new_kw, str);
	 dataLine->clearFlag(KW_READ_END);

	 kw_type = TITLE_CARD;
	 impObj = new ImportObject(str, kw_type);
	 Title title(dataLine, impObj);
	 title.readCard();
	 controlManPtr->add(new_kw, impObj);
      }
   }

   return 1;
}

