#include "loadbodygeneralized.hpp"
#include "loadbodyparts.hpp"
#include "loadbodyporous.hpp"
#include "loadbodyx.hpp"
#include "loadgravitypart.hpp"
#include "loadremovepart.hpp"
#include "loadstiffenpart.hpp"
#include "typemap.h"
#include "loadimport.h"

void LoadImport::initBodyTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(LOAD_BODY_GENERALIZED, importLoadBodyGeneralized) );
   typeFuncMap.insert( typeFuncPair(LOAD_BODY_PARTS, importLoadBodyParts) );
   typeFuncMap.insert( typeFuncPair(LOAD_BODY_POROUS, importLoadBodyPorous) );
   typeFuncMap.insert( typeFuncPair(LOAD_BODY_RX, importLoadBodyX) );
   typeFuncMap.insert( typeFuncPair(LOAD_BODY_RY, importLoadBodyX) );
   typeFuncMap.insert( typeFuncPair(LOAD_BODY_RZ, importLoadBodyX) );
   typeFuncMap.insert( typeFuncPair(LOAD_BODY_X, importLoadBodyX) );
   typeFuncMap.insert( typeFuncPair(LOAD_BODY_Y, importLoadBodyX) );
   typeFuncMap.insert( typeFuncPair(LOAD_BODY_Z, importLoadBodyX) );
   typeFuncMap.insert( typeFuncPair(LOAD_GRAVITY_PART, importLoadGravityPart) );
   typeFuncMap.insert( typeFuncPair(LOAD_REMOVE_PART, importLoadRemovePart) );
   typeFuncMap.insert( typeFuncPair(LOAD_STIFFEN_PART, importLoadStiffenPart) );
}
