#ifndef _LoadBodyPorous_h_
#define _LoadBodyPorous_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *LOAD_BODY_POROUS keyword
  * from LSDYNA native file */

class LoadBodyPorous : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   LoadBodyPorous(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~LoadBodyPorous()
   {
   }

public:
/** Function to import Card details for *LOAD_BODY_POROUS
  * keyword from file */
   void readCard()
   {
      const char *fields[] = {"SID","SIDTYP","AX","AY","AZ","BX","BY","BZ",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 8;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         airbagVentHoleFind(wordArray, numFields, 0, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *LOAD_BODY_POROUS
  * from LSDYNA native file */
   unsigned int importLoadBodyPorous()
   {
      readCard();
      return 0;
   }
};

#endif

