#include "loadbeamelement.hpp"
#include "loadheatgenerationset.hpp"
#include "loadmovingpressure.hpp"
#include "loadrigidbody.hpp"
#include "loadshellelement.hpp"
#include "loadsuperplasticforming.hpp"
#include "loadsurfacestress.hpp"
#include "typemap.h"
#include "loadimport.h"

void LoadImport::initElementTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(LOAD_BEAM_ELEMENT, importLoadBeamElement) );
   typeFuncMap.insert( typeFuncPair(LOAD_BEAM_SET, importLoadBeamElement) );
   typeFuncMap.insert( typeFuncPair(LOAD_HEAT_GENERATION_SET, importLoadHeatGenerationSet) );
   typeFuncMap.insert( typeFuncPair(LOAD_HEAT_GENERATION_SOLID, importLoadHeatGenerationSet) );
   typeFuncMap.insert( typeFuncPair(LOAD_MOVING_PRESSURE, importLoadMovingPressure) );
   typeFuncMap.insert( typeFuncPair(LOAD_RIGID_BODY, importLoadRigidBody) );
   typeFuncMap.insert( typeFuncPair(LOAD_SHELL_ELEMENT, importLoadShellElement) );
   typeFuncMap.insert( typeFuncPair(LOAD_SHELL_ELEMENT_ID, importLoadShellElement) );
   typeFuncMap.insert( typeFuncPair(LOAD_SHELL_SET, importLoadShellElement) );
   typeFuncMap.insert( typeFuncPair(LOAD_SHELL_SET_ID, importLoadShellElement) );
   typeFuncMap.insert( typeFuncPair(LOAD_SUPERPLASTIC_FORMING, importLoadSuperplasticForming) );
   typeFuncMap.insert( typeFuncPair(LOAD_SURFACE_STRESS, importLoadSurfaceStress) );
   typeFuncMap.insert( typeFuncPair(LOAD_SURFACE_STRESS_SET, importLoadSurfaceStress) );
}
