#ifndef _LoadShellElement_h_
#define _LoadShellElement_h_

#include "manager.h"
#include "dispexport.h"
#include "loadid.h"

/** This class is used for importing *LOAD_SHELL_ELEMENT keyword
  * from LSDYNA native file */

class LoadShellElement : public LoadID
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   LoadShellElement(DataLine *data_line, ImportObject *imp_obj) : LoadID (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~LoadShellElement()
   {
   }

public:
/** Function to import Card1 details for *LOAD_SHELL_ELEMENT
  * keyword from file */
   void readCard1()
   {
      const char *fields[] = {"EID/ESID","LCID","SF","AT",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 4;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         loadShellFind(wordArray, numFields, 0, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *LOAD_SHELL_ELEMENT
  * from LSDYNA native file */
   unsigned int importLoadShellElement()
   {
      importLoadID();
      readCard1();
      return 0;
   }
};

#endif

