#include "loadheatcontroller.hpp"
#include "loadmotionnode.hpp"
#include "loadnodepoint.hpp"
#include "loadsegment.hpp"
#include "loadsegmentnonuniform.hpp"
#include "loadsegmentset.hpp"
#include "loadsegmentsetnonuniform.hpp"
#include "typemap.h"
#include "loadimport.h"

void LoadImport::initSegmentTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(LOAD_HEAT_CONTROLLER, importLoadHeatController) );
   typeFuncMap.insert( typeFuncPair(LOAD_MOTION_NODE, importLoadMotionNode) );
   typeFuncMap.insert( typeFuncPair(LOAD_NODE_POINT, importLoadNodePoint) );
   typeFuncMap.insert( typeFuncPair(LOAD_NODE_SET, importLoadNodePoint) );
   typeFuncMap.insert( typeFuncPair(LOAD_SEGMENT, importLoadSegment) );
   typeFuncMap.insert( typeFuncPair(LOAD_SEGMENT_ID, importLoadSegment) );
   typeFuncMap.insert( typeFuncPair(LOAD_SEGMENT_NONUNIFORM, importLoadSegmentNonuniform) );
   typeFuncMap.insert( typeFuncPair(LOAD_SEGMENT_NONUNIFORM_ID, importLoadSegmentNonuniform) );
   typeFuncMap.insert( typeFuncPair(LOAD_SEGMENT_SET, importLoadSegmentSet) );
   typeFuncMap.insert( typeFuncPair(LOAD_SEGMENT_SET_ID, importLoadSegmentSet) );
   typeFuncMap.insert( typeFuncPair(LOAD_SEGMENT_SET_NONUNIFORM, importLoadSegmentSetNonuniform) );
   typeFuncMap.insert( typeFuncPair(LOAD_SEGMENT_SET_NONUNIFORM_ID, importLoadSegmentSetNonuniform) );
}
