#include "loadaleconvection.hpp"
#include "loadblast.hpp"
#include "loadbrode.hpp"
#include "loaddensitydepth.hpp"
#include "loadmask.hpp"
#include "loadssa.hpp"
#include "loadvolumeloss.hpp"
#include "typemap.h"
#include "loadimport.h"

void LoadImport::initSimpleTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(LOAD_ALE_CONVECTION, importLoadAleConvection) );
   typeFuncMap.insert( typeFuncPair(LOAD_ALE_CONVECTION_ID, importLoadAleConvection) );
   typeFuncMap.insert( typeFuncPair(LOAD_BLAST, importLoadBlast) );
   typeFuncMap.insert( typeFuncPair(LOAD_BRODE, importLoadBrode) );
   typeFuncMap.insert( typeFuncPair(LOAD_DENSITY_DEPTH, importLoadDensityDepth) );
   typeFuncMap.insert( typeFuncPair(LOAD_MASK, importLoadMask) );
   typeFuncMap.insert( typeFuncPair(LOAD_SSA, importLoadSsa) );
   typeFuncMap.insert( typeFuncPair(LOAD_VOLUME_LOSS, importLoadVolumeLoss) );
}
