#include "loadthermalconstant.hpp"
#include "loadthermalconstantnode.hpp"
#include "loadthermalloadcurve.hpp"
#include "nocards.hpp"
#include "loadthermalvariable.hpp"
#include "loadthermalvariablenode.hpp"
#include "loadthermalvariableshell.hpp"
#include "typemap.h"
#include "loadimport.h"

void LoadImport::initThermalTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(LOAD_THERMAL_CONSTANT, importLoadThermalConstant) );
   typeFuncMap.insert( typeFuncPair(LOAD_THERMAL_CONSTANT_NODE, importLoadThermalConstantNode) );
   typeFuncMap.insert( typeFuncPair(LOAD_THERMAL_LOAD_CURVE, importLoadThermalLoadCurve) );
   typeFuncMap.insert( typeFuncPair(LOAD_THERMAL_TOPAZ, importNoCards) );
   typeFuncMap.insert( typeFuncPair(LOAD_THERMAL_VARIABLE, importLoadThermalVariable) );
   typeFuncMap.insert( typeFuncPair(LOAD_THERMAL_VARIABLE_NODE, importLoadThermalVariableNode) );
   typeFuncMap.insert( typeFuncPair(LOAD_THERMAL_VARIABLE_SHELL, importLoadThermalVariableShell) );
   typeFuncMap.insert( typeFuncPair(LOAD_THERMAL_VARIABLE_SHELL_SET, importLoadThermalVariableShell) );
}
