#include "matalegasmixture.hpp"
#include "matalevacuum.hpp"
#include "mataleviscous.hpp"
#include "matjohnsonholmquistceramics.hpp"
#include "matjohnsonholmquistconcrete.hpp"
#include "matjointedrock.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initAleTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_ALE_GAS_MIXTURE, importMatAleGasMixture) );
   typeFuncMap.insert( typeFuncPair(MAT_ALE_VACUUM, importMatAleVacuum) );
   typeFuncMap.insert( typeFuncPair(MAT_ALE_VISCOUS, importMatAleViscous) );
   typeFuncMap.insert( typeFuncPair(MAT_JOHNSON_HOLMQUIST_CERAMICS, importMatJohnsonHolmquistCeramics) );
   typeFuncMap.insert( typeFuncPair(MAT_JOHNSON_HOLMQUIST_CONCRETE, importMatJohnsonHolmquistConcrete) );
   typeFuncMap.insert( typeFuncPair(MAT_JOINTED_ROCK, importMatJointedRock) );
}
