#include "matfldtransverselyanisotropic.hpp"
#include "matisotropicelasticfailure.hpp"
#include "matisotropicelasticplastic.hpp"
#include "matresultantanisotropic.hpp"
#include "mattransverselyanisotropicelasticplastic.hpp"
#include "mattransverselyanisotropicelasticplasticechange.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initAnisotropicTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_FLD_TRANSVERSELY_ANISOTROPIC, importMatFldTransverselyAnisotropic) );
   typeFuncMap.insert( typeFuncPair(MAT_ISOTROPIC_ELASTIC_FAILURE, importMatIsotropicElasticFailure) );
   typeFuncMap.insert( typeFuncPair(MAT_ISOTROPIC_ELASTIC_PLASTIC, importMatIsotropicElasticPlastic) );
   typeFuncMap.insert( typeFuncPair(MAT_RESULTANT_ANISOTROPIC, importMatResultantAnisotropic) );
   typeFuncMap.insert( typeFuncPair(MAT_TRANSVERSELY_ANISOTROPIC_ELASTIC_PLASTIC, importMatTransverselyAnisotropicElasticPlastic) );
   typeFuncMap.insert( typeFuncPair(MAT_TRANSVERSELY_ANISOTROPIC_ELASTIC_PLASTIC_ECHANGE, importMatTransverselyAnisotropicElasticPlasticEchange) );
}
