#ifndef _MatTransverselyAnisotropicElasticPlasticEchange_h_
#define _MatTransverselyAnisotropicElasticPlasticEchange_h_

#include "manager.h"
#include "dispexport.h"
#include "mattransverselyanisotropicelasticplastic.h"

/** This class is used for importing *MAT_TRANSVERSELY_ANISOTROPIC_ELASTIC_PLASTIC_ECHANGE keyword
  * from LSDYNA native file */

class MatTransverselyAnisotropicElasticPlasticEchange : public MatTransverselyAnisotropicElasticPlastic
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   MatTransverselyAnisotropicElasticPlasticEchange(DataLine *data_line, ImportObject *imp_obj) : MatTransverselyAnisotropicElasticPlastic (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~MatTransverselyAnisotropicElasticPlasticEchange()
   {
   }

public:
/** Function to import CardExchange details for *MAT_TRANSVERSELY_ANISOTROPIC_ELASTIC_PLASTIC_ECHANGE
  * keyword from file */
   void readCardExchange()
   {
      const char *fields[] = {"IDSCALE","EA","COE",};
      unsigned int field_types[] = {DATA_INT, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 3;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("CardExchange");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *MAT_TRANSVERSELY_ANISOTROPIC_ELASTIC_PLASTIC_ECHANGE
  * from LSDYNA native file */
   unsigned int importMatTransverselyAnisotropicElasticPlasticEchange()
   {
      importMatTransverselyAnisotropicElasticPlastic();
      readCardExchange();
      return 0;
   }
};

#endif

