#include "matbamman.hpp"
#include "matbammandamage.hpp"
#include "matlaminatedglass.hpp"
#include "matpowerlawplasticity.hpp"
#include "matratesensitivepowerlawplasticity.hpp"
#include "matresultantplasticity.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initBammanTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_BAMMAN, importMatBamman) );
   typeFuncMap.insert( typeFuncPair(MAT_BAMMAN_DAMAGE, importMatBammanDamage) );
   typeFuncMap.insert( typeFuncPair(MAT_LAMINATED_GLASS, importMatLaminatedGlass) );
   typeFuncMap.insert( typeFuncPair(MAT_POWER_LAW_PLASTICITY, importMatPowerLawPlasticity) );
   typeFuncMap.insert( typeFuncPair(MAT_RATE_SENSITIVE_POWERLAW_PLASTICITY, importMatRateSensitivePowerlawPlasticity) );
   typeFuncMap.insert( typeFuncPair(MAT_RESULTANT_PLASTICITY, importMatResultantPlasticity) );
}
