#include "mat3parameterbarlat.hpp"
#include "matbarlatanisotropicplasticity.hpp"
#include "matbarlatyld2000.hpp"
#include "matbarlatyld96.hpp"
#include "matfld3parameterbarlat.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initBarlatTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_3_PARAMETER_BARLAT, importMat3ParameterBarlat) );
   typeFuncMap.insert( typeFuncPair(MAT_BARLAT_ANISOTROPIC_PLASTICITY, importMatBarlatAnisotropicPlasticity) );
   typeFuncMap.insert( typeFuncPair(MAT_BARLAT_YLD2000, importMatBarlatYld2000) );
   typeFuncMap.insert( typeFuncPair(MAT_BARLAT_YLD96, importMatBarlatYld96) );
   typeFuncMap.insert( typeFuncPair(MAT_FLD_3_PARAMETER_BARLAT, importMatFld3ParameterBarlat) );
}
