#include "matadderosion.hpp"
#include "mataddthermalexpansion.hpp"
#include "matbilkhuduboisfoam.hpp"
#include "matblatzkofoam.hpp"
#include "matblatzkorubber.hpp"
#include "matbrittledamage.hpp"
#include "matforcelimited.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initBlatzTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_ADD_EROSION, importMatAddErosion) );
   typeFuncMap.insert( typeFuncPair(MAT_ADD_THERMAL_EXPANSION, importMatAddThermalExpansion) );
   typeFuncMap.insert( typeFuncPair(MAT_BILKHU_DUBOIS_FOAM, importMatBilkhuDuboisFoam) );
   typeFuncMap.insert( typeFuncPair(MAT_BLATZ_KO_FOAM, importMatBlatzKoFoam) );
   typeFuncMap.insert( typeFuncPair(MAT_BLATZ_KO_RUBBER, importMatBlatzKoRubber) );
   typeFuncMap.insert( typeFuncPair(MAT_BRITTLE_DAMAGE, importMatBrittleDamage) );
   typeFuncMap.insert( typeFuncPair(MAT_FORCE_LIMITED, importMatForceLimited) );
}
