#include "matcompositedirect.hpp"
#include "matcompositelayup.hpp"
#include "matcompositematrix.hpp"
#include "matcompositemsc.hpp"
#include "matcompositemscdmg.hpp"
#include "matdeshpandefleckfoam.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initCompoTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_COMPOSITE_DIRECT, importMatCompositeDirect) );
   typeFuncMap.insert( typeFuncPair(MAT_COMPOSITE_LAYUP, importMatCompositeLayup) );
   typeFuncMap.insert( typeFuncPair(MAT_COMPOSITE_MATRIX, importMatCompositeMatrix) );
   typeFuncMap.insert( typeFuncPair(MAT_COMPOSITE_MSC, importMatCompositeMsc) );
   typeFuncMap.insert( typeFuncPair(MAT_COMPOSITE_MSC_DMG, importMatCompositeMscDmg) );
   typeFuncMap.insert( typeFuncPair(MAT_DESHPANDE_FLECK_FOAM, importMatDeshpandeFleckFoam) );
}
