#ifndef _MatCompositeMscDmg_h_
#define _MatCompositeMscDmg_h_

#include "manager.h"
#include "dispexport.h"
#include "matcompositemsc.h"

/** This class is used for importing *MAT_COMPOSITE_MSC_DMG keyword
  * from LSDYNA native file */

class MatCompositeMscDmg : public MatCompositeMsc
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   MatCompositeMscDmg(DataLine *data_line, ImportObject *imp_obj) : MatCompositeMsc (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~MatCompositeMscDmg()
   {
   }

public:
/** Function to import Card8 details for *MAT_COMPOSITE_MSC_DMG
  * keyword from file */
   void readCard8()
   {
      const char *fields[] = {"AM2","AM3","AM4","CERATE2","CERATE3","CERATE4",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 6;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card8");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *MAT_COMPOSITE_MSC_DMG
  * from LSDYNA native file */
   unsigned int importMatCompositeMscDmg()
   {
      importMatCompositeMsc();
      readCard8();
      return 0;
   }
};

#endif

