#include "matgeneraljointdiscretebeam.hpp"
#include "mathydraulicgasdamperdiscretebeam.hpp"
#include "matlinearelasticdiscretebeam.hpp"
#include "matnonlinearelasticdiscretebeam.hpp"
#include "matnonlinearplasticdiscretebeam.hpp"
#include "matsiddamperdiscretebeam.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initDiscreteTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_GENERAL_JOINT_DISCRETE_BEAM, importMatGeneralJointDiscreteBeam) );
   typeFuncMap.insert( typeFuncPair(MAT_HYDRAULIC_GAS_DAMPER_DISCRETE_BEAM, importMatHydraulicGasDamperDiscreteBeam) );
   typeFuncMap.insert( typeFuncPair(MAT_LINEAR_ELASTIC_DISCRETE_BEAM, importMatLinearElasticDiscreteBeam) );
   typeFuncMap.insert( typeFuncPair(MAT_NONLINEAR_ELASTIC_DISCRETE_BEAM, importMatNonlinearElasticDiscreteBeam) );
   typeFuncMap.insert( typeFuncPair(MAT_NONLINEAR_PLASTIC_DISCRETE_BEAM, importMatNonlinearPlasticDiscreteBeam) );
   typeFuncMap.insert( typeFuncPair(MAT_SID_DAMPER_DISCRETE_BEAM, importMatSidDamperDiscreteBeam) );
}
