#include "mat1dofgeneralizedspring.hpp"
#include "matarupadhesive.hpp"
#include "matelastic6dofspringdiscretebeam.hpp"
#include "matgeneralnonlinear1dofdiscretebeam.hpp"
#include "matgeneralnonlinear6dofdiscretebeam.hpp"
#include "matinelastic6dofspringdiscretebeam.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initDofTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_1DOF_GENERALIZED_SPRING, importMat1dofGeneralizedSpring) );
   typeFuncMap.insert( typeFuncPair(MAT_ARUP_ADHESIVE, importMatArupAdhesive) );
   typeFuncMap.insert( typeFuncPair(MAT_ELASTIC_6DOF_SPRING_DISCRETE_BEAM, importMatElastic6dofSpringDiscreteBeam) );
   typeFuncMap.insert( typeFuncPair(MAT_GENERAL_NONLINEAR_1DOF_DISCRETE_BEAM, importMatGeneralNonlinear1dofDiscreteBeam) );
   typeFuncMap.insert( typeFuncPair(MAT_GENERAL_NONLINEAR_6DOF_DISCRETE_BEAM, importMatGeneralNonlinear6dofDiscreteBeam) );
   typeFuncMap.insert( typeFuncPair(MAT_INELASTIC_6DOF_SPRING_DISCRETE_BEAM, importMatInelastic6dofSpringDiscreteBeam) );
}
