#include "matelastic.hpp"
#include "matelasticfluid.hpp"
#include "matelasticplastichydro.hpp"
#include "matelasticplasticthermal.hpp"
#include "matelasticwithviscosity.hpp"
#include "matelasticwithviscositycurve.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initElasticTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_ELASTIC, importMatElastic) );
   typeFuncMap.insert( typeFuncPair(MAT_ELASTIC_FLUID, importMatElasticFluid) );
   typeFuncMap.insert( typeFuncPair(MAT_ELASTIC_PLASTIC_HYDRO, importMatElasticPlasticHydro) );
   typeFuncMap.insert( typeFuncPair(MAT_ELASTIC_PLASTIC_HYDRO_SPALL, importMatElasticPlasticHydro) );
   typeFuncMap.insert( typeFuncPair(MAT_ELASTIC_PLASTIC_THERMAL, importMatElasticPlasticThermal) );
   typeFuncMap.insert( typeFuncPair(MAT_ELASTIC_WITH_VISCOSITY, importMatElasticWithViscosity) );
   typeFuncMap.insert( typeFuncPair(MAT_ELASTIC_WITH_VISCOSITY_CURVE, importMatElasticWithViscosityCurve) );
}
