#ifndef _MatElasticFluid_h_
#define _MatElasticFluid_h_

#include "manager.h"
#include "dispexport.h"
#include "matelastic.h"

/** This class is used for importing *MAT_ELASTIC_FLUID keyword
  * from LSDYNA native file */

class MatElasticFluid : public MatElastic
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   MatElasticFluid(DataLine *data_line, ImportObject *imp_obj) : MatElastic (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~MatElasticFluid()
   {
   }

public:
/** Function to import Card2 details for *MAT_ELASTIC_FLUID
  * keyword from file */
   void readCard2()
   {
      const char *fields[] = {"VC","CP",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 2;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card2");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *MAT_ELASTIC_FLUID
  * from LSDYNA native file */
   unsigned int importMatElasticFluid()
   {
      importMatElastic();
      readCard2();
      return 0;
   }
};

#endif

