#include "matcellularrubber.hpp"
#include "matclosedcellfoam.hpp"
#include "matcrushablefoam.hpp"
#include "matfrazernashrubbermodel.hpp"
#include "matfuchangfoam.hpp"
#include "matstrainratedependentplasticity.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initFoamTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_CELLULAR_RUBBER, importMatCellularRubber) );
   typeFuncMap.insert( typeFuncPair(MAT_CLOSED_CELL_FOAM, importMatClosedCellFoam) );
   typeFuncMap.insert( typeFuncPair(MAT_CRUSHABLE_FOAM, importMatCrushableFoam) );
   typeFuncMap.insert( typeFuncPair(MAT_FRAZER_NASH_RUBBER_MODEL, importMatFrazerNashRubberModel) );
   typeFuncMap.insert( typeFuncPair(MAT_FU_CHANG_FOAM, importMatFuChangFoam) );
   typeFuncMap.insert( typeFuncPair(MAT_STRAIN_RATE_DEPENDENT_PLASTICITY, importMatStrainRateDependentPlasticity) );
}
