#include "matemmi.hpp"
#include "matpolymer.hpp"
#include "matrambergosgood.hpp"
#include "matshapememory.hpp"
#include "matsimplifiedjohnsoncook.hpp"
#include "mattrip.hpp"
#include "matviscousfoam.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initGeneralTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_EMMI, importMatEmmi) );
   typeFuncMap.insert( typeFuncPair(MAT_POLYMER, importMatPolymer) );
   typeFuncMap.insert( typeFuncPair(MAT_RAMBERG_OSGOOD, importMatRambergOsgood) );
   typeFuncMap.insert( typeFuncPair(MAT_SHAPE_MEMORY, importMatShapeMemory) );
   typeFuncMap.insert( typeFuncPair(MAT_SIMPLIFIED_JOHNSON_COOK, importMatSimplifiedJohnsonCook) );
   typeFuncMap.insert( typeFuncPair(MAT_TRIP, importMatTrip) );
   typeFuncMap.insert( typeFuncPair(MAT_VISCOUS_FOAM, importMatViscousFoam) );
}
