#include "matbrainlinearviscoelastic.hpp"
#include "matelasticviscoplasticthermal.hpp"
#include "matgeneralspringdiscretebeam.hpp"
#include "matthermoelastoviscoplasticcreep.hpp"
#include "matviscoelastichillfoam.hpp"
#include "matviscoelasticthermal.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initGensprTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_BRAIN_LINEAR_VISCOELASTIC, importMatBrainLinearViscoelastic) );
   typeFuncMap.insert( typeFuncPair(MAT_ELASTIC_VISCOPLASTIC_THERMAL, importMatElasticViscoplasticThermal) );
   typeFuncMap.insert( typeFuncPair(MAT_GENERAL_SPRING_DISCRETE_BEAM, importMatGeneralSpringDiscreteBeam) );
   typeFuncMap.insert( typeFuncPair(MAT_THERMO_ELASTO_VISCOPLASTIC_CREEP, importMatThermoElastoViscoplasticCreep) );
   typeFuncMap.insert( typeFuncPair(MAT_VISCOELASTIC_HILL_FOAM, importMatViscoelasticHillFoam) );
   typeFuncMap.insert( typeFuncPair(MAT_VISCOELASTIC_THERMAL, importMatViscoelasticThermal) );
}
