#include "matgurson.hpp"
#include "matgursonjc.hpp"
#include "matgursonrcdc.hpp"
#include "mathill3r.hpp"
#include "mathillfoam.hpp"
#include "matinvhyperbolicsin.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initGursonTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_GURSON, importMatGurson) );
   typeFuncMap.insert( typeFuncPair(MAT_GURSON_JC, importMatGursonJc) );
   typeFuncMap.insert( typeFuncPair(MAT_GURSON_RCDC, importMatGursonRcdc) );
   typeFuncMap.insert( typeFuncPair(MAT_HILL_3R, importMatHill3r) );
   typeFuncMap.insert( typeFuncPair(MAT_HILL_FOAM, importMatHillFoam) );
   typeFuncMap.insert( typeFuncPair(MAT_INV_HYPERBOLIC_SIN, importMatInvHyperbolicSin) );
}
