#include "matanisotropicelastic.hpp"
#include "mathoneycomb.hpp"
#include "matjohnsoncook.hpp"
#include "matlowdensityfoam.hpp"
#include "matlowdensityviscousfoam.hpp"
#include "matrigid.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initHoneyTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_ANISOTROPIC_ELASTIC, importMatAnisotropicElastic) );
   typeFuncMap.insert( typeFuncPair(MAT_HONEYCOMB, importMatHoneycomb) );
   typeFuncMap.insert( typeFuncPair(MAT_JOHNSON_COOK, importMatJohnsonCook) );
   typeFuncMap.insert( typeFuncPair(MAT_LOW_DENSITY_FOAM, importMatLowDensityFoam) );
   typeFuncMap.insert( typeFuncPair(MAT_LOW_DENSITY_VISCOUS_FOAM, importMatLowDensityViscousFoam) );
   typeFuncMap.insert( typeFuncPair(MAT_RIGID, importMatRigid) );
}
