#include "matgasmixture.hpp"
#include "matlowdensitysyntheticfoam.hpp"
#include "matlowdensitysyntheticfoamwithfailure.hpp"
#include "matmodifiedcrushablefoam.hpp"
#include "mattransverselyisotropiccrushablefoam.hpp"
#include "matvacuum.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initLowdenseTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_GAS_MIXTURE, importMatGasMixture) );
   typeFuncMap.insert( typeFuncPair(MAT_LOW_DENSITY_SYNTHETIC_FOAM, importMatLowDensitySyntheticFoam) );
   typeFuncMap.insert( typeFuncPair(MAT_LOW_DENSITY_SYNTHETIC_FOAM_ORTHO, importMatLowDensitySyntheticFoam) );
   typeFuncMap.insert( typeFuncPair(MAT_LOW_DENSITY_SYNTHETIC_FOAM_ORTHO_WITH_FAILURE, importMatLowDensitySyntheticFoamWithFailure) );
   typeFuncMap.insert( typeFuncPair(MAT_LOW_DENSITY_SYNTHETIC_FOAM_WITH_FAILURE, importMatLowDensitySyntheticFoamWithFailure) );
   typeFuncMap.insert( typeFuncPair(MAT_MODIFIED_CRUSHABLE_FOAM, importMatModifiedCrushableFoam) );
   typeFuncMap.insert( typeFuncPair(MAT_TRANSVERSELY_ISOTROPIC_CRUSHABLE_FOAM, importMatTransverselyIsotropicCrushableFoam) );
   typeFuncMap.insert( typeFuncPair(MAT_VACUUM, importMatVacuum) );
}
