#ifndef _MatModifiedPiecewiseLinearPlasticityRate_h_
#define _MatModifiedPiecewiseLinearPlasticityRate_h_

#include "manager.h"
#include "dispexport.h"
#include "matmodifiedpiecewiselinearplasticity.h"

/** This class is used for importing *MAT_MODIFIED_PIECEWISE_LINEAR_PLASTICITY_RATE keyword
  * from LSDYNA native file */

class MatModifiedPiecewiseLinearPlasticityRate : public MatModifiedPiecewiseLinearPlasticity
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   MatModifiedPiecewiseLinearPlasticityRate(DataLine *data_line, ImportObject *imp_obj) : MatModifiedPiecewiseLinearPlasticity (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~MatModifiedPiecewiseLinearPlasticityRate()
   {
   }

public:
/** Function to import Card5 details for *MAT_MODIFIED_PIECEWISE_LINEAR_PLASTICITY_RATE
  * keyword from file */
   void readCard5()
   {
      const char *fields[] = {"LCTSRF",};
      unsigned int field_types[] = {DATA_INT, };
      unsigned int field_indices[] = {0, };
      unsigned int man_types[] = {DEFINE, };
      unsigned int kw_types[] = {CURVE, };
      unsigned int num_indices = 1;
      numFields = 1;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card5");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *MAT_MODIFIED_PIECEWISE_LINEAR_PLASTICITY_RATE
  * from LSDYNA native file */
   unsigned int importMatModifiedPiecewiseLinearPlasticityRate()
   {
      importMatModifiedPiecewiseLinearPlasticity();
      readCard5();
      return 0;
   }
};

#endif

