#include "matkinematichardeningtransverselyanisotropic.hpp"
#include "matmohrcoulomb.hpp"
#include "matmomentcurvaturebeam.hpp"
#include "matmuscle.hpp"
#include "matorthotropicsmearedcrack.hpp"
#include "matpitzercrushablefoam.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initMohrTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_KINEMATIC_HARDENING_TRANSVERSELY_ANISOTROPIC, importMatKinematicHardeningTransverselyAnisotropic) );
   typeFuncMap.insert( typeFuncPair(MAT_MOHR_COULOMB, importMatMohrCoulomb) );
   typeFuncMap.insert( typeFuncPair(MAT_MOMENT_CURVATURE_BEAM, importMatMomentCurvatureBeam) );
   typeFuncMap.insert( typeFuncPair(MAT_MUSCLE, importMatMuscle) );
   typeFuncMap.insert( typeFuncPair(MAT_ORTHOTROPIC_SMEARED_CRACK, importMatOrthotropicSmearedCrack) );
   typeFuncMap.insert( typeFuncPair(MAT_PITZER_CRUSHABLE_FOAM, importMatPitzerCrushableFoam) );
}
