#include "matnonlinearorthotropic.hpp"
#include "matorthoelasticplastic.hpp"
#include "matorthotropicelastic.hpp"
#include "matorthotropicthermal.hpp"
#include "matsimplifiedjohnsoncookorthotropicdamage.hpp"
#include "mattemperaturedependentorthotropic.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initOrthoTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_NONLINEAR_ORTHOTROPIC, importMatNonlinearOrthotropic) );
   typeFuncMap.insert( typeFuncPair(MAT_ORTHO_ELASTIC_PLASTIC, importMatOrthoElasticPlastic) );
   typeFuncMap.insert( typeFuncPair(MAT_ORTHOTROPIC_ELASTIC, importMatOrthotropicElastic) );
   typeFuncMap.insert( typeFuncPair(MAT_ORTHOTROPIC_THERMAL, importMatOrthotropicThermal) );
   typeFuncMap.insert( typeFuncPair(MAT_SIMPLIFIED_JOHNSON_COOK_ORTHOTROPIC_DAMAGE, importMatSimplifiedJohnsonCookOrthotropicDamage) );
   typeFuncMap.insert( typeFuncPair(MAT_TEMPERATURE_DEPENDENT_ORTHOTROPIC, importMatTemperatureDependentOrthotropic) );
}
