#include "matcablediscretebeam.hpp"
#include "matgeologiccapmodel.hpp"
#include "matgeplasticsrate2000a.hpp"
#include "mathighexplosiveburn.hpp"
#include "matorientedcrack.hpp"
#include "matpseudotensor.hpp"
#include "matuserdefinedmaterialmodels.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initOthersTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_CABLE_DISCRETE_BEAM, importMatCableDiscreteBeam) );
   typeFuncMap.insert( typeFuncPair(MAT_GEOLOGIC_CAP_MODEL, importMatGeologicCapModel) );
   typeFuncMap.insert( typeFuncPair(MAT_GEPLASTIC_SRATE_2000a, importMatGeplasticSrate2000a) );
   typeFuncMap.insert( typeFuncPair(MAT_HIGH_EXPLOSIVE_BURN, importMatHighExplosiveBurn) );
   typeFuncMap.insert( typeFuncPair(MAT_ORIENTED_CRACK, importMatOrientedCrack) );
   typeFuncMap.insert( typeFuncPair(MAT_PSEUDO_TENSOR, importMatPseudoTensor) );
   typeFuncMap.insert( typeFuncPair(MAT_USER_DEFINED_MATERIAL_MODELS, importMatUserDefinedMaterialModels) );
}
