#ifndef _MatPlasticGreenNaghdiRate_h_
#define _MatPlasticGreenNaghdiRate_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *MAT_PLASTIC_GREEN_NAGHDI_RATE keyword
  * from LSDYNA native file */

class MatPlasticGreenNaghdiRate : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   MatPlasticGreenNaghdiRate(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~MatPlasticGreenNaghdiRate()
   {
   }

public:
/** Function to import Card1 details for *MAT_PLASTIC_GREEN_NAGHDI_RATE
  * keyword from file */
   void readCard1()
   {
      const char *fields[] = {"MID","RO","E","PR",};
      unsigned int field_types[] = {DATA_CHAR_ARRAY, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 4;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_IDS) )
         addIDToFile(wordArray, 0, MAT, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import Card2 details for *MAT_PLASTIC_GREEN_NAGHDI_RATE
  * keyword from file */
   void readCard2()
   {
      const char *fields[] = {"SIGY","ETAN","SRC","SRP","BETA",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 5;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card2");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *MAT_PLASTIC_GREEN_NAGHDI_RATE
  * from LSDYNA native file */
   unsigned int importMatPlasticGreenNaghdiRate()
   {
      readCard1();
      readCard2();
      return 0;
   }
};

#endif

