#ifndef _MatPlasticityWithDamageOrthoRcdc_h_
#define _MatPlasticityWithDamageOrthoRcdc_h_

#include "manager.h"
#include "dispexport.h"
#include "matplasticitywithdamage.h"

/** This class is used for importing *MAT_PLASTICITY_WITH_DAMAGE_ORTHO_RCDC keyword
  * from LSDYNA native file */

class MatPlasticityWithDamageOrthoRcdc : public MatPlasticityWithDamage
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   MatPlasticityWithDamageOrthoRcdc(DataLine *data_line, ImportObject *imp_obj) : MatPlasticityWithDamage (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~MatPlasticityWithDamageOrthoRcdc()
   {
   }

public:
/** Function to import Card5 details for *MAT_PLASTICITY_WITH_DAMAGE_ORTHO_RCDC
  * keyword from file */
   void readCard5()
   {
      const char *fields[] = {"ALPHA","BETA","GAMMA","D0","B","LAMBDA","DS","L",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 8;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card5");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *MAT_PLASTICITY_WITH_DAMAGE_ORTHO_RCDC
  * from LSDYNA native file */
   unsigned int importMatPlasticityWithDamageOrthoRcdc()
   {
      importMatPlasticityWithDamage();
      readCard5();
      return 0;
   }
};

#endif

