#include "matpiecewiselinearplasticity.hpp"
#include "matplasticgreennaghdirate.hpp"
#include "matplastickinematic.hpp"
#include "matplasticitypolymer.hpp"
#include "matplasticitywithdamage.hpp"
#include "matplasticitywithdamageorthorcdc.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initPlasticTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_PIECEWISE_LINEAR_PLASTICITY, importMatPiecewiseLinearPlasticity) );
   typeFuncMap.insert( typeFuncPair(MAT_PLASTIC_GREEN_NAGHDI_RATE, importMatPlasticGreenNaghdiRate) );
   typeFuncMap.insert( typeFuncPair(MAT_PLASTIC_KINEMATIC, importMatPlasticKinematic) );
   typeFuncMap.insert( typeFuncPair(MAT_PLASTICITY_POLYMER, importMatPlasticityPolymer) );
   typeFuncMap.insert( typeFuncPair(MAT_PLASTICITY_WITH_DAMAGE, importMatPlasticityWithDamage) );
   typeFuncMap.insert( typeFuncPair(MAT_PLASTICITY_WITH_DAMAGE_ORTHO, importMatPlasticityWithDamage) );
   typeFuncMap.insert( typeFuncPair(MAT_PLASTICITY_WITH_DAMAGE_ORTHO_RCDC, importMatPlasticityWithDamageOrthoRcdc) );
}
