#include "matanisotropicelasticplastic.hpp"
#include "matfiniteelasticstrainplasticity.hpp"
#include "matlayeredlinearplasticity.hpp"
#include "matplasticitycompressiontension.hpp"
#include "matplasticitycompressiontensioneos.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initPlasticityTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_ANISOTROPIC_ELASTIC_PLASTIC, importMatAnisotropicElasticPlastic) );
   typeFuncMap.insert( typeFuncPair(MAT_FINITE_ELASTIC_STRAIN_PLASTICITY, importMatFiniteElasticStrainPlasticity) );
   typeFuncMap.insert( typeFuncPair(MAT_LAYERED_LINEAR_PLASTICITY, importMatLayeredLinearPlasticity) );
   typeFuncMap.insert( typeFuncPair(MAT_PLASTICITY_COMPRESSION_TENSION, importMatPlasticityCompressionTension) );
   typeFuncMap.insert( typeFuncPair(MAT_PLASTICITY_COMPRESSION_TENSION_EOS, importMatPlasticityCompressionTensionEos) );
}
