#include "matconcretebeam.hpp"
#include "matconcreteec2.hpp"
#include "matsamp1.hpp"
#include "matschwermurraycapmodel.hpp"
#include "matseatbelt.hpp"
#include "matspecialorthotropic.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initSeatbeltTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_CONCRETE_BEAM, importMatConcreteBeam) );
   typeFuncMap.insert( typeFuncPair(MAT_CONCRETE_EC2, importMatConcreteEc2) );
   typeFuncMap.insert( typeFuncPair(MAT_SAMP_1, importMatSamp1) );
   typeFuncMap.insert( typeFuncPair(MAT_SCHWER_MURRAY_CAP_MODEL, importMatSchwerMurrayCapModel) );
   typeFuncMap.insert( typeFuncPair(MAT_SEATBELT, importMatSeatbelt) );
   typeFuncMap.insert( typeFuncPair(MAT_SPECIAL_ORTHOTROPIC, importMatSpecialOrthotropic) );
}
