#include "matcorusvegter.hpp"
#include "mathearttissue.hpp"
#include "matlungtissue.hpp"
#include "matmccormick.hpp"
#include "matseismicbeam.hpp"
#include "matseismicisolator.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initSeismicTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_CORUS_VEGTER, importMatCorusVegter) );
   typeFuncMap.insert( typeFuncPair(MAT_HEART_TISSUE, importMatHeartTissue) );
   typeFuncMap.insert( typeFuncPair(MAT_LUNG_TISSUE, importMatLungTissue) );
   typeFuncMap.insert( typeFuncPair(MAT_MCCORMICK, importMatMccormick) );
   typeFuncMap.insert( typeFuncPair(MAT_SEISMIC_BEAM, importMatSeismicBeam) );
   typeFuncMap.insert( typeFuncPair(MAT_SEISMIC_ISOLATOR, importMatSeismicIsolator) );
}
