#include "matratesensitivecompositefabric.hpp"
#include "matratesensitivepolymer.hpp"
#include "matrcbeam.hpp"
#include "matrcshearwall.hpp"
#include "matwtmstm.hpp"
#include "matwtmstmplc.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initSensitiveTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_RATE_SENSITIVE_COMPOSITE_FABRIC, importMatRateSensitiveCompositeFabric) );
   typeFuncMap.insert( typeFuncPair(MAT_RATE_SENSITIVE_POLYMER, importMatRateSensitivePolymer) );
   typeFuncMap.insert( typeFuncPair(MAT_RC_BEAM, importMatRcBeam) );
   typeFuncMap.insert( typeFuncPair(MAT_RC_SHEAR_WALL, importMatRcShearWall) );
   typeFuncMap.insert( typeFuncPair(MAT_WTM_STM, importMatWtmStm) );
   typeFuncMap.insert( typeFuncPair(MAT_WTM_STM_PLC, importMatWtmStmPlc) );
}
