#ifndef _MatSimplifiedRubberFoamWithFailure_h_
#define _MatSimplifiedRubberFoamWithFailure_h_

#include "manager.h"
#include "dispexport.h"
#include "matsimplifiedrubberfoam.h"

/** This class is used for importing *MAT_SIMPLIFIED_RUBBER_FOAM_WITH_FAILURE keyword
  * from LSDYNA native file */

class MatSimplifiedRubberFoamWithFailure : public MatSimplifiedRubberFoam
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   MatSimplifiedRubberFoamWithFailure(DataLine *data_line, ImportObject *imp_obj) : MatSimplifiedRubberFoam (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~MatSimplifiedRubberFoamWithFailure()
   {
   }

public:
/** Function to import Card3 details for *MAT_SIMPLIFIED_RUBBER_FOAM_WITH_FAILURE
  * keyword from file */
   void readCard3()
   {
      const char *fields[] = {"K","GAMA1","GAMA2","EH",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 4;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card3");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *MAT_SIMPLIFIED_RUBBER_FOAM_WITH_FAILURE
  * from LSDYNA native file */
   unsigned int importMatSimplifiedRubberFoamWithFailure()
   {
      importMatSimplifiedRubberFoam();
      readCard3();
      return 0;
   }
};

#endif

