#include "mathyperelasticrubber.hpp"
#include "matsimplifiedrubberfoam.hpp"
#include "matsimplifiedrubberfoamwithfailure.hpp"
#include "matsimplifiedrubberwithdamage.hpp"
#include "matsoilbrick.hpp"
#include "matsteelconcentricbrace.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initSimpleTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_HYPERELASTIC_RUBBER, importMatHyperelasticRubber) );
   typeFuncMap.insert( typeFuncPair(MAT_SIMPLIFIED_RUBBER_FOAM, importMatSimplifiedRubberFoam) );
   typeFuncMap.insert( typeFuncPair(MAT_SIMPLIFIED_RUBBER_FOAM_WITH_FAILURE, importMatSimplifiedRubberFoamWithFailure) );
   typeFuncMap.insert( typeFuncPair(MAT_SIMPLIFIED_RUBBER_WITH_DAMAGE, importMatSimplifiedRubberWithDamage) );
   typeFuncMap.insert( typeFuncPair(MAT_SOIL_BRICK, importMatSoilBrick) );
   typeFuncMap.insert( typeFuncPair(MAT_STEEL_CONCENTRIC_BRACE, importMatSteelConcentricBrace) );
}
