#include "mathystereticsoil.hpp"
#include "matsoilandfoam.hpp"
#include "matsteinberg.hpp"
#include "matsteinberglund.hpp"
#include "matthermaluserdefined.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initSoilTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_HYSTERETIC_SOIL, importMatHystereticSoil) );
   typeFuncMap.insert( typeFuncPair(MAT_SOIL_AND_FOAM, importMatSoilAndFoam) );
   typeFuncMap.insert( typeFuncPair(MAT_SOIL_AND_FOAM_FAILURE, importMatSoilAndFoam) );
   typeFuncMap.insert( typeFuncPair(MAT_STEINBERG, importMatSteinberg) );
   typeFuncMap.insert( typeFuncPair(MAT_STEINBERG_LUND, importMatSteinbergLund) );
   typeFuncMap.insert( typeFuncPair(MAT_THERMAL_USER_DEFINED, importMatThermalUserDefined) );
}
