#include "matanisotropicplastic.hpp"
#include "matfabric.hpp"
#include "matspringelastic.hpp"
#include "matspringelastoplastic.hpp"
#include "matspringgeneralnonlinear.hpp"
#include "matspringmaxwell.hpp"
#include "matspringnonlinearelastic.hpp"
#include "matspringsquatshearwall.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initSpringTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_ANISOTROPIC_PLASTIC, importMatAnisotropicPlastic) );
   typeFuncMap.insert( typeFuncPair(MAT_FABRIC, importMatFabric) );
   typeFuncMap.insert( typeFuncPair(MAT_SPRING_ELASTIC, importMatSpringElastic) );
   typeFuncMap.insert( typeFuncPair(MAT_SPRING_ELASTOPLASTIC, importMatSpringElastoplastic) );
   typeFuncMap.insert( typeFuncPair(MAT_SPRING_GENERAL_NONLINEAR, importMatSpringGeneralNonlinear) );
   typeFuncMap.insert( typeFuncPair(MAT_SPRING_MAXWELL, importMatSpringMaxwell) );
   typeFuncMap.insert( typeFuncPair(MAT_SPRING_NONLINEAR_ELASTIC, importMatSpringNonlinearElastic) );
   typeFuncMap.insert( typeFuncPair(MAT_SPRING_SQUAT_SHEARWALL, importMatSpringSquatShearwall) );
}
