#include "matacoustic.hpp"
#include "matelasticspringdiscretebeam.hpp"
#include "matinelasticspringdiscretebeam.hpp"
#include "matisotropicsmearedcrack.hpp"
#include "matsofttissue.hpp"
#include "matsofttissuevisco.hpp"
#include "matsoilconcrete.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initSpringdisTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_ACOUSTIC, importMatAcoustic) );
   typeFuncMap.insert( typeFuncPair(MAT_ELASTIC_SPRING_DISCRETE_BEAM, importMatElasticSpringDiscreteBeam) );
   typeFuncMap.insert( typeFuncPair(MAT_INELASTIC_SPRING_DISCRETE_BEAM, importMatInelasticSpringDiscreteBeam) );
   typeFuncMap.insert( typeFuncPair(MAT_ISOTROPIC_SMEARED_CRACK, importMatIsotropicSmearedCrack) );
   typeFuncMap.insert( typeFuncPair(MAT_SOFT_TISSUE, importMatSoftTissue) );
   typeFuncMap.insert( typeFuncPair(MAT_SOFT_TISSUE_VISCO, importMatSoftTissueVisco) );
   typeFuncMap.insert( typeFuncPair(MAT_SOIL_CONCRETE, importMatSoilConcrete) );
}
