#include "matthermalisotropic.hpp"
#include "matthermalisotropicphasechange.hpp"
#include "matthermalisotropictd.hpp"
#include "matthermalisotropictdlc.hpp"
#include "matthermalorthotropic.hpp"
#include "matthermalorthotropictd.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initThermalTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_THERMAL_ISOTROPIC, importMatThermalIsotropic) );
   typeFuncMap.insert( typeFuncPair(MAT_THERMAL_ISOTROPIC_PHASE_CHANGE, importMatThermalIsotropicPhaseChange) );
   typeFuncMap.insert( typeFuncPair(MAT_THERMAL_ISOTROPIC_TD, importMatThermalIsotropicTd) );
   typeFuncMap.insert( typeFuncPair(MAT_THERMAL_ISOTROPIC_TD_LC, importMatThermalIsotropicTdLc) );
   typeFuncMap.insert( typeFuncPair(MAT_THERMAL_ORTHOTROPIC, importMatThermalOrthotropic) );
   typeFuncMap.insert( typeFuncPair(MAT_THERMAL_ORTHOTROPIC_TD, importMatThermalOrthotropicTd) );
}
