#include "matgeneralviscoelastic.hpp"
#include "matkelvinmaxwellviscoelastic.hpp"
#include "matorthotropicviscoelastic.hpp"
#include "matplasticnonlinearkinematic.hpp"
#include "matquasilinearviscoelastic.hpp"
#include "matviscoelastic.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initViscoelasticTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_GENERAL_VISCOELASTIC, importMatGeneralViscoelastic) );
   typeFuncMap.insert( typeFuncPair(MAT_KELVIN_MAXWELL_VISCOELASTIC, importMatKelvinMaxwellViscoelastic) );
   typeFuncMap.insert( typeFuncPair(MAT_ORTHOTROPIC_VISCOELASTIC, importMatOrthotropicViscoelastic) );
   typeFuncMap.insert( typeFuncPair(MAT_PLASTIC_NONLINEAR_KINEMATIC, importMatPlasticNonlinearKinematic) );
   typeFuncMap.insert( typeFuncPair(MAT_QUASILINEAR_VISCOELASTIC, importMatQuasilinearViscoelastic) );
   typeFuncMap.insert( typeFuncPair(MAT_VISCOELASTIC, importMatViscoelastic) );
}
