#include "matanisotropicthermoelastic.hpp"
#include "matanisotropicviscoplastic.hpp"
#include "matarrudaboycerubber.hpp"
#include "matspringinelastic.hpp"
#include "matspringmuscle.hpp"
#include "matspringtrilineardegrading.hpp"
#include "typemap.h"
#include "matimport.h"

void MatImport::initViscoplasticTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(MAT_ANISOTROPIC_THERMOELASTIC, importMatAnisotropicThermoelastic) );
   typeFuncMap.insert( typeFuncPair(MAT_ANISOTROPIC_VISCOPLASTIC, importMatAnisotropicViscoplastic) );
   typeFuncMap.insert( typeFuncPair(MAT_ARRUDA_BOYCE_RUBBER, importMatArrudaBoyceRubber) );
   typeFuncMap.insert( typeFuncPair(MAT_SPRING_INELASTIC, importMatSpringInelastic) );
   typeFuncMap.insert( typeFuncPair(MAT_SPRING_MUSCLE, importMatSpringMuscle) );
   typeFuncMap.insert( typeFuncPair(MAT_SPRING_TRILINEAR_DEGRADING, importMatSpringTrilinearDegrading) );
}
