#ifndef _NodeScalar_h_
#define _NodeScalar_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *NODE_SCALAR keyword
  * from LSDYNA native file */

class NodeScalar : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   NodeScalar(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~NodeScalar()
   {
   }

public:
/** Function to import Card1 details for *NODE_SCALAR
  * keyword from file */
   void readCard1()
   {
      const char *fields[] = {"NID","NDOF",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, };
      unsigned int field_indices[] = {0, };
      unsigned int man_types[] = {NOD, };
      unsigned int kw_types[] = {9999, };
      unsigned int num_indices = 1;
      numFields = 2;
      unsigned int field_widths[] = {8, 8, };
      strBuff = dataLine->readNextCard(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, field_widths, fields, strBuff);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *NODE_SCALAR
  * from LSDYNA native file */
   unsigned int importNodeScalar()
   {
      readCard1();
      return 0;
   }
};

#endif

