#ifndef _NodeTransform_h_
#define _NodeTransform_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *NODE_TRANSFORM keyword
  * from LSDYNA native file */

class NodeTransform : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   NodeTransform(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~NodeTransform()
   {
   }

public:
/** Function to import Card1 details for *NODE_TRANSFORM
  * keyword from file */
   void readCard1()
   {
      const char *fields[] = {"TRSID","NSID",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, };
      unsigned int field_indices[] = {0, 1, };
      unsigned int man_types[] = {DEFINE, SET, };
      unsigned int kw_types[] = {TRANS, NOD, };
      unsigned int num_indices = 2;
      numFields = 2;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *NODE_TRANSFORM
  * from LSDYNA native file */
   unsigned int importNodeTransform()
   {
      readCard1();
      return 0;
   }
};

#endif

