#ifndef _ParameterExpression_h_
#define _ParameterExpression_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *PARAMETER_EXPRESSION keyword
  * from LSDYNA native file */

class ParameterExpression : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   ParameterExpression(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~ParameterExpression()
   {
   }

public:
/** Function to import Card1 details for *PARAMETER_EXPRESSION
  * keyword from file */
   void readCard1()
   {
      const char *fields[] = {"PRMR1","EXPRESSION1",};
      unsigned int field_types[] = {DATA_CHAR_ARRAY, DATA_CHAR_ARRAY, };
      numFields = 2;
      unsigned int field_widths[] = {10, 70, };
      strBuff = dataLine->readNextCard(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, field_widths, fields, strBuff);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *PARAMETER_EXPRESSION
  * from LSDYNA native file */
   unsigned int importParameterExpression()
   {
      readCard1();
      while(numFields)
      {
         readCard1();
      }
      return 0;
   }
};

#endif

