#ifndef _PartAdaptiveFailure_h_
#define _PartAdaptiveFailure_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *PART_ADAPTIVE_FAILURE keyword
  * from LSDYNA native file */

class PartAdaptiveFailure : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   PartAdaptiveFailure(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~PartAdaptiveFailure()
   {
   }

public:
/** Function to import PartCard details for *PART_ADAPTIVE_FAILURE
  * keyword from file */
   void readPartCard()
   {
      const char *fields[] = {"PID","T",};
      unsigned int field_types[] = {DATA_INT, DATA_DOUBLE, };
      unsigned int field_indices[] = {0, };
      unsigned int man_types[] = {PARTC, };
      unsigned int kw_types[] = {9999, };
      unsigned int num_indices = 1;
      numFields = 2;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("PartCard");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *PART_ADAPTIVE_FAILURE
  * from LSDYNA native file */
   unsigned int importPartAdaptiveFailure()
   {
      readPartCard();
      return 0;
   }
};

#endif

