#ifndef _PartMove_h_
#define _PartMove_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *PART_MOVE keyword
  * from LSDYNA native file */

class PartMove : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   PartMove(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~PartMove()
   {
   }

public:
/** Function to import PartCard details for *PART_MOVE
  * keyword from file */
   void readPartCard()
   {
      const char *fields[] = {"PID","XMOV","YMOV","ZMOV","CID",};
      unsigned int field_types[] = {DATA_INT, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_INT, };
      unsigned int field_indices[] = {0, 4, };
      unsigned int man_types[] = {PARTC, DEFINE, };
      unsigned int kw_types[] = {9999, COORDINATE, };
      unsigned int num_indices = 2;
      numFields = 5;
      unsigned int field_widths[] = {8, 16, 16, 16, 8, };
      strBuff = dataLine->readNextCard(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("PartCard");
         cardObj->addFields(numFields, field_types, field_widths, fields, strBuff);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *PART_MOVE
  * from LSDYNA native file */
   unsigned int importPartMove()
   {
      readPartCard();
      return 0;
   }
};

#endif

