#ifndef _PartPrint_h_
#define _PartPrint_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *PART_PRINT keyword
  * from LSDYNA native file */

class PartPrint : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   PartPrint(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~PartPrint()
   {
   }

public:
/** Function to import PrintCard details for *PART_PRINT
  * keyword from file */
   void readPrintCard()
   {
      const char *fields[] = {"PRBF",};
      unsigned int field_types[] = {DATA_INT, };
      numFields = 1;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("PrintCard");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *PART_PRINT
  * from LSDYNA native file */
   unsigned int importPartPrint()
   {
      readPrintCard();
      return 0;
   }
};

#endif

