#ifndef _PartReposition_h_
#define _PartReposition_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *PART_REPOSITION keyword
  * from LSDYNA native file */

class PartReposition : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   PartReposition(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~PartReposition()
   {
   }

public:
/** Function to import ReposCard details for *PART_REPOSITION
  * keyword from file */
   void readReposCard()
   {
      const char *fields[] = {"CMSN","MDEP","MOVOPT",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, };
      numFields = 3;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("ReposCard");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *PART_REPOSITION
  * from LSDYNA native file */
   unsigned int importPartReposition()
   {
      readReposCard();
      return 0;
   }
};

#endif

