#ifndef _RigidwallGeometricMotion_h_
#define _RigidwallGeometricMotion_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *RIGIDWALL_GEOMETRIC_MOTION keyword
  * from LSDYNA native file */

class RigidwallGeometricMotion : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   RigidwallGeometricMotion(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~RigidwallGeometricMotion()
   {
   }

public:
/** Function to import CardA details for *RIGIDWALL_GEOMETRIC_MOTION
  * keyword from file */
   void readCardA()
   {
      const char *fields[] = {"LCID","OPT","VX","VY","VZ",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      unsigned int field_indices[] = {0, };
      unsigned int man_types[] = {DEFINE, };
      unsigned int kw_types[] = {CURVE, };
      unsigned int num_indices = 1;
      numFields = 5;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("CardA");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *RIGIDWALL_GEOMETRIC_MOTION
  * from LSDYNA native file */
   unsigned int importRigidwallGeometricMotion()
   {
      readCardA();
      return 0;
   }
};

#endif

