#ifndef _RigidwallGeometricSphere_h_
#define _RigidwallGeometricSphere_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *RIGIDWALL_GEOMETRIC_SPHERE keyword
  * from LSDYNA native file */

class RigidwallGeometricSphere : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   RigidwallGeometricSphere(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~RigidwallGeometricSphere()
   {
   }

public:
/** Function to import Card3 details for *RIGIDWALL_GEOMETRIC_SPHERE
  * keyword from file */
   void readCard3()
   {
      const char *fields[] = {"RADSPH",};
      unsigned int field_types[] = {DATA_DOUBLE, };
      numFields = 1;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card3");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *RIGIDWALL_GEOMETRIC_SPHERE
  * from LSDYNA native file */
   unsigned int importRigidwallGeometricSphere()
   {
      readCard3();
      return 0;
   }
};

#endif

