#ifndef _RigidwallPlanarFinite_h_
#define _RigidwallPlanarFinite_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *RIGIDWALL_PLANAR_FINITE keyword
  * from LSDYNA native file */

class RigidwallPlanarFinite : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   RigidwallPlanarFinite(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~RigidwallPlanarFinite()
   {
   }

public:
/** Function to import CardC details for *RIGIDWALL_PLANAR_FINITE
  * keyword from file */
   void readCardC()
   {
      const char *fields[] = {"XHEV","YHEV","ZHEV","LENL","LENM",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 5;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("CardC");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *RIGIDWALL_PLANAR_FINITE
  * from LSDYNA native file */
   unsigned int importRigidwallPlanarFinite()
   {
      readCardC();
      return 0;
   }
};

#endif

