#ifndef _RigidwallPlanarForces_h_
#define _RigidwallPlanarForces_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *RIGIDWALL_PLANAR_FORCES keyword
  * from LSDYNA native file */

class RigidwallPlanarForces : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   RigidwallPlanarForces(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~RigidwallPlanarForces()
   {
   }

public:
/** Function to import CardE details for *RIGIDWALL_PLANAR_FORCES
  * keyword from file */
   void readCardE()
   {
      const char *fields[] = {"SOFT","SSID","N1","N2","N3","N4",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, };
      unsigned int field_indices[] = {1, 2, 3, 4, 5, };
      unsigned int man_types[] = {SET, NOD, NOD, NOD, NOD, };
      unsigned int kw_types[] = {SEGMENT, 9999, 9999, 9999, 9999, };
      unsigned int num_indices = 5;
      numFields = 6;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("CardE");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *RIGIDWALL_PLANAR_FORCES
  * from LSDYNA native file */
   unsigned int importRigidwallPlanarForces()
   {
      readCardE();
      return 0;
   }
};

#endif

