#ifndef _SectionSeatbelt_h_
#define _SectionSeatbelt_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *SECTION_SEATBELT keyword
  * from LSDYNA native file */

class SectionSeatbelt : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   SectionSeatbelt(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~SectionSeatbelt()
   {
   }

public:
/** Function to import Card1 details for *SECTION_SEATBELT
  * keyword from file */
   void readCard1()
   {
      const char *fields[] = {"SECID",};
      unsigned int field_types[] = {DATA_CHAR_ARRAY, };
      numFields = 1;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_IDS) )
         addIDToFile(wordArray, 0, SECTION, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *SECTION_SEATBELT
  * from LSDYNA native file */
   unsigned int importSectionSeatbelt()
   {
      readCard1();
      return 0;
   }
};

#endif

