#include "sensorcontrol.hpp"
#include "sensordefinecalcmath.hpp"
#include "sensordefineelement.hpp"
#include "sensordefineforce.hpp"
#include "sensordefinenode.hpp"
#include "sensorswitch.hpp"
#include "sensorswitchcalclogic.hpp"
#include "typemap.h"
#include "sensorimport.h"

void SensorImport::initSensorTypesAndFunctions()
{
   typeFuncMap.insert( typeFuncPair(SENSOR_CONTROL, importSensorControl) );
   typeFuncMap.insert( typeFuncPair(SENSOR_DEFINE_CALC_MATH, importSensorDefineCalcMath) );
   typeFuncMap.insert( typeFuncPair(SENSOR_DEFINE_ELEMENT, importSensorDefineElement) );
   typeFuncMap.insert( typeFuncPair(SENSOR_DEFINE_FORCE, importSensorDefineForce) );
   typeFuncMap.insert( typeFuncPair(SENSOR_DEFINE_NODE, importSensorDefineNode) );
   typeFuncMap.insert( typeFuncPair(SENSOR_SWITCH, importSensorSwitch) );
   typeFuncMap.insert( typeFuncPair(SENSOR_SWITCH_CALC_LOGIC, importSensorSwitchCalcLogic) );
}
