#ifndef _SetIdAttribute_h_
#define _SetIdAttribute_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *SET_ID_ATTRIBUTE keyword
  * from LSDYNA native file */

class SetIdAttribute : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   SetIdAttribute(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~SetIdAttribute()
   {
   }

public:
/** Function to import Card1 details for *SET_ID_ATTRIBUTE
  * keyword from file */
   void readCard1()
   {
      const char *fields[] = {"SID","DA1","DA2","DA3","DA4",};
      unsigned int field_types[] = {DATA_INT, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 5;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_IDS) )
         addIDToFile(wordArray, 0, SET, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *SET_ID_ATTRIBUTE
  * from LSDYNA native file */
   unsigned int importSetIdAttribute()
   {
      readCard1();
      return 0;
   }
};

#endif

