#ifndef _SetNodeAddCard1_h_
#define _SetNodeAddCard1_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *SET_NODE_ADD_CARD1 keyword
  * from LSDYNA native file */

class SetNodeAddCard1 : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   SetNodeAddCard1(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~SetNodeAddCard1()
   {
   }

public:
/** Function to import Card1 details for *SET_NODE_ADD_CARD1
  * keyword from file */
   void readCard1()
   {
      const char *fields[] = {"NSID","A1","A2","A3","A4",};
      unsigned int field_types[] = {DATA_INT, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 5;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_IDS) )
         addIDToFile(wordArray, 0, SET, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card1");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *SET_NODE_ADD_CARD1
  * from LSDYNA native file */
   unsigned int importSetNodeAddCard1()
   {
      readCard1();
      return 0;
   }
};

#endif

