#ifndef _SetNodeAdd_h_
#define _SetNodeAdd_h_

#include "manager.h"
#include "dispexport.h"
#include "setnodeaddcard1.h"

/** This class is used for importing *SET_NODE_ADD keyword
  * from LSDYNA native file */

class SetNodeAdd : public SetNodeAddCard1
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   SetNodeAdd(DataLine *data_line, ImportObject *imp_obj) : SetNodeAddCard1 (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~SetNodeAdd()
   {
   }

public:
/** Function to import CardLoop details for *SET_NODE_ADD
  * keyword from file */
   void readCardLoop()
   {
      const char *fields[] = {"NSID1","NSID2","NSID3","NSID4","NSID5","NSID6","NSID7","NSID8",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, };
      unsigned int field_indices[] = {0, 1, 2, 3, 4, 5, 6, 7, };
      unsigned int man_types[] = {SET, SET, SET, SET, SET, SET, SET, SET, };
      unsigned int kw_types[] = {NOD, NOD, NOD, NOD, NOD, NOD, NOD, NOD, };
      unsigned int num_indices = 8;
      numFields = 8;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         addIDToRefFile(wordArray, num_indices, field_indices, man_types, kw_types, impObj);

      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("CardLoop");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *SET_NODE_ADD
  * from LSDYNA native file */
   unsigned int importSetNodeAdd()
   {
      importSetNodeAddCard1();
      readCardLoop();
      while(numFields)
      {
         readCardLoop();
      }
      return 0;
   }
};

#endif

