#ifndef _SetNodeAddAdvanced_h_
#define _SetNodeAddAdvanced_h_

#include "manager.h"
#include "dispexport.h"
#include "setnodeaddcard1.h"

/** This class is used for importing *SET_NODE_ADD_ADVANCED keyword
  * from LSDYNA native file */

class SetNodeAddAdvanced : public SetNodeAddCard1
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   SetNodeAddAdvanced(DataLine *data_line, ImportObject *imp_obj) : SetNodeAddCard1 (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~SetNodeAddAdvanced()
   {
   }

public:
/** Function to import CardLoop details for *SET_NODE_ADD_ADVANCED
  * keyword from file */
   void readCardLoop()
   {
      const char *fields[] = {"SID1","TYPE1","SID2","TYPE2","SID3","TYPE3","SID4","TYPE4",};
      unsigned int field_types[] = {DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, DATA_INT, };
      numFields = 8;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         setNodeAddFind(wordArray, numFields, 0, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("CardLoop");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *SET_NODE_ADD_ADVANCED
  * from LSDYNA native file */
   unsigned int importSetNodeAddAdvanced()
   {
      importSetNodeAddCard1();
      readCardLoop();
      while(numFields)
      {
         readCardLoop();
      }
      return 0;
   }
};

#endif

