#ifndef _Set2dSegment_h_
#define _Set2dSegment_h_

#include "manager.h"
#include "dispexport.h"
#include "setidattribute.h"

/** This class is used for importing *SET_2D_SEGMENT keyword
  * from LSDYNA native file */

class Set2dSegment : public SetIdAttribute
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   Set2dSegment(DataLine *data_line, ImportObject *imp_obj) : SetIdAttribute (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~Set2dSegment()
   {
   }

public:
/** Function to import Card2 details for *SET_2D_SEGMENT
  * keyword from file */
   void readCard2()
   {
      const char *fields[] = {"PID/PSID",};
      unsigned int field_types[] = {DATA_INT, };
      numFields = 1;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_REFERENCES) )
         initialPartFind(wordArray, numFields, 0, impObj);
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("Card2");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *SET_2D_SEGMENT
  * from LSDYNA native file */
   unsigned int importSet2dSegment()
   {
      importSetIdAttribute();
      readCard2();
      return 0;
   }
};

#endif

