#ifndef _UserLoading_h_
#define _UserLoading_h_

#include "manager.h"
#include "dispexport.h"
#include "importbase.h"

/** This class is used for importing *USER_LOADING keyword
  * from LSDYNA native file */

class UserLoading : public ImportBase
{
public:
/** Class constructor for creating the objects.
  * \param data_line DataLine object pointer to access file data
  * \param imp_obj ImportObject pointer to save data
  */
   UserLoading(DataLine *data_line, ImportObject *imp_obj) : ImportBase (data_line, imp_obj)
   {
   }

/** Class destructor for releasing the memory.
  */
   virtual ~UserLoading()
   {
   }

public:
/** Function to import CardLoop details for *USER_LOADING
  * keyword from file */
   void readCardLoop()
   {
      const char *fields[] = {"PARM1","PARM2","PARM3","PARM4","PARM5","PARM6","PARM7","PARM8",};
      unsigned int field_types[] = {DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, DATA_DOUBLE, };
      numFields = 8;
      wordArray = dataLine->readNextCardAsWords(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;
      if( Card::isFlagOn(SAVE_CARDS_FIELDS) )
      {
         cardObj = new Card("CardLoop");
         cardObj->addFields(numFields, field_types, fields, wordArray);
         impObj->addCard(cardObj);
      }
   }

/** Function to import all the cards of the keyword *USER_LOADING
  * from LSDYNA native file */
   unsigned int importUserLoading()
   {
      readCardLoop();
      while(numFields)
      {
         readCardLoop();
      }
      return 0;
   }
};

#endif

