/*
#include "manager_inc.h"
#include "propmanager.h"
#include "partmanager.h"
#include "shellmanager.h"
#include "partctype.h"
*/
#include "sectiontype.h"
#include "mattype.h"
#include "validate.h"
/*
#include "node.h"
#include "shell.h"
#include "part.h"
#include "elementtype.h"
#include "generic.h"
*/

/*
unsigned int Validate::createObjectsFromCards()
{
   createNodesFromCards();
   createMaterialsFromCards();
   createSectionsFromCards();
   createEosFromCards();
   createHgFromCards();
   createPartsFromCards();
   unsigned int num_elm = createShellElementsFromCards();
cout << "NUM ELM = " << num_elm << endl;

   return 0;
}


unsigned int Validate::createNodesFromCards()
{
   const char                *kw, *card_name;
   int                       node_id = 0;
   unsigned int              i, j;
   NodManager                *nod_man = NodManager::create();
   vector<ImportObject *> &  impobj_list = nod_man->getImportObjectList();
   ImportObject              *imp_obj = NULL;
   Card                      *card = NULL;
   Data                      *data = NULL;
   Node                      *node = NULL;
   NodeManager               *node_man = NodeManager::create();
   map<unsigned int, Node *> & node_map = node_man->getNodeMap();
   
   for(i = 0; i < impobj_list.size(); i++)
   {
      imp_obj = impobj_list[i];
      kw = imp_obj->getKeyword().data();
      if( kw[6] != 'T' )
      {
         vector<Card *> & card_list = imp_obj->getCardList();
         for(j = 0; j < card_list.size(); j++)
         {
	    card = card_list[j];
            card_name = card->getName().data();
            if( !strcmp(card_name, "Card1") )
            {
	       vector<Data *> & values = card->getVarValues();
	       data = values[0];
	       data->value(&node_id);
	       node = new Node(node_id);
	       node_man->add( node );
            }
         }
      }
   }

   return node_map.size();
}

unsigned int Validate::createMaterialsFromCards()
{
   const char                *card_name = NULL;
   char                      *mat_id = 0, str_buff[16];
   unsigned int              kw_type = 0, mid = 0, i, j;
   MatManager                *mat_man = MatManager::create();
   PropManager               *prop_man = PropManager::create();
   vector<ImportObject *> &  impobj_list = mat_man->getImportObjectList();
   ImportObject              *imp_obj = NULL;
   Card                      *card = NULL;
   Data                      *data = NULL;
   map<string, unsigned int> & mat_list  = prop_man->getPropList(PROP_MATERIAL);
   
   for(i = 0; i < impobj_list.size(); i++)
   {
      imp_obj = impobj_list[i];
      kw_type = imp_obj->getKeywordType();

      vector<Card *> & card_list = imp_obj->getCardList();
      for(j = 0; j < card_list.size(); j++)
      {
	 card = card_list[j];
         card_name = card->getName().data();
         if( !strcmp(card_name, "Card1") )
         {
	    vector<Data *> & values = card->getVarValues();
	    data = values[0];

	    switch(kw_type)
	    {
               case MAT_NONLOCAL:
	          data->value(&mid);
                  sprintf(str_buff, "%d", mid);
		  prop_man->add( PROP_MATERIAL, str_buff, kw_type );
                  break;
               case MAT_ADD_THERMAL_EXPANSION:
                  break;
	       case MAT_THERMAL_USER_DEFINED:
	       case MAT_THERMAL_ISOTROPIC:
	       case MAT_THERMAL_ISOTROPIC_PHASE_CHANGE:
	       case MAT_THERMAL_ISOTROPIC_TD:
	       case MAT_THERMAL_ISOTROPIC_TD_LC:
	       case MAT_THERMAL_ORTHOTROPIC:
	       case MAT_THERMAL_ORTHOTROPIC_TD:
		  {
	             data->value(&mat_id);
                     Generic::RemoveLeadingAndTrailingBlanks(mat_id);
		     prop_man->add( PROP_THERMAL_MATERIAL, mat_id, kw_type );
		  }
		  break;
	       default:
	          data->value(&mat_id);
                  Generic::RemoveLeadingAndTrailingBlanks(mat_id);
		  prop_man->add( PROP_MATERIAL, mat_id, kw_type );
		  break;
	    }
         }
      }
   }

   return mat_list.size();
}

unsigned int Validate::createSectionsFromCards()
{
   char                      *sec_id = 0;
   const char                *card_name;
   unsigned int              i, j, kw_type;
   int                       elm_form = 0;
   SectionManager            *sec_man = SectionManager::create();
   PropManager               *prop_man = PropManager::create();
   vector<ImportObject *> &  impobj_list = sec_man->getImportObjectList();
   ImportObject              *imp_obj = NULL;
   Card                      *card = NULL;
   Data                      *data = NULL;
   map<string, unsigned int> & sec_list = prop_man->getPropList(PROP_SECTION);
   
   for(i = 0; i < impobj_list.size(); i++)
   {
      imp_obj = impobj_list[i];
      kw_type = imp_obj->getKeywordType();
      vector<Card *> & card_list = imp_obj->getCardList();
      for(j = 0; j < card_list.size(); j++)
      {
	 card = card_list[j];
         card_name = card->getName().data();
         if( !strcmp(card_name, "Card1") )
         {
	    vector<Data *> & values = card->getVarValues();
	    data = values[0];
	    data->value(&sec_id);

            if( kw_type == SECTION_BEAM )
            {
               data = values[1];
	       data->value(&elm_form);
//cout << "ELFORM = " << elm_form << endl;
               switch(elm_form)
               {
                  case 1:
                     kw_type = SECTION_BEAM_HUGHES_LIU;
                     break;
                  case 2:
                     kw_type = SECTION_BEAM_BELYTSCHKO_SCHWER_RESULTANT;
                     break;
                  case 3:
                     kw_type = SECTION_BEAM_TRUSS_RESULTANT;
                     break;
                  case 4:
                     kw_type = SECTION_BEAM_BELYTSCHKO_SCHWER_SOLID;
                     break;
                  case 5:
                     kw_type = SECTION_BEAM_BELYTSCHKO_SCHWER_TUBULAR;
                     break;
                  case 6:
                     kw_type = SECTION_BEAM_DISCRETE_OR_CABLE;
                     break;
                  case 7:
                     kw_type = SECTION_BEAM_2D_PLANE_STRAIN_SHELL;
                     break;
                  case 8:
                     kw_type = SECTION_BEAM_2D_AXISYMMETRIC_SHELL;
                     break;
                  case 9:
                     kw_type = SECTION_BEAM_SPOTWELD;
                     break;
                  case 11:
                     kw_type = SECTION_BEAM_INTEGRATED_WARPED;
                     break;
                  case 12:
                     kw_type = SECTION_BEAM_RESULTANT_WARPED;
                     break;
               }
            }
            Generic::RemoveLeadingAndTrailingBlanks(sec_id);
	    prop_man->add( PROP_SECTION, sec_id, kw_type );
         }
      }
   }

   return sec_list.size();
}

unsigned int Validate::createEosFromCards()
{
   char                      *eos_id = 0;
   const char                *card_name;
   unsigned int              i, j, kw_type;
   EosManager                *eos_man = EosManager::create();
   PropManager               *prop_man = PropManager::create();
   vector<ImportObject *> &  impobj_list = eos_man->getImportObjectList();
   ImportObject              *imp_obj = NULL;
   Card                      *card = NULL;
   Data                      *data = NULL;
   map<string, unsigned int> & eos_list = prop_man->getPropList(PROP_EOS);
   
   for(i = 0; i < impobj_list.size(); i++)
   {
      imp_obj = impobj_list[i];
      kw_type = imp_obj->getKeywordType();
      vector<Card *> & card_list = imp_obj->getCardList();
      for(j = 0; j < card_list.size(); j++)
      {
	 card = card_list[j];
         card_name = card->getName().data();
         if( !strcmp(card_name, "Card1") )
         {
	    vector<Data *> & values = card->getVarValues();
	    data = values[0];
	    data->value(&eos_id);
            Generic::RemoveLeadingAndTrailingBlanks(eos_id);
	    prop_man->add( PROP_EOS, eos_id, kw_type );
         }
      }
   }

   return eos_list.size();
}

unsigned int Validate::createHgFromCards()
{
   char                      *hg_id = 0;
   unsigned int              i, j, kw_type;
   HgManager                 *hg_man = HgManager::create();
   PropManager               *prop_man = PropManager::create();
   vector<ImportObject *>    & impobj_list = hg_man->getImportObjectList();
   ImportObject              *imp_obj = NULL;
   Card                      *card = NULL;
   Data                      *data = NULL;
   map<string, unsigned int> & hg_list = prop_man->getPropList(PROP_HG);
   
   for(i = 0; i < impobj_list.size(); i++)
   {
      imp_obj = impobj_list[i];
      kw_type = imp_obj->getKeywordType();
      vector<Card *> & card_list = imp_obj->getCardList();
      for(j = 0; j < card_list.size(); j++)
      {
	 card = card_list[j];
	 vector<Data *> & values = card->getVarValues();
	 data = values[0];
	 data->value(&hg_id);
         Generic::RemoveLeadingAndTrailingBlanks(hg_id);
	 prop_man->add( PROP_HG, hg_id, kw_type );
      }
   }

   return hg_list.size();
}

unsigned int Validate::createPartsFromCards()
{
   bool                      section_found = true;
   char                      *part_name,*sec_id,*mat_id,*eos_id,*hg_id,*tm_id;
   unsigned int              kw_type = 0, sec_type = 0, i, num_values = 0;
   int                       part_id = 0;
   PartCManager              *partc_man = PartCManager::create();
   vector<ImportObject *> &  impobj_list = partc_man->getImportObjectList();
   ImportObject              *imp_obj = NULL;
   Card                      *card = NULL;
   Data                      *data = NULL;
   PartManager               *part_man = PartManager::create();
   Part                      *part = NULL;
   PropManager               *prop_man = PropManager::create();
   map<unsigned int, Part *> & part_map = part_man->getPartMap();
   map<string, unsigned int> & mat_list = prop_man->getPropList(PROP_MATERIAL);
   map<string, unsigned int> & sec_list = prop_man->getPropList(PROP_SECTION);
   map<string, unsigned int> & eos_list = prop_man->getPropList(PROP_EOS);
   map<string, unsigned int> & hg_list = prop_man->getPropList(PROP_HG);
   map<string, unsigned int> & tm_list =
				prop_man->getPropList(PROP_THERMAL_MATERIAL);
   StringUIntIterator        mat_iter, mat_e = mat_list.end();
   StringUIntIterator        sec_iter, sec_e = sec_list.end();
   StringUIntIterator        eos_iter, eos_e = eos_list.end();
   StringUIntIterator        hg_iter, hg_e = hg_list.end();
   StringUIntIterator        tm_iter, tm_e = tm_list.end();
   
   for(i = 0; i < impobj_list.size(); i++)
   {
      imp_obj = impobj_list[i];
      kw_type = imp_obj->getKeywordType();
      if( kw_type >= PART )
      {
         vector<Card *> & card_list = imp_obj->getCardList();
	 card = card_list[0];
	 vector<Data *> & values = card->getVarValues();
         num_values = values.size();
	 data = values[0];
	 data->value(&part_name);

         sec_id = NULL;
         mat_id = NULL;
         eos_id = NULL;
         hg_id = NULL;
         tm_id = NULL;

	 card = card_list[1];
	 values = card->getVarValues();
	 data = values[0];
	 data->value(&part_id);
	 data = values[1];
	 data->value(&sec_id);
	 data = values[2];
	 data->value(&mat_id);

         Generic::RemoveLeadingAndTrailingBlanks(sec_id);
         Generic::RemoveLeadingAndTrailingBlanks(mat_id);

         if( num_values > 3 )
         {
	    data = values[3];
	    data->value(&eos_id);
            Generic::RemoveLeadingAndTrailingBlanks(eos_id);
         }

         if( num_values > 4 )
         {
	    data = values[4];
	    data->value(&hg_id);
            Generic::RemoveLeadingAndTrailingBlanks(hg_id);
         }

         if( num_values > 7 )
         {
	    data = values[7];
	    data->value(&tm_id);
            Generic::RemoveLeadingAndTrailingBlanks(tm_id);
         }


	 if( sec_id && sec_id[0] != '\0' && sec_id[0] != '0' )
	 {
	    sec_iter = sec_list.find(sec_id);
	    if( sec_iter != sec_e )
	    {
               sec_type = (sec_iter->second);
               section_found = true;
	    }
            else
            {
               section_found = false;
	       cout << "SECTION <" << sec_id << "> NOT FOUND for PART <" 
		    << part_id << ">" << endl;
            }
	 }

	 if( mat_id && mat_id[0] != '\0' && mat_id[0] != '0' )
	 {
	    mat_iter = mat_list.find(mat_id);
	    if( mat_iter != mat_e )
	    {
               bool valid_mat = false;

               if( section_found )
               {
                  valid_mat = validateMaterialForSectionType(
					mat_iter->second, sec_type);
		  if(!valid_mat)
		  {
		     cout << "MATERIAL and SECTION are not matching for PART <"
			  << part_id << ">" << endl;
		  }
               }
	    }
            else
	    {
	       cout << "MATERIAL <" << mat_id << "> NOT FOUND for PART <" 
		    << part_id << ">" << endl;
	    }
	 }

	 if( eos_id && eos_id[0] != '\0' && eos_id[0] != '0' )
	 {
	    eos_iter = eos_list.find(eos_id);
	    if( eos_iter == eos_e )
	    {
	       cout << "EOS <" << eos_id << "> NOT FOUND for PART <" 
		    << part_id << ">" << endl;
	    }
	 }

	 if( hg_id && hg_id[0] != '\0' && hg_id[0] != '0' )
	 {
	    hg_iter = hg_list.find(hg_id);
	    if( hg_iter == hg_e )
	    {
	       cout << "HG <" << hg_id << "> NOT FOUND for PART <" 
		    << part_id << ">" << endl;
	    }
	 }

	 if( tm_id && tm_id[0] != '\0' && tm_id[0] != '0' )
	 {
	    tm_iter = tm_list.find(tm_id);
	    if( tm_iter == tm_e )
	    {
	       cout << "THERMAL MATERIAL <" << tm_id 
		    << "> NOT FOUND for PART <" << part_id << ">" << endl;
	    }
	 }

	 part = new Part(part_name, part_id);
	 part->setPropIDs(sec_id, mat_id, eos_id, hg_id, tm_id);
	 part_man->add( part );
      }
   }

   return part_map.size();
}

unsigned int Validate::createShellElementsFromCards()
{
   bool                      node_not_found = false;
   const char                *kw, *card_name;
   char                      part_str[64];
   unsigned int              i, j, k, err = 0, num_nodes = 4;
   int                       pid, eid, elm_nodes[8];
   ElementManager            *elm_man = ElementManager::create();
   vector<ImportObject *> &  impobj_list = elm_man->getImportObjectList();
   ImportObject              *imp_obj = NULL;
   Card                      *card = NULL;
   Data                      *data = NULL;
   Part                      *part;
   PartManager               *part_man = PartManager::create();
   map<unsigned int, Part *>  & part_map = part_man->getPartMap();
   ShellManager              *shell_man = ShellManager::create();
   Shell                     *shell = NULL;
   map<unsigned int, Shell *> & shell_map = shell_man->getShellMap();
   IDPartPtrIterator          id_itr, end_itr = part_map.end();
   NodeManager                *node_man = NodeManager::create();
   map<unsigned int, Node *>  & node_map = node_man->getNodeMap();
   IDNodePtrIterator          node_itr, node_e = node_map.end();

   for(i = 0; i < impobj_list.size(); i++)
   {
      imp_obj = impobj_list[i];
      kw = imp_obj->getKeyword().data();

      if( kw[10] == 'H' )
      {
         vector<Card *> & card_list = imp_obj->getCardList();

         for(j = 0; j < card_list.size(); j++)
         {
            card = card_list[j];
            card_name = card->getName().data();
            if( strcmp(card_name, "Card1") )
               continue;
            vector<Data *> & values = card->getVarValues();
            data = values[0];
            data->value(&eid);
            data = values[1];
            data->value(&pid);

            data = values[2];
            data->value(&elm_nodes[0]);
            data = values[3];
            data->value(&elm_nodes[1]);
            data = values[4];
            data->value(&elm_nodes[2]);
            data = values[5];
            data->value(&elm_nodes[3]);

            num_nodes = 4;
            if( elm_nodes[2] == elm_nodes[3] )
               num_nodes = 3;
            node_not_found = false;
            for(k = 0; k < num_nodes; k++)
            {
	       node_itr = node_map.find(elm_nodes[k]);
	       if(node_itr == node_e)
	       {
		  cout << "NODE <" << elm_nodes[0] << "> NOT FOUND"
                       << " for Element <" << eid << ">" << endl;
		  node_not_found = true;
                  break;
	       }
            }

            if( !node_not_found )
            {
               shell = new Shell(eid, pid, elm_nodes[0], elm_nodes[1],
				              elm_nodes[2], elm_nodes[3]);

	       if( values.size() > 6 )
	       {
		  data = values[6];
		  data->value(&elm_nodes[4]);
		  data = values[7];
		  data->value(&elm_nodes[5]);
		  data = values[8];
		  data->value(&elm_nodes[6]);
		  data = values[9];
		  data->value(&elm_nodes[7]);
		  shell->setMidsideNodes(elm_nodes[4], elm_nodes[5],
				elm_nodes[6], elm_nodes[7]);
	       }

	       shell_man->add(shell);

	       id_itr = part_map.find(pid);
	       if( id_itr != end_itr )
	       {
		  part = id_itr->second;
		  part->addElement(shell);
		  err = 0;
	       }
	       else if( !err )
	       {
		  cout << "SHELL PART <" << pid << "> NOT FOUND" << endl;
		  cout << "NEW PART CREATED WITH ID = " << pid << endl;
		  sprintf(part_str, "Part_NotFound_%d", pid);
		  part = new Part(part_str, pid);
		  part->addElement(shell);
                  part_man->add( part );
		  err++;
	       }
            }
         }
      }
   }

   return shell_map.size();
}

unsigned int Validate::getElementTypeFromSectionType(unsigned int sec_type)
{
   switch(sec_type)
   {
      case SECTION_DISCRETE:
         return ELEMENT_DISCRETE;
      case SECTION_POINT_SOURCE:
      case SECTION_POINT_SOURCE_MIXTURE:
         break;
      case SECTION_SHELL:
      case SECTION_SHELL_ALE:
      case SECTION_SHELL_EFG:
         return ELEMENT_SHELL;
      case SECTION_TSHELL:
         return ELEMENT_TSHELL;
      case SECTION_BEAM:
         return ELEMENT_BEAM;
      case SECTION_SEATBELT:
         return ELEMENT_SEATBELT;
      case SECTION_SOLID:
      case SECTION_SOLID_ALE:
      case SECTION_SOLID_EFG:
         return ELEMENT_SOLID;
      case SECTION_SPH:
      case SECTION_SPH_TENSOR:
      case SECTION_SPH_USER:
         return ELEMENT_SPH;
   }

   return ELEMENT_NEW_TYPE;
}
*/
bool Validate::validateMaterialForSectionType
     (
        unsigned int mat_type, 
        unsigned int sec_type
     )
{

//cout << "MAT TYPE = " << mat_type << endl;
//cout << "SEC TYPE = " << sec_type << endl;

   switch(mat_type)
   {
      case MAT_ALE_GAS_MIXTURE:
      case MAT_ALE_VACUUM:
      case MAT_ALE_VISCOUS:
	 {
	    if( sec_type == SECTION_SOLID_ALE )
	       return true;
	    else
	       return false;
	 }
      case MAT_HILL_FOAM:
      case MAT_ANISOTROPIC_ELASTIC:
      case MAT_HONEYCOMB:
      case MAT_LOW_DENSITY_SYNTHETIC_FOAM:
      case MAT_LOW_DENSITY_SYNTHETIC_FOAM_ORTHO:
      case MAT_LOW_DENSITY_SYNTHETIC_FOAM_ORTHO_WITH_FAILURE:
      case MAT_LOW_DENSITY_SYNTHETIC_FOAM_WITH_FAILURE:
      case MAT_TRANSVERSELY_ISOTROPIC_CRUSHABLE_FOAM:
      case MAT_MODIFIED_HONEYCOMB:
      case MAT_MOHR_COULOMB:
      case MAT_ORTHOTROPIC_SMEARED_CRACK:
      case MAT_ORIENTED_CRACK:
      case MAT_HEART_TISSUE:
      case MAT_LUNG_TISSUE:
      case MAT_SOIL_BRICK:
      case MAT_ACOUSTIC:
      case MAT_CSCM:
      case MAT_SPOTWELD_DAIMLERCHRYSLER:
      case MAT_WOOD:
      case MAT_WOOD_FIR:
      case MAT_WOOD_PINE:
      case MAT_VISCOELASTIC_HILL_FOAM:
      case MAT_ARUP_ADHESIVE:
      case MAT_BRAIN_LINEAR_VISCOELASTIC:
      case MAT_COMPOSITE_FAILURE_SOLID_MODEL:
      case MAT_COHESIVE_ELASTIC:
      case MAT_COHESIVE_GENERAL:
      case MAT_COHESIVE_MIXED_MODE:
      case MAT_COHESIVE_TH:
      case MAT_JOINTED_ROCK:
      case MAT_COMPOSITE_MSC:
      case MAT_DRUCKER_PRAGER:
      case MAT_ADD_EROSION:
      case MAT_CSCM_CONCRETE:
	 {
	    if( sec_type == SECTION_SOLID )
	       return true;
	    else
	       return false;
	 }
      case MAT_FLD_3_PARAMETER_BARLAT:
      case MAT_COMPOSITE_DIRECT:
      case MAT_COMPOSITE_LAYUP:
      case MAT_COMPOSITE_MATRIX:
      case MAT_COMPOSITE_FAILURE_SHELL_MODEL:
      case MAT_ENHANCED_COMPOSITE_DAMAGE:
      case MAT_TRIP:
      case MAT_KINEMATIC_HARDENING_TRANSVERSELY_ANISOTROPIC:
      case MAT_ORTHO_ELASTIC_PLASTIC:
      case MAT_GEPLASTIC_SRATE_2000a:
      case MAT_PLASTICITY_POLYMER:
      case MAT_ANISOTROPIC_ELASTIC_PLASTIC:
      case MAT_LAYERED_LINEAR_PLASTICITY:
      case MAT_SPECIAL_ORTHOTROPIC:
      case MAT_CORUS_VEGTER:
      case MAT_RC_SHEAR_WALL:
      case MAT_FABRIC:
      case MAT_RESULTANT_ANISOTROPIC:
	 {
	    if( sec_type == SECTION_SHELL )
	       return true;
	    else
	       return false;
	 }
      case MAT_GENERAL_SPRING_DISCRETE_BEAM:
      case MAT_CABLE_DISCRETE_BEAM:
      case MAT_SEISMIC_ISOLATOR:
      case MAT_ELASTIC_SPRING_DISCRETE_BEAM:
      case MAT_INELASTIC_SPRING_DISCRETE_BEAM:
      case MAT_GENERAL_JOINT_DISCRETE_BEAM:
      case MAT_HYDRAULIC_GAS_DAMPER_DISCRETE_BEAM:
      case MAT_LINEAR_ELASTIC_DISCRETE_BEAM:
      case MAT_NONLINEAR_ELASTIC_DISCRETE_BEAM:
      case MAT_NONLINEAR_PLASTIC_DISCRETE_BEAM:
      case MAT_SID_DAMPER_DISCRETE_BEAM:
      case MAT_1DOF_GENERALIZED_SPRING:
      case MAT_ELASTIC_6DOF_SPRING_DISCRETE_BEAM:
      case MAT_GENERAL_NONLINEAR_1DOF_DISCRETE_BEAM:
      case MAT_GENERAL_NONLINEAR_6DOF_DISCRETE_BEAM:
      case MAT_INELASTIC_6DOF_SPRING_DISCRETE_BEAM:
	 {
	    if( sec_type == SECTION_BEAM_DISCRETE_OR_CABLE )
	       return true;
	    else
	       return false;
	 }
      case MAT_FLD_TRANSVERSELY_ANISOTROPIC:
      case MAT_TRANSVERSELY_ANISOTROPIC_ELASTIC_PLASTIC:
      case MAT_TRANSVERSELY_ANISOTROPIC_ELASTIC_PLASTIC_ECHANGE:
      case MAT_LAMINATED_GLASS:
      case MAT_3_PARAMETER_BARLAT:
      case MAT_BARLAT_YLD2000:
      case MAT_BARLAT_YLD96:
      case MAT_LAMINATED_COMPOSITE_FABRIC:
      case MAT_RATE_SENSITIVE_COMPOSITE_FABRIC:
      case MAT_WTM_STM:
      case MAT_WTM_STM_PLC:
      case MAT_ANISOTROPIC_PLASTIC:
      case MAT_ORTHOTROPIC_VISCOELASTIC:
      case MAT_HILL_3R:
	 {
	    if( sec_type == SECTION_SHELL || sec_type == SECTION_TSHELL )
	       return true;
	    else
	       return false;
	 }
      case MAT_DESHPANDE_FLECK_FOAM:
      case MAT_WINFRITH_CONCRETE:
      case MAT_WINFRITH_CONCRETE_REINFORCEMENT:
      case MAT_ELASTIC_FLUID:
      case MAT_CLOSED_CELL_FOAM:
      case MAT_FRAZER_NASH_RUBBER_MODEL:
      case MAT_POLYMER:
      case MAT_RAMBERG_OSGOOD:
      case MAT_VISCOUS_FOAM:
      case MAT_INV_HYPERBOLIC_SIN:
      case MAT_LOW_DENSITY_VISCOUS_FOAM:
      case MAT_GAS_MIXTURE:
      case MAT_MODIFIED_CRUSHABLE_FOAM:
      case MAT_VACUUM:
      case MAT_PITZER_CRUSHABLE_FOAM:
      case MAT_MCCORMICK:
      case MAT_RATE_SENSITIVE_POLYMER:
      case MAT_SOIL_CONCRETE:
      case MAT_ANISOTROPIC_THERMOELASTIC:
      case MAT_BRITTLE_DAMAGE:
	 {
	    if( sec_type == SECTION_SOLID || sec_type == SECTION_SOLID_ALE )
	       return true;
	    else
	       return false;
	 }
      case MAT_ISOTROPIC_ELASTIC_PLASTIC:
      case MAT_STRAIN_RATE_DEPENDENT_PLASTICITY:
      case MAT_BAMMAN:
      case MAT_BAMMAN_DAMAGE:
      case MAT_RATE_SENSITIVE_POWERLAW_PLASTICITY:
      case MAT_MODIFIED_ZERILLI_ARMSTRONG:
      case MAT_MTS:
      case MAT_PLASTICITY_COMPRESSION_TENSION:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_TSHELL || sec_type == SECTION_SPH ||
	       sec_type == SECTION_SPH_TENSOR || sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_POWER_LAW_PLASTICITY:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_TSHELL || sec_type == SECTION_SPH ||
	       sec_type == SECTION_SPH_TENSOR || sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_RESULTANT_PLASTICITY:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_BEAM_HUGHES_LIU )
	    return true;
	 else
	    return false;
      case MAT_ADD_THERMAL_EXPANSION:
	 return true;
      case MAT_BLATZ_KO_FOAM:
      case MAT_BLATZ_KO_RUBBER:
      case MAT_OGDEN_RUBBER:
      case MAT_PLASTIC_NONLINEAR_KINEMATIC:
	 {
	    if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
		  sec_type == SECTION_SOLID_ALE )
	       return true;
	    else
	       return false;
	 }
      case MAT_JOHNSON_HOLMQUIST_CERAMICS:
      case MAT_JOHNSON_HOLMQUIST_CONCRETE:
      case MAT_CONCRETE_DAMAGE_REL3:
      case MAT_GEOLOGIC_CAP_MODEL:
      case MAT_FINITE_ELASTIC_STRAIN_PLASTICITY:
      case MAT_ARRUDA_BOYCE_RUBBER:
      case MAT_SCHWER_MURRAY_CAP_MODEL:
	 if( sec_type == SECTION_SOLID || sec_type == SECTION_SPH || 
	    sec_type == SECTION_SPH_TENSOR || sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_DAMAGE_3:
	 if( sec_type == SECTION_SOLID || sec_type == SECTION_SHELL || 
	    sec_type == SECTION_TSHELL || sec_type == SECTION_BEAM_HUGHES_LIU )
	    return true;
	 else
	    return false;
      case MAT_ELASTIC:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_RESULTANT || 
	       sec_type == SECTION_BEAM_TRUSS_RESULTANT || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_SOLID || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_TUBULAR ||
	       sec_type == SECTION_TSHELL || sec_type == SECTION_SPH ||
	       sec_type == SECTION_SPH_TENSOR || sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_ELASTIC_PLASTIC_HYDRO:
      case MAT_ELASTIC_PLASTIC_HYDRO_SPALL:
      case MAT_STEINBERG:
      case MAT_STEINBERG_LUND:
      case MAT_ISOTROPIC_ELASTIC_FAILURE:
      case MAT_SOIL_AND_FOAM_FAILURE:
      case MAT_PSEUDO_TENSOR:
      case MAT_PLASTIC_GREEN_NAGHDI_RATE:
      case MAT_LOW_DENSITY_FOAM:
      case MAT_KELVIN_MAXWELL_VISCOELASTIC:
      case MAT_CRUSHABLE_FOAM:
      case MAT_CONCRETE_DAMAGE:
      case MAT_BILKHU_DUBOIS_FOAM:
      case MAT_HYSTERETIC_SOIL:
      case MAT_FU_CHANG_FOAM:
      case MAT_CELLULAR_RUBBER:
      case MAT_ISOTROPIC_SMEARED_CRACK:
      case MAT_FHWA_SOIL:
      case MAT_FHWA_SOIL_NEBRASKA:
      case MAT_EMMI:
      case MAT_PLASTICITY_COMPRESSION_TENSION_EOS:
      case MAT_SOIL_AND_FOAM:
      case MAT_HIGH_EXPLOSIVE_BURN:
	 if( sec_type == SECTION_SOLID || sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_SPH || sec_type == SECTION_SPH_TENSOR || 
	       sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_ELASTIC_PLASTIC_THERMAL:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_BEAM_TRUSS_RESULTANT || 
	       sec_type == SECTION_TSHELL )
	    return true;
	 else
	    return false;
      case MAT_ELASTIC_WITH_VISCOSITY:
      case MAT_ELASTIC_WITH_VISCOSITY_CURVE:
      case MAT_GENERAL_VISCOELASTIC:
      case MAT_HYPERELASTIC_RUBBER:
      case MAT_MODIFIED_JOHNSON_COOK:
      case MAT_VISCOELASTIC_THERMAL:
      case MAT_QUASILINEAR_VISCOELASTIC:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID || 
	    sec_type == SECTION_SOLID_ALE || sec_type == SECTION_SPH || 
	    sec_type == SECTION_SPH_TENSOR || sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_SHAPE_MEMORY:
      case MAT_UNIFIED_CREEP:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SPH || sec_type == SECTION_SPH_TENSOR || 
	       sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_SIMPLIFIED_JOHNSON_COOK:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_RESULTANT || 
	       sec_type == SECTION_BEAM_TRUSS_RESULTANT || 
	       sec_type == SECTION_TSHELL )
	    return true;
	 else
	    return false;
      case MAT_JOHNSON_COOK:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE || sec_type == SECTION_TSHELL || 
	       sec_type == SECTION_SPH || sec_type == SECTION_SPH_TENSOR || 
	       sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_RIGID:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_RESULTANT || 
	       sec_type == SECTION_BEAM_TRUSS_RESULTANT || 
	       sec_type == SECTION_TSHELL )
	    return true;
	 else
	    return false;
      case MAT_FORCE_LIMITED:
      case MAT_MODIFIED_FORCE_LIMITED:
      case MAT_MOMENT_CURVATURE_BEAM:
      case MAT_STEEL_CONCENTRIC_BRACE:
      case MAT_SEISMIC_BEAM:
	 if( sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_RESULTANT )
	    return true;
	 else
	    return false;
      case MAT_MOONEY_RIVLIN_RUBBER:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_TRUSS_RESULTANT )
	    return true;
	 else
	    return false;
      case MAT_NULL:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_RESULTANT || 
	       sec_type == SECTION_BEAM_TRUSS_RESULTANT || 
	       sec_type == SECTION_BEAM_DISCRETE_OR_CABLE || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_SOLID || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_TUBULAR ||
	       sec_type == SECTION_SPH || sec_type == SECTION_SPH_TENSOR || 
	       sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_MUSCLE:
	 if( sec_type == SECTION_BEAM_TRUSS_RESULTANT )
	    return true;
	 else
	    return false;
      case MAT_ORTHOTROPIC_ELASTIC:
      case MAT_ORTHOTROPIC_THERMAL:
      case MAT_COMPOSITE_DAMAGE:
      case MAT_TEMPERATURE_DEPENDENT_ORTHOTROPIC:
      case MAT_BARLAT_ANISOTROPIC_PLASTICITY:
      case MAT_PLASTICITY_WITH_DAMAGE:
      case MAT_PLASTICITY_WITH_DAMAGE_ORTHO:
      case MAT_PLASTICITY_WITH_DAMAGE_ORTHO_RCDC:
      case MAT_SIMPLIFIED_JOHNSON_COOK_ORTHOTROPIC_DAMAGE:
      case MAT_DAMAGE_1:
      case MAT_DAMAGE_2:
      case MAT_MODIFIED_PIECEWISE_LINEAR_PLASTICITY:
      case MAT_MODIFIED_PIECEWISE_LINEAR_PLASTICITY_RATE:
	 if( sec_type == SECTION_SOLID || sec_type == SECTION_SHELL ||
	       sec_type == SECTION_TSHELL )
	    return true;
	 else
	    return false;
      case MAT_USER_DEFINED_MATERIAL_MODELS:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_BEAM_TRUSS_RESULTANT || 
	       sec_type == SECTION_BEAM_DISCRETE_OR_CABLE || 
	       sec_type == SECTION_TSHELL || 
	       sec_type == SECTION_SPH || sec_type == SECTION_SPH_TENSOR || 
	       sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_PIECEWISE_LINEAR_PLASTICITY:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_TSHELL || sec_type == SECTION_SPH ||
	       sec_type == SECTION_SPH_TENSOR || sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_PLASTIC_KINEMATIC:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_HUGHES_LIU || 
	       sec_type == SECTION_BEAM_TRUSS_RESULTANT || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_SOLID || 
	       sec_type == SECTION_BEAM_BELYTSCHKO_SCHWER_TUBULAR ||
	       sec_type == SECTION_TSHELL || sec_type == SECTION_SPH ||
	       sec_type == SECTION_SPH_TENSOR || sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_CONCRETE_EC2:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_BEAM_HUGHES_LIU )
	    return true;
	 else
	    return false;
      case MAT_SEATBELT:
	 if( sec_type == SECTION_SEATBELT )
	    return true;
	 else
	    return false;
      case MAT_CONCRETE_BEAM:
      case MAT_RC_BEAM:
         {
	    if( sec_type == SECTION_BEAM_HUGHES_LIU )
	       return true;
	    else
	       return false;
         }
      case MAT_NONLINEAR_ORTHOTROPIC:
      case MAT_SOFT_TISSUE:
      case MAT_SOFT_TISSUE_VISCO:
      case MAT_ELASTIC_VISCOPLASTIC_THERMAL:
      case MAT_GURSON:
      case MAT_GURSON_JC:
      case MAT_GURSON_RCDC:
      case MAT_COMPOSITE_MSC_DMG:
      case MAT_SIMPLIFIED_RUBBER_FOAM:
      case MAT_SIMPLIFIED_RUBBER_FOAM_WITH_FAILURE:
      case MAT_SIMPLIFIED_RUBBER_WITH_DAMAGE:
      case MAT_SAMP_1:
      case MAT_THERMO_ELASTO_VISCOPLASTIC_CREEP:
      case MAT_NONLOCAL:
	 {
	    if( sec_type == SECTION_SOLID || sec_type == SECTION_SHELL )
	       return true;
	    else
	       return false;
	 }
      case MAT_DAMPER_NONLINEAR_VISCOUS:
      case MAT_DAMPER_VISCOUS:
      case MAT_SPRING_INELASTIC:
      case MAT_SPRING_MUSCLE:
      case MAT_SPRING_TRILINEAR_DEGRADING:
      case MAT_SPRING_ELASTIC:
      case MAT_SPRING_ELASTOPLASTIC:
      case MAT_SPRING_GENERAL_NONLINEAR:
      case MAT_SPRING_MAXWELL:
      case MAT_SPRING_NONLINEAR_ELASTIC:
      case MAT_SPRING_SQUAT_SHEARWALL:
	 {
	    if( sec_type == SECTION_DISCRETE )
	       return true;
	    else
	       return false;
	 }
      case MAT_THERMAL_ISOTROPIC:
      case MAT_THERMAL_ISOTROPIC_PHASE_CHANGE:
      case MAT_THERMAL_ISOTROPIC_TD:
      case MAT_THERMAL_ISOTROPIC_TD_LC:
      case MAT_THERMAL_ORTHOTROPIC:
      case MAT_THERMAL_ORTHOTROPIC_TD:
      case MAT_THERMAL_USER_DEFINED:
	 return true;
      case MAT_VISCOELASTIC:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_SOLID_ALE ||
	       sec_type == SECTION_BEAM_HUGHES_LIU ||
	       sec_type == SECTION_SPH || sec_type == SECTION_SPH_TENSOR ||
	       sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_ANISOTROPIC_VISCOPLASTIC:
	 if( sec_type == SECTION_SHELL || sec_type == SECTION_SOLID ||
	       sec_type == SECTION_TSHELL || sec_type == SECTION_SPH || 
	       sec_type == SECTION_SPH_TENSOR || sec_type == SECTION_SPH_USER )
	    return true;
	 else
	    return false;
      case MAT_SPOTWELD:
      case MAT_SPOTWELD_DAMAGE_FAILURE:
	 {
	    if( sec_type == SECTION_BEAM_SPOTWELD || 
	       sec_type == SECTION_BEAM_HUGHES_LIU || sec_type == SECTION_SOLID)
	       return true;
	    else
	       return false;
	 }
   }

   return false;
}

