#ifndef _EF_MANAGER_H_
#define _EF_MANAGER_H_

#include "manager.h"

using namespace std;

/** Manager class to hold all the keywords starting with *EF. All the keywords
  * are stored as list of ImportObject. This class holds its own instance here.
  */
class EFManager : public Manager
{
private:
   /** Default constructor for creating this object */
   EFManager() : Manager()
   {
   }

public:
   /** Static function to create this object. Object is created if already not 
     * there. only one instance exists at any point of time.
     */
   static EFManager *create()
   {
      if( !managerPtr )
         managerPtr = new EFManager();

      return managerPtr;
   }

   /** Destroys the stored instance of this object and initializes to NULL. */
   static void reset()
   {
      if( managerPtr )
         delete managerPtr;

      managerPtr = NULL;
   }

   ~EFManager()
   {
      managerPtr = NULL;
   }

private:
   static EFManager *managerPtr;
};

#endif

