#ifndef _GENERIC_H_
#define _GENERIC_H_

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define TITLE_CARD 500

using namespace std;

/** Abstract class for holding generic functions. */
class Generic
{
public:
   /** Function to remove leading and trailing blanks, new-line and control chars
     * \param char_array string from which control chars to be removed
     */
   inline static void RemoveLeadingAndTrailingBlanks(char *char_array)
   {
       char    *ptr = char_array, *eptr = NULL;
       char    temp_arr[128];

       int len = strlen(char_array);

#ifdef DEBUG
cout << "ORIGINAL = " << char_array << endl;
cout << "LENGTH = " << len << endl;
#endif

       for(int i = 0; i < len;i++)
       {
	   if( !isgraph(char_array[i]) )
	       ptr++;
	   else
	       break;
       }

       eptr = char_array + len - 1;

       if( ptr[0] == '\0' )
       {
	   char_array[0] = '\0';
	   return;
       }

       for(int k = len-1; k >= 0;k--)
       {
	   if( !isgraph(char_array[k]) || iscntrl(char_array[k]) )
	       eptr--;
	   else
	       break;
       }

       len = eptr - ptr + 1;

       memcpy(temp_arr, ptr, len);
       temp_arr[len] = '\0';
       memcpy(char_array, temp_arr, len);
       char_array[len] = '\0';

#ifdef DEBUG
cout << "LENGTH = " << len << endl;
cout << "MODIFIED = " << char_array << endl;
#endif
   }

   /** Function to remove trailing blanks, new-line and control chars
     * \param char_array string from which control chars to be removed
     */
   inline static void RemoveTrailingBlanks(char *char_array)
   {
       char    *ptr = char_array, *eptr = NULL;
       char    temp_arr[128];

       int len = strlen(char_array);

#ifdef DEBUG
cout << "ORIGINAL = " << char_array << endl;
cout << "LENGTH = " << len << endl;
#endif

       eptr = char_array + len - 1;

       for(int k = len-1; k >= 0;k--)
       {
	   //if( !isgraph(char_array[k]) )
	   if( !isgraph(char_array[k]) || iscntrl(char_array[k]) )
	       eptr--;
	   else
	       break;
       }

       len = eptr - ptr + 1;

       memcpy(temp_arr, ptr, len);
       temp_arr[len] = '\0';
       memcpy(char_array, temp_arr, len);
       char_array[len] = '\0';

#ifdef DEBUG
cout << "LENGTH = " << len << endl;
cout << "MODIFIED = " << char_array << endl;
#endif
   }


   /** Function to copy chars from source to destination with a specified number
     * \param dest Destination pointer to where the chars are to be copied
     * \param src Source pointer from which the chars are to be taken
     * \param n Count of chars
     */
   inline static void MemCpy(char *dest, const char *src, size_t n)
   {
      memcpy(dest, src, n);

      void *vptr = memrchr(dest, 'e', n);
      void *vptr1 = memrchr(dest, 'E', n);
      void *vptr2 = memrchr(dest, '.', n);

      if( vptr || vptr1 || !vptr2 )
	 return;

      char c = *(dest + n -1);
      char d = *(dest + n -2);
      char f = *(dest + n -3);

      if( d == '+' || d == '-' )
      {
	 dest[n-2] = 'e';
	 dest[n-1] = d;
	 dest[n] = c;
	 dest[n+1] = '\0';
      }
      else if( f == '+' || f == '-' )
      {
	 dest[n-3] = 'e';
	 dest[n-2] = f;
	 dest[n-1] = d;
	 dest[n] = c;
	 dest[n+1] = '\0';
      }

      return;
   }
};

#endif
