#ifndef _Term_MANAGER_H_
#define _Term_MANAGER_H_

#include "manager.h"
#include "termtype.h"

using namespace std;

/** Manager class to hold all the keywords starting with *TERMINATION. All the 
  * keywords are stored as list of ImportObject. This class holds its own 
  * instance here.
  */
class TermManager : public Manager
{
private:
   /** Default constructor for creating this object */
   TermManager() : Manager()
   {
   }

public:
   /** Static function to create this object. Object is created if already not 
     * there. only one instance exists at any point of time.
     */
   static TermManager *create()
   {
      if( !managerPtr )
         managerPtr = new TermManager();
      return managerPtr;
   }

   /** Destroys the stored instance of this object and initializes to NULL. */
   static void reset()
   {
      if( managerPtr )
         delete managerPtr;
      managerPtr = NULL;
   }

   ~TermManager()
   {
      managerPtr = NULL;
   }

private:
   static TermManager *managerPtr;
};

#endif

