#ifndef _User_MANAGER_H_
#define _User_MANAGER_H_

#include "manager.h"

using namespace std;

/** Manager class to hold all the keywords starting with *USER. All the keywords
  * are stored as list of ImportObject. This class holds its own instance here.
  */
class UserManager : public Manager
{
private:
   /** Default constructor for creating this object */
   UserManager() : Manager()
   {
   }

public:
   /** Static function to create this object. Object is created if already not 
     * there. only one instance exists at any point of time.
     */
   static UserManager *create()
   {
      if( !managerPtr )
         managerPtr = new UserManager();

      return managerPtr;
   }

   /** Destroys the stored instance of this object and initializes to NULL. */
   static void reset()
   {
      if( managerPtr )
         delete managerPtr;

      managerPtr = NULL;
   }

   ~UserManager()
   {
      managerPtr = NULL;
   }


private:
   static UserManager *managerPtr;
};

#endif

