<?php
  //This file is used for automatic generation of enums for all the keywords 
  //except part, rigidwall and contact. The new types are to be added to the
  // end of the existing enums.
  $imp_class = $argv[1];
  $enum_name = basename($imp_class, 'Import');

  $type_str = "#ifndef _" . $enum_name . "Type_h_\n";
  $type_str .= "#define _" . $enum_name . "Type_h_\n\n";
  $type_str .= "typedef enum _" . $enum_name . "Type\n";
  $type_str .= "{\n";

  if( $enum_name == "Keyword" )
     $num = 400;
  else
     $num = 1;
  for($i = 2; $i < $argc; $i++)
  {
     $file_list = scandir($argv[$i]);

     foreach ($file_list as $file)
     {
	$file_name = basename($file);
	if( strstr($file_name, ".xml") )
	{
	   $xml = simplexml_load_file("$argv[$i]/$file");
	   $kw = $xml['name'];
	   $cpp = $xml['cppfile'];

	   if( strcmp($cpp, "no") || (strstr($kw, "KEYWORD") || strstr($kw, "HOURGLASS")) )
	   {
              $num = $xml['id'];
/** This three lines of code was used for adding the id to the xml files.
  This was done because as the new keywords are added through XML files
  the developer need not take about the enums for each new version. The enum
  is added to the XML files itself. So that the enums are generated
  automatically without worrying about the changing of enums after new XMLs for
  new keywords. From here onwards each keyword will have a fixed enum forever.
		  $xml['id'] = $num;
		  file_put_contents("$argv[$i]/$file", $xml->asXML());
		  $num += 1;
*/
              $type_str .= "   $kw = $num,\n";
              //$type_str .= "   $kw,\n";
	   }
	}
     }
  }

  $type_str .= "\n   " . strtoupper($enum_name) . "_NEW_TYPE\n";
  $type_str .= "}\n";
  $type_str .= "   " . $enum_name . "Type;\n\n";
  $type_str .= "#endif\n\n";

  $file_name = strtolower($enum_name) . "type.h";
  $file_ptr = fopen($file_name, 'w');
  fwrite($file_ptr, $type_str);
  fclose($file_ptr);
?>
