<?php
   function getCardsFromXml($file_name)
   {
      $xml = simplexml_load_file($file_name);

      $kw = $xml['name'];
      $cpp = $xml['cppfile'];
      $class_name = $xml['classname'];

      $card = $xml->card;
      if( !$card )
	 return "";

      $class_str = "";
      $glb_var_arr = array();
      $field_card_array = array();
      $var_str = "";

      $base_class = $xml->baseclass['name'];

      $card_arr = array();
      $card_widths_array = array();
      $card_num = 0;
      $loop_card_arr = array();
      foreach ($xml->card as $card)
      {
	 $head_str = "echo \"<tr class='fields'>\";\n";
	 $input_str = "echo \"<tr class='fields'>\";\n";

	 $card_name = $card['name'];
	 $ret_var = $card['return'];
	 $ret_type = $card['returntype'];
	 $card_num++;

	 if( $ret_var )
	 {
	    $glb_var_arr["$ret_var"] = $ret_type;
	 }

	 $field_arr = array();
	 $field_widths_array = array();
	 $alt_field_arr = array();
	 $field_num = 0;

	 $cname = $card_name;

	 foreach($card->field as $field)
	 {
	    $unused_name = "";
	    $width = (int)$field['width'];
	    $field_name = $field['name'];
            if( $width != 10 )
               $field_widths_array["$field_name"] = $width;

	    $field_num++;

            //don't change this name as this has dependency of field names
	    if( !strcasecmp($field_name, "unused") )
	      //$unused_name="UU_" . $field_num . "_C_" . $card_num;
	      $unused_name="UU_" . $field_num . "_" . $cname;

	    $alt_field_name = "C_" . $card_num . "_F_" . $field_num;

	    $value = $field['value'];
	    $type = $field['type'];

	    if( $unused_name )
	    {
	       array_push($field_arr, $unused_name);
	       array_push($alt_field_arr, $alt_field_name);
               $fname = $cname . "__" . $unused_name;
	       $field_card_array["$fname"] = $cname;
	    }
	    else
	    {
	       array_push($field_arr, $field_name);
	       array_push($alt_field_arr, $alt_field_name);
               $fname = $cname . "__" . $field_name;
	       $field_card_array["$fname"] = $cname;
	    }

	    $col_span = 1;
	    switch($width)
	    {
	       case 8:
	       case 10:
		  $col_span = 1;
		  break;
	       case 16:
	       case 20:
		  $col_span = 2;
		  break;
	       case 70:
		  $col_span = 7;
		  break;
	       case 80:
		  $col_span = 8;
		  break;
	    }

	    if( $col_span == 1 )
	    {
	       $head_str .= "echo \"<td>\";\n";
	    }
	    else
	    {
	       $head_str .= "echo \"<td colspan='$col_span'>\";\n";
	    }

            $pos = strpos($kw, "_");
            $html_name = "";

            if( $pos )
               $html_name = substr($kw, 0, $pos);
	    else
	       $html_name = $kw;
            $html_name = strtolower($html_name);
	    $head_str .= "echo \"<a target='_blank' href='/lsdhelp/$html_name.xml#$field_name'>$field_name</a>\";\n";
	    $head_str .= "echo \"</td>\";\n";

	    if( !strncmp($field_name, "UNUSED", 6) )
	    {
	       $input_str .= "initVar('krishna', \"$cname\", \"$unused_name\");\necho \"<td><input readonly='yes' class='textProp' type='text' size='$width' name=\\\"$unused_name\\\" onchange=\\\"return sendRequest('krishna', '$cname', '$unused_name', this.value)\\\" value='\" . getVarValue('krishna', \"$cname\", \"$unused_name\") . \"' maxlength='$width' id=\\\"$alt_field_name\\\"></input></td>\";\n";
	    }
	    else
	    {
	       if( $col_span == 1 )
	       {
		  if( strcmp($field_name, $ret_var) )
		  {
                     if( $field['global'] == null )
                     {
		        $input_str .= "initVar('krishna', \"$cname\", \"$field_name\");\necho \"<td><input class='textProp' type='text' size='$width' name=\\\"$field_name\\\" onchange=\\\"return sendRequest('krishna', '$cname', '$field_name', this.value)\\\" value='\" . getVarValue('krishna', \"$cname\", \"$field_name\") . \"' maxlength='$width' id=\\\"$alt_field_name\\\"></input></td>\";\n";
                     }
                     else
                     {
		        $input_str .= "initVar('krishna', \"$cname\", \"$field_name\");\necho \"<td><input class='textProp' type='text' size='$width' name=\\\"$field_name\\\" onchange=\\\"return sendRequestAndReload('krishna', '$cname', '$field_name', this.value)\\\" value='\" . getVarValue('krishna', \"$cname\", \"$field_name\") . \"' maxlength='$width' id=\\\"$alt_field_name\\\"></input></td>\";\n";
                     }
		  }
		  else
		  {
		     $input_str .= "initVar('krishna', \"$cname\", \"$field_name\");\necho \"<td><input class='textProp' type='text' size='$width' name=\\\"$field_name\\\" onchange=\\\"return sendRequestAndReload('krishna', '$cname', '$field_name', this.value)\\\" value='\" . getVarValue('krishna', \"$cname\", \"$field_name\") . \"' maxlength='$width' id=\\\"$alt_field_name\\\"></input></td>\";\n";
		  }
	       }
	       else
	       {
		  if( strcmp($field_name, $ret_var) )
		  {
		     $input_str .= "initVar('krishna', \"$cname\", \"$field_name\");\necho \"<td colspan='$col_span'><input class='textProp' type='text' size='$width' name=\\\"$field_name\\\" onchange=\\\"return sendRequest('krishna', '$cname', '$field_name', this.value)\\\" value='\" . getVarValue('krishna', \"$cname\", \"$field_name\") . \"' maxlength='$width' id=\\\"$alt_field_name\\\"></input></td>\";\n";
		  }
		  else
		  {
		     $input_str .= "initVar('krishna', \"$cname\", \"$field_name\");\necho \"<td colspan='$col_span'><input class='textProp' type='text' size='$width' name=\\\"$field_name\\\" onchange=\\\"return sendRequestAndReload('krishna', '$cname', '$field_name', this.value)\\\" value='\" . getVarValue('krishna', \"$cname\", \"$field_name\") . \"' maxlength='$width' id=\\\"$alt_field_name\\\"></input></td>\";\n";
		  }
	       }
	    }
	 }

	 $card_arr["$card_name"] = $field_arr;
         if( count($field_widths_array) )
         {
	    $card_widths_array["$card_name"] = $field_widths_array;
         }

	 $head_str .= "echo \"</tr>\";\n";
	 $input_str .= "insertCard(\"$card_name\");\n";
	 $input_str .= "echo \"</tr>\";\n";

	 $loop_str = "";
	 if( $card->loop )
	 {
	    array_push($loop_card_arr, $card_name);
	    $loop_field = strtolower($card->loop['loopfield']);
	    if( $loop_field )
	       $glb_var_arr["$loop_field"] = "int";
	    $start = $card->loop['start'];
	    $end = strtolower($card->loop['end']);
	    if( $loop_field )
	       $end = str_replace($loop_field, "\$$loop_field", $end);
	    $loop_str .= "for(\$i = $start;\$i < (int) $end;\$i++)\n";
	    $loop_str .= "{\n";
	 }

	 if( $loop_str )
	 {
	    $card_array["head_$card_name"] = $loop_str . $head_str;
	    $card_array["input_$card_name"] = $input_str . "}\n";
	 }
	 else
	 {
	    $card_array["head_$card_name"] = $head_str;
	    $card_array["input_$card_name"] = $input_str;
	 }
      }

/* this was for dyna file export
      if( count($card_widths_array) )
      {
echo "\"$kw\" => ";
         $wstr = var_export($card_widths_array);
echo "$wstr,\n";
      }
*/

      //check for duplicate fields in one kw
      $card_keys = array_keys($card_arr);
      $card_count = count($card_keys);
      $flag = 0;
      for($c = 0; $c < $card_count; $c++)
      {
         $card_key = $card_keys[$c];
         $f_arr = $card_arr["$card_key"];

         foreach($f_arr as $f_key)
         {
	    for($f = $c; $f < $card_count; $f++)
	    {
               if( $f == $c )
                  continue;

	       $ckey = $card_keys[$f];
	       $farray = $card_arr["$ckey"];
               foreach($farray as $fkey)
               {
                  if( !strcmp($f_key, $fkey) )
                  {
                     echo "WARNING: field names are same in <$card_key> and " .
                              "<$ckey> for $fkey\n";
                     $flag = 1;
                  }
               }
	    }
         }
      }

      if( $flag == 1 )
      {
         echo $file_name . "\n";
      }

      foreach ($xml->condition as $cond)
      {
	 $stmt = $cond['statement'];

	 if( $cond->refcard )
	 {
	    foreach ($cond->refcard as $refcard)
	    {
	       $refcard_name = $refcard['name'];
	       foreach ($refcard->reffield as $reffield)
	       {
		  $ref_field = $reffield['name'];
                  $fname = $refcard_name . "__" . $ref_field;
		  $field_card_array["$fname"] = $refcard_name;
		  $ref_type = $reffield['type'];
		  $glb_var_arr["$ref_field"] = $ref_type;
	       }
	    }
	 }

	 $glb_var_arr = array_change_key_case($glb_var_arr, CASE_LOWER);
	 $var_keys = array_keys($glb_var_arr);

         $starloop = $cond['starloop'];

	 if( $stmt )
	 {
	    $new_stmt = $stmt;
	    foreach ($var_keys as $var)
	    {
	       $new_stmt = str_replace($var, "\$$var", $new_stmt);
	    }
	    
	    $class_str .= $new_stmt;
	    $class_str .= "{\n";

	    $loop_str = "";
	    if( $cond->loop )
	    {
	       $start = $cond->loop['start'];
	       $end = $cond->loop['end'];

	       foreach ($var_keys as $var)
	       {
		  $end = str_replace($var, "\$$var", $end);
	       }

	       $loop_str .= "for(\$i = $start; \$i < (int) $end; \$i++)\n";
	       $loop_str .= "{\n";
	       $class_str .= $loop_str;
	    }

	    foreach ($cond->card as $con_card)
	    {
	       $cname = $con_card['name'];
	       if( $cond->loop )
		  array_push($loop_card_arr, $cname);
          
               $stmt = $con_card['statement'];
               if( $stmt )
               {
		  $new_stmt = $stmt;
		  foreach ($var_keys as $var)
		  {
		     $new_stmt = str_replace($var, "\$$var", $new_stmt);
		  }
		  
		  $class_str .= $new_stmt;
		  $class_str .= "{\n";
               }

	       $class_str .= $card_array["head_$cname"];
	       $class_str .= $card_array["input_$cname"];

               if( $stmt )
	          $class_str .= "}\n";
	    }

	    if( $loop_str )
	    {
	       $class_str .= "}\n";
	    }

	    $class_str .= "}\n";
	 }
         else if( !strcmp($starloop, 'yes') )
         {
	    $class_str .= "echo \"<tr class='fields'>\";\n";
	    $class_str .= "echo \"<td title='not used in save'>LOOP VAR</td>\";\n";
	    $class_str .= "echo \"</tr>\";\n";
	    $class_str .= "echo \"<tr class='fields'>\";\n";
	    $class_str .= "initVar('krishna', \"StarCard\", \"STARVAR\");\necho \"<td><input class='textProp' type='text' size='10' name=\\\"STARVAR\\\" onchange=\\\"return sendRequestAndReload('krishna', 'StarCard', 'STARVAR', this.value)\\\" value='\" . getVarValue('krishna', \"StarCard\", \"STARVAR\") . \"' maxlength='10'></input></td>\";\n";
	    $class_str .= "echo \"</tr>\";\n";
	    $class_str .= "insertCard(\"StarCard\");\n";

	    $glb_var_arr["STARVAR"] = "int";
            $fname = "StarCard__STARVAR";
            $field_card_array["$fname"] = "StarCard";

	    $class_str .= "for(\$i = 0; \$i < \$STARVAR; \$i++)\n";
	    $class_str .= "{\n";
            
	    foreach ($cond->card as $con_card)
	    {
	       $cname = $con_card['name'];
	       array_push($loop_card_arr, $cname);

               $stmt = $con_card['statement'];
               if( $stmt )
               {
		  $new_stmt = $stmt;
                  $get_str = "";
		  foreach ($var_keys as $var)
		  {
                     if( strstr($new_stmt, $var) )
                     {
                        $up_var = strtoupper($var);
	                $get_str .= "\$$var = (" . $glb_var_arr["$var"] . ") getVarValue('krishna', \"" . getCardName($field_card_array, $up_var, 0) . "\", \"" . $up_var . "\");\n";
                     }

		     $new_stmt = str_replace($var, "\$$var", $new_stmt);
		  }
		  
                  if( !strstr($new_stmt, "else if") )
                     $class_str .= $get_str;
		  $class_str .= $new_stmt;
		  $class_str .= "{\n";
               }

               //$class_str .= "if( (\$i == 0) )\n";
               //$class_str .= "{\n";
	       $class_str .= $card_array["head_$cname"];
               //$class_str .= "}\n";
	       $class_str .= $card_array["input_$cname"];

               if( $stmt )
	          $class_str .= "}\n";
	    }

	    $class_str .= "}\n";
         }
	 else
	 {
	    $loop_str = "";
	    if( $cond->loop )
	    {
	       $start = $cond->loop['start']; 
	       $end = $cond->loop['end']; 

	       foreach ($var_keys as $var)
	       {
		  $end = str_replace($var, "\$$var", $end);
	       }

	       $loop_str .= "for(\$i = $start; \$i < (int) $end; \$i++)\n";
	       $loop_str .= "{\n";
	       $class_str .= $loop_str;
	    }

	    foreach ($cond->card as $con_card)
	    {
	       $cname = $con_card['name'];
	       if( $cond->loop )
		  array_push($loop_card_arr, $cname);

               $stmt = $con_card['statement'];
               if( $stmt )
               {
		  $new_stmt = $stmt;
		  foreach ($var_keys as $var)
		  {
		     $new_stmt = str_replace($var, "\$$var", $new_stmt);
		  }
		  
		  $class_str .= $new_stmt;
		  $class_str .= "{\n";
               }

	       $class_str .= $card_array["head_$cname"];
	       $class_str .= $card_array["input_$cname"];

               if( $stmt )
	          $class_str .= "}\n";
	    }

	    if( $loop_str )
	    {
	       $class_str .= "}\n";
	    }
	 }
      }

      $var_keys = array_keys($glb_var_arr);
      $uniq_var_keys = array_unique($var_keys);

      foreach ($uniq_var_keys as $var)
      {
	 $up_var = strtoupper($var);
	 $var_str .= "\$$var = (" . $glb_var_arr["$var"] . ") getVarValue('krishna', \"" . getCardName($field_card_array, $up_var, 0) . "\", \"" . $up_var . "\");\n";
	 $var_find = "name=\\\"" . strtoupper($var) . "\\\" onchange=\\\"return sendRequestAndReload";
	 $var_find1 = "name=\\\"" . strtoupper($var) . "\\\" onchange=\\\"return sendRequest";
	 if( !strstr($class_str, $var_find) )
	 {
	   $class_str = str_replace($var_find1, $var_find, $class_str);
	 }
      }

      if( $class_str )
      {
	 $uniq_loop_cards = array_unique($loop_card_arr);

	 foreach ($uniq_loop_cards as $card_loop)
	 {
	    $fields = $card_arr["$card_loop"];
	    foreach ($fields as $fld)
	    {
	       //$class_str = str_replace("name=\\\"$fld\\\"", "name=\\\"$fld\$i\\\"", $class_str);

               $c_name = getCardName($field_card_array, $fld, 1);

	       $find = "'" . $c_name . "', '$fld', this.value";
	       //$rpl = "'" . $c_name . "\$i', '$fld\$i', this.value";
	       $rpl = "'" . $c_name . "_\$i', '$fld', this.value";
	       $class_str = str_replace($find, $rpl, $class_str);
	       //$class_str = str_replace("php', '$fld'", "php', '$fld\$i'", $class_str);


	       $find = "getVarValue('krishna', \"" . $c_name . "\", \"$fld\"";
	       //$rpl = "getVarValue('krishna', \"" . $c_name . "\$i\", \"$fld\$i\"";
	       $rpl = "getVarValue('krishna', \"" . $c_name . "_\$i\", \"$fld\"";
	       $class_str = str_replace($find, $rpl, $class_str);


	       $find = "initVar('krishna', \"" . $c_name . "\", \"$fld\"";
	       //$rpl = "initVar('krishna', \"" . $c_name . "\$i\", \"$fld\$i\"";
	       $rpl = "initVar('krishna', \"" . $c_name . "_\$i\", \"$fld\"";
	       $class_str = str_replace($find, $rpl, $class_str);

	       $class_str = str_replace("insertCard(\"$c_name\");", "insertCard(\"$c_name" . "_\$i\");", $class_str);
	    }
	 }

	 $comb_str = $var_str . $class_str;
      }

      return $comb_str;
   }

   function startOfPage(&$kw, &$kw_short_name)
   {
      $loc = strpos($kw, "_");
      $short = "";
      if( $loc )
         $short = substr($kw, 0, $loc);
      else
         $short = $kw;
      $str = getStartOfPage($kw);

      $str .= "<?php\n";
      $str .= "include '../lsd.php';\n";
      $str .= "?>\n";
      $str .= "<table cellspacing='0' cellpadding='0' border='1'>\n";
      $str .= "<thead align='left'>\n";
      $str .= "<tr>\n<th class='headingTextProp'>*$kw</th><td><a href='/lsdhelp/" . strtolower($short) . ".xml' target='_blank'>Help</a></td></tr>\n</thead>\n";
      $str .= "</table>\n";      
      $str .= "<table cellspacing='0' cellpadding='0' border='1'>\n";


      $str .= "<?php\n";
      
      $str .= "initCardsArray('$kw_short_name');\n";
      $str .= "\$edit = getVarValue('ObjectFrame','Gui','CommandButton');\n";
      $str .= "if( \$edit == 'Edit' )\n{\n";
      $str .= "\$user_dir = getVarValue('DBFrame', 'Gui', 'UserDir');\n";
      $str .= "include \"../../\$user_dir/data.php\";\n";
      $str .= "loadData(\"$kw_short_name\", \"$kw\");\n";
      $str .= "setValue('ObjectFrame','Gui','CommandButton', \"\");\n";
      $str .= "}\n";

      return $str;
   }

   function endOfPage(&$kw, &$kw_short_name)
   {
      $str = "?>\n"; 
      $str .= "</table>\n";

      $str .= "<table cellspacing='1' cellpadding='0' border='0'>\n";
      $str .= "<tr><td align='center'><input disabled='true' class='okProp' type='button' name='New' value='New' onclick=\"return saveRequest('$kw', '$kw_short_name', 'New')\"></input></td>\n";
      $str .= "<td align='center'><input disabled='true' class='okProp' type='button' name='Save' value='Save' onclick=\"return saveRequest('$kw', '$kw_short_name', 'Save')\"></input></td>\n";
      $str .= "<td align='center'><input class='resetProp' type='button' name='Reset' value='Reset' onclick=\"return resetRequest('$kw', '$kw_short_name')\"></input></td></tr>\n";
      $str .= "</table>\n";
      $str .= "<div id='testElm'></div>\n";
      $str .= "<input type='hidden' name='$kw_short_name' value='$kw'></input>\n";
      $str .= "</form>\n</body>\n</html>\n";

      return $str;
   }

   function getStartOfPage(&$kw)
   {
      return "<!DOCTYPE HTML>
<html lang='en'>
<head><title>$kw</title>
<meta charset='UTF-8'>
<meta name='viewport' content='width=device-width,initial-scale=1.0'>
<meta http-equiv='X-UA-Compatible' content='ie=edge'>
<link href='/js/lsd.css' rel='stylesheet'/>
<script language='JavaScript' src='/js/jquery.js' type='text/javascript'>
</script>
<script language='JavaScript' src='/js/lsdxmlhttp.js' type='text/javascript'>
</script>
<script language='JavaScript' src='/js/lsd.js' type='text/javascript'>
</script>
</head>
<body>
<form action=\"\" method=\"POST\" name=\"" . strtolower($kw) . "\">\n";
   }

   function createLinks(&$dir_name, &$web_root, &$link_list)
   {
      $link_str = "<html><head><title>" . strtoupper($dir_name) . " KEYWORDS </title></head><body><table>\n";
      ksort($link_list);
      $link_keys = array_keys($link_list);
      foreach ($link_keys as $link)
      {
	 $link_str .= "<tr><td><a href='" . $link_list["$link"] . "'>*$link</a></td></tr>\n";
      }

      $link_str .= "</table></body></html>\n";

      $link_file = $web_root . $dir_name . "_index.html"; 
      echo "LINK FILE = " . $link_file . "\n";

      $link_file_ptr = fopen($link_file, 'w');
      fwrite($link_file_ptr, $link_str);
      fclose($link_file_ptr);
   }

   function createJSFiles(&$dir_name, &$web_root, &$kw_array)
   {
      ksort($kw_array);
      $kw_keys = array_keys($kw_array);
      $kw_str = "var options=parent.frames['HeadFrame'].document.mainForm.KWList.options;\n";
      $kw_str .= "var names_array = [";
      $cnt = count($kw_keys) -1;
      for($i = 0; $i < $cnt; $i++)
      {
         $kw_str .= "\"*$kw_keys[$i]\",";
      }
      $kw_str .= "\"*$kw_keys[$i]\"];\n";
      $kw_str .= "var values_array = [";

      for($i = 0; $i < $cnt; $i++)
      {
         $kw_str .= "\"" . strtolower($kw_keys[$i]) . "\",";
      }
      $kw_str .= "\"" . strtolower($kw_keys[$i]) . "\"];\n";
      $kw_str .= "modifyKWList(options, names_array, values_array);\n";

      if( !file_exists("$web_root/js") )
         mkdir("$web_root/js", 0755, true);
      $kw_file = $web_root . "js/" . $dir_name . ".js";
      $kw_file_ptr = fopen($kw_file, 'w');
      fwrite($kw_file_ptr, $kw_str);
      fclose($kw_file_ptr);
   }

   function getCardName(&$field_card_array, &$field_name, $del)
   {
      $fkeys = array_keys($field_card_array);

      foreach ($fkeys as $fkey)
      {
         $cname = $field_card_array["$fkey"];

         $arr = explode("__", $fkey);
         if( !strcmp($cname, $arr[0]) && !strcmp($field_name, $arr[1]) )
         {
            if( $del == 1 )
               unset($field_card_array["$fkey"]);
            return $arr[0];
         }
      }

      return "";
   }

   function getKWShortName($kw)
   {
      if( strstr($kw, "*AIRBAG_") )
         return "ABG";
      else if( strstr($kw, "*ALE_") )
         return "ALE";
      else if( strstr($kw, "*BOUNDARY_") )
         return "BDR";
      else if( strstr($kw, "*COMPONENT_") )
         return "COM";
      else if( strstr($kw, "*CONSTRAINED_") )
         return "CNS";
      else if( strstr($kw, "*CONTACT_") )
         return "CNT";
      else if( strstr($kw, "*CONTROL_") )
         return "CTL";
      else if( strstr($kw, "*DAMPING_") )
         return "DMP";
      else if( strstr($kw, "*DATABASE_") )
         return "DBS";
      else if( strstr($kw, "*DEFINE_") )
         return "DEF";
      else if( strstr($kw, "*DEFORMABLE_") )
         return "DFM";
      else if( strstr($kw, "*EF_") )
         return "EFA";
      else if( strstr($kw, "*ELEMENT_") )
         return "ELM";
      else if( strstr($kw, "*EOS_") )
         return "EOS";
      else if( strstr($kw, "*HOURGLASS") )
         return "HGL";
      else if( strstr($kw, "*INCLUDE") )
         return "INC";
      else if( strstr($kw, "*INITIAL_") )
         return "INI";
      else if( strstr($kw, "*INTEGRATION_") )
         return "INT";
      else if( strstr($kw, "*INTERFACE_") )
         return "INF";
      else if( strstr($kw, "*LOAD_") )
         return "LOD";
      else if( strstr($kw, "*MAT_") )
         return "MAT";
      else if( strstr($kw, "*NODE") )
         return "NOD";
      else if( strstr($kw, "*PARAMETER") )
         return "PRM";
      else if( strstr($kw, "*PART") )
         return "PRT";
      else if( strstr($kw, "*PERTURBATION_") )
         return "PER";
      else if( strstr($kw, "*RAIL_") )
         return "RAL";
      else if( strstr($kw, "*RIGIDWALL_") )
         return "RGW";
      else if( strstr($kw, "*SECTION_") )
         return "SEC";
      else if( strstr($kw, "*SENSOR_") )
         return "SEN";
      else if( strstr($kw, "*SET_") )
         return "SET";
      else if( strstr($kw, "*TERMINATION_") )
         return "TRM";
      else if( strstr($kw, "*USER_") )
         return "USR";
      else if( strstr($kw, "*KEY") )
         return "KEY";
      else if( strstr($kw, "*TITL") )
         return "TTL";
      else
         return "NEW";
   }
   
   function createKeywordMapFile(&$dir_name, &$web_root, &$kw_array)
   {
      $kw_keys = array_keys($kw_array);
      $kw_5chars = getKWShortName("*$kw_keys[0]");
      $kw_str = "<?php\n\$$dir_name" . "_array = array(\n";
      foreach ($kw_keys as $kw_key)
      {
/*
         if( $kw_key == "KEYWORD" )
            $kw_str .= "\"$kw_key\" => \"KEY_400\",\n";
         else if( $kw_key == "KEYWORD_ID" )
            $kw_str .= "\"$kw_key\" => \"KEY_401\",\n";
         else if( $kw_key == "TITLE" )
            $kw_str .= "\"$kw_key\" => \"TTL_500\",\n";
         else    
*/
            $kw_str .= "\"$kw_key\" => \"" . $kw_array["$kw_key"] . "\",\n";
      }
      $kw_str .= ");\n?>\n";

echo "DIR=$dir_name SHORT=$kw_5chars\n";
      $kw_file = $web_root . $dir_name . "/" . $dir_name . "_array.php";
      $kw_file_ptr = fopen($kw_file, 'w');
      fwrite($kw_file_ptr, $kw_str);
      fclose($kw_file_ptr);
   }

   function writeFieldWidthsFile(&$card_widths_array)
   {
/*
      $ckeys = array_keys($card_widths_array);

      foreach($ckeys as $cname)
      {
         $farray = $card_widths_array["$cname"];
         foreach($farray as $)
         {
         }
      }
*/
   }
?>
