<?php
if (file_exists($argv[1]))
{
   $xml = simplexml_load_file($argv[1]);

   $card = $xml->card;

   if( !$card )
      return;

   $str = "";
   $card_num = 1;
   $class_name = $xml['classname'];

   if( $class_name == 'NoCards' )
      return;

   $class_name = "DB" . $class_name;

   $str .= "#ifndef _" . strtoupper($class_name) . "_H_\n";
   $str .= "#define _" . strtoupper($class_name) . "_H_\n\n";

   $base_class = $xml->baseclass['name'];

   if( $base_class )
   {
      if( !strcmp($base_class, 'ImportBase') )
         $base_class = "GetDBBase";
      else
         $base_class = "DB" . $base_class;
   }

   $str .= "#include \"manager.h\"\n";

   if( $base_class )
   {
      $str .= "#include \"" . strtolower($base_class) . ".h\"\n\n";
      if( !strcmp($base_class, "GetDBBase") )
         $str .= "class " . $class_name . " : public $base_class\n";
      else
         $str .= "class " . $class_name . " : public $base_class\n";
      $str .= "{\n";
      $str .= "public:\n";
      if( !strcmp($base_class, "GetDBBase") )
         $str .= "   " . $class_name . "(GoldenConn *gold_conn, ImportObject *imp_obj) : $base_class (gold_conn, imp_obj)\n";
      else
         $str .= "   " . $class_name . "(GoldenConn *gold_conn, ImportObject *imp_obj) : $base_class (gold_conn, imp_obj)\n";
      $str .= "   {\n";
      $str .= "   }\n\n";

      $str .= "   virtual ~" . $class_name . "()\n";
      $str .= "   {\n";
      $str .= "   }\n\n";
   }
   else
   {
      $str .= "#include \"goldenconn.h\"\n";
      $str .= "#include \"dbcard.h\"\n\n";

      $str .= "class " . $class_name . "\n";
      $str .= "{\n";
      $str .= "public:\n";
      $str .= "   " . $class_name . "(GoldenConn *gold_conn, ImportObject *imp_obj)\n";
      $str .= "   {\n";
      $str .= "      goldenConn = gold_conn;\n";
      $str .= "      impObj = imp_obj;\n";
      $str .= "      numFields = 0;\n";
      $str .= "      wordArray = NULL;\n";
      $str .= "      cardObj = NULL;\n";
      $str .= "   }\n\n";

      $str .= "   virtual ~" . $class_name . "()\n";
      $str .= "   {\n";
      $str .= "      goldenConn = NULL;\n";
      $str .= "      impObj = NULL;\n";
      $str .= "      numFields = 0;\n";
      $str .= "      wordArray = NULL;\n";
      $str .= "      cardObj = NULL;\n";
      $str .= "   }\n\n";

      $str .= "public:\n";
      $str .= "   unsigned int   numFields;\n";
      $str .= "   char           **wordArray;\n";
      $str .= "   ImportObject   *impObj;\n";
      $str .= "   GoldenConn     *goldenConn;\n";
      $str .= "   Card           *cardObj;\n\n";
   }

   $str .= "public:\n";

   foreach ($xml->card as $card)
   {
      $field_check = $card->field;

      //added for no card keywords
      if( !$field_check )
         continue;

      $str1 = "";
      $str2 = "";

      $card_name = $card['name'];

      $ret_var = strtolower($card['return']);
      $ret_type = $card['returntype'];
  
      $func_name = "";
      $ret_name = $card_name . "_return";
      switch($ret_type)
      {
	 case 'uint':
            $func_name .= "   unsigned int dbRead" . $card_name . "(unsigned int loop_count = (1 << 31))\n";
            $main_func = "   $ret_var = dbRead" . $card_name . "();\n";
            $func_array["$card_name"] = $main_func;
            $func_array["$ret_name"] = "unsigned int $ret_var = 0;\n";
	    break;
	 case 'int':
            $func_name .= "   int dbRead" . $card_name . "(unsigned int loop_count = (1 << 31))\n";
            $main_func = "   $ret_var = dbRead" . $card_name . "();\n";
            $func_array["$card_name"] = $main_func;
            $func_array["$ret_name"] = "int $ret_var = 0;\n";
	    break;
	 case 'double':
            $func_name .= "   double dbRead" . $card_name . "(unsigned int loop_count = (1 << 31))\n";
            $main_func = "   $ret_var = dbRead" . $card_name . "();\n";
            $func_array["$card_name"] = $main_func;
            $func_array["$ret_name"] = "double $ret_var = 0.0;\n";
	    break;
	 case 'string':
            $func_name .= "   char *dbRead" . $card_name . "(unsigned int loop_count = (1 << 31))\n";
            $main_func = "   $ret_var = dbRead" . $card_name . "();\n";
            $func_array["$card_name"] = $main_func;
            $func_array["$ret_name"] = "char* $ret_var = NULL;\n";
	    break;
	 default:
            $func_name .= "   void dbRead" . $card_name . "(unsigned int loop_count = (1 << 31))\n";
            $main_func = "   dbRead" . $card_name . "();\n";
            $func_array["$card_name"] = $main_func;
      }

      $str .= $func_name;

      $str .= "   {\n";
      $str .= "      char *fields[] = {";
      $str1 .= "      unsigned int field_types[] = {";
      $str2 .= "      unsigned int field_widths[] = {";
 
      $num_fields = 0;
      $field_index = -1;
      $unequal_width = false;
      $str_type = false;
      $int_type = false;
      $man_name = "";

      $findex = 0;
      $field_indices = "";
      $man_types = "";
      $kw_types = "";
      $find_func = "";
      $func_index = -1;

      foreach ($card->field as $field)
      {
         $var_name = $field['name'];
         $str .= "\"$var_name\",";




/** adding id to manager **/
         $add = $field['add'];
         $find = $field['find'];
         $findtype = $field['findtype'];
         $ffunc = $field['func'];

         if( $add )
         {
            $field_index = $num_fields;
            $man_name = $add;
         }

         if( $ffunc )
         {
            $find_func = $ffunc;
            $func_index = $num_fields;
         }
         else if( $find )
         {
            $man_types[$findex] = strtoupper($find);
            $field_indices[$findex] = $num_fields;
            if( $findtype )
            {
               $kw_types[$findex] = strtoupper($findtype);
            }
            else
            {
               $kw_types[$findex] = 9999;
            }
            $findex++;
         }
/** adding id to manager **/





         $num_fields++;
         $width = (int)$field['width'];
         $str2 .= "$width, ";
         $type = $field['type'];

         switch((string)$type)
         {
            case 'uint':
               $str1 .= "DATA_UINT, ";
               break;
            case 'int':
               $str1 .= "DATA_INT, ";
               break;
            case 'double':
               $str1 .= "DATA_DOUBLE, ";
               break;
            case 'string':
               $str1 .= "DATA_CHAR_ARRAY, ";
               break;
            case 'unused':
               $str1 .= "DATA_UNUSED, ";
               break;
         }

         if( $width != "10" )
            $unequal_width = true;

         if( $type == "string" )
            $str_type = true;

         if( $type == "int" )
            $int_type = true;
      }
      $str .= "};\n";
      $str1 .= "};\n";
      $str2 .= "};\n";

      $str .= $str1;

/**** add to manager code ****/
      if( $findex )
      {
         $str3 = "      unsigned int field_indices[] = {";
         $str4 = "      unsigned int man_types[] = {";
         $str5 = "      unsigned int kw_types[] = {";

	 for($cnt = 0; $cnt < $findex;$cnt++)
	 {
	    $str3 .= $field_indices[$cnt] . ", ";
	    $str4 .= $man_types[$cnt] . ", ";
	    $str5 .= $kw_types[$cnt] . ", ";
	 }

         $str3 .= "};\n";
         $str4 .= "};\n";
         $str5 .= "};\n";

         $str .= $str3 . $str4 . $str5;
         $str .= "      unsigned int num_indices = " . $findex . ";\n";
      }
/** end of add to manager **/

      $str .= "      numFields = $num_fields;\n";
      
      $loop = $card->loop;
      if( $loop )
      {
         $loop_card = $loop['loopcard'];
         $loop_field = $loop['loopfield'];

	 $str .= $str2;

         if( $loop_card )
         {
	    $str .= "      Card *card = impObj->findCard(\"" . $loop_card . "\");\n";
	    $str .= "      unsigned int " . strtolower($loop_field) . " = 0, end_loop;\n";
	    $str .= "      if( card )\n";
	    $str .= "      {\n";
	    $str .= "         " . strtolower($loop_field) . " = card->intValue(\"" . $loop_field . "\");\n";
	    $str .= "      }\n\n";
         }
         else
         {
	    //$str .= "      unsigned int i, end_loop;\n";
	    $str .= "      unsigned int end_loop;\n";
         }

         $start = $loop['start'];
         $end = strtolower($loop['end']);
         $str .= "      end_loop = $end;\n";
         $str .= "      for(loop_count = $start; loop_count < end_loop; loop_count++)\n";
         $str .= "      {\n";
         $str .= "         numFields = $num_fields;\n";

	 $str .= "         wordArray = goldenConn->nextCard();\n";
         $str .= "         if( !wordArray )\n";
         $str .= "         {\n";
         $str .= "            numFields = 0;\n";
         getReturnCode($card, $str);
         $str .= "         }\n";


/*** add id to manager **/
	       if( $field_index != -1 )
	       {
		  $str .= "         addIDToManager(wordArray, $field_index, " .
                       strtoupper($man_name) . ", impObj->getKeywordType());\n";
	       }               

	       if( $func_index != -1 )
	       {
		  $str .= "         $find_func" . "(wordArray, numFields, $func_index, impObj);\n";
	       }
	       else if( $findex )
	       {
                  $str .= "         findIDInManager(wordArray, num_indices, field_indices, man_types, kw_types);\n\n";
               }
/***** add to manager code **/



         $str .= "         char name_buf[64];\n";
         $str .= "         sprintf(name_buf,\"%s_%d\",\"$card_name\",loop_count);\n";
	 $str .= "         cardObj = new DBCard(name_buf);\n";
         $str .= "         ((DBCard *)cardObj)->index = atoi(wordArray[0]);\n";
	 $str .= "         cardObj->addFields(numFields, field_types, field_widths, fields, &wordArray[2]);\n";

	 $str .= "         impObj->addCard(cardObj);\n";

         $str .= "      }\n";
      }
      else
      {
	 $str .= $str2;
	 $str .= "      wordArray = goldenConn->nextCard();\n";
         $str .= "      if( !wordArray )\n";
         $str .= "      {\n";
         $str .= "         numFields = 0;\n";
         getReturnCode($card, $str);
         $str .= "      }\n";


/*** add id to manager */
               if( $field_index != -1 )
               {
	          $str .= "      addIDToManager(wordArray, $field_index, " .
                    strtoupper($man_name) . ", impObj->getKeywordType());\n\n";
               }               

	       if( $func_index != -1 )
	       {
		  $str .= "      $find_func" . "(wordArray, numFields, $func_index, impObj);\n";
	       }
	       else if( $findex )
	       {
		  $str .= "      findIDInManager(wordArray, num_indices, field_indices, man_types, kw_types);\n\n";
	       }
/***** add to manager code **/




         $str .= "      if( loop_count & (1<<31) )\n";
	 $str .= "         cardObj = new DBCard(\"" . $card_name . "\");\n";
         $str .= "      else\n";
         $str .= "      {\n";
         $str .= "         char name_buf[64];\n";
         $str .= "         sprintf(name_buf,\"%s_%d\",\"$card_name\",loop_count);\n";
	 $str .= "         cardObj = new DBCard(name_buf);\n";
         $str .= "      }\n";
         $str .= "      ((DBCard *)cardObj)->index = atoi(wordArray[0]);\n";
	 $str .= "      cardObj->addFields(numFields, field_types, field_widths, fields, &wordArray[2]);\n";

	 $str .= "      impObj->addCard(cardObj);\n";
      }

      $ret_var = $card['return'];

      if( $ret_var )
      {
         $ret_type = $card['returntype'];
         switch($ret_type)
         {
            case 'uint':
               $str .= "      return cardObj->uintValue(\"$ret_var\");\n";
               break;
            case 'int':
               $str .= "      return cardObj->intValue(\"$ret_var\");\n";
               break;
            case 'double':
               $str .= "      return cardObj->doubleValue(\"$ret_var\");\n";
               break;
            case 'string':
               $str .= "      return cardObj->strValue(\"$ret_var\");\n";
               break;
            default:
               $str .= "      return;\n";
         }
      }
      
      $str .= "   }\n\n";
   }

 
   $main_func = "   unsigned int import" . $class_name . "()\n";
   $main_func .= "   {\n";

   foreach ($xml->card as $card)
   {
      $ret_name = $card['name'] . "_return";

      if( isset($func_array["$ret_name"]) )
      {
	 $main_func .= "      " . $func_array["$ret_name"];
      }
   }

   //hardcoded for import base class
   if( $base_class && strcmp($base_class, "GetDBBase") )
   {
      $main_func .= "      import" . $base_class . "();\n";
   }

   $star_loop_funcs = array();
   foreach ($xml->condition as $condition)
   {
      foreach($condition->refcard as $refcard)
      {
         $ref_name = $refcard['name'];

	 $main_func .= "      cardObj = impObj->findCard(\"" . $ref_name . "\");\n";
         foreach ($refcard->reffield as $reffield)
         {
	    $ref_field = $reffield['name'];
	    $type = $reffield['type'];

	    switch((string)$type)
	    {
	       case 'uint':
	          $main_func .= "      unsigned int " . strtolower($ref_field) . " = 0;\n";
                  break;
	       case 'int':
		  $main_func .= "      int " . strtolower($ref_field) . " = 0;\n";
                  break;
	       case 'double':
		  $main_func .= "      double " . strtolower($ref_field) . " = 0.0;\n";
                  break;
	       case 'string':
		  $main_func .= "      char* " . strtolower($ref_field) . " = NULL;\n";
                  break;
            }
         }

	 $main_func .= "      if( cardObj )\n";
	 $main_func .= "      {\n";

         foreach ($refcard->reffield as $reffield)
         {
	    $ref_field = $reffield['name'];
	    $type = $reffield['type'];

	    switch((string)$type)
	    {
	       case 'uint':
		  $main_func .= "         " . strtolower($ref_field) . " = cardObj->uintValue(\"" . $ref_field . "\");\n";
		  break;
	       case 'int':
		  $main_func .= "         " . strtolower($ref_field) . " = cardObj->intValue(\"" . $ref_field . "\");\n";
		  break;
	       case 'double':
		  $main_func .= "         " . strtolower($ref_field) . " = cardObj->doubleValue(\"" . $ref_field . "\");\n";
		  break;
	       case 'string':
		  $main_func .= "         " . strtolower($ref_field) . " = cardObj->stringValue(\"" . $ref_field . "\");\n";
		  break;
	    }
         }

	 $main_func .= "      }\n\n";
      }

      $statement = $condition['statement'];
      $starloop = $condition['starloop'];

      if( $statement )
      {
	 //$main_func .= "      $statement\n";
         $state_strs = explode('\n', $statement);
         foreach ($state_strs as $state_str)
         {
	    $main_func .= "      $state_str\n";
         }
	 $main_func .= "      {\n";

         $loop = $condition->loop;
         if( $loop )
         {
            $start = $loop['start'];
            $end = $loop['end'];
            $main_func .= "         for(int i = $start; i < $end; i++)\n";
            $main_func .= "         {\n";
	    foreach ($condition->card as $con_card)
	    {
	       $crdname = $con_card['name'];
	       $crd_state = $con_card['statement'];

	       if( isset($func_array["$crdname"]) )
	       {
                  if( !$crd_state )
                  {
		     $main_func .= "         " . $func_array["$crdname"];
		     //$func_array["$crdname"] = null;
                  }
                  else
                  {
                     $main_func .= "            " . $crd_state . "\n";
                     $main_func .= "            {\n";
		     $main_func .= "            " . $func_array["$crdname"];
                     $main_func .= "            }\n";
                  }
	       }
	    }
            $main_func .= "         }\n";
         }
         else
         {
	    foreach ($condition->card as $con_card)
	    {
	       $crdname = $con_card['name'];
	       $crd_state = $con_card['statement'];

	       if( isset($func_array["$crdname"]) )
	       {
                  if( !$crd_state )
                  {
		     $main_func .= "      " . $func_array["$crdname"];
		     //$func_array["$crdname"] = null;
                  }
                  else
                  {
                     $main_func .= "         " . $crd_state . "\n";
                     $main_func .= "         {\n";
		     $main_func .= "         " . $func_array["$crdname"];
                     $main_func .= "         }\n";
                  }
	       }
	    }
         }

	 $main_func .= "      }\n";
      }
      else if( !strcmp($starloop, 'yes') )
      {
         $main_func .= "      unsigned int loop_count = 0;\n";
	 foreach ($condition->card as $con_card)
	 {
	    $crdname = $con_card['name'];
	    $crd_state = $con_card['statement'];

	    if( isset($func_array["$crdname"]) )
	    {
               if( !$crd_state )
               {
	          $main_func .= "   " . $func_array["$crdname"];
               }
	       else
	       {
		  $main_func .= "      " . $crd_state . "\n";
		  $main_func .= "      {\n";
		  $main_func .= "      " . $func_array["$crdname"];
		  $main_func .= "      }\n";
	       }
               $star_loop_funcs["$crdname"] = $func_array["$crdname"];
	    }
	 }
         $main_func .= "      loop_count++;\n";

	 $main_func .= "      while(numFields)\n";
	 $main_func .= "      {\n";
	 foreach ($condition->card as $con_card)
	 {
	    $crdname = $con_card['name'];
	    $crd_state = $con_card['statement'];

	    if( isset($func_array["$crdname"]) )
	    {
               if( !$crd_state )
               {
	          $main_func .= "      " . $func_array["$crdname"];
               }
	       else
	       {
		  $main_func .= "         " . $crd_state . "\n";
		  $main_func .= "         {\n";
		  $main_func .= "         " . $func_array["$crdname"];
		  $main_func .= "         }\n";
	       }
	    }
	 }
         $main_func .= "         loop_count++;\n";
	 $main_func .= "      }\n";
	 $main_func .= "      ((ExportObject *)impObj)->loopCount = loop_count-1;\n";
      }
      else
      {
         $loop = $condition->loop;
         if( $loop )
         {
            $start = $loop['start'];
            $end = $loop['end'];
            $main_func .= "      for(int i = $start; i < $end; i++)\n";
            $main_func .= "      {\n";
	    foreach ($condition->card as $con_card)
	    {
	       $crdname = $con_card['name'];
	       $crd_state = $con_card['statement'];

	       if( isset($func_array["$crdname"]) )
	       {
		  if( !$crd_state )
		  {
		     $main_func .= "      " . $func_array["$crdname"];
		     //$func_array["$crdname"] = null;
                  }
		  else
		  {
		     $main_func .= "         " . $crd_state . "\n";
		     $main_func .= "         {\n";
		     $main_func .= "         " . $func_array["$crdname"];
		     $main_func .= "         }\n";
		  }
	       }
	    }
            $main_func .= "      }\n";
         }
         else
         {
	    foreach ($condition->card as $con_card)
	    {
	       $crdname = $con_card['name'];
	       $crd_state = $con_card['statement'];

	       if( isset($func_array["$crdname"]) )
	       {
		  if( !$crd_state )
		  {
		     $main_func .= "   " . $func_array["$crdname"];
		     //$func_array["$crdname"] = null;
                  }
		  else
		  {
		     $main_func .= "      " . $crd_state . "\n";
		     $main_func .= "      {\n";
		     $main_func .= "      " . $func_array["$crdname"];
		     $main_func .= "      }\n";
		  }
	       }
	    }
         }
      }
   }

   //adding the star loop count to the function to change the card name
   foreach($star_loop_funcs as $loop_func)
   {
      $len = strlen($loop_func);
      $rep = substr($loop_func, 0, $len-3);
//echo "$rep" . "\n";
      $replace_loop_str = $rep . "loop_count);\n";
      $main_func = str_replace($loop_func, $replace_loop_str, $main_func);
   }

   $main_func .= "      return 0;\n";
   $main_func .= "   }\n";

   $str .= $main_func;

   $str .= "};\n\n";
   
   $str .= "#endif\n\n";

   $file_name = strtolower($class_name) . '.h';
   $file_ptr = fopen($file_name, 'w');
   fwrite($file_ptr, $str);
   fclose($file_ptr);
   $str = "";

   $flag = $xml['cppfile'];

   //if( $base_class || !strcmp($flag, "yes") )
   if( !$flag || !strcmp($flag, "yes") )
   {
      writeHPAndCPPFile($class_name);
   }
}
else
{
   exit("Failed to open $argv[1]\n");
}

function writeHPAndCPPFile(&$class_name)
{
   $file_name = strtolower($class_name) . '.hpp';
   $file_ptr = fopen($file_name, 'w');
   $str = "";
  
   $str .= "#ifndef _" . strtoupper($class_name) . "_HPP_\n";
   $str .= "#define _" . strtoupper($class_name) . "_HPP_\n\n";

   $str .= "#include \"goldenconn.h\"\n";
   $str .= "#include \"dbcard.h\"\n\n";

   $str .= "unsigned int import" . $class_name . "(GoldenConn *gold_conn, ImportObject *imp_obj);\n\n";

   $str .= "#endif\n\n";
    
   fwrite($file_ptr, $str);
   fclose($file_ptr);

   $str = "";
   $str .= "#include \"" . strtolower($class_name) . ".h\"\n";
   $str .= "#include \"" . strtolower($class_name) . ".hpp\"\n\n";

   $str .= "unsigned int import" . $class_name . "(GoldenConn *gold_conn, ImportObject *imp_obj)\n";
   $str .= "{\n";
   $str .= "   $class_name " . strtolower($class_name) . "(gold_conn, imp_obj);\n\n";
   $str .= "   return " . strtolower($class_name) . ".import" . $class_name . "();\n";
   $str .= "}\n\n";
   $file_name = strtolower($class_name) . '.cpp';
   $file_ptr = fopen($file_name, 'w');

   fwrite($file_ptr, $str);
   fclose($file_ptr);
   $str = "";
}

function getReturnCode(&$card, &$str)
{
   $ret_var = $card['return'];

   if( $ret_var )
   {
      $ret_type = $card['returntype'];
      switch($ret_type)
      {
	 case 'uint':
	    $str .= "         return 0;\n";
	    break;
	 case 'int':
	    $str .= "         return 0;\n";
	    break;
	 case 'double':
	    $str .= "         return 0.0;\n";
	    break;
	 case 'string':
	    $str .= "         return NULL;\n";
	    break;
	 default:
	    $str .= "         return;\n";
      }
   }
   else
      $str .= "         return;\n";
}


?>
