<?php
   include '../html_gen_inc.php';

   $dir_name = "rigidwall/";
   //$web_root = "/home/krishna/WEB_ROOT/lsdyna/";
   $doc_root = getenv("WEB_ROOT");
   if( $doc_root == null )
   {
      echo "set WEB_ROOT enviroment variable\n";
      return;
   }
   $web_root = $doc_root . "/lsdyna/";
   $comp_dir = $web_root . $dir_name;
   if( !file_exists($comp_dir) )
      mkdir($comp_dir);

   $kw_list = array();
   $link_list = array();
   $str = "";

   $id_str = getCardsFromXml("rigidwall_id.xml");
   $rw_geo = getCardsFromXml("rigidwall_geometric.xml");
   $rw_geo_flat = getCardsFromXml("rigidwall_geometric_flat.xml");
   $rw_geo_pr = getCardsFromXml("rigidwall_geometric_prism.xml");
   $rw_geo_cyl = getCardsFromXml("rigidwall_geometric_cylinder.xml");
   $rw_geo_sp = getCardsFromXml("rigidwall_geometric_sphere.xml");
   $rw_geo_mot = getCardsFromXml("rigidwall_geometric_motion.xml");


   $rw_plan = getCardsFromXml("rigidwall_planar.xml");
   $rw_plan_ortho = getCardsFromXml("rigidwall_planar_ortho.xml");
   $rw_plan_fin = getCardsFromXml("rigidwall_planar_finite.xml");
   $rw_plan_mov = getCardsFromXml("rigidwall_planar_moving.xml");
   $rw_plan_for = getCardsFromXml("rigidwall_planar_forces.xml");

   $rwg_types[0] = "_FLAT";
   $rwg_types[1] = "_PRISM";
   $rwg_types[2] = "_CYLINDER";
   $rwg_types[3] = "_SPHERE";

   $id_type[0] = "_ID";
   $mot_type[0] = "_MOTION";

   $kw_str = "";

   $RIGIDWALL_GEOMETRIC = 0;
   $RIGIDWALL_PLANAR = 1;
   $RIGIDWALL_ID = 2;
   $RIGIDWALL_FLAT = 3;
   $RIGIDWALL_PRISM = 4;
   $RIGIDWALL_CYLINDER = 5;
   $RIGIDWALL_SPHERE = 6;
   $RIGIDWALL_MOTION = 7;
   $RIGIDWALL_ORTHO = 8;
   $RIGIDWALL_FINITE = 9;
   $RIGIDWALL_MOVING = 10;
   $RIGIDWALL_FORCES = 11;


   foreach ($rwg_types as $rwg_type)
   {
      $rigid_flag = 0;
      $rigid_flag |= (1 << $RIGIDWALL_GEOMETRIC);
      foreach ($id_type as $id)
      {
	 $kw = "RIGIDWALL_GEOMETRIC" . $rwg_type . $mot_type[0] . $id;
	 //$kw_str .= "*" . $kw . "\n";
         //$kw_str = startOfPage($kw);
         $kw_str = "";
	 $kw_str .= $id_str;
	 $kw_str .= $rw_geo;

         $rigid_flag |= (1 << $RIGIDWALL_MOTION);
         $rigid_flag |= (1 << $RIGIDWALL_ID);

	 if( $rwg_type == "_FLAT" )
	 {
	    $kw_str .= $rw_geo_flat;
            $rigid_flag |= (1 << $RIGIDWALL_FLAT);
	 }
	 else if( $rwg_type == "_PRISM" )
	 {
	    $kw_str .= $rw_geo_pr;
            $rigid_flag |= (1 << $RIGIDWALL_PRISM);
	 }
	 else if( $rwg_type == "_CYLINDER" )
	 {
	    $kw_str .= $rw_geo_cyl;
            $rigid_flag |= (1 << $RIGIDWALL_CYLINDER);
	 }
	 else if( $rwg_type == "_SPHERE" )
	 {
	    $kw_str .= $rw_geo_sp;
            $rigid_flag |= (1 << $RIGIDWALL_SPHERE);
	 }

	 $kw_str .= $rw_geo_mot;

         $kw_short_name = "RGW_" . $rigid_flag;

         $kw_str = startOfPage($kw, $kw_short_name) . $kw_str;

	 $kw_str .= endOfPage($kw, $kw_short_name);
         $kw_list["$kw"] = $kw_short_name;
	 
	 $kw_str = str_replace("krishna", "$kw_short_name", $kw_str);

	 $link_list["$kw"] = $dir_name . strtolower($kw) . ".php";
	 $file_name = $comp_dir . strtolower($kw) . ".php";
	 $file_ptr = fopen($file_name, 'w');
	 fwrite($file_ptr, $kw_str);
	 fclose($file_ptr);
	 $kw_str = "";
      }
   }



   foreach ($rwg_types as $rwg_type)
   {
      $rigid_flag = 0;
      $rigid_flag |= (1 << $RIGIDWALL_GEOMETRIC);
      $rigid_flag |= (1 << $RIGIDWALL_MOTION);

      $kw = "RIGIDWALL_GEOMETRIC" . $rwg_type . $mot_type[0];
      //$kw_str = startOfPage($kw);
         $kw_str = "";
      //$kw_str .= "*" . $kw . "\n";
      $kw_str .= $rw_geo;

      if( $rwg_type == "_FLAT" )
      {
	 $kw_str .= $rw_geo_flat;
         $rigid_flag |= (1 << $RIGIDWALL_FLAT);
      }
      else if( $rwg_type == "_PRISM" )
      {
	 $kw_str .= $rw_geo_pr;
         $rigid_flag |= (1 << $RIGIDWALL_PRISM);
      }
      else if( $rwg_type == "_CYLINDER" )
      {
	 $kw_str .= $rw_geo_cyl;
         $rigid_flag |= (1 << $RIGIDWALL_CYLINDER);
      }
      else if( $rwg_type == "_SPHERE" )
      {
	 $kw_str .= $rw_geo_sp;
         $rigid_flag |= (1 << $RIGIDWALL_SPHERE);
      }

      $kw_str .= $rw_geo_mot;

      $kw_short_name = "RGW_" . $rigid_flag;

      $kw_str = startOfPage($kw, $kw_short_name) . $kw_str;

      $kw_str .= endOfPage($kw, $kw_short_name);
         $kw_list["$kw"] = $kw_short_name;
      
      $kw_str = str_replace("krishna", "$kw_short_name", $kw_str);

      $link_list["$kw"] = $dir_name . strtolower($kw) . ".php";
      $file_name = $comp_dir . strtolower($kw) . ".php";
      $file_ptr = fopen($file_name, 'w');
      fwrite($file_ptr, $kw_str);
      fclose($file_ptr);
      $kw_str = "";
   }


   foreach ($rwg_types as $rwg_type)
   {
      $rigid_flag = 0;
      $rigid_flag |= (1 << $RIGIDWALL_GEOMETRIC);

      foreach ($id_type as $id)
      {
	 $kw = "RIGIDWALL_GEOMETRIC" . $rwg_type . $id;
         //$kw_str = startOfPage($kw);
         $kw_str = "";
	 //$kw_str .= "*" . $kw . "\n";
	 $kw_str .= $id_str;
	 $kw_str .= $rw_geo;

         $rigid_flag |= (1 << $RIGIDWALL_ID);
	 if( $rwg_type == "_FLAT" )
	 {
	    $kw_str .= $rw_geo_flat;
            $rigid_flag |= (1 << $RIGIDWALL_FLAT);
	 }
	 else if( $rwg_type == "_PRISM" )
	 {
	    $kw_str .= $rw_geo_pr;
            $rigid_flag |= (1 << $RIGIDWALL_PRISM);
	 }
	 else if( $rwg_type == "_CYLINDER" )
	 {
	    $kw_str .= $rw_geo_cyl;
            $rigid_flag |= (1 << $RIGIDWALL_CYLINDER);
	 }
	 else if( $rwg_type == "_SPHERE" )
	 {
	    $kw_str .= $rw_geo_sp;
            $rigid_flag |= (1 << $RIGIDWALL_SPHERE);
	 }

         $kw_short_name = "RGW_" . $rigid_flag;

      $kw_str = startOfPage($kw, $kw_short_name) . $kw_str;

	 $kw_str .= endOfPage($kw, $kw_short_name);
         $kw_list["$kw"] = $kw_short_name;
	 
	 $kw_str = str_replace("krishna", "$kw_short_name", $kw_str);

	 $link_list["$kw"] = $dir_name . strtolower($kw) . ".php";
	 $file_name = $comp_dir . strtolower($kw) . ".php";
	 $file_ptr = fopen($file_name, 'w');
	 fwrite($file_ptr, $kw_str);
	 fclose($file_ptr);
	 $kw_str = "";
      }
   }







   foreach ($rwg_types as $rwg_type)
   {
      $rigid_flag = 0;
      $rigid_flag |= (1 << $RIGIDWALL_GEOMETRIC);

      $kw = "RIGIDWALL_GEOMETRIC" . $rwg_type;
      //$kw_str = startOfPage($kw);
      $kw_str = "";
      //$kw_str .= "*" . $kw . "\n";
      $kw_str .= $rw_geo;

      if( $rwg_type == "_FLAT" )
      {
	 $kw_str .= $rw_geo_flat;
            $rigid_flag |= (1 << $RIGIDWALL_FLAT);
      }
      else if( $rwg_type == "_PRISM" )
      {
	 $kw_str .= $rw_geo_pr;
            $rigid_flag |= (1 << $RIGIDWALL_PRISM);
      }
      else if( $rwg_type == "_CYLINDER" )
      {
	 $kw_str .= $rw_geo_cyl;
            $rigid_flag |= (1 << $RIGIDWALL_CYLINDER);
      }
      else if( $rwg_type == "_SPHERE" )
      {
	 $kw_str .= $rw_geo_sp;
            $rigid_flag |= (1 << $RIGIDWALL_SPHERE);
      }

      $kw_short_name = "RGW_" . $rigid_flag;

      $kw_str = startOfPage($kw, $kw_short_name) . $kw_str;

      $kw_str .= endOfPage($kw, $kw_short_name);
         $kw_list["$kw"] = $kw_short_name;
      
      $kw_str = str_replace("krishna", "$kw_short_name", $kw_str);

      $link_list["$kw"] = $dir_name . strtolower($kw) . ".php";
      $file_name = $comp_dir . strtolower($kw) . ".php";
      $file_ptr = fopen($file_name, 'w');
      fwrite($file_ptr, $kw_str);
      fclose($file_ptr);
      $kw_str = "";
   }











   $rwp_types[0] = "RIGIDWALL_PLANAR";
   $rwp_types[1] = "RIGIDWALL_PLANAR_ORTHO";
   $rwp_types[2] = "RIGIDWALL_PLANAR_FINITE";
   $rwp_types[3] = "RIGIDWALL_PLANAR_MOVING";
   $rwp_types[4] = "RIGIDWALL_PLANAR_FORCES";
   $rwp_types[5] = "RIGIDWALL_PLANAR_ID";
   $rwp_types[6] = "RIGIDWALL_PLANAR_ORTHO_ID";
   $rwp_types[7] = "RIGIDWALL_PLANAR_FINITE_ID";
   $rwp_types[8] = "RIGIDWALL_PLANAR_MOVING_ID";
   $rwp_types[9] = "RIGIDWALL_PLANAR_FORCES_ID";
   $rwp_types[10] = "RIGIDWALL_PLANAR_ORTHO_FINITE";
   $rwp_types[11] = "RIGIDWALL_PLANAR_ORTHO_FORCES";
   $rwp_types[12] = "RIGIDWALL_PLANAR_FINITE_MOVING";
   $rwp_types[13] = "RIGIDWALL_PLANAR_FINITE_FORCES";
   $rwp_types[14] = "RIGIDWALL_PLANAR_MOVING_FORCES";
   $rwp_types[15] = "RIGIDWALL_PLANAR_ORTHO_FINITE_FORCES";
   $rwp_types[16] = "RIGIDWALL_PLANAR_FINITE_MOVING_FORCES";
   $rwp_types[17] = "RIGIDWALL_PLANAR_ORTHO_FINITE_ID";
   $rwp_types[18] = "RIGIDWALL_PLANAR_ORTHO_FORCES_ID";
   $rwp_types[19] = "RIGIDWALL_PLANAR_FINITE_MOVING_ID";
   $rwp_types[20] = "RIGIDWALL_PLANAR_FINITE_FORCES_ID";
   $rwp_types[21] = "RIGIDWALL_PLANAR_MOVING_FORCES_ID";

   foreach ($rwp_types as $rwp_type)
   {
      $rigid_flag = 0;
      $rigid_flag |= (1 << $RIGIDWALL_PLANAR);

      $kw = $rwp_type;

      //$kw_str = startOfPage($kw);
      $kw_str = "";

      if( strstr($rwp_type, "_ID") )
      {
	 $kw_str .= $id_str;
	 $rigid_flag |= (1 << $RIGIDWALL_ID);
      }

      $kw_str .= $rw_plan;

      if( strstr($rwp_type, "_ORTHO") )
      {
	 $kw_str .= $rw_plan_ortho;
	 $rigid_flag |= (1 << $RIGIDWALL_ORTHO);
      }

      if( strstr($rwp_type, "_FINITE") )
      {
	 $kw_str .= $rw_plan_fin;
	 $rigid_flag |= (1 << $RIGIDWALL_FINITE);
      }

      if( strstr($rwp_type, "_MOVING") )
      {
	 $kw_str .= $rw_plan_mov;
	 $rigid_flag |= (1 << $RIGIDWALL_MOVING);
      }

      if( strstr($rwp_type, "_FORCES") )
      {
	 $kw_str .= $rw_plan_for;
	 $rigid_flag |= (1 << $RIGIDWALL_FORCES);
      }

      $kw_short_name = "RGW_" . $rigid_flag;

      $kw_str = startOfPage($kw, $kw_short_name) . $kw_str;

      $kw_str .= endOfPage($kw, $kw_short_name);
         $kw_list["$kw"] = $kw_short_name;
      
      $kw_str = str_replace("krishna", "$kw_short_name", $kw_str);

      $link_list["$kw"] = $dir_name . strtolower($kw) . ".php";
      $file_name = $comp_dir . strtolower($kw) . ".php";
      $file_ptr = fopen($file_name, 'w');
      fwrite($file_ptr, $kw_str);
      fclose($file_ptr);
      $kw_str = "";
   }

   $dir_name = "rigidwall";
   //createLinks($dir_name, $web_root, $link_list);
   createJSFiles($dir_name, $web_root, $link_list);
   ksort($kw_list);
   createKeywordMapFile($dir_name, $web_root, $kw_list);
?>
