#include "filelist.h"
#include <sstream>

static int filterLen;
static vector<string> filterList;

int fileFilterFunc(const struct dirent *dir_ent)
{
//cout << "FILTER=" << filterList.size() << endl;
   //if( !strncmp(dir_ent->d_name, filterStr, filterLen) )
   for(size_t iIndex = 0; iIndex < filterList.size(); iIndex++)
   {
       if( strstr(dir_ent->d_name, filterList[iIndex].data()) )
	  return 1;
   }

   return 0;
}

FileList::FileList(const char *dir, const char *fil)
{
   filterList.clear();
   istringstream strStream(fil);
   string filterStr;
   while(getline(strStream, filterStr, '|'))
   {
      filterList.push_back(filterStr);
   }

   filterStr = fil;
   filterLen = strlen(fil);
   m_NumDirEnt = scandir(dir, &m_DirEntList, fileFilterFunc, alphasort);
cout << fil << " FILES=" << m_NumDirEnt << endl;
}

FileList::~FileList()
{
   if( m_NumDirEnt > 0 )
   {
      for(int i = 0; i < m_NumDirEnt; i++)
	 free(m_DirEntList[i]);
      free(m_DirEntList);
   }
}

int FileList::getNames(vector<const char *> *file_list)
{
   if( m_NumDirEnt < 0 )
      return 0;

   for(int i = 0; i < m_NumDirEnt; i++)
   {
      file_list->push_back(m_DirEntList[i]->d_name);
//cout << "FILE=" << m_DirEntList[i]->d_name << endl;
   }
   return m_NumDirEnt;
}

int FileList::getNamesList(list<const char *> *file_list)
{
   if( m_NumDirEnt < 0 )
      return 0;

   for(int i = 0; i < m_NumDirEnt; i++)
   {
      file_list->push_back(m_DirEntList[i]->d_name);
//cout << "FILE=" << m_DirEntList[i]->d_name << endl;
   }
   return m_NumDirEnt;
}

