#ifndef _FILE_LIST_H_
#define _FILE_LIST_H_

#include <iostream>
#include <unistd.h>
#include <vector>
#include <list>
#include <dirent.h>
#include <stdlib.h>
#include "readgen.h"

using namespace std;

/** Class that fetches the list of files in a directory. It stores all the names
  * of files for specified filter
  */
class FileList
{
public:
   /** Constructor for creating this object
     * \param dir Name of directory
     * \param fil Filter for file names
     */
   FileList(const char *dir, const char *fil = ".bin");

   ~FileList();

   /** Gets a pointer to the list of filtered files
     * \param file_list Pointer the list of file names as vector container
     * \return Returns the number of files.
     */
   int getNames(vector<const char *> *file_list);
   /** Gets a pointer to the list of filtered files
     * \param file_list Pointer the list of file names as list container
     * \return Returns the number of files.
     */
   int getNamesList(list<const char *> *file_list);

private:
   int             m_NumDirEnt;
   struct dirent   **m_DirEntList;
};

#endif

