#include "kwgroup.h"

void KWGroup::nameFromType(unsigned int grp_type, string & grp_name)
{
   switch(grp_type)
   {
      case AIRBAG:
         grp_name = "airbag";
      break;
      case CONST:
         grp_name = "constrained";
      break;
      case SET:
         grp_name = "set";
      break;
      case SECTION:
         grp_name = "section";
      break;
      case DEFINE:
         grp_name = "define";
      break;
      case EOS:
         grp_name = "eos";
      break;
      case HG:
         grp_name = "hourglass";
      break;
      case MAT:
         grp_name = "mat";
      break;
      case PARTC:
         grp_name = "part";
      break;
      case ELEMENT:
         grp_name = "element";
      break;
      case NOD:
         grp_name = "node";
      break;
      case DAMPING:
         grp_name = "damping";
      break;
      case COMP:
         grp_name = "component";
      break;
      case EF:
         grp_name = "ef";
      break;
      case PARAM:
         grp_name = "parameter";
      break;
      case DEFORM:
         grp_name = "deformable";
      break;
      case SENSOR:
         grp_name = "sensor";
      break;
      case INTERFACE:
         grp_name = "interface";
      break;
      case INTEGRATION:
         grp_name = "integration";
      break;
      case CONTROL:
         grp_name = "control";
      break;
      case RIGIDWALL:
         grp_name = "rigidwall";
      break;
      case CONTACT:
         grp_name = "contact";
      break;
      case INC:
         grp_name = "include";
      break;
      case DATABASE:
         grp_name = "database";
      break;
      case INITIAL:
         grp_name = "initial";
      break;
      case LOAD:
         grp_name = "load";
      break;
      case BDRY:
         grp_name = "boundary";
      break;
      case ALE:
         grp_name = "ale";
      break;
      case RAIL:
         grp_name = "rail";
      break;
      case TERM:
         grp_name = "termination";
      break;
      case USER:
         grp_name = "user";
      break;
      case PERTURB:
         grp_name = "perturbation";
      break;
   }
}

unsigned int KWGroup::typeFromName(const char *grp_name)
{
   if( !strncmp(grp_name, "air", 3) )
      return AIRBAG;
   else if( !strncmp(grp_name, "cons", 4) )
      return CONST;
   else if( !strcmp(grp_name, "set") )
      return SET;
   else if( !strncmp(grp_name, "sec", 3) )
      return SECTION;
   else if( !strncmp(grp_name, "defi", 4) )
      return DEFINE;
   else if( !strcmp(grp_name, "eos") )
      return EOS;
   else if( !strncmp(grp_name, "hour", 4) )
      return HG;
   else if( !strcmp(grp_name, "mat") )
      return MAT;
   else if( !strcmp(grp_name, "part") )
      return PARTC;
   else if( !strncmp(grp_name, "elem", 4) )
      return ELEMENT;
   else if( !strcmp(grp_name, "node") )
      return NOD;
   else if( !strncmp(grp_name, "damp", 4) )
      return DAMPING;
   else if( !strncmp(grp_name, "comp", 4) )
      return COMP;
   else if( !strcmp(grp_name, "ef") )
      return EF;
   else if( !strncmp(grp_name, "para", 4) )
      return PARAM;
   else if( !strncmp(grp_name, "defo", 4) )
      return DEFORM;
   else if( !strncmp(grp_name, "sens", 4) )
      return SENSOR;
   else if( !strncmp(grp_name, "inter", 5) )
      return INTERFACE;
   else if( !strncmp(grp_name, "integ", 5) )
      return INTEGRATION;
   else if( !strncmp(grp_name, "contr", 5) )
      return CONTROL;
   else if( !strncmp(grp_name, "rig", 3) )
      return RIGIDWALL;
   else if( !strncmp(grp_name, "conta", 5) )
      return CONTACT;
   else if( !strncmp(grp_name, "inc", 3) )
      return INC;
   else if( !strncmp(grp_name, "dat", 3) )
      return DATABASE;
   else if( !strncmp(grp_name, "init", 4) )
      return INITIAL;
   else if( !strcmp(grp_name, "load") )
      return LOAD;
   else if( !strncmp(grp_name, "bou", 3) )
      return BDRY;
   else if( !strcmp(grp_name, "ale") )
      return ALE;
   else if( !strcmp(grp_name, "rail") )
      return RAIL;
   else if( !strncmp(grp_name, "term", 4) )
      return TERM;
   else if( !strncmp(grp_name, "user", 4) )
      return USER;
   else if( !strncmp(grp_name, "pert", 4) )
      return PERTURB;

   return (UNSIGNED_INT_MAX_FLAG);
}

