#include "kwtypefromid.h"

KWTypeFromID::KWTypeFromID()
{
}

KWTypeFromID::~KWTypeFromID()
{
   if( fileDes >= 0 )
      close(fileDes);

   indexMap.clear();
}

int KWTypeFromID::createMap
    (
       const char *dir,
       const char *model,
       const char *ent_name
    )
{
   char               buf[256];
   unsigned int       *base;
   struct stat        statbuf;

   sprintf(buf, "%s/%s/%s.ids", dir, model, ent_name);
   fileDes = open(buf, O_RDONLY);

   if( fileDes < 0 )
   {
      cout << "Unable to open file for reading in getindices.h " << buf << endl;
      return 1;
   }

   if( fstat(fileDes, &statbuf) < 0 )
   {
      cout << "Unable to stat file " << buf << endl;
      return 2;
   }

   base = (unsigned int *)mmap(0, statbuf.st_size, PROT_READ,
			  MAP_SHARED, fileDes, 0);
   if( !base )
   {
      cout << "MMAP error for file " << buf << endl;
      return 3;
   }

   unsigned int *ptr = base;
   //here 3 means card_idx,id,kw_type
   unsigned int num_indices = statbuf.st_size/(sizeof(int) * 3), i;
   indexMap.clear();
   //map is created between the object id and kw type
   for(i = 0; i < num_indices; i++, ptr += 3)
   {
//cout << "IDX=" << *ptr << " ID=" << *(ptr+1) << endl;
      indexMap.insert(UIUIPair(*(ptr+1), *(ptr+2)));
   }

   eIter = indexMap.end();

   munmap(base, statbuf.st_size);
   close(fileDes);
   fileDes = -1;

   return 0;
}

