#ifndef _KW_TYPE_FROM_ID_H_
#define _KW_TYPE_FROM_ID_H_

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <map>
#include <iostream>
#include <unistd.h>
#include "maptypes.h"

/** Class for providing the services of finding the entity id, entity type and
  * entity index given any one of the information */
class KWTypeFromID
{
public:
   KWTypeFromID();

   ~KWTypeFromID();

   /** Creates the map between the entity id, entity type and card index
     * \param dir Name of the directory from which the file has to be loaded
     * \param model Name of the model
     * \param ent_name Name of the group
     * \return Returns 0 on success else greater than 0
     */
   int createMap
       (
	  const char *dir,
	  const char *model,
	  const char *ent_name
       );

   /** Gets the kw type from the object id
     * \param obj_id Object id for which the type to be determined
     * \return Returns the type from the object id
     */
   inline unsigned int get(unsigned int obj_id)
   {
      iter = indexMap.find(obj_id);

      if( iter != eIter )
         return iter->second;
      else
         return (1<<31);
   }

private:
   int     fileDes;
   UIUIMap indexMap;
   UIUIIter eIter, iter;
};

#endif

