#ifndef _R_USAGE_H_
#define _R_USAGE_H_

#include <sys/resource.h>
#include <sys/time.h>
#include <iostream>

using namespace std;

class ResourceUsage
{
public:
   static void print(int process)
   {
      struct rusage ruse;

      if( !getrusage(process, &ruse) )
      {
	 cout << "Time Spent=" << ruse.ru_utime.tv_sec << "."
	      << ruse.ru_utime.tv_usec << endl;
	 cout << "Time System=" << ruse.ru_stime.tv_sec << "."
	      << ruse.ru_stime.tv_usec << endl;
	 cout << "MAX Physical Memory used=" << ruse.ru_maxrss << endl;
	 cout << "Text memory=" << ruse.ru_ixrss << endl;
	 cout << "Unshared memory for data=" << ruse.ru_idrss << endl;
	 cout << "Unshared memory for stack=" << ruse.ru_isrss << endl;
	 cout << "Num Page faults with no i/o=" << ruse.ru_minflt << endl;
	 cout << "Num Page faults with i/o=" << ruse.ru_majflt << endl;
	 cout << "Num times out of memory into swap=" << ruse.ru_nswap << endl;
	 cout << "Num times read from disk=" << ruse.ru_inblock << endl;
	 cout << "Num times write to disk=" << ruse.ru_oublock << endl;
	 cout << "Num IPC sent=" << ruse.ru_msgsnd << endl;
	 cout << "Num IPC received=" << ruse.ru_msgrcv << endl;
	 cout << "Num signals received=" << ruse.ru_nsignals << endl;
	 cout << "Num times waited for a service=" << ruse.ru_nvcsw << endl;
	 cout << "Num times not waited for s service=" << ruse.ru_nivcsw <<endl;
      }
   }
};

#endif

