#ifndef _SAVE_IMG_H_
#define _SAVE_IMG_H_

typedef enum _ImgType
{
   IMG_PNG,
   IMG_JPEG,
}
  ImageType;

/** Function for saving the model into the given image format like IMG_PNG or
  * IMG_JPEG. This function gets the image data from active glxContext and
  * exports the data to the image file
  * \param img_name Name of image to which the data is saved from the window
  * \param img_type Type of image ie. IMG_PNG-0 or IMG_JPEG-1
  * \param width Width of image
  * \param height Height of image
  * \return Returns 0 on success else greater than 0
  */
int saveImage
    (
       const char *img_name, 
       int img_type, 
       unsigned int width, 
       unsigned int height
    );

/** Function for saving the model into the given image format like IMG_PNG or
  * IMG_JPEG. The available image data to be given to this function for saving.
  * \param img_name Name of image to which the data is saved from the window
  * \param img_type Type of image ie. IMG_PNG-0 or IMG_JPEG-1
  * \param width Width of image
  * \param height Height of image
  * \param buffer Pointer to the buffer holding the window data directly. The data
  * is arranged in the required form for saving
  * \return Returns 0 on success else greater than 0
  */
int saveImage
    (
       const char *img_name, 
       int img_type, 
       unsigned int width, 
       unsigned int height,
       unsigned char *buffer
    );

#endif

