#include "savetojpeg.h"
#include "jpeglib.h"
#include <GL/gl.h>

int SaveToJpeg::save
    (
       unsigned char **data, 
       int width, 
       int height, 
       int gl_type
    )
{
   J_COLOR_SPACE color = JCS_RGB;
   int num_comp = 3;

   if( gl_type == GL_LUMINANCE )
   {
      color = JCS_GRAYSCALE;
      num_comp = 1;
   }

   if( !filePtr )
      return 1;

   jpeg_compress_struct info;

   jpeg_error_mgr jerr;

   info.err = jpeg_std_error( &jerr );
    
   jpeg_create_compress( &info );

   info.image_width = width; 
   info.image_height = height;
   info.input_components = num_comp;
   info.in_color_space = color;
   info.data_precision = 8;

   jpeg_set_defaults( &info );

   jpeg_stdio_dest(&info, filePtr); 

   int quality = 96;
   boolean base_line = TRUE;
   jpeg_set_quality(&info, quality, base_line);

   jpeg_start_compress(&info, base_line);

   while (info.next_scanline < info.image_height) 
   {
      jpeg_write_scanlines(&info, &data[info.next_scanline], 1);
   }

   jpeg_finish_compress(&info);

   jpeg_destroy_compress(&info);

   return 0;
}

