#include <iostream>
#include "mesactx.h"
#include "saveimg.h"

using namespace std;

unsigned int MesaContext::create(unsigned int width, unsigned int height, int imgType)
{
   int numComponents = 4;
   int type = GL_RGBA;
   switch(imgType)
   {
      case IMG_JPEG:
	 numComponents = 3;
	 type = GL_RGB;
	 break;
   }

   /* Create an RGBA-mode context */
#if OSMESA_MAJOR_VERSION * 100 + OSMESA_MINOR_VERSION >= 305
   /* specify Z, stencil, accum sizes */
   mesaCtx = OSMesaCreateContextExt( type, 32, 0, 0, NULL );
#else
   mesaCtx = OSMesaCreateContext( type, NULL );
#endif
   if (!mesaCtx)
   {
      printf("OSMesaCreateContext failed!\n");
      return 1;
   }


   /* Allocate the image buffer */
   mesaBuffer = (unsigned char *)malloc(width * height * numComponents *sizeof(GLubyte));
   if (!mesaBuffer)
   {
      cout << "Alloc image buffer failed!\n";
      return 2;
   }

   /* Bind the buffer to the context and make it current */
   if (!OSMesaMakeCurrent( mesaCtx, mesaBuffer, GL_UNSIGNED_BYTE,
						     width, height ))
   {
      cout << "OSMesaMakeCurrent failed!\n";
      return 3;
   }
 
   int z, s, a;
   glGetIntegerv(GL_DEPTH_BITS, &z);
   glGetIntegerv(GL_STENCIL_BITS, &s);
   glGetIntegerv(GL_ACCUM_RED_BITS, &a);
   printf("Depth=%d Stencil=%d Accum=%d\n", z, s, a);
   return 0;
}

