#ifndef _MESA_CTX_H_
#define _MESA_CTX_H_

#include <GL/osmesa.h>
#include <stdio.h>
#include <stdlib.h>

/** Class for creating the Mesa context for off-screeing rendering of model */
class MesaContext
{
public:
   MesaContext() : mesaCtx(NULL), mesaBuffer(NULL) {}

   /** Creates the context for the width and height of window */
   unsigned int create(unsigned int width, unsigned int height, int img_type);

   /** Gets the buffer holding the model image data */
   unsigned char *getBuffer() { return mesaBuffer; }

   ~MesaContext()
   {
      if( mesaCtx )
         OSMesaDestroyContext( mesaCtx );
      if( mesaBuffer )
         free( mesaBuffer );
   }

private:
   OSMesaContext mesaCtx;
   unsigned char *mesaBuffer;
};

#endif

