#include "savetopng.h"

int SaveToPng::save
    (
       unsigned char **data, 
       int  width, 
       int  height, 
       int  gl_type,
       int compress_level
    )
{
   int color;

   if( !filePtr )
      return 1;

   png_structp png = png_create_write_struct(PNG_LIBPNG_VER_STRING, 
                                          NULL, NULL, NULL);

   if( !png )
   {
      cout << "Out of memory" << endl;
      return 2;
   }

   png_infop info = png_create_info_struct( png );

   if( !info )
   {
      png_destroy_write_struct( &png, NULL );
      cout << "Error in creating info" << endl;
      return 3;
   }

   if (setjmp(png_jmpbuf(png))) 
   {
      png_destroy_write_struct(&png, &info);
      return 4;
   }

   png_set_compression_level(png, compress_level);

   png_init_io(png, filePtr);

   switch( gl_type )
   {
      case GL_RGBA:
         color = PNG_COLOR_TYPE_RGB_ALPHA;
cout << "PNG_COLOR_TYPE_RGB_ALPHA\n";
      break;
      case GL_RGB:
         color = PNG_COLOR_TYPE_RGB;
cout << "PNG_COLOR_TYPE_RGB\n";
      break;
      case GL_LUMINANCE:
         color = PNG_COLOR_TYPE_GRAY;
cout << "PNG_COLOR_TYPE_GRAY\n";
      break;
      case GL_ALPHA:
         color = PNG_COLOR_TYPE_GRAY;
cout << "PNG_COLOR_TYPE_GRAY\n";
      break;
      case GL_LUMINANCE_ALPHA:
         color = PNG_COLOR_TYPE_GRAY_ALPHA;
cout << "PNG_COLOR_TYPE_GRAY_ALPHA\n";
      break;
      default:
         color = PNG_COLOR_TYPE_RGB_ALPHA;
   }

   png_set_IHDR(png, info, width, height, 8, color,
	PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_DEFAULT, 
        PNG_FILTER_TYPE_DEFAULT);

   png_write_info(png, info);
//cout << "ROW BYTES = " << png_get_rowbytes(png, info) << endl;
   png_write_image(png, data);

   if (setjmp(png_jmpbuf(png))) 
   {
      png_destroy_write_struct(&png, &info);
      return 5;
   }

   png_write_end(png, NULL);

   png_destroy_write_struct(&png, &info);

   return 0;
}

