#include "boundbox.h"
#include <GL/gl.h>

unsigned int BoundBox::boxIndices[] = 
                        {
                           0, 1, 2, 3,
                           1, 2, 6, 5,
                           4, 5, 6, 7,
                           3, 0, 4, 7,
                           2, 3, 7, 6,
                           0, 1, 5, 4,
                        };

unsigned int BoundBox::fontBase;

BoundBox::BoundBox(float ext[6])
{
   boxVertices[0] = boxVertices[9] = boxVertices[12] = boxVertices[21] = ext[0];
   boxVertices[3] = boxVertices[6] = boxVertices[15] = boxVertices[18] = ext[1];
   boxVertices[1] = boxVertices[4] = boxVertices[13] = boxVertices[16] = ext[2];
   boxVertices[7] = boxVertices[10] = boxVertices[19] = boxVertices[22] =ext[3];
   boxVertices[2] = boxVertices[5] = boxVertices[8] = boxVertices[11] = ext[4];
   boxVertices[14] = boxVertices[17] = boxVertices[20] = boxVertices[23]=ext[5];
}

void BoundBox::render()
{
   char buf[16];
   int i, pmode[2];
//cout << "EXTS=" << ext[0] << "," << ext[1] << "," << ext[2] << ","
//                       << ext[3] << "," << ext[4] << "," << ext[5] << endl;
   glColor4f(1.0f, 1.0f, 1.0f, 0.6f);
   for(i = 0; i < 8; i++)
   {
      glRasterPos3fv(&boxVertices[i*3]);
      glListBase(fontBase);
      sprintf(buf, "%d", i);
      glCallLists(strlen(buf), GL_UNSIGNED_BYTE, (GLubyte *) buf);
   }

   glPointSize(5.0);
   glBegin(GL_POINTS);
   glColor3f(0.0, 1.0, 0.0);
      glVertex3f(boxVertices[0], boxVertices[1], boxVertices[2]);
   glColor3f(1.0, 0.0, 0.0);
      glVertex3f(boxVertices[3], boxVertices[7], boxVertices[14]);
   glEnd();
   glPointSize(1.0);

   glColor4f(1.0, 1.0, 1.0, 0.6);

   glGetIntegerv(GL_POLYGON_MODE, pmode);
   glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
   glEnableClientState(GL_VERTEX_ARRAY);
   glVertexPointer(3, GL_FLOAT, 0, boxVertices);
   glDrawElements(GL_QUADS, 24, GL_UNSIGNED_INT, boxIndices);
   glPolygonMode(GL_FRONT_AND_BACK, pmode[0]);
}

