#ifndef _BOUND_BOX_H_
#define _BOUND_BOX_H_

#include <iostream>
#include <stdio.h>
#include <string.h>

using namespace std;

/** Class for rendering a box around a part using it's extents. */
class BoundBox
{
public:
   /** Constructor for creating this object with given extents
     * \param ext Extents of the part xmin,xmax,ymin,ymax,zmin,zmax
     */
   BoundBox(float ext[6]);

   /** Function to draw the box */
   void render();

   /** Setting the font to draw the extents on the window
     * \param font_base Font base id to set
     */
   static void setFontBase(unsigned int font_base)
   {
      fontBase = font_base;
   }

   ~BoundBox(){}

private:
   /** Vertices of bounding box */
   float boxVertices[24];
   /** Indices of connectivity for drawing box */
   static unsigned int boxIndices[24], fontBase;
};

#endif

