#include <GL/glu.h>
#include "glfuncs.h"
#include <iostream>

using namespace std;

void GLFuncs::process(int gl_type)
{
   switch(gl_type)
   {
      case GL_SHADE_MODEL:
      {
	 int shade;
	 glGetIntegerv(GL_SHADE_MODEL, &shade);
	 switch(shade)
	 {
	    case GL_SMOOTH:
	       glShadeModel(GL_FLAT);
	    break;
	    case GL_FLAT:
	       glShadeModel(GL_SMOOTH);
	    break;
	 }
      }
      break;
      case GL_POLYGON_MODE:
      {
	 int p_mode[2];
	 glGetIntegerv(GL_POLYGON_MODE, p_mode);
	 switch(p_mode[0])
	 {
	    case GL_FILL:
	       glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	    break;
	    case GL_LINE:
	       glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	    break;
	 }
      }
      break;
      case GL_DEPTH_TEST:
      {
	 if( glIsEnabled(GL_DEPTH_TEST) )
	    glDisable(GL_DEPTH_TEST);
	 else
	 {
	    glEnable(GL_DEPTH_TEST);
	    glDepthFunc(GL_LESS);
	    glDepthRange(0.0, 1.0);
	 }
      }
      break;
      case GL_BLEND:
      {
	 if( glIsEnabled(GL_BLEND) )
	    glDisable(GL_BLEND);
	 else
	 {
	    glEnable(GL_BLEND);
	    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	 }
      }
      break;
   }
}

