#ifndef _PICK_RECT_H_
#define _PICK_RECT_H_

#include <GL/glu.h>
#include <map>
#include "maptypes.h"

using namespace std;

/** Class to store the pick information of model enitities
  */
class PickRect
{
public:
   /** Default constructor for creating this object */
   PickRect()
   {
   }

   ~PickRect()
   {
      zPartMap.clear();
   }

   /** Function for processing the picked data of the model
     * \param pick_type Type of pick PART_PICK,NODE_PICK,ELEMENT_PICK
     * \param pick_method Type of pick method SELECT_PICK, RECT_PICK
     * \param mouse_xy Input of mouse values have to be sent properly, otherwise 
     * the pick is not going to work. The CENTER OF PICK REGION and REGION in 
     * window coordinates are to be sent. Be careful with the CENTER.
     */
     
   int process(int pick_type, int pick_method, float mouse_xy[4]);
   //int processFeedback(unsigned int proc_flag, float mouse_xy[4]);

private:
   int processHits(GLint num_hits, GLuint *select_buf);
   //int processFeedbackBuffer(GLint size, GLfloat *buffer);

private:
   unsigned int pickType, pickMethod;

   /** A map between the z value of entity and picked entity. The pick selects
     * all entities under the mouse. To select the top most entity, this map is
     * used
     */
   ZPartMap zPartMap;
};

#endif

