#include "rubberband.h"
#include <GL/gl.h>
#include <GL/glu.h>
#include <iostream>
#include <vector>

using namespace std;

void createRubberBand
     (
        int *view_port, 
        float mouse_values[4],
        double *proj_mat
     ) //int sx, int sy, int ex, int ey)
{
   int pmode[2];
   double wstartp[3], wendp[3];
   double mvmat[16], value = 1.0;

   memset(mvmat, 0, sizeof(double) * 16);
   memcpy(mvmat, &value, sizeof(double));
   memcpy(mvmat+5, &value, sizeof(double));
   memcpy(mvmat+10, &value, sizeof(double));
   memcpy(mvmat+15, &value, sizeof(double));
   
   gluUnProject(mouse_values[0], mouse_values[1], 0.5, mvmat, proj_mat, view_port, &wstartp[0], &wstartp[1], &wstartp[2]);
cout << "start world=" << wstartp[0] << "," << wstartp[1] << "," << wstartp[2] << endl;
   gluUnProject(mouse_values[2], mouse_values[3], 0.5, mvmat, proj_mat, view_port, &wendp[0], &wendp[1], &wendp[2]);
cout << "end world=" << wendp[0] << "," << wendp[1] << "," << wendp[2] << endl;
   //moved to mtrans.h
   //depth_test = glIsEnabled(GL_DEPTH_TEST);
   //glDisable(GL_DEPTH_TEST);
   glGetIntegerv(GL_POLYGON_MODE, pmode);
   glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
   glMatrixMode(GL_MODELVIEW);
   glPushMatrix();
      glLoadIdentity();
      glColor4f(1.0, 1.0, 1.0, 1.0);

      glBegin(GL_LINE_LOOP);
	 glVertex3dv(wstartp);
	 glVertex3d(wendp[0], wstartp[1], -wstartp[2]);
	 glVertex3d(wendp[0], wendp[1], -wstartp[2]);
	 glVertex3d(wstartp[0], wendp[1], -wstartp[2]);
      glEnd();

   glPopMatrix();
   glPolygonMode(GL_FRONT_AND_BACK, pmode[0]);
   //if( depth_test )
      //glEnable(GL_DEPTH_TEST);
}

void createPolyline
     (
        vector<Point3D *> & points_list
     )
{
   unsigned int i;
   int pmode[2];

   glGetIntegerv(GL_POLYGON_MODE, pmode);
   glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
   glMatrixMode(GL_MODELVIEW);
   //glPushMatrix();
      //glLoadIdentity();
      glColor4f(1.0, 1.0, 1.0, 1.0);

      glBegin(GL_POLYGON);
      for(i = 0; i < points_list.size(); i++)
	 glVertex3fv(points_list[i]->point);
      glEnd();

   //glPopMatrix();
   glPolygonMode(GL_FRONT_AND_BACK, pmode[0]);
}

