#ifndef _RUBBER_BAND_H_
#define _RUBBER_BAND_H_

#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

using namespace std;

/** Function to create the rubber band for a rectangular pick
  * \param view_port Viewport of window. x,y, width and height
  * \param mouse_values start and end point of mouse 
  * \param proj_mat Projection matrix of the model from OpenGL
  */
void createRubberBand
     (
        int *view_port, 
        float mouse_values[4],
        double *proj_mat
     );

/** Union for float and int. As per Mesa integer processing is faster in intel */
typedef union _IntFloat
{
   /** integer variable */
   int   i;
   /** float variable */
   float f;
}
  IntFloat;

/** Represents a 3D point */
typedef struct _Point3D
{
   /** x,y and z coordinates */
   float point[3];
}
  Point3D, *Point3DPtr;

/** Represents a 2D point */
typedef struct _Point2D
{
   /** x and y coordinates */
   float point[2];
}
  Point2D, *Point2DPtr;

/** Function to create polyline for picking
  * \param points_list List of points created for the polyline
  */
void createPolyline
     (
        vector<Point3D *> & points_list
     );

#endif

