#include "d3plot.h"
#include <iostream>
#include <set>
#include "filegeneric.h"
#include "filepath.h"

using namespace std;

int D3Plot::m_GlobalFileIndex = 0;

int D3Plot::getNextFile(string & fileName, string & filePath)
{
    static int fileIndex = 1;
   char pathBuf[1024], pathFile[1024];

   if (fileIndex < 10)
   {
      sprintf(pathBuf, "%s/%s0%d", resultsDir, m_BaseFile.data(), fileIndex);
      sprintf(pathFile, "%s0%d", m_BaseFile.data(), fileIndex);
   }
   else
   {
      sprintf(pathBuf, "%s/%s%d", resultsDir, m_BaseFile.data(), fileIndex);
      sprintf(pathFile, "%s%d", m_BaseFile.data(), fileIndex);
   }

   if (access(pathBuf, R_OK) >= 0)
   {
      filePath = pathBuf;
      fileName = pathFile;
      fileIndex++;
      return fileIndex;
   }
   else
       fileIndex = 1;

   return 0;
}

int D3Plot::getNextAvailableFile(string & fileName, string & filePath, int *newDirFlag)
{
    static int fileIndex = 0;
    if(newDirFlag)
        *newDirFlag = 0;

   char pathBuf[1024], pathFile[1024];

   if(!fileIndex)
   {
       sprintf(pathBuf, "%s/d3plot", resultsDir);
       sprintf(pathFile, "d3plot");

       if (access(pathBuf, R_OK) >= 0)
       {
          filePath = pathBuf;
          fileName = pathFile;
          ++fileIndex;
          m_BaseFile = pathFile;
          return fileIndex;
       }

       sprintf(pathBuf, "%s/%s.d3plot", resultsDir, modelName);
       sprintf(pathFile, "%s.d3plot", modelName);

       if (access(pathBuf, R_OK) >= 0)
       {
          filePath = pathBuf;
          fileName = pathFile;
          ++fileIndex;
          m_BaseFile = pathFile;
          return fileIndex;
       }
   }

//   if (fileIndex < 10)
//   {
//      sprintf(pathBuf, "%s/d3plot0%d", resultsDir, fileIndex);
//      sprintf(pathFile, "d3plot0%d", fileIndex);
//   }
//   else
//   {
//      sprintf(pathBuf, "%s/d3plot%d", resultsDir, fileIndex);
//      sprintf(pathFile, "d3plot%d", fileIndex);
//   }

//   if (access(pathBuf, R_OK) >= 0)
//   {
//      filePath = pathBuf;
//      fileName = pathFile;
//      fileIndex++;
//      return fileIndex;
//   }

//   if (fileIndex < 10)
//   {
//      sprintf(pathBuf, "%s/%s.d3plot0%d", resultsDir, modelName, fileIndex);
//      sprintf(pathFile, "%s.d3plot0%d", modelName, fileIndex);
//   }
//   else
//   {
//      sprintf(pathBuf, "%s/%s.d3plot%d", resultsDir, modelName, fileIndex);
//      sprintf(pathFile, "%s.d3plot%d", modelName, fileIndex);
//   }

//   if (access(pathBuf, R_OK) >= 0)
//   {
//      filePath = pathBuf;
//      fileName = pathFile;
//      fileIndex++;
//      return fileIndex;
//   }

   static char literal1Flag = 'a';
   static char literal2Flag = 'b';
   static int literalFileIndex = 0;

   if(!literalFileIndex)
   {
       sprintf(pathBuf, "%s/d3plot%c%c", resultsDir, literal1Flag, literal2Flag);
       sprintf(pathFile, "d3plot%c%c", literal1Flag, literal2Flag);

       if (access(pathBuf, R_OK) >= 0)
       {
          filePath = pathBuf;
          fileName = pathFile;
          ++literalFileIndex;
          if(newDirFlag)
              *newDirFlag = 1;
          m_BaseFile = pathFile;
          return fileIndex;
       }
   }
   else
   {
        if(literalFileIndex < 10)
        {
            sprintf(pathBuf, "%s/d3plot%c%c0%d", resultsDir, literal1Flag, literal2Flag, literalFileIndex);
            sprintf(pathFile, "d3plot%c%c0%d", literal1Flag, literal2Flag, literalFileIndex);

            if (access(pathBuf, R_OK) >= 0)
            {
               filePath = pathBuf;
               fileName = pathFile;
               ++literalFileIndex;
               return fileIndex;
            }

            literalFileIndex =  0;
            if(literal2Flag != 'z')
               literal2Flag++;
            else
            {
               literal2Flag = 'b';
               literal1Flag++;
            }

            sprintf(pathBuf, "%s/d3plot%c%c", resultsDir, literal1Flag, literal2Flag);
            sprintf(pathFile, "d3plot%c%c", literal1Flag, literal2Flag);

            if (access(pathBuf, R_OK) >= 0)
            {
               filePath = pathBuf;
               fileName = pathFile;
               ++literalFileIndex;
               if(newDirFlag)
                   *newDirFlag = 1;
               return fileIndex;
            }
        }
        else
        {
            sprintf(pathBuf, "%s/d3plot%c%c%d", resultsDir, literal1Flag, literal2Flag, literalFileIndex);
            sprintf(pathFile, "d3plot%c%c%d", literal1Flag, literal2Flag, literalFileIndex);

            if (access(pathBuf, R_OK) >= 0)
            {
               filePath = pathBuf;
               fileName = pathFile;
               ++literalFileIndex;
               return fileIndex;
            }

            literalFileIndex =  0;
            if(literal2Flag != 'z')
               literal2Flag++;
            else
            {
               literal2Flag = 'b';
               literal1Flag++;
            }

            sprintf(pathBuf, "%s/d3plot%c%c", resultsDir, literal1Flag, literal2Flag);
            sprintf(pathFile, "d3plot%c%c", literal1Flag, literal2Flag);

            if (access(pathBuf, R_OK) >= 0)
            {
               filePath = pathBuf;
               fileName = pathFile;
               ++literalFileIndex;
               if(newDirFlag)
                   *newDirFlag = 1;
               return fileIndex;
            }
        }
   }

   if(!literalFileIndex)
   {
        sprintf(pathBuf, "%s/%s.d3plot%c%c", resultsDir, modelName, literal1Flag, literal2Flag);
        sprintf(pathFile, "%s.d3plot%c%c", modelName, literal1Flag, literal2Flag);

        if (access(pathBuf, R_OK) >= 0)
        {
           filePath = pathBuf;
           fileName = pathFile;
           ++literalFileIndex;
           if(newDirFlag)
               *newDirFlag = 1;
           m_BaseFile = pathFile;
           return fileIndex;
        }
   }
   else
   {
       if(literalFileIndex < 10)
       {
           sprintf(pathBuf, "%s/%s.d3plot%c%c0%d", resultsDir, modelName, literal1Flag, literal2Flag, literalFileIndex);
           sprintf(pathFile, "%s.d3plot%c%c0%d", modelName, literal1Flag, literal2Flag, literalFileIndex);

           if (access(pathBuf, R_OK) >= 0)
           {
              filePath = pathBuf;
              fileName = pathFile;
              ++literalFileIndex;
              return fileIndex;
           }

           literalFileIndex =  0;
           if(literal2Flag != 'z')
              literal2Flag++;
           else
           {
              literal2Flag = 'b';
              literal1Flag++;
           }

           sprintf(pathBuf, "%s/%s.d3plot%c%c", resultsDir, modelName, literal1Flag, literal2Flag);
           sprintf(pathFile, "%s.d3plot%c%c", modelName, literal1Flag, literal2Flag);

           if (access(pathBuf, R_OK) >= 0)
           {
              filePath = pathBuf;
              fileName = pathFile;
              ++literalFileIndex;
              if(newDirFlag)
                  *newDirFlag = 1;
              return fileIndex;
           }
       }
       else
       {
           sprintf(pathBuf, "%s/%s.d3plot%c%c%d", resultsDir, modelName, literal1Flag, literal2Flag, literalFileIndex);
           sprintf(pathFile, "%s.d3plot%c%c%d", modelName, literal1Flag, literal2Flag, literalFileIndex);

           if (access(pathBuf, R_OK) >= 0)
           {
              filePath = pathBuf;
              fileName = pathFile;
              ++literalFileIndex;
              return fileIndex;
           }

           literalFileIndex =  0;
           if(literal2Flag != 'z')
              literal2Flag++;
           else
           {
              literal2Flag = 'b';
              literal1Flag++;
           }

           sprintf(pathBuf, "%s/%s.d3plot%c%c", resultsDir, modelName, literal1Flag, literal2Flag);
           sprintf(pathFile, "%s.d3plot%c%c", modelName, literal1Flag, literal2Flag);

           if (access(pathBuf, R_OK) >= 0)
           {
              filePath = pathBuf;
              fileName = pathFile;
              ++literalFileIndex;
              if(newDirFlag)
                  *newDirFlag = 1;
              return fileIndex;
           }
       }
   }

   return 0;
}

int D3Plot::openFile(const char *file)
{
   /*char buf[1024], baseFile[1024];
   sprintf(buf, "%s/%s", resultsDir, file);
   sprintf(baseFile, "%s", file);*/

   struct stat statbuf;
   fileDes = open(file, O_RDONLY);

   if (fileDes < 0)
   {
         cout << "binary file=" << file << " not exists" << endl;
         return 1;
   }

   if (fstat(fileDes, &statbuf) < 0)
   {
      cout << "Unable to stat file " << file << endl;
      return 2;
   }
   //cout << "BLOCK SIZE=" << statbuf.st_blksize << endl;
   //cout << "NUM BLOCK =" << statbuf.st_blocks << endl;

   fileSize = statbuf.st_size;

   fileBase = (WORD *)mmap(NULL, statbuf.st_size, PROT_READ,
                           MAP_PRIVATE, fileDes, 0);
   if (fileBase == MAP_FAILED)
   {
      cout << "MMAP error for file " << file << endl;
      return 3;
   }

   m_FilePtr = fileBase;

   return 0;
}

int D3Plot::readControlData()
{
   //WORD *filePtr = fileBase; //node data was wrong because of this local
   memcpy(title, m_FilePtr, WSIZE * 10);
   m_FilePtr += 10;
   title[WSIZE * 10] = '\0';
   cout << "title=" << title << endl;
   memcpy(time, m_FilePtr, WSIZE);
   m_FilePtr++;
   time[WSIZE] = '\0';
   cout << "time=" << time << endl;
   memcpy(&inum, m_FilePtr, WSIZE);
   m_FilePtr++;
   cout << "inum=" << inum << endl;
   if(!inum)
      inum = 1;
   memcpy(&srcVer, m_FilePtr, WSIZE);
   m_FilePtr++;
   cout << "srcVer=" << srcVer << endl;
   dynaVersion = srcVer/1000000;
   memcpy(releaseNum, m_FilePtr, WSIZE);
   releaseNum[WSIZE] = '\0';
   m_FilePtr++;
   cout << "releaseNum=" << releaseNum << endl;
   memcpy(&version, m_FilePtr, WSIZE);
   m_FilePtr++;
   cout << "version=" << version << endl;

   memcpy(&ndim, m_FilePtr, WSIZE);
   m_FilePtr++;
   nDim = ndim;
   cout << "ndim=" << ndim << endl;
   mattyp = 0;
   switch (ndim)
   {
   case 5:
   case 7:
      mattyp = 1;
      break;
   }
   cout << "mattyp=" << mattyp << endl;

   numnp = *m_FilePtr++;
   cout << "numnp=" << numnp << endl;

   icode = *m_FilePtr++;
   cout << "icode=" << icode << endl;

   nglbv = *m_FilePtr++;
   cout << "nglbv=" << nglbv << endl;

   it = *m_FilePtr++;
   cout << "it=" << it << endl;

   iu = *m_FilePtr++;
   cout << "iu=" << iu << endl;

   iv = *m_FilePtr++;
   cout << "iv=" << iv << endl;

   ia = *m_FilePtr++;
   cout << "ia=" << ia << endl;

   nel8 = *m_FilePtr++;
   cout << "nel8=" << nel8 << endl;

   nummat8 = *m_FilePtr++;
   cout << "nummat8=" << nummat8 << endl;

   numds = *m_FilePtr++;
   cout << "numds=" << numds << endl;

   numst = *m_FilePtr++;
   cout << "numst=" << numst << endl;

   nv3d = *m_FilePtr++;
   cout << "nv3d=" << nv3d << endl;

   nel2 = *m_FilePtr++;
   cout << "nel2=" << nel2 << endl;

   nummat2 = *m_FilePtr++;
   cout << "nummat2=" << nummat2 << endl;

   nv1d = *m_FilePtr++;
   cout << "nv1d=" << nv1d << endl;

   nel4 = *m_FilePtr++;
   cout << "nel4=" << nel4 << endl;

   nummat4 = *m_FilePtr++;
   cout << "nummat4=" << nummat4 << endl;

   nv2d = *m_FilePtr++;
   cout << "nv2d=" << nv2d << endl;

   neiph = *m_FilePtr++;
   cout << "neiph=" << neiph << endl;

   neips = *m_FilePtr++;
   cout << "neips=" << neips << endl;

   maxint = *m_FilePtr++;
   cout << "maxint=" << maxint << endl;

   if (maxint >= 0)
      mdlopt = 0;
   else if (maxint < -10000)
   {
      mdlopt = 2;
      maxint = abs(maxint) - 10000;
   }
   else if (maxint < 0)
   {
      mdlopt = 1;
      maxint = abs(maxint);
   }

   cout << "modified maxint=" << maxint << endl;
   cout << "mdlopt=" << mdlopt << endl;

   nmsph = *m_FilePtr++;
   cout << "nmsph=" << nmsph << endl;

   ngpsph = *m_FilePtr++;
   cout << "ngpsph=" << ngpsph << endl;

   narbs = *m_FilePtr++;
   cout << "narbs=" << narbs << endl;

   nelt = *m_FilePtr++;
   cout << "nelt=" << nelt << endl;

   nummatt = *m_FilePtr++;
   cout << "nummatt=" << nummatt << endl;

   nv3dt = *m_FilePtr++;
   cout << "nv3dt=" << nv3dt << endl;

   ioshl1 = *m_FilePtr++;
   cout << "ioshl1=" << ioshl1 << endl;
   if (ioshl1 == 1000)
      ioshl1 = 1;
   else
      ioshl1 = 0;
   cout << "ioshl1=" << ioshl1 << endl;

   ioshl2 = *m_FilePtr++;
   cout << "ioshl2=" << ioshl2 << endl;
   if (ioshl2 == 1000)
      ioshl2 = 1;
   else
      ioshl2 = 0;
   cout << "ioshl2=" << ioshl2 << endl;

   ioshl3 = *m_FilePtr++;
   cout << "ioshl3=" << ioshl3 << endl;
   if (ioshl3 == 1000)
      ioshl3 = 1;
   else
      ioshl3 = 0;
   cout << "ioshl3=" << ioshl3 << endl;

   ioshl4 = *m_FilePtr++;
   cout << "ioshl4=" << ioshl4 << endl;
   if (ioshl4 == 1000)
      ioshl4 = 1;
   else
      ioshl4 = 0;
   cout << "ioshl4=" << ioshl4 << endl;

   ialemat = *m_FilePtr++;
   cout << "ialemat=" << ialemat << endl;

   ncfdv1 = *m_FilePtr++;
   cout << "ncfdv1=" << ncfdv1 << endl;

   ncfdv2 = *m_FilePtr++;
   cout << "ncfdv2=" << ncfdv2 << endl;

   nadapt = *m_FilePtr++;
   cout << "nadapt=" << nadapt << endl;
   m_FilePtr += 13;

   istrn = 0;
   if (nel4 > 0)
   {
      int localVar = nv2d - (maxint * (6 * ioshl1 + ioshl2 + neips) + 8 * ioshl3 + 4 * ioshl4);
      if (localVar > 1)
         istrn = 1;
   }
   else if (nelt > 0)
   {
      int localInt = nv3dt - maxint * (6 * ioshl1 + ioshl2 + neips);
      if (localInt > 1)
         istrn = 1;
   }
   cout << "istrn=" << istrn << endl;

   return 0;
}

int D3Plot::readMatTypeData()
{
   if (mattyp == 0)
      return 0;

   cout << "IN MAT TYPE DATA\n";

   numrbe = *m_FilePtr++;
   nummat = *m_FilePtr++;
   irbtyp = new WORD[nummat];
   memcpy(irbtyp, m_FilePtr, nummat * WSIZE);
   m_FilePtr += nummat;

   return numrbe;
}

int D3Plot::readFluidMaterialIDData()
{
   if (!ialemat)
      return 0;

   cout << "IN FLUID MAT ID DATA\n";

   fluidid = new WORD[ialemat];
   memcpy(fluidid, m_FilePtr, ialemat * WSIZE);
   m_FilePtr += ialemat;

   return ialemat;
}

int D3Plot::readSPHElementDataFlags()
{
   if (nmsph <= 0)
      return 0;

   cout << "IN SPHELEMENT DATAFlags\n";

   memcpy(isphfg, m_FilePtr, WSIZE * 9);
   m_FilePtr += 9;

   return nmsph;
}

int D3Plot::readSPHElementData(StateDataPtr state)
{
   if (nmsph <= 0)
      return 0;

   cout << "IN SPHELEMENT DATA\n";

   WORD i, j;
   state->sph = new SPHElementStr[nmsph];
   SPHElementPtr sph_ptr;
   memset(state->sph, 0, sizeof(SPHElementStr) * nmsph);

   for (i = 0; i < nmsph; i++)
   {
      sph_ptr = &state->sph[i];
      for (j = 0; j < 9; j++)
      {
         switch (j)
         {
         case 0:
            memcpy(&sph_ptr->matNumber, m_FilePtr, WSIZE);
            m_FilePtr++;
            break;
         case 1:
            if (isphfg[j])
            {
               memcpy(&sph_ptr->radius, m_FilePtr, WSIZE);
               m_FilePtr++;
            }
            break;
         case 2:
            if (isphfg[j])
            {
               memcpy(&sph_ptr->pressure, m_FilePtr, WSIZE);
               m_FilePtr++;
            }
            break;
         case 3:
            if (isphfg[j])
            {
               sph_ptr->stress = new StressStr;
               memcpy(sph_ptr->stress, m_FilePtr, sizeof(StressStr));
               m_FilePtr += 6;
            }
            break;
         case 4:
            if (isphfg[j])
            {
               memcpy(&sph_ptr->ps, m_FilePtr, WSIZE);
               m_FilePtr++;
            }
            break;
         case 5:
            if (isphfg[j])
            {
               memcpy(&sph_ptr->rho, m_FilePtr, WSIZE);
               m_FilePtr++;
            }
            break;
         case 6:
            if (isphfg[j])
            {
               memcpy(&sph_ptr->ie, m_FilePtr, WSIZE);
               m_FilePtr++;
            }
            break;
         case 7:
            if (isphfg[j])
            {
               memcpy(&sph_ptr->nn, m_FilePtr, WSIZE);
               m_FilePtr++;
            }
            break;
         case 8:
            if (isphfg[j])
            {
               sph_ptr->strain = new StrainStr;
               memcpy(sph_ptr->strain, m_FilePtr, sizeof(StrainStr));
               m_FilePtr += 6;
            }
            break;
         }
      }
   }

   return nmsph;
}

int D3Plot::readGeometryData(int dirIndex)
{
   if (!numnp)
      return 0;

   if(dirIndex)
        FilePath::setPath(userDir, modelName, dirIndex);
   else
       FilePath::set(userDir, modelName);
   cout << "NUM NODES=" << numnp << endl;
   cout << "BASE ADDRESS=" << fileBase << endl;
   cout << "CUR ADDRESS=" << m_FilePtr << endl;
   //filePtr = fileBase + 64;
   //cout << "ADDRESS=" << filePtr << endl;

   switch(ndim)
   {
   case 4:
   case 5:
   case 7:
       ndim = 3;
       break;
   }

   ndim = 3;

   nodeValues = new FWORD[numnp * ndim];
   memcpy(nodeValues, m_FilePtr, numnp * ndim * WSIZE);
   m_FilePtr += numnp * ndim;

   cout << "NODE SIZE=" << ndim * numnp * WSIZE << endl;
   cout << "FILE SIZE=" << fileSize << endl;
   saveGeometryNodes();
   int i, j;
   /*cout << "NODES\n";
   for (i = 0; i < numnp * ndim; i += 3)
   {
      cout << nodeValues[i] << "," << nodeValues[i + 1] << "," << nodeValues[i + 2] << endl;
   }*/

   //solid elements
   if (nel8 > 0)
   {
      solids = new WORD[nel8 * 9];
      memcpy(solids, m_FilePtr, WSIZE * nel8 * 9);

      saveElements("solid", 8, nel8, solids, ELEMENT_SOLID);
      /*
   cout << "SOLIDS\n";
      for(i = 0; i < nel8 * 9; i += 9)
      {
     for(j = i; j < i+9; j++)
     {
        cout << solids[j] << ",";
     }
   cout << "\n";
      }
*/

      m_FilePtr += (nel8 * 9);
      FilePath::closeFile();
   }

   if (nelt > 0)
   {
      tshells = new WORD[nelt * 9];
      memcpy(tshells, m_FilePtr, WSIZE * nelt * 9);

      saveElements("tshell", 8, nelt, tshells, ELEMENT_TSHELL);
      /*
   cout << "THICK SHELLS\n";
      for(i = 0; i < nelt * 9; i += 9)
      {
     for(j = i; j < i+9; j++)
     {
        cout << tshells[j] << ",";
     }
   cout << "\n";
      }
*/

      m_FilePtr += (nelt * 9);
      FilePath::closeFile();
   }

   if (nel2 > 0)
   {
      beams = new WORD[nel2 * 6];
      memcpy(beams, m_FilePtr, WSIZE * nel2 * 6);

      saveElements("beam", 2, nel2, beams, ELEMENT_BEAM);
      /*
   cout << "BEAMS\n";
      for(i = 0; i < nel2 * 6; i += 6)
      {
     for(j = i; j < i+6; j++)
     {
        cout << beams[j] << ",";
     }
   cout << "\n";
      }
*/

      m_FilePtr += nel2 * 6;
      FilePath::closeFile();
   }

   if (nel4 > 0)
   {
      shells = new WORD[nel4 * 5];
      memcpy(shells, m_FilePtr, WSIZE * nel4 * 5);

      saveElements("shell", 4, nel4, shells, ELEMENT_SHELL);
      FilePath::closeFile();
      /*
      cout << "SHELLS\n";
      for (int i = 0; i < nel4 * 5; i += 5)
      {
         for (int j = i; j < i + 5; j++)
         {
            cout << shells[j] << ",";
         }
         cout << "\n";
      }
      */

      m_FilePtr += (nel4 * 5);
   }

   map<unsigned int, Part *> *partMap = m_GetDB->GetPartMap();
   map<unsigned int, Node *> *nodeIDMap = m_GetDB->GetNodeMap();
   if(partMap->size())
   {
       char     dir_name[1024], file_name[1024];
       sprintf(dir_name, "%s/%s/jsdata/%d/", userDir, modelName, m_GlobalFileIndex);

       if( access(dir_name, W_OK) )
          _mkdir(dir_name);

       int modifyFlag = 0;
       //if(m_GlobalFileIndex > 1)
           //modifyFlag = 1;

       string   partDetailsJSON = "{\"PDArray\":[";
       m_GetDB->writeDataToFilesForResults(dir_name, 0, GL_TRIANGLES, GZIP_COMPRESSION, &partDetailsJSON, modifyFlag, "0", m_GlobalFileIndex);
       partDetailsJSON += "]}";

       unsigned int wh[2] = {800, 600};
       GetDB::writeStartEndFiles(partMap->size(), m_Exts, wh, dir_name);

       sprintf(file_name, "%s/partdetails.js", dir_name);
       string details_file_name = file_name;
       GetDB::writeGZIPFile(details_file_name, partDetailsJSON);
       ++m_GlobalFileIndex;
   }

   return numnp;
}

int D3Plot::readUserIDsData()
{
   if (!narbs)
      return 0;

   WORD *localFilePtr = m_FilePtr;

   int temp_narbs = 10 + numnp + nel8 + nel2 + nel4 + nelt + (3 * nmmat);
   //temp_narbs += (6 + nummat8 + nummat4 + nummat2 + nummatt);
   cout << "TEMP NARBS=" << temp_narbs << endl;
   cout << "NARBS=" << narbs << endl;

   nsort = *localFilePtr++;
   cout << "nsort=" << nsort << endl;
   mat_arb = 0;
   if (nsort < 0)
   {
      nsort = nsort * -1;
      mat_arb = 1;
      temp_narbs += 6;
      cout << " NSORT TEMP NARBS=" << temp_narbs << endl;
   }
   cout << "nsort=" << nsort << endl;
   /*cout << "DYNA NODEIDS=" << endl;
   for (long j = nsort; j <= nsort + numnp; j++)
   {
        cout << *(fileBase + j) << endl;
        arbitraryNIDsVector.insert(make_pair(*(fileBase + j), arbitraryNIDsVector.size()));
   }
   cout << "END DYNA\n";
   cout << "NODE ID=" << *(fileBase + nsort) << endl;
   cout << "NODE ID=" << *(fileBase + nsort + 1) << endl;*/

   nsrh = *localFilePtr++;
   cout << "nsrh=" << nsrh << endl;
   cout << "nsort+numnp=" << nsort + numnp << endl;

   nsrb = *localFilePtr++;
   cout << "nsrb=" << nsrb << endl;
   cout << "nsrh+nel8=" << nsrh + nel8 << endl;

   nsrs = *localFilePtr++;
   cout << "nsrs=" << nsrs << endl;
   cout << "nsrb+nel2=" << nsrb + nel2 << endl;

   nsrt = *localFilePtr++;
   cout << "nsrt=" << nsrt << endl;
   cout << "nsrs+nel4=" << nsrs + nel4 << endl;
   /*cout << "USER SHELL\n";
   for(long j = nsrb+nel2; j <= nsrt; j++)
   {
      cout << *(fileBase + j) << endl;
      nidsFromUserElementsMap.insert(WWPair(*(fileBase + j), j));
   }
   cout << "END USER SHELL\n";*/

   nsortd = *localFilePtr++;
   cout << "nsortd=" << nsortd << endl;

   nsorth = *localFilePtr++;
   cout << "nsorth=" << nsorth << endl;

   nsortb = *localFilePtr++;
   cout << "nsortb=" << nsortb << endl;

   nsorts = *localFilePtr++;
   cout << "nsorts=" << nsorts << endl;

   nsortt = *localFilePtr++;
   cout << "nsortt=" << nsortt << endl;

   if(mat_arb)
   {
      nsrma = *localFilePtr++;
      cout << "nsrma=" << nsrma << endl;

      nsrmu = *localFilePtr++;
      cout << "nsrmu=" << nsrmu << endl;

      nsrmp = *localFilePtr++;
      cout << "nsrmp=" << nsrmp << endl;

      nsrtm = *localFilePtr++;
      cout << "nsrtm=" << nsrtm << endl;

      numrbs = *localFilePtr++;
      cout << "numrbs=" << numrbs << endl;

      nmmat = *localFilePtr++;
      cout << "nmmat=" << nmmat << endl;
   }

   for (int i = 0; i < nsortd; i++)
   {
      //nidsMap.insert(WWPair(*filePtr, i));
      nidsMap.insert(WWPair(i+1, i));
   }

   localFilePtr += nsortd;

   cout << "MAP NODES=" << nidsMap.size() << endl;

/*cout << "NODES FROM IDS\n";
      WWIter bIter = nidsMap.begin(), eIter = nidsMap.end();
      for(; bIter != eIter; bIter++)
      {
            cout << bIter->first << endl;
      }*/
   saveNodeIDs();
  // saveGeometryNodes();
   /*
   nusern = new WORD[nsortd];
   memcpy(nusern, filePtr, WSIZE * nsortd);
   filePtr += nsortd;

   char dir[128], file_name[256];
   sprintf(dir, "%s/%s", userDir, modelName);
   if( access(dir, W_OK) )
      mkdir(dir, 0755);
   sprintf(file_name, "%s/node_ids", dir);
   writeFile(file_name, nusern, nsortd * WSIZE);
cout << "NODEIDS\n";
for(int i = 0; i < nsortd; i++)
   cout << nusern[i] << endl;

cout << "USER NODE ID=" << *nusern << endl;
*/

   /*
   char dir[128], file_name[256];
   sprintf(dir, "%s/%s", userDir, modelName);
   if( access(dir, W_OK) )
      mkdir(dir, 0755);
   sprintf(file_name, "%s/node_values", dir);
   writeFile(file_name, nodeValues, numnp * ndim * WSIZE);
   writeStartFile(numnp, nodeValues);
*/

   if (nsorth)
   {
      nuserh = new WORD[nsorth];
      memcpy(nuserh, localFilePtr, WSIZE * nsorth);
      localFilePtr += nsorth;
   }

   if (nsortb)
   {
      nuserb = new WORD[nsortb];
      memcpy(nuserb, localFilePtr, WSIZE * nsortb);
      localFilePtr += nsortb;
   }

   if (nsorts)
   {
      nusers = new WORD[nsorts];
      memcpy(nusers, localFilePtr, WSIZE * nsorts);
      localFilePtr += nsorts;
   }

   if (nsortt)
   {
      nusert = new WORD[nsortt];
      memcpy(nusert, localFilePtr, WSIZE * nsortt);
      localFilePtr += nsortt;
   }

   if (nmmat)
   {
      norder = new WORD[nmmat];
      memcpy(norder, localFilePtr, WSIZE * nmmat);
      localFilePtr += nmmat;

      nsrmua = new WORD[nmmat];
      memcpy(nsrmua, localFilePtr, WSIZE * nmmat);
      localFilePtr += nmmat;

      nsrmpa = new WORD[nmmat];
      memcpy(nsrmpa, localFilePtr, WSIZE * nmmat);
      localFilePtr += nmmat;
   }

   m_FilePtr += narbs;

   cout << "FILE SIZE READ=" << (localFilePtr - fileBase) * WSIZE << endl;
   return narbs;
}

int D3Plot::readAdaptedElementParentList()
{
   if (!nadapt)
      return 0;

   adapt = new WORD[nadapt * 2];
   memcpy(adapt, m_FilePtr, nadapt * 2 * WSIZE);
   m_FilePtr += nadapt * 2;

   return nadapt;
}

int D3Plot::readSPHNodeMaterialList()
{
   if (!nmsph)
      return 0;

   sphnodemat = new WORD[nmsph * 2];
   memcpy(sphnodemat, m_FilePtr, nmsph * 2 * WSIZE);
   m_FilePtr += nmsph * 2;

   return nmsph;
}

int D3Plot::readRigidRoadSurfaceData()
{
   nnode = 0;

   if (nDim <= 5)
      return 0;

   nnode = *m_FilePtr++;
   cout << "nnode=" << nnode << endl;

   nseg = *m_FilePtr++;
   cout << "nseg=" << nseg << endl;

   nsurf = *m_FilePtr++;
   cout << "nsurf=" << nsurf << endl;

   motion = *m_FilePtr++;
   cout << "motion=" << motion << endl;

   nodeids = new WORD[nnode];
   memcpy(nodeids, m_FilePtr, nnode * WSIZE);
   m_FilePtr += nnode;

   surfnodes = new FWORD[nnode * 3];
   memcpy(surfnodes, m_FilePtr, nnode * 3 * WSIZE);
   m_FilePtr += nnode * 3;

   if (nsurf)
   {
      roads = new RoadSurfaceStr[nsurf];
      RoadSurfacePtr road_ptr;
      for (int i = 0; i < nsurf; i++)
      {
         road_ptr = &roads[i];
         road_ptr->surfid = *m_FilePtr++;
         road_ptr->surfnseg = *m_FilePtr++;
         road_ptr->surfsegs = new WORD[road_ptr->surfnseg * 4];
         memcpy(road_ptr->surfsegs, m_FilePtr, WSIZE * road_ptr->surfnseg * 4);
         m_FilePtr += road_ptr->surfnseg * 4;
      }
   }

   return nnode;
}

int D3Plot::readStateData(int dirIndex)
{
   if (!nglbv)
      return 0;

   numTimes = 0;

   total_mats = (nummat8 + nummat2 + nummat4 + nummatt + numrbs);
   int localN = 1;
   if(dynaVersion == 971)
      localN = 4;
   //numrw = (nglbv - (6 + 7 * total_mats))/localN;

   cout << "nglbv=" << nglbv << endl;
   cout << "total mats=" << total_mats << endl;
   cout << "numrw=" << numrw << endl;

   states = (StateDataPtr)malloc(sizeof(StateDataStr) * 100);
   memset(states, 0, sizeof(StateDataStr) * 100);

   char dir[1024]; //, file_name[256];
   //int i, j;
   int local_file_size = 0, num_files = 0;
   StateDataPtr state;
   FWORD time;

   if(dirIndex)
        sprintf(dir, "%s/%s/%d", userDir, modelName, dirIndex);
   else
        sprintf(dir, "%s/%s", userDir, modelName);

   if (access(dir, W_OK))
      _mkdir(dir);

   //FWORD *node_values = new FWORD[numnp * ndim];
   int adaptFileFlag = 0;
   while (1)
   {
      local_file_size = (m_FilePtr - fileBase) * WSIZE;

      cout << "FILE READ=" << local_file_size << endl;
      cout << "FILE SIZE=" << fileSize << endl;
      memcpy(&time, m_FilePtr, WSIZE);
      cout << "CUR TIME=" << time << endl;

      if (time <= -999999.0 || local_file_size >= fileSize)
      {
         if (fileBase >= 0)
         {
            munmap(fileBase, fileSize);
            close(fileDes);
            fileDes = -1;
         }

         num_files++;

         string   fName, fPath;
         int        newDirFlag = 0;
         int retInt = getNextFile(fName, fPath);
         if(!retInt)
            break;

         cout << "FILE NAME=" << fName << " PATH=" << fPath << endl;

         if (openFile(fPath.data()))
            break;
      }

      if (numTimes && !(numTimes % 100))
      {
         states = (StateDataPtr)realloc(states, (numTimes + 100) *
                                                    sizeof(StateDataStr));
         cout << "REALLOCING********************\n";
      }

      state = &states[numTimes];

      //read time
      memcpy(&state->time, m_FilePtr, WSIZE);
      m_FilePtr++;
      cout << "Time=" << state->time << endl;

      WORD *localFilePtr = m_FilePtr;
      m_FilePtr += nglbv;

      //Read global variables
      {
         //energy values ke, ie, te, xvel, yvel, zvel//, ew
         memcpy(&state->global.energy, localFilePtr, sizeof(EnergyStr));
         localFilePtr += 6;

         cout << "ke=" << state->global.energy.ke << endl;
         cout << "ie=" << state->global.energy.ie << endl;
         cout << "te=" << state->global.energy.te << endl;
         cout << "xvel=" << state->global.energy.xvel << endl;
         cout << "yvel=" << state->global.energy.yvel << endl;
         cout << "zvel=" << state->global.energy.zvel << endl;
         //cout << "ew=" << state->global.energy.ew << endl;

         //read ie for each material
         state->global.mat.ie = new FWORD[total_mats];
         memcpy(state->global.mat.ie, localFilePtr, WSIZE * total_mats);
         localFilePtr += total_mats;

         //read ke for each material
         state->global.mat.ke = new FWORD[total_mats];
         memcpy(state->global.mat.ke, localFilePtr, WSIZE * total_mats);
         localFilePtr += total_mats;

         //read xvel, yvel, zvel for each material
         state->global.mat.vel = new VelocityStr[total_mats];
         memcpy(state->global.mat.vel, localFilePtr, sizeof(VelocityStr) * total_mats);
         localFilePtr += (total_mats * 3);

         //read mass for each material
         state->global.mat.mass = new FWORD[total_mats];
         memcpy(state->global.mat.mass, localFilePtr, WSIZE * total_mats);
         localFilePtr += total_mats;

         //read hourglass energy for each material
         state->global.mat.hg = new FWORD[total_mats];
         memcpy(state->global.mat.hg, localFilePtr, WSIZE * total_mats);
         localFilePtr += total_mats;

         int localN = 1;
         if(dynaVersion == 971)
            localN = 4;
         if (numrw)
         {
            //read rw_forces for all rigid walls
            state->global.rw_forces = new FWORD[numrw * localN];
            memcpy(state->global.rw_forces, localFilePtr, WSIZE * numrw * localN);
            localFilePtr += (numrw * localN);
            cout << "RIGIDWALL FORCES\n";
            /*for(int rIndex = 0; rIndex < numrw; rIndex++)
            {
               cout << "FORCE=" << state->global.rw_forces[rIndex * 4];
               if(localN == 4)
               {
                   cout << " x=" << state->global.rw_forces[(rIndex * 4)+1];
                   cout << " y=" << state->global.rw_forces[(rIndex * 4)+2];
                   cout << " z=" << state->global.rw_forces[(rIndex * 4)+3];
               }
               cout << "\n";
            }*/
         }
      }

      //Read node data
      WORD num_values = (it + ndim * (iu + iv + ia));
      state->nnd = num_values * numnp;
      state->nodedata = new FWORD[state->nnd];
      memcpy(state->nodedata, m_FilePtr, WSIZE * state->nnd);
      m_FilePtr += state->nnd;
      cout << "STATE NODES=" << state->nnd << endl;

      saveNodes(num_files, num_values, state->nodedata, state->nnd, state->time);
      /*
      for(i = 0, j = 0; i < state->nnd; i+=9, j+=3)
         memcpy(&node_values[j], &state->nodedata[i], WSIZE * 3);
      sprintf(file_name, "%s/node_values_%u", dir, num_files);
cout << "VALUE FILE=" << file_name << endl;
      writeFile(file_name, node_values, numnp * ndim * WSIZE);
*/

      //read CFD data
      if (ncfdv1 || ncfdv2)
         readCFDData(state);

      readElementData(state);
      WORD num_sph_vars = 1;
      int num_size = nel4 * nv2d;
      if (mattyp == 1)
         num_size = (nel4 - numrbe) * nv2d;
      WORD enn = (nel8 * nv3d) + (nelt * nv3dt) + (nel2 * nv1d) + (num_size)
               + (nmsph * num_sph_vars);
      WORD curSize = m_FilePtr - fileBase;
      m_FilePtr += enn;
      readElementDeleteOption(state);
      readSPHElementData(state);

      numTimes++;
   }

   //delete node_values;
   if (!numTimes)
   {
      free(states);
      return 0;
   }
   if (numTimes < 100)
      states = (StateDataPtr)realloc(states, numTimes * sizeof(StateDataStr));
   cout << "NUM TIMESTEPS=" << numTimes << endl;

   MongoDB *mongoDB = MongoDB::Get();
   if(mongoDB)
   {
      vector<float>  keVect(numTimes), ieVect(numTimes), teVect(numTimes), 
                     xVel(numTimes), yVel(numTimes), zVel(numTimes);
      vector<float>  timeVect(numTimes);
      char           timeBuf[128];
      vector< vector<float> >    matKEVector(total_mats);
      vector< vector<float> >    matIEVector(total_mats);
      vector< vector<float> >    matHEVector(total_mats);
      vector< vector<float> >    matXVVector(total_mats);
      vector< vector<float> >    matYVVector(total_mats);
      vector< vector<float> >    matZVVector(total_mats);
      vector< vector<float> >    matMassVector(total_mats);
      for(int iIndex = 0; iIndex < numTimes; ++iIndex)
      {
         keVect[iIndex] = states[iIndex].global.energy.ke;
         ieVect[iIndex] = states[iIndex].global.energy.ie;
         teVect[iIndex] = states[iIndex].global.energy.te;
         xVel[iIndex] = states[iIndex].global.energy.xvel;
         yVel[iIndex] = states[iIndex].global.energy.yvel;
         zVel[iIndex] = states[iIndex].global.energy.zvel;
         timeVect[iIndex] = states[iIndex].time;
         sprintf(timeBuf, "%g", states[iIndex].time);
         for(int jIndex = 0; jIndex < total_mats; ++jIndex)
         {
            matKEVector[jIndex].push_back(states[iIndex].global.mat.ke[jIndex]);
            matIEVector[jIndex].push_back(states[iIndex].global.mat.ie[jIndex]);
            matHEVector[jIndex].push_back(states[iIndex].global.mat.hg[jIndex]);
            matXVVector[jIndex].push_back(states[iIndex].global.mat.vel[jIndex].xvel);
            matYVVector[jIndex].push_back(states[iIndex].global.mat.vel[jIndex].yvel);
            matZVVector[jIndex].push_back(states[iIndex].global.mat.vel[jIndex].zvel);
            matMassVector[jIndex].push_back(states[iIndex].global.mat.mass[jIndex]);
         }
      }

      mongoDB->CreateEntity("Time Steps", timeVect);
      mongoDB->CreateEntity("Global Kinetic Energy", keVect);
      mongoDB->CreateEntity("Global Internal Energy", ieVect);
      mongoDB->CreateEntity("Global Total Energy", teVect);
      mongoDB->CreateEntity("Global X Velocity", xVel);
      mongoDB->CreateEntity("Global Y Velocity", yVel);
      mongoDB->CreateEntity("Global Z Velocity", zVel);

      for(int jIndex = 0; jIndex < total_mats; ++jIndex)
      {
         sprintf(timeBuf, "Kinetic Energy For Material %d", jIndex+1);
         mongoDB->CreateEntity(timeBuf, matKEVector[jIndex]);
         sprintf(timeBuf, "Internal Energy For Material %d", jIndex+1);
         mongoDB->CreateEntity(timeBuf, matIEVector[jIndex]);
         sprintf(timeBuf, "HourGlass Energy For Material %d", jIndex+1);
         mongoDB->CreateEntity(timeBuf, matHEVector[jIndex]);
         sprintf(timeBuf, "X Velocity For Material %d", jIndex+1);
         mongoDB->CreateEntity(timeBuf, matXVVector[jIndex]);
         sprintf(timeBuf, "Y Velocity For Material %d", jIndex+1);
         mongoDB->CreateEntity(timeBuf, matYVVector[jIndex]);
         sprintf(timeBuf, "Z Velocity For Material %d", jIndex+1);
         mongoDB->CreateEntity(timeBuf, matZVVector[jIndex]);
         sprintf(timeBuf, "Mass For Material %d", jIndex+1);
         mongoDB->CreateEntity(timeBuf, matMassVector[jIndex]);
      }
   }

   return numTimes;
}

int D3Plot::readElementData(StateDataPtr state)
{
    WORD *localFilePtr = m_FilePtr;
   if (nel8)
   {
      state->solids = new FWORD[nel8 * nv3d];
      memcpy(state->solids, localFilePtr, WSIZE * nel8 * nv3d);
      localFilePtr += (nel8 * nv3d);
   }

   if (nelt)
   {
      state->tshells = new FWORD[nelt * nv3dt];
      memcpy(state->tshells, localFilePtr, WSIZE * nelt * nv3dt);
      localFilePtr += (nelt * nv3dt);
   }

   if (nel2)
   {
      state->beams = new FWORD[nel2 * nv1d];
      memcpy(state->beams, localFilePtr, WSIZE * nel2 * nv1d);
      localFilePtr += (nel2 * nv1d);
   }

   if (nel4)
   {
      int num_size = nel4 * nv2d;
      if (mattyp == 1)
         num_size = (nel4 - numrbe) * nv2d;
      state->shells = new FWORD[num_size];
      memcpy(state->shells, localFilePtr, WSIZE * num_size);
      localFilePtr += (num_size);
   }

   return (nel8 + nel4 + nel2 + nelt);
}

int D3Plot::readRoadSurfaceMotion(StateDataPtr state)
{
   if (nDim <= 5)
      return 0;

   state->road_surf = new FWORD[nsurf * 6];
   memcpy(state->road_surf, m_FilePtr, WSIZE * nsurf * 6);
   m_FilePtr += nsurf * 6;

   return nsurf;
}

int D3Plot::readElementDeleteOption(StateDataPtr state)
{
   switch (mdlopt)
   {
   case 0:
      return 0;
   case 1:
      state->num_del_opt = numnp;
      state->del_opt = new FWORD[numnp];
      memcpy(state->del_opt, m_FilePtr, WSIZE * numnp);
      m_FilePtr += numnp;
      return numnp;
   case 2:
      state->num_del_opt = nel8 + nelt + nel4 + nel2;
      state->del_opt = new FWORD[state->num_del_opt];
      memcpy(state->del_opt, m_FilePtr, WSIZE * state->num_del_opt);
      m_FilePtr += state->num_del_opt;
      return state->num_del_opt;
   }

   return 0;
}

int D3Plot::readCFDData(StateDataPtr state)
{
   cout << "READING CFD DATA*********\n";
   num_cfdv1 = 0;
   if (ncfdv1)
   {
      for (int i = 2; i < 21; i++)
      {
         if (ncfdv1 & (0 << i))
            num_cfdv1++;
      }

      state->cfdv1 = new FWORD[num_cfdv1];
      memcpy(state->cfdv1, m_FilePtr, WSIZE * num_cfdv1);
      m_FilePtr += num_cfdv1;
   }

   num_cfdv2 = 0;
   if (ncfdv2)
   {
      for (int i = 2; i < 12; i++)
      {
         if (ncfdv2 & (0 << i))
            num_cfdv2++;
      }

      state->cfdv2 = new FWORD[num_cfdv2];
      memcpy(state->cfdv2, m_FilePtr, WSIZE * num_cfdv2);
      m_FilePtr += num_cfdv2;
   }

   return (num_cfdv1 + num_cfdv2);
}

int D3Plot::saveNodeIDs()
{
   char file_name[1024];

   FilePath::closeFile();
   sprintf(file_name, "%s/node_ids", FilePath::fPath);

   if (FilePath::openFile(file_name))
      return 0;

   WWIter b = nidsMap.begin(), e = nidsMap.end();
   cout << "NODEIDS\n";
   for (; b != e; b++)
   {
      //cout << b->first << endl;
      WORD id = b->first;
      BufFileWrite(FilePath::bufPtr, (char *)&id, WSIZE);
   }
   cout << "END NODEIDS\n";
   FilePath::closeFile();

   return numnp;
}

int D3Plot::saveGeometryNodes()
{
   char file_name[1024];

   FilePath::closeFile();
   sprintf(file_name, "%s/node_values", FilePath::fPath);
   if (FilePath::openFile(file_name))
      return 0;
   WWIter b = nidsMap.begin(), e = nidsMap.end();
   BufFileWrite(FilePath::bufPtr, (char *)nodeValues, WSIZE * 3 * numnp);
   Node *new_node;
   FWORD *node_ptr = nodeValues;
   map<unsigned int, Node *> *dbNodeMap = m_GetDB->GetNodeMap();
   set<FWORD> xset, yset, zset;
   for (size_t i = 0; i < numnp; ++i)
   {
       new_node = new Node(*node_ptr++, *node_ptr++, *node_ptr++) ;
       xset.insert(new_node->x);
       yset.insert(new_node->y);
       zset.insert(new_node->z);
       dbNodeMap->insert( IDNodePtrPair(i+1, new_node) );
   }
   /*cout << "NODES\n";
   for (int i = 0; b != e; i += 3, b++)
   {
      //cout << nodeValues[b->second*3] << "," << nodeValues[b->second*3+1] << ","
      //<< nodeValues[b->second*3+2] << endl;
      cout << nodeValues[i] << "," << nodeValues[i + 1] << ","
           << nodeValues[i + 2] << endl;
      //BufFileWrite(FilePath::bufPtr, (char *)&nodeValues[b->second*3],WSIZE*3);
      BufFileWrite(FilePath::bufPtr, (char *)&nodeValues[i], WSIZE * 3);
   }
   cout << "END NODES\n";*/

   FilePath::closeFile();
   writeStartFile(0, xset, yset, zset);

   return numnp;
}

int D3Plot::saveNodes(WORD file_idx, WORD stride, FWORD *node_values, WORD nnd, float timeStep)
{
   char file_name[1024];

   cout << "STRIDE=" << stride << endl;
   char timestep_buff[64];
   sprintf(timestep_buff, "%g", timeStep);

   FilePath::closeFile();
   sprintf(file_name, "%s/node_values_%u", FilePath::fPath, file_idx);
   if (FilePath::openFile(file_name))
      return 0;

   WWIter b = nidsMap.begin(), e = nidsMap.end();
   memcpy(nodeValues, node_values, WSIZE * 3 * (nnd/stride));
   BufFileWrite(FilePath::bufPtr, (char *)nodeValues, WSIZE * 3 * (nnd/stride));

   cout << "STATENODES\n";
   Node *new_node;
   FWORD  *nodelist_ptr = nodeValues;
   map<unsigned int, Node *> *nodeIDMap = m_GetDB->GetNodeMap();
   map<unsigned int, Node*>::iterator nbIter = nodeIDMap->begin(), neIter = nodeIDMap->end();
   set<FWORD> xset, yset, zset;
   for (; nbIter != neIter; ++nbIter)
   {
        /*BufFileWrite(FilePath::bufPtr, (char *)&node_values[i],
                   WSIZE * 3);
        memcpy(&nodeValues[j], &node_values[i], WSIZE * 3);
        cout << node_values[i] << "," << node_values[i + 1] << "," << node_values[i + 2] << endl;*/
        new_node = nbIter->second;
        new_node->x = *nodelist_ptr++;
        new_node->y = *nodelist_ptr++;
        new_node->z = *nodelist_ptr++;
        xset.insert(new_node->x);
        yset.insert(new_node->y);
        zset.insert(new_node->z);
   }

   writeStartFile(file_idx, xset, yset, zset);

   map<unsigned int, Part *> *partMap = m_GetDB->GetPartMap();

   if(partMap->size())
   {
       char     dir_name[1024];
       sprintf(dir_name, "%s/%s/jsdata/%d/", userDir, modelName, m_GlobalFileIndex);

       if( access(dir_name, W_OK) )
          _mkdir(dir_name);

       string   partDetailsJSON = "{\"PDArray\":[";
       m_GetDB->writeDataToFilesForResults(dir_name, 0, GL_TRIANGLES, GZIP_COMPRESSION, &partDetailsJSON, true, timestep_buff, m_GlobalFileIndex);
       partDetailsJSON += "]}";
       unsigned int wh[2] = {800, 600};
       GetDB::writeStartEndFiles(partMap->size(), m_Exts, wh, dir_name);

       sprintf(file_name, "%s/partdetails.js", dir_name);
       string details_file_name = file_name;
       GetDB::writeGZIPFile(details_file_name, partDetailsJSON);
       ++m_GlobalFileIndex;
   }

   cout << "END STATENODES\n";
   FilePath::closeFile();

   return numnp;
}

int D3Plot::saveElements(
    const char *elm_name,
    WORD num_nodes,
    WORD num_elms,
    WORD *elm_ids,
    int     elm_type)
{
   WORD old_pid = 0, new_pid, num_values = num_nodes + 1, num_parts = 0;

cout << "SAVING " << elm_name << endl;
   char idBuf[128];
   Part  *new_part = NULL;
   Shell  *new_shell;
   Solid  *new_solid;
   map<unsigned int, Node *> *dbNodeMap = m_GetDB->GetNodeMap();
   map<unsigned int, Part *> *dbPartMap = m_GetDB->GetPartMap();
   map<unsigned int, Node *>::iterator nitr, en = dbNodeMap->end();
   int     elm_id = 0, offSet = 0;
   map<unsigned int, Part *>::iterator pbIter;
   for (WORD i = 0; i < (num_elms * num_values); i += num_values)
   {
      new_pid = *(elm_ids + i + num_nodes);
      if (old_pid != new_pid)
      {
          //TO DO FOR BEAM
          if(elm_type != ELEMENT_BEAM)
          {
              sprintf(idBuf, "PART_%d", new_pid);
              pbIter = dbPartMap->find(new_pid);
              if(pbIter != dbPartMap->end())
                  new_part = pbIter->second;
              else
              {
                    new_part = new Part(idBuf, elm_type);
                    dbPartMap->insert( IDPartPtrPair(new_pid, new_part) );
                    num_parts++;
              }
          }
          else
              num_parts++;


         FilePath::closeFile();
         char file_name[1024];
         sprintf(file_name, "%s/%s%d_pid_%d.bin", FilePath::fPath, elm_name,
                 num_nodes, new_pid);
         if (FilePath::openFile(file_name))
            return 0;
      }
      /*static int nidCount = 0;
      for(int j = 0; j < num_nodes; j++)
      {
            std::cout << elm_ids[i+j] << ",";
            nidsFromElementsMap.insert(WWPair(elm_ids[i+j], nidCount));
            nidCount++;
      }
      std::cout << endl;*/
      BufFileWrite(FilePath::bufPtr, (char *)&elm_ids[i],
                   WSIZE * num_nodes);
      old_pid = new_pid;
      switch(elm_type)
     {
        case ELEMENT_SHELL:
        {
            new_shell = new Shell(elm_id, new_pid, *(elm_ids+i), *(elm_ids+i+1), *(elm_ids+i+2), *(elm_ids+i+3), offSet);
            new_part->elementList.push_back( new_shell );

            for(int i = 0; i < 4; i++)
            {
                nitr = dbNodeMap->find(new_shell->NIDList[i]);

               if( nitr != en )
               {
                   new_shell->nodePtrList[i] = (*nitr).second;
                   new_part->uniqueNodeList.insert((*nitr).second);
               }
               else
                  cout << "node id <" << new_shell->NIDList[i] << "> is not found" << endl;
            }
        }
        break;
        case ELEMENT_SOLID:
        case ELEMENT_TSHELL:
        {
            new_solid = new Solid(elm_id, new_pid, *(elm_ids+i), *(elm_ids+i+1), *(elm_ids+i+2),
             *(elm_ids+i+3), *(elm_ids+i+4), *(elm_ids+i+5), *(elm_ids+i+6), *(elm_ids+i+7), offSet);
            new_part->elementList.push_back( new_solid );

            for(int i = 0; i < 8; i++)
            {
                nitr = dbNodeMap->find(new_solid->NIDList[i]);

               if( nitr != en )
               {
                   new_solid->nodePtrList[i] = (*nitr).second;
                   new_part->uniqueNodeList.insert((*nitr).second);
               }
               else
                  cout << "node id <" << new_solid->NIDList[i] << "> is not found" << endl;
            }
        }
        break;
        case ELEMENT_BEAM:
        break;
    }
   }

   cout << "NUM PARTS=" << num_parts << endl;

   return num_elms;
}

int D3Plot::writeStartFile(WORD file_idx, set<FWORD> & x, set<FWORD> & y, set<FWORD> & z)
{
   set<FWORD>::iterator b, e;
   b = x.begin();
   e = x.end();
   e--;
   m_Exts[0] = *b;
   m_Exts[1] = *e;

   b = y.begin();
   e = y.end();
   e--;
   m_Exts[2] = *b;
   m_Exts[3] = *e;

   b = z.begin();
   e = z.end();
   e--;
   m_Exts[4] = *b;
   m_Exts[5] = *e;

   char buf[1024];
   if (file_idx)
      sprintf(buf, "%s/part_start_%u", FilePath::fPath, file_idx);
   else
      sprintf(buf, "%s/part_start", FilePath::fPath);

   cout << "START FILE=" << buf << endl;
   for (int i = 0; i < 6; i++)
      cout << m_Exts[i] << ",";
   cout << "\n";

   FILE *fp = fopen(buf, "wb");
   if(fp)
   {
      fwrite(m_Exts, sizeof(float) * 6, 1, fp);

      int num_files = 1;
      fwrite(&num_files, sizeof(int), 1, fp);

      int len = strlen(modelName);
      fwrite(&len, sizeof(int), 1, fp);
      fwrite(modelName, len * sizeof(char), 1, fp);

      fclose(fp);
   }

   //writeFile(buf, exts, sizeof(float) * 6);

   return 0;
}

int D3Plot::readData(int dirIndex)
{
    readControlData();
    readMatTypeData();
    readFluidMaterialIDData();
    readSPHElementDataFlags();
    readGeometryData(dirIndex);
    readUserIDsData();
    readAdaptedElementParentList();
    readSPHNodeMaterialList();
    readRigidRoadSurfaceData();
    readStateData(dirIndex);
}
