#include <iostream>
#include "d3plot.h"
#include <stdio.h>
#include "filepath.h"

int main(int argc, char *argv[])
{
   if( argc < 4 )
   {
      cout << "Usage:results results_dir user_dir model_name\n";
      return 1;
   }

   time_t t1, t2, t3, t4;
   const unsigned char little_endian = mesa_little_endian();
   cout << "endian=" << ((little_endian) ? "little" : "big") << endl;

   string resultsDir = argv[1], userDir = argv[2], modelName = argv[3];
   int fileIndex = 0, fileAvailable =0;
   char     dirBuf[64];
   time(&t3);
   while(true)
   {
       time(&t1);
       D3Plot d3plot(resultsDir.data(), userDir.data(), modelName.data());
       string filePath, fileName;
       int newDirFlag = 0;

       fileAvailable = d3plot.getNextAvailableFile(fileName, filePath, &newDirFlag);
       cout << "FILENAME=" << fileName << endl;
       cout << "FILEPATH=" << filePath << endl;
       if(!fileAvailable)
           break;

       if(fileIndex)
           FilePath::setPath(userDir.data(), modelName.data(), fileIndex);

       d3plot.openFile(filePath.data());

       d3plot.readData(fileIndex);

       time(&t2);
cout << "FILE TIME=" << difftime(t2, t1) << endl;
       ++fileIndex;
    }

    MongoDB *mongoDB = MongoDB::Get();
    string newPath = userDir + "/" + modelName + "/jsdata/";
    mongoDB->SetDirName(newPath);
    mongoDB->GetData();
    time(&t4);
    cout << "TOTAL TIME=" << difftime(t4, t3) << endl;

   return 0;
}

