#ifndef _STATE_DATA_H_
#define _STATE_DATA_H_

typedef enum _CFDV1Types
{
   PRESSURE = 2,
   X_VORTICITY,
   Y_VORTICITY,
   Z_VORTICITY,
   RESULTANT_VORTICITY,
   ENSTROPHY,
   HELICITY,
   STREAM_FUNCTION,
   ENTHALPY,
   DENSITY,
   TURBULENT_KE,
   DISSIPATION,
   EDDY_VISCOSITY1,
   EDDY_VISCOSITY2,
   EDDY_VISCOSITY3,
   EDDY_VISCOSITY4,
   EDDY_VISCOSITY5,
   EDDY_VISCOSITY6,
   EDDY_VISCOSITY7,
   
   CFDV1_MAX
}
  CFDV1Types;

typedef enum _CFDV2Types
{
   SPECIES1 = 2,
   SPECIES2,
   SPECIES3,
   SPECIES4,
   SPECIES5,
   SPECIES6,
   SPECIES7,
   SPECIES8,
   SPECIES9,
   SPECIES10,
   
   CFDV2_MAX
}
  CFDV2Types;

typedef struct _VelocityStr
{
   FWORD xvel, yvel, zvel;
}
  VelocityStr, *VelocityPtr;

typedef struct _MatDataStr
{
   FWORD *ie, *ke;
   VelocityPtr vel;
   FWORD *mass;
   FWORD *hg;
}
  MatDataStr, *MatDataPtr;

typedef struct _EnergyStr
{
   FWORD ke, ie, te, xvel, yvel, zvel;//, ew; doubt about external work
}
  EnergyStr, *EnergyPtr;

typedef struct
{
   FWORD rwforce;
   FWORD x;
   FWORD y;
   FWORD z;
} RWForcesStr, *RWForcesPtr;

typedef struct _GlobalDataStr
{
   EnergyStr energy;
   MatDataStr mat;
   FWORD *rw_forces;
}
  GlobalDataStr, *GlobalDataPtr;

typedef struct _StateDataStr
{
   FWORD time;
   GlobalDataStr global;
   WORD nnd;
   FWORD *nodedata;
   FWORD *cfdv1, *cfdv2;
   FWORD *solids, *tshells, *shells, *beams;
   //ELEMENT DELETE OPTION
   WORD num_del_opt;
   FWORD *del_opt;
   //SPH ELEMENT DATA
   SPHElementPtr sph;
   FWORD *road_surf;
} 
  StateDataStr, *StateDataPtr;

#endif

