#ifndef _GlStat_h_
#define _GlStat_h_

#include "resultfuncs.h"
#include "dataline.h"
#include "datatype.h"

class GlStat
{
public:
   GlStat(DataLine *data_line)
   {
      dataLine = data_line;
      numFields = 0;
      strBuff = NULL;
      wordArray = NULL;
   }

   virtual ~GlStat()
   {
      dataLine = NULL;
      numFields = 0;
      strBuff = NULL;
      wordArray = NULL;
   }

public:
   unsigned int   numFields;
   char           *strBuff;
   char           **wordArray;
   DataLine       *dataLine;
public:
   void readTitle()
   {
      char *fields[] = {"TITLE",};
      unsigned int field_types[] = {DATA_CHAR_ARRAY, };
      numFields = 1;
      unsigned int field_widths[] = {80, };
      strBuff = dataLine->readNextCard(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;

      wordArray = dataLine->splitIntoWords(numFields, field_widths);
         saveGlstatValues(wordArray, numFields, 0);
   }

   void readVersion()
   {
      char *fields[] = {"NAME","VERSION","DATE",};
      unsigned int field_types[] = {DATA_CHAR_ARRAY, DATA_INT, DATA_CHAR_ARRAY, };
      numFields = 3;
      unsigned int field_widths[] = {42, 3, 35, };
      strBuff = dataLine->readNextCard(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;

      wordArray = dataLine->splitIntoWords(numFields, field_widths);
         saveGlstatValues(wordArray, numFields, 0);
   }

   void readCycle()
   {
      char *fields[] = {"DT","NUM","CONTROL","ELMTYPE","ELM","ELMNUM",};
      unsigned int field_types[] = {DATA_CHAR_ARRAY, DATA_INT, DATA_CHAR_ARRAY, DATA_CHAR_ARRAY, DATA_CHAR_ARRAY, DATA_CHAR_ARRAY, };
      numFields = 6;
      unsigned int field_widths[] = {12, 8, 18, 10, 8, 8, };
      strBuff = dataLine->readNextCard(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;

      wordArray = dataLine->splitIntoWords(numFields, field_widths);
         saveGlstatValues(wordArray, numFields, 0);
   }

   void readTime()
   {
      char *fields[] = {"TSTR","TIME",};
      unsigned int field_types[] = {DATA_CHAR_ARRAY, DATA_DOUBLE, };
      numFields = 2;
      unsigned int field_widths[] = {34, 12, };
      strBuff = dataLine->readNextCard(numFields);
      if( !numFields && dataLine->isFlagOn(KW_READ_END) )
         return;

      wordArray = dataLine->splitIntoWords(numFields, field_widths);
         saveGlstatValues(wordArray, numFields, 0);
   }

   unsigned int importGlStat()
   {
      readTitle();
      readVersion();
      readCycle();
      while( !strstr(wordArray[0], "percent") )
      {
         readTime();
      }
      while(numFields)
      {
         readCycle();
         while( !strstr(wordArray[0], "percent") )
         {
            readTime();
         }
      }
      return 0;
   }
};

#endif

