#include <pthread.h>
#include <iostream>
#include <X11/Shell.h>
#include <X11/IntrinsicP.h>
#include <X11/Xatom.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glext.h>
#include "xtgc.h"
#include "gentime.h"
#include "mtrans.h"
#include "pickrect.h"
#include "saveimg.h"
#include "rusage.h"
#include "meminfo.h"
#include "glfuncs.h"
#include "bestvis.h"

using namespace std;

Atom deleteWindow;
CAEEnv *CAEEnv::cae_Env = NULL;

void mouseEventsProc
(
   Widget w,
   XtPointer client_data,
   XEvent  *event,
   Boolean*
)
{
   static int button, startx, starty, endx, endy, orgy, num_selected;
   int    pending_events = XPending(XtDisplay(w)) + 1;
   float  values[4];
   XtGC   *xtgc = (XtGC *)client_data;
   CAEEnv *cae_env = CAEEnv::getPtr();

   if( !cae_env )
      return;

cout << "button=" << event->xbutton.button << endl;
cout << "event=" << event->type << endl;
   
   MTransform *m_trans = cae_env->getMTransformPtr();

cout << "MOUSE PENDING=" << pending_events << endl;

   do
   {
/*
      switch(event->type)
      {
	 case ButtonPress:
         {
            switch(event->xbutton.button)
            {
               case Button1:
                  values[1] = BUTTON1;
               break;
               case Button2:
                  values[1] = BUTTON2;
               break;
               case Button3:
                  values[1] = BUTTON3;
               break;
            }
            values[0] = BUTTON_PRESS;
         }
         break;
	 case ButtonRelease:
            values[0] = BUTTON_RELEASE;
         break;
	 case MotionNotify:
            values[0] = MOTION_NOTIFY;
         break;
      }

      values[2] = event->xbutton.x;
      values[3] = event->xbutton.y;
      m_trans->processMouseEvents(values);
*/
      switch(event->type)
      {
	 case ButtonPress:
         {
	    button = event->xbutton.button;
	    startx = event->xbutton.x;
	    starty = xtgc->windowHeight - event->xbutton.y;
	    orgy = event->xbutton.y;

            switch(event->xbutton.button)
            {
               case Button1:
               {
		  switch( xtgc->transFlag )
		  {
		     case SELECT_PICK:
		     {
			PickRect pick_rect;
			values[0] = startx;
			values[1] = starty;
			values[2] = values[3] = 5.0;
                        if( xtgc->pickFlag == NODE_PICK )
                        {
                           values[2] = values[3] = 8.0;
                        }
			num_selected = pick_rect.process(xtgc->pickFlag, 
                                                  xtgc->transFlag, values);
		     }
		     break;
                     case POLYLINE_PICK:
			values[0] = startx;
			values[1] = starty;
			values[2] = 0.0;
			values[3] = 0.0;
			m_trans->updateValues(START_POLYLINE, values);
		     break;
                     case RECT_PICK:
                        if( xtgc->sendEvent )
                        {
			   int dx = (endx - startx);
			   int dy = (endy - orgy);
			   PickRect pick_rect;
			   values[0] = (dx != 0.0f) ? (startx+dx/2.0f) : startx;
			   values[1] = (dy != 0.0f) ? (starty-dy/2.0f) : starty;
			   values[2] = ( dx != 0.0f ) ? dx : 2.0f;
			   values[3] = ( dy != 0.0f ) ? dy : 2.0f;
			   num_selected = pick_rect.process(xtgc->pickFlag, 
                                                    xtgc->transFlag, values);
                           xtgc->sendEvent = 0;
                        }
		     break;
		  }
               }
               break;
               case Button2:
               {
		  switch(xtgc->transFlag)
		  {
		     case SELECT_PICK:
		     case RECT_PICK:
		     case POLYLINE_PICK:
                        if( num_selected )
			   cae_env->processParts(xtgc->onOff);
                        num_selected = 0;
		     break;
		  }
               }
               break;
	       case Button4:
	       {
                  values[0] = values[1] = values[2] = -0.2f;
		  m_trans->updateValues(GLOBAL_SCALE, values);
	       }
	       break;
	       case Button5:
	       {
                  values[0] = values[1] = values[2] = 0.2f;
		  m_trans->updateValues(GLOBAL_SCALE, values);
	       }
	       break;
            }
         }
	 break;
	 case ButtonRelease:
         {
            switch(button)
            {
               case Button1:
               {
		  switch(xtgc->transFlag)
		  {
		     case RECT_SCALE:
		     {
			values[0] = startx;
			values[1] = starty;
			values[2] = event->xbutton.x;
			values[3] = xtgc->windowHeight - event->xbutton.y;

			int dx = (event->xbutton.x - startx);
			int dy = (orgy - event->xbutton.y);

			if( dx && dy )
			{
       cout << "sx=" << startx << " sy=" << starty << " cx=" << event->xbutton.x
	      << " cy=" << (xtgc->windowHeight - event->xbutton.y) << endl;
			   m_trans->updateValues(RECT_SCALE, values);
			}
		     }
		     break;
		     case RECT_PICK:
		     {
                        event->type = ButtonPress;
                        event->xbutton.button = Button1;
                        event->xbutton.type = ButtonPress;
                        endx = event->xbutton.x;
                        endy = event->xbutton.y;
                        event->xbutton.x = startx;
                        event->xbutton.y = xtgc->windowHeight - starty;
                        xtgc->sendEvent = 1;
                        XSendEvent(XtDisplay(w), XtWindow(w), false,
                                                       ButtonPress, event);
		     }
		     break;
                     case POLYLINE_PICK:
/*
                        num_selected = cae_env->processPolylinePick(ELEMENT_PICK);
                        memset(values, 0, sizeof(int) * 4);
			m_trans->updateValues(POLYLINE_PICK, values);
*/
		     break;
		  }
               }
               break;
            }

            button = startx = starty = 0;
         }
	 break;
	 case MotionNotify:
	 {
	    switch(button)
	    {
	       case Button1:
	       {
                  switch(xtgc->transFlag)
                  {
                     case RECT_SCALE:
                     case RECT_PICK:
                     {
			values[0] = startx;
			values[1] = starty;
			values[2] = event->xbutton.x;
			values[3] = xtgc->windowHeight - event->xbutton.y;
			m_trans->updateValues(START_RUBBER_BAND, values);
                     }
                     break;
                     case POLYLINE_PICK:
                     {
			values[0] = event->xbutton.x;
			values[1] = xtgc->windowHeight - event->xbutton.y;
			values[2] = 0.0f;
			values[3] = 0.0f;
			m_trans->updateValues(START_POLYLINE, values);
                     }
                     break;
                     default:
		     {
			endx = startx;
			endy = starty;
			startx = event->xbutton.x;
			starty = xtgc->windowHeight - event->xbutton.y;
			if( startx > xtgc->windowWidth )
			   startx = xtgc->windowWidth;
			else if( startx < 0 )
			   startx = 0;
			if( starty > xtgc->windowHeight )
			   starty = xtgc->windowHeight;
			else if( starty < 0 )
			   starty = 0;
			values[0] = (startx - endx);
			values[1] = (starty - endy);
			values[2] = xtgc->windowWidth;
			values[3] = xtgc->windowHeight;
			m_trans->updateValues(GLOBAL_TRANSLATION, values);
		     }
                  }
	       }
	       break;
	       case Button3:
	       {
                  values[0] = startx;
                  values[1] = starty;
                  values[2] = event->xbutton.x;
                  values[3] = event->xbutton.y;

		  m_trans->updateValues(GLOBAL_ROTATION, values);
                  startx = event->xbutton.x;
                  starty = event->xbutton.y;

	       }
	       break;
	    }
	 }
	 break;
      }

      pending_events--;
      if( pending_events > 0 )
         XNextEvent(XtDisplay(w), event);
   }
      while( pending_events > 0 );

   cae_env->renderModel();
   glXSwapBuffers(XtDisplay(w), XtWindow(w));
}

void keyEventsProc
(
   Widget w,
   XtPointer client_data,
   XEvent  *event,
   Boolean*
)
{
   Modifiers          modifiers;
   KeySym             key_sym;
   KeyViewIterator    iter1, iter2, iter3;
   int                pending_events = XPending(XtDisplay(w)) + 1;

cout << "KEY PENDING=" << pending_events << endl;

   key_sym = XtGetActionKeysym(event, &modifiers);
   XtGC   *xtgc = (XtGC *)client_data;
   CAEEnv *cae_env = CAEEnv::getPtr();

   if( !cae_env )
      return;
   
   MTransform *m_trans = cae_env->getMTransformPtr();

   do
   {
      switch( key_sym )
      {
	 case XK_Escape:
            delete xtgc;
	    exit(0);
	 break;
	 case XK_e:
         {
            switch(xtgc->pickFlag)
            {
               case PART_PICK:
                  xtgc->pickFlag = ELEMENT_PICK;
               break;
               case ELEMENT_PICK:
                  xtgc->pickFlag = NODE_PICK;
               break;
               case NODE_PICK:
                  xtgc->pickFlag = PART_PICK;
               break;
            }
         }
	 break;
	 case XK_j:
            saveImage(cae_env->getModelName(), IMG_JPEG, xtgc->windowWidth, 
                                    xtgc->windowHeight);
	 break;
	 case XK_n:
            saveImage(cae_env->getModelName(), IMG_PNG, xtgc->windowWidth, 
                                    xtgc->windowHeight);
	 break;
	 case XK_r:
	    xtgc->transFlag = (xtgc->transFlag == RECT_SCALE) ?
					NO_TRANSFORM : RECT_SCALE;
	 break;
	 case XK_R:
	    xtgc->transFlag = (xtgc->transFlag == RECT_PICK) ?
					NO_TRANSFORM : RECT_PICK;
	 break;
	 case XK_p:
	    xtgc->transFlag = (xtgc->transFlag == SELECT_PICK) ?
					NO_TRANSFORM : SELECT_PICK;
	 break;
	 case XK_P:
	    xtgc->transFlag = (xtgc->transFlag == POLYLINE_PICK) ?
					NO_TRANSFORM : POLYLINE_PICK;
	 break;
	 case XK_o:
	    cout << "PRESSSING O" << endl;
	    xtgc->onOff = (xtgc->onOff == DISP_ON) ? DISP_OFF : DISP_ON;
	 break;
	 case XK_a:
	    cae_env->displayAllParts();
	 break;
	 case XK_c:
         {
            switch(xtgc->pickFlag)
            {
               case PART_PICK:
	          cae_env->clearSelectedParts();
               break;
               case ELEMENT_PICK:
	          cae_env->clearSelectedElements();
               break;
               case NODE_PICK:
	          cae_env->clearSelectedNodes();
               break;
            }
         }
	 break;
	 case XK_b:
	    cae_env->setBoxDisplay(DISP_ON);
	 break;
	 case XK_B:
	    cae_env->setBoxDisplay(DISP_OFF);
	 break;
	 case XK_l:
         {
            string model_name = cae_env->getModelName();
            model_name += ".gss";
	    cae_env->save(model_name.data());
         }
	 break;
	 case XK_k:
         {
            string model_name = cae_env->getModelName();
            model_name += ".gss";
	    xtgc->restore(model_name.data());
            cae_env = CAEEnv::getPtr();
         }
         break;
      }

      iter1 = xtgc->keyViewMap.find(key_sym);
      iter2 = xtgc->keyTransMap.find(key_sym);
      iter3 = xtgc->keyGLMap.find(key_sym);

      if( iter1 != xtgc->keyViewMap.end() )
      {
	 cae_env->getMViewPtr()->changeView(iter1->second);
	 m_trans->changeTransform(RESET_TRANSFORM);
      }
      else if( iter2 != xtgc->keyTransMap.end() )
      {
	 m_trans->changeTransform(iter2->second);
      }
      else if( iter3 != xtgc->keyGLMap.end() )
      {
         GLFuncs::process(iter3->second);
         if( iter3->second == GL_SHADE_MODEL)
         {
	    int shade;
	    glGetIntegerv(GL_SHADE_MODEL, &shade);
            cae_env->setShadeModel(shade);
         }
      }

      pending_events--;
      if( pending_events > 0 )
         XNextEvent(XtDisplay(w), event);
   }
      while( pending_events > 0 );

   cae_env->renderModel();
   glXSwapBuffers(XtDisplay(w), XtWindow(w));
}

void eventProc
(
   Widget w,
   XtPointer client_data,
   XEvent  *event,
   Boolean*
)
{
   XtGC                *xtgc = (XtGC *)client_data;
   CAEEnv              *cae_env = CAEEnv::getPtr();
   int                 width = xtgc->windowWidth, height = xtgc->windowHeight;
   int                 pending_events = XPending(XtDisplay(w)) + 1;

cout << "WIN PENDING=" << pending_events << endl;

   do
   {
      switch(event->type)
      {
	 case ConfigureNotify:
            width = event->xconfigure.width;
            height = event->xconfigure.height;
	 break;
	 case ClientMessage:
	 {
	    if(static_cast<Atom>(event->xclient.data.l[0]) == deleteWindow)
            {
               delete xtgc;
               exit(0);
            }
	 }
         break;
      }

      pending_events--;
      if( pending_events > 0 )
         XNextEvent(XtDisplay(w), event);
   }
      while( pending_events > 0 );

   if( xtgc->windowWidth != width || xtgc->windowHeight != height )
   {
      xtgc->windowWidth = width;
      xtgc->windowHeight = height;
      cae_env->resizeModel(width, height);
   }

   cae_env->renderModel();
   glXSwapBuffers(XtDisplay(w), XtWindow(w));
}

static void *threadFunction(void *data)
{
   ((CAEEnv *)data)->getAll();
   return 0;
}

int XtGC::createContext
    (
       int    *argc,
       char   *argv[]
    )
{
   char                 *name, *value;

   for(int i = 1; i < (*argc); i += 2)
   {
      name = argv[i];
      value = argv[i+1];
      modelParams.insert(name, value);
   }

   string model_name = modelParams.getString("-model");
   string dir_name = modelParams.getString("-dir");

   XtToolkitInitialize();
   threadStatus = XtToolkitThreadInitialize();

   caeEnv = new CAEEnv(dir_name.data(), model_name.data());
   CAEEnv::setPtr(caeEnv);

   if( threadStatus )
   {
      pthread_t            p_thread;
      pthread_create(&p_thread, NULL, threadFunction, caeEnv);
      if( !pthread_join(p_thread, NULL) )
          cout << "thread success\n";
   }

   appContext = XtCreateApplicationContext();

   if( !appContext )
   {
      cout << "Could not create app context\n";
      return 1;
   }

   display = XtOpenDisplay(appContext, NULL, model_name.data(), 
               "ShellWidgetClass", NULL, 0, argc, argv);

   if( !display )
   {
      cout << "Could not open display\n";
      return 2;
   }

   // don't change this variable. resizeModel is called first time.
   int width = modelParams.getInt("-width");
   width = (width != -1) ? width : 800;

   windowHeight = modelParams.getInt("-height");
   windowHeight = (windowHeight != -1) ? windowHeight : 600;

   Arg         args[10];
   Cardinal    num_args = 0;
   XtSetArg(args[num_args], "x", 0); num_args++;
   XtSetArg(args[num_args], "y", 0); num_args++;
   XtSetArg(args[num_args], "width", width); num_args++;
   XtSetArg(args[num_args], "height", windowHeight); num_args++;
   XtSetArg(args[num_args], "background", 0); num_args++;

   wWidget = XtAppCreateShell(model_name.data(), "ShellWidgetClass",
                      shellWidgetClass, display, args, num_args);

   int scrnum = XDefaultScreen( display );
   Window root = RootWindow( display, scrnum );
   int attribs[] = { GLX_RGBA,
                     GLX_RED_SIZE, 1,
                     GLX_GREEN_SIZE, 1,
                     GLX_BLUE_SIZE, 1,
                     GLX_DOUBLEBUFFER,
                     GLX_DEPTH_SIZE, 1,
                     None };

   XVisualInfo *visinfo = find_best_visual(display, scrnum);
   //XVisualInfo *visinfo = glXChooseVisual( display, scrnum, attribs );
cout << "VIS ID=" << visinfo->visualid << endl;

   if( !visinfo )
   {
      cout << "Could not get an RGB and double buffered visual\n";
      return 2;
   }

   XtRealizeWidget(wWidget);

   XStoreName(display, XtWindow(wWidget), model_name.data());

   deleteWindow = XInternAtom (display, "WM_DELETE_WINDOW", False);
   XSetWMProtocols(display, XtWindow(wWidget), &deleteWindow, 1);

   XSetWindowAttributes attr;
   //memset(&attr, 0, sizeof(XSetWindowAttributes));
   attr.background_pixel = 0;
   attr.border_pixel = 0;
   attr.colormap = XCreateColormap(display, root, visinfo->visual,
				AllocNone);
   attr.event_mask = StructureNotifyMask | ExposureMask;

   unsigned long mask = CWBackPixel | CWBorderPixel | CWColormap | CWEventMask;
   XChangeWindowAttributes(display, XtWindow(wWidget), mask, &attr);

   XtAddEventHandler(wWidget, attr.event_mask, true, eventProc, this);
   XtAddEventHandler(wWidget, KeyPressMask, true, keyEventsProc, this);
   mask = ButtonPressMask | ButtonReleaseMask | Button1MotionMask |
          Button2MotionMask | Button3MotionMask;
   XtAddEventHandler(wWidget, mask, true, mouseEventsProc, this);

   glxContext = glXCreateContext( display, visinfo, NULL, True );

   XFree(visinfo);
   if( !glxContext )
   {
      cout << "Could not create GLX context" << endl;
      return 3;
   }
 
   glXMakeCurrent(display, XtWindow(wWidget), glxContext);

   setupFont(fontName);

   caeEnv->loadAndInitGL(fontBase, threadStatus);

   initKeysAndViews();

   XtAppMainLoop(appContext);

   return 0;
}

void XtGC::setupFont(char *font_name)
{
   XFontStruct *font_info;
   Font id;
   unsigned int first, last;
   int numFonts = 0;

   char **fontList = XListFonts(display, "*", 1000, &numFonts);

   font_info = XLoadQueryFont(display, fontList[0]);
   if(!font_info) 
   {
      printf("Error: font %s not found\n", font_name);
      exit(0);
   }

   id = font_info->fid;
   first = font_info->min_char_or_byte2;
   last = font_info->max_char_or_byte2;

   fontBase = glGenLists((GLuint) last + 1);
   numFonts = last + 1;
   if(!fontBase) 
   {
      printf("Error: unable to allocate display lists\n");
      exit(0);
   }

   glXUseXFont(id, first, last - first + 1, fontBase + first);
}

void XtGC::initKeysAndViews()
{
   // views
   keyViewMap.insert(KeyViewPair(XK_1, ISO_VIEW)); 
   keyViewMap.insert(KeyViewPair(XK_2, LEFT_VIEW)); 
   keyViewMap.insert(KeyViewPair(XK_3, RIGHT_VIEW)); 
   keyViewMap.insert(KeyViewPair(XK_4, TOP_VIEW)); 
   keyViewMap.insert(KeyViewPair(XK_5, BOTTOM_VIEW)); 
   keyViewMap.insert(KeyViewPair(XK_6, FRONT_VIEW)); 
   keyViewMap.insert(KeyViewPair(XK_7, BACK_VIEW)); 

   //rotations
   keyTransMap.insert(KeyViewPair(XK_x, ROTATE_X_CCW)); 
   keyTransMap.insert(KeyViewPair(XK_X, ROTATE_X_CW)); 
   keyTransMap.insert(KeyViewPair(XK_y, ROTATE_Y_CCW)); 
   keyTransMap.insert(KeyViewPair(XK_Y, ROTATE_Y_CW)); 
   keyTransMap.insert(KeyViewPair(XK_z, ROTATE_Z_CCW)); 
   keyTransMap.insert(KeyViewPair(XK_Z, ROTATE_Z_CW)); 

   //translations
   keyTransMap.insert(KeyViewPair(XK_Left, TRANS_LEFT)); 
   keyTransMap.insert(KeyViewPair(XK_Right, TRANS_RIGHT)); 
   keyTransMap.insert(KeyViewPair(XK_Up, TRANS_UP)); 
   keyTransMap.insert(KeyViewPair(XK_Down, TRANS_DOWN)); 

   //scaling
   keyTransMap.insert(KeyViewPair(XK_s, SCALE_INCR)); 
   keyTransMap.insert(KeyViewPair(XK_S, SCALE_DECR)); 

/*
   keyTransMap.insert(KeyViewPair(XK_r, RECT_SCALE)); 
   keyTransMap.insert(KeyViewPair(XK_R, RECT_PICK)); 
   keyTransMap.insert(KeyViewPair(XK_p, SELECT_PICK)); 
   keyTransMap.insert(KeyViewPair(XK_g, GLOBAL_TRANSLATION)); 
*/

   keyGLMap.insert(KeyViewPair(XK_f, GL_SHADE_MODEL));
   keyGLMap.insert(KeyViewPair(XK_w, GL_POLYGON_MODE));
   keyGLMap.insert(KeyViewPair(XK_t, GL_BLEND));
   keyGLMap.insert(KeyViewPair(XK_h, GL_DEPTH_TEST));
}

int XtGC::createGLXContext()
{
   int scrnum = XDefaultScreen( display );
   int attribs[] = { GLX_RGBA,
                     GLX_RED_SIZE, 1,
                     GLX_GREEN_SIZE, 1,
                     GLX_BLUE_SIZE, 1,
                     GLX_DOUBLEBUFFER,
                     GLX_DEPTH_SIZE, 1,
                     None };
   XVisualInfo *visinfo = find_best_visual(display, scrnum);
   //XVisualInfo *visinfo = glXChooseVisual( display, scrnum, attribs );

   if( !visinfo )
   {
      cout << "Could not get an RGB and double buffered visual\n";
      return 2;
   }
   
   glxContext = glXCreateContext( display, visinfo, NULL, True );

   XFree(visinfo);
   if( !glxContext )
   {
      cout << "Could not create GLX context" << endl;
      return 3;
   }
 
   glXMakeCurrent(display, XtWindow(wWidget), glxContext);

   return 0;
}

int XtGC::restore(const char *file_name)
{
   char dir_name[256], model_name[256];
   unsigned int len = 0;

   FILE *file_ptr = fopen(file_name, "rb");

   if( !file_ptr )
   {
      cout << "Unable to open file <" << file_name << "> to restore\n";
      return 1;
   }

   //dir name
   fread(&len, sizeof(int), 1, file_ptr);
   fread(dir_name, sizeof(char), len, file_ptr);
   dir_name[len] = '\0';

   //model name
   fread(&len, sizeof(int), 1, file_ptr);
   fread(model_name, sizeof(char), len, file_ptr);
   model_name[len] = '\0';

   delete caeEnv;
   glDeleteLists(fontBase, numFonts);

   glXDestroyContext(display, glxContext);
   createGLXContext();

   caeEnv = new CAEEnv(dir_name, model_name);
   CAEEnv::setPtr(caeEnv);
   setupFont(fontName);
   caeEnv->loadAndInitGL(fontBase);
   caeEnv->resizeModel(windowWidth, windowHeight);
   caeEnv->restore(file_ptr);
   fclose(file_ptr);

   return 0;
}

int XtGC::restore(int *argc, char *argv[], const char *file_name)
{
   char dir_name[256], model_name[256];
   unsigned int len = 0;

   FILE *file_ptr = fopen(file_name, "rb");

   if( !file_ptr )
   {
      cout << "Unable to open file <" << file_name << "> to restore\n";
      return 1;
   }

   //dir name
   fread(&len, sizeof(int), 1, file_ptr);
   fread(dir_name, sizeof(char), len, file_ptr);
   dir_name[len] = '\0';

   //model name
   fread(&len, sizeof(int), 1, file_ptr);
   fread(model_name, sizeof(char), len, file_ptr);
   model_name[len] = '\0';

   int width = 800;
   windowHeight = 600;

   XtToolkitInitialize();
   threadStatus = XtToolkitThreadInitialize();

   caeEnv = new CAEEnv(dir_name, model_name);
   CAEEnv::setPtr(caeEnv);

   if( threadStatus )
   {
      pthread_t            p_thread;
      pthread_create(&p_thread, NULL, threadFunction, caeEnv);
      if( !pthread_join(p_thread, NULL) )
          cout << "thread success\n";
   }

   appContext = XtCreateApplicationContext();

   if( !appContext )
   {
      cout << "Could not create app context\n";
      return 1;
   }

   display = XtOpenDisplay(appContext, NULL, model_name, 
               "ShellWidgetClass", NULL, 0, argc, argv);

   if( !display )
   {
      cout << "Could not open display\n";
      return 2;
   }

   Arg         args[10];
   Cardinal    num_args = 0;
   XtSetArg(args[num_args], "x", 0); num_args++;
   XtSetArg(args[num_args], "y", 0); num_args++;
   XtSetArg(args[num_args], "width", width); num_args++;
   XtSetArg(args[num_args], "height", windowHeight); num_args++;
   XtSetArg(args[num_args], "background", 0); num_args++;

   wWidget = XtAppCreateShell(model_name, "ShellWidgetClass",
                      shellWidgetClass, display, args, num_args);

   int scrnum = XDefaultScreen( display );
   Window root = RootWindow( display, scrnum );
   int attribs[] = { GLX_RGBA,
                     GLX_RED_SIZE, 1,
                     GLX_GREEN_SIZE, 1,
                     GLX_BLUE_SIZE, 1,
                     GLX_DOUBLEBUFFER,
                     GLX_DEPTH_SIZE, 1,
                     None };
   XVisualInfo *visinfo = find_best_visual(display, scrnum);
   //XVisualInfo *visinfo = glXChooseVisual( display, scrnum, attribs );

   if( !visinfo )
   {
      cout << "Could not get an RGB and double buffered visual\n";
      return 2;
   }

   XtRealizeWidget(wWidget);
   XStoreName(display, XtWindow(wWidget), model_name);

   deleteWindow = XInternAtom (display, "WM_DELETE_WINDOW", False);
   XSetWMProtocols(display, XtWindow(wWidget), &deleteWindow, 1);

   XSetWindowAttributes attr;
   attr.background_pixel = 0;
   attr.border_pixel = 0;
   attr.colormap = XCreateColormap(display, root, visinfo->visual,
				AllocNone);
   attr.event_mask = StructureNotifyMask | ExposureMask;

   unsigned long mask = CWBackPixel | CWBorderPixel | CWColormap | CWEventMask;
   XChangeWindowAttributes(display, XtWindow(wWidget), mask, &attr);

   XtAddEventHandler(wWidget, attr.event_mask, true, eventProc, this);
   XtAddEventHandler(wWidget, KeyPressMask, true, keyEventsProc, this);
   mask = ButtonPressMask | ButtonReleaseMask | Button1MotionMask |
          Button2MotionMask | Button3MotionMask;
   XtAddEventHandler(wWidget, mask, true, mouseEventsProc, this);

   glxContext = glXCreateContext( display, visinfo, NULL, True );

   XFree(visinfo);
   if( !glxContext )
   {
      cout << "Could not create GLX context for " << model_name << endl;
      return 3;
   }
 
   glXMakeCurrent(display, XtWindow(wWidget), glxContext);

   initKeysAndViews();
   setupFont(fontName);

   caeEnv->loadAndInitGL(fontBase, threadStatus);
   caeEnv->restore(file_ptr);

   XtAppMainLoop(appContext);

   return 0;
}

